// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Clap2 -pn processClap2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Clap2SIG0 {
	iRec6: [i32;2],
}

impl DSP_Clap2SIG0 {
	
	fn get_num_inputsDSP_Clap2SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Clap2SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Clap2SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec6[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Clap2SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec6[0] = i32::wrapping_add(self.iRec6[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec6[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec6[1] = self.iRec6[0];
		}
	}

}


pub fn newDSP_Clap2SIG0() -> DSP_Clap2SIG0 { 
	DSP_Clap2SIG0 {
		iRec6: [0;2],
	}
}

pub struct DSP_Clap2SIG1 {
	iRec10: [i32;2],
}

impl DSP_Clap2SIG1 {
	
	fn get_num_inputsDSP_Clap2SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Clap2SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Clap2SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec10[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Clap2SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec10[0] = i32::wrapping_add(self.iRec10[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec10[0], -1)) as F32));
			self.iRec10[1] = self.iRec10[0];
		}
	}

}


pub fn newDSP_Clap2SIG1() -> DSP_Clap2SIG1 { 
	DSP_Clap2SIG1 {
		iRec10: [0;2],
	}
}

pub struct DSP_Clap2SIG2 {
	iVec3: [i32;2],
	iRec14: [i32;2],
}

impl DSP_Clap2SIG2 {
	
	fn get_num_inputsDSP_Clap2SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Clap2SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Clap2SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec14[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Clap2SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec14[0] = (i32::wrapping_add(self.iVec3[1], self.iRec14[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec14[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec14[1] = self.iRec14[0];
		}
	}

}


pub fn newDSP_Clap2SIG2() -> DSP_Clap2SIG2 { 
	DSP_Clap2SIG2 {
		iVec3: [0;2],
		iRec14: [0;2],
	}
}

pub struct DSP_Clap2SIG3 {
	iRec25: [i32;2],
}

impl DSP_Clap2SIG3 {
	
	fn get_num_inputsDSP_Clap2SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Clap2SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Clap2SIG3(&mut self, sample_rate: i32) {
		for l22 in 0..2 {
			self.iRec25[(l22) as usize] = 0;
		}
	}
	
	fn fillDSP_Clap2SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec25[0] = i32::wrapping_add(self.iRec25[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec25[0], -1)) as F32) + -128.0));
			self.iRec25[1] = self.iRec25[0];
		}
	}

}


pub fn newDSP_Clap2SIG3() -> DSP_Clap2SIG3 { 
	DSP_Clap2SIG3 {
		iRec25: [0;2],
	}
}
static mut iDSP_Clap2SIG4Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Clap2SIG4 {
	iDSP_Clap2SIG4Wave0_idx: i32,
}

impl DSP_Clap2SIG4 {
	
	fn get_num_inputsDSP_Clap2SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Clap2SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Clap2SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Clap2SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Clap2SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Clap2SIG4Wave0[(self.iDSP_Clap2SIG4Wave0_idx) as usize] };
			self.iDSP_Clap2SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Clap2SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Clap2SIG4() -> DSP_Clap2SIG4 { 
	DSP_Clap2SIG4 {
		iDSP_Clap2SIG4Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Clap2SIG0: [F32;16384] = [0.0;16384];
fn DSP_Clap2_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Clap2SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Clap2SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Clap2SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Clap2SIG4: [i32;100] = [0;100];
fn DSP_Clap2_faustpower4_f(value: F32) -> F32 {
	return value * value * value * value;
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Clap2 {
	iVec0: [i32;2],
	fHslider0: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider1: F32,
	fRec8: [F32;2],
	fRec7: [F32;2],
	fRec9: [F32;2],
	fRec11: [F32;2],
	fSampleRate: i32,
	fConst0: F32,
	fRec12: [F32;2],
	fHslider2: F32,
	fRec13: [F32;2],
	fHslider3: F32,
	fRec15: [F32;2],
	fRec16: [F32;2],
	fRec17: [F32;2],
	fRec18: [F32;2],
	fRec19: [F32;2],
	fRec20: [F32;2],
	fRec21: [F32;2],
	fRec22: [F32;2],
	fRec23: [F32;2],
	iConst1: i32,
	iRec26: [i32;2],
	fConst2: F32,
	fRec24: [F32;2],
	fRec28: [F32;2],
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fConst4: F32,
	fRec32: [F32;2],
	fRec27: [F32;2],
	fConst7: F32,
	fRec33: [F32;2],
	fConst9: F32,
	fRec34: [F32;2],
	fRec1: [F32;2],
	fRec2: [F32;2],
	fRec3: [F32;2],
	fRec4: [F32;2],
	fRec5: [F32;2],
	fConst11: F32,
	fConst12: F32,
	fConst14: F32,
	fConst15: F32,
	fRec0: [F32;2],
	fHslider4: F32,
	fHslider5: F32,
	fHslider6: F32,
}

impl FaustDsp for DSP_Clap2 {
	type T = F32;
		
	fn new() -> DSP_Clap2 { 
		DSP_Clap2 {
			iVec0: [0;2],
			fHslider0: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider1: 0.0,
			fRec8: [0.0;2],
			fRec7: [0.0;2],
			fRec9: [0.0;2],
			fRec11: [0.0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fRec12: [0.0;2],
			fHslider2: 0.0,
			fRec13: [0.0;2],
			fHslider3: 0.0,
			fRec15: [0.0;2],
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fRec20: [0.0;2],
			fRec21: [0.0;2],
			fRec22: [0.0;2],
			fRec23: [0.0;2],
			iConst1: 0,
			iRec26: [0;2],
			fConst2: 0.0,
			fRec24: [0.0;2],
			fRec28: [0.0;2],
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fConst4: 0.0,
			fRec32: [0.0;2],
			fRec27: [0.0;2],
			fConst7: 0.0,
			fRec33: [0.0;2],
			fConst9: 0.0,
			fRec34: [0.0;2],
			fRec1: [0.0;2],
			fRec2: [0.0;2],
			fRec3: [0.0;2],
			fRec4: [0.0;2],
			fRec5: [0.0;2],
			fConst11: 0.0,
			fConst12: 0.0,
			fConst14: 0.0,
			fConst15: 0.0,
			fRec0: [0.0;2],
			fHslider4: 0.0,
			fHslider5: 0.0,
			fHslider6: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Clap2 -pn processClap2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
		m.declare("vaeffects.lib/moogLadder:author", "Dario Sanfilippo");
		m.declare("vaeffects.lib/moogLadder:license", "MIT-style STK-4.3 license");
		m.declare("vaeffects.lib/name", "Faust Virtual Analog Filter Effect Library");
		m.declare("vaeffects.lib/version", "1.2.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Clap2SIG0 = newDSP_Clap2SIG0();
		sig0.instance_initDSP_Clap2SIG0(sample_rate);
		sig0.fillDSP_Clap2SIG0(16384, unsafe { &mut ftbl0DSP_Clap2SIG0 });
		let mut sig1: DSP_Clap2SIG1 = newDSP_Clap2SIG1();
		sig1.instance_initDSP_Clap2SIG1(sample_rate);
		sig1.fillDSP_Clap2SIG1(144, unsafe { &mut ftbl1DSP_Clap2SIG1 });
		let mut sig2: DSP_Clap2SIG2 = newDSP_Clap2SIG2();
		sig2.instance_initDSP_Clap2SIG2(sample_rate);
		sig2.fillDSP_Clap2SIG2(1024, unsafe { &mut ftbl2DSP_Clap2SIG2 });
		let mut sig3: DSP_Clap2SIG3 = newDSP_Clap2SIG3();
		sig3.instance_initDSP_Clap2SIG3(sample_rate);
		sig3.fillDSP_Clap2SIG3(4096, unsafe { &mut ftbl3DSP_Clap2SIG3 });
		let mut sig4: DSP_Clap2SIG4 = newDSP_Clap2SIG4();
		sig4.instance_initDSP_Clap2SIG4(sample_rate);
		sig4.fillDSP_Clap2SIG4(100, unsafe { &mut itbl4DSP_Clap2SIG4 });
	}
	fn instance_reset_params(&mut self) {
		self.fHslider0 = 9e+01;
		self.fEntry0 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 5e+01;
		self.fHslider3 = 36.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 0.0;
		self.fHslider6 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec8[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec7[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec9[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec11[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec12[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec13[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec15[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec16[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec17[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec18[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec19[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec20[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec21[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec22[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec23[(l21) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.iRec26[(l23) as usize] = 0;
		}
		for l24 in 0..2 {
			self.fRec24[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec28[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec29[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec30[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec31[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec32[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec27[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec33[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec34[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec1[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec2[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec3[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec4[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec5[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec0[(l38) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		self.iConst1 = unsafe { itbl4DSP_Clap2SIG4[50] };
		self.fConst2 = 2.2e+02 / self.fConst0;
		let mut fConst3: F32 = unsafe { ftbl3DSP_Clap2SIG3[2678] };
		self.fConst4 = 1e+03 / self.fConst0 * (fConst3 + 0.7599262 * (unsafe { ftbl3DSP_Clap2SIG3[2679] } - fConst3));
		let mut fConst5: F32 = unsafe { ftbl3DSP_Clap2SIG3[2047] };
		let mut fConst6: F32 = 1.0 / self.fConst0;
		self.fConst7 = fConst6 * (fConst5 + 0.5 * (unsafe { ftbl3DSP_Clap2SIG3[2048] } - fConst5));
		let mut fConst8: F32 = unsafe { ftbl3DSP_Clap2SIG3[2289] };
		self.fConst9 = fConst6 * (fConst8 + 0.8017898 * (unsafe { ftbl3DSP_Clap2SIG3[2290] } - fConst8));
		let mut fConst10: F32 = F32::tan(62.831852 / self.fConst0);
		self.fConst11 = 1.0 / fConst10;
		self.fConst12 = 1.0 - self.fConst11;
		let mut fConst13: F32 = self.fConst11 + 1.0;
		self.fConst14 = 1.0 / fConst13;
		self.fConst15 = 0.0 - 1.0 / (fConst10 * fConst13);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Clap2::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "6", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Attack");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Attack", ParamIndex(3), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "7", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Tone");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Tone", ParamIndex(4), 9e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(5)), "8", "");
		ui_interface.declare(Some(ParamIndex(5)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(5)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(5), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(6), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(7), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			4 => Some(self.fHslider0),
			6 => Some(self.fHslider1),
			3 => Some(self.fHslider2),
			7 => Some(self.fHslider3),
			2 => Some(self.fHslider4),
			1 => Some(self.fHslider5),
			5 => Some(self.fHslider6),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			4 => { self.fHslider0 = value }
			6 => { self.fHslider1 = value }
			3 => { self.fHslider2 = value }
			7 => { self.fHslider3 = value }
			2 => { self.fHslider4 = value }
			1 => { self.fHslider5 = value }
			5 => { self.fHslider6 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = 0.11 * self.fHslider2;
		let mut fSlow9: F32 = self.fHslider3;
		let mut fSlow10: F32 = fSlow9 + -73.0;
		let mut fSlow11: F32 = F32::min(99.0, 2.5656567 * F32::max(0.0, F32::abs(fSlow10)) + (99.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow10))));
		let mut fSlow12: F32 = 0.42857143 * (0.33333334 * fSlow9 + 1.0);
		let mut fSlow13: F32 = F32::powf(2.0, 0.083333336 * (fSlow9 + -69.0));
		let mut fSlow14: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow13, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow15: i32 = ((fSlow14) as i32);
		let mut fSlow16: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iSlow15) as usize] };
		let mut fSlow17: F32 = fSlow16 + (fSlow14 - ((iSlow15) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iSlow15, 1)) as usize] } - fSlow16);
		let mut fSlow18: F32 = self.fConst2 * fSlow13;
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Clap2_faustpower4_f(fSlow1) * fSlow4 / DSP_Clap2_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider4;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider5 + 3.0));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider6 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Clap2_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 94.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec9[1] };
			let mut fTemp7: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec11[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 80.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp10: F32 = self.fRec7[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 71.5 - fSlow8) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec12[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 56.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec13[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec13[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec13[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec13[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec13[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec13[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec13[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec7[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec7[0] + fTemp7 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec9[0] } } } else { if (((self.fRec13[0] < fTemp16) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec12[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec12[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp23) as usize] };
			let mut fTemp25: F32 = F32::max(0.0, F32::min(127.0, fSlow11 + fTemp4));
			let mut fTemp26: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp25) * (fTemp25 + 28.0);
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp26 + 4064.0 } else { self.fRec15[1] };
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp26 + 3456.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = self.fRec16[0] - self.fRec15[0];
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec17[1] };
			let mut fTemp28: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp27) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 50.5) as i32)) as usize] } * if (((fTemp27 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp26 } else { self.fRec18[1] };
			let mut fTemp29: F32 = F32::max(5076.0, self.fRec18[0]);
			let mut fTemp30: F32 = self.fRec15[0] - fTemp29;
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp30) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 83.5) as i32)) as usize] } * if (((fTemp30 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp29)) + 2.0) } else { 0.96 }))));
			let mut fTemp32: F32 = fTemp31 + fTemp28;
			let mut fTemp33: F32 = self.fRec18[0] - self.fRec16[0];
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 42.5) as i32)) as usize] } * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec16[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp32 + fTemp34;
			self.fRec19[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp35, self.fRec19[1] + 1.0) };
			let mut iTemp36: i32 = ((self.fRec19[0] < fTemp32) as i32);
			let mut fTemp37: F32 = (self.fRec19[0] - fTemp32) / fTemp34;
			let mut iTemp38: i32 = ((self.fRec19[0] < fTemp31) as i32);
			let mut fTemp39: F32 = (self.fRec19[0] - fTemp31) / fTemp28;
			let mut fTemp40: F32 = self.fRec19[0] / fTemp31;
			let mut fTemp41: F32 = if (iTemp36 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp29 } else { if (iTemp38 as i32 != 0) { fTemp29 + fTemp30 * if (((self.fRec15[0] > fTemp29) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec15[0] } } } else { if (iTemp36 as i32 != 0) { self.fRec15[0] + fTemp27 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec16[0] } } } else { if (((self.fRec19[0] < fTemp35) as i32) as i32 != 0) { self.fRec16[0] + fTemp33 * if (((self.fRec18[0] > self.fRec16[0]) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec18[0] } };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 9e+01));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4064.0 } else { self.fRec20[1] };
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3744.0 } else { self.fRec21[1] };
			let mut fTemp46: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 78.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec22[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp49: F32 = self.fRec20[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 96.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 60.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec23[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec23[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec23[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec23[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec23[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec23[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec23[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec20[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec20[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec20[0] + fTemp46 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec21[0] } } } else { if (((self.fRec23[0] < fTemp54) as i32) as i32 != 0) { self.fRec21[0] + fTemp52 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec22[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst1 } else { self.iRec26[1] };
			let mut fTemp64: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iTemp65) as usize] };
			let mut fTemp67: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + fSlow18 * fSlow17 * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) };
			self.fRec24[0] = fTemp67 - F32::floor(fTemp67);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { 7904.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 39.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 99.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 0.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp83) as usize] };
			let mut fTemp85: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec32[1] + self.fConst4 };
			self.fRec32[0] = fTemp85 - F32::floor(fTemp85);
			self.fRec27[0] = 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec32[0] + 24.347826 * self.fRec27[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84));
			let mut fTemp86: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fConst7 + self.fRec33[1] };
			self.fRec33[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst9 };
			self.fRec34[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = fSlow19 * (0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec34[0] + 2.0 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec33[0] + 17.391304 * (self.fRec27[0] + 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * self.fRec24[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24)) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp88;
			let mut fTemp89: F32 = self.fRec1[1] + fSlow3 * fTemp88 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp89;
			let mut fTemp90: F32 = self.fRec2[1] + fSlow3 * fTemp89 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp90;
			let mut fTemp91: F32 = self.fRec3[1] + fSlow3 * fTemp90 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp91;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp91;
			self.fRec0[0] = self.fConst15 * self.fRec5[1] - self.fConst14 * (self.fConst12 * self.fRec0[1] - self.fConst11 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Clap2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Clap2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Clap2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = 0.11 * self.fHslider2;
		let mut fSlow9: F32 = self.fHslider3;
		let mut fSlow10: F32 = fSlow9 + -73.0;
		let mut fSlow11: F32 = F32::min(99.0, 2.5656567 * F32::max(0.0, F32::abs(fSlow10)) + (99.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow10))));
		let mut fSlow12: F32 = 0.42857143 * (0.33333334 * fSlow9 + 1.0);
		let mut fSlow13: F32 = F32::powf(2.0, 0.083333336 * (fSlow9 + -69.0));
		let mut fSlow14: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow13, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow15: i32 = ((fSlow14) as i32);
		let mut fSlow16: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iSlow15) as usize] };
		let mut fSlow17: F32 = fSlow16 + (fSlow14 - ((iSlow15) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iSlow15, 1)) as usize] } - fSlow16);
		let mut fSlow18: F32 = self.fConst2 * fSlow13;
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Clap2_faustpower4_f(fSlow1) * fSlow4 / DSP_Clap2_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider4;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider5 + 3.0));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider6 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Clap2_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 94.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec9[1] };
			let mut fTemp7: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec11[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 80.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp10: F32 = self.fRec7[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 71.5 - fSlow8) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec12[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 56.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec13[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec13[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec13[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec13[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec13[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec13[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec13[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec7[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec7[0] + fTemp7 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec9[0] } } } else { if (((self.fRec13[0] < fTemp16) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec12[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec12[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp23) as usize] };
			let mut fTemp25: F32 = F32::max(0.0, F32::min(127.0, fSlow11 + fTemp4));
			let mut fTemp26: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp25) * (fTemp25 + 28.0);
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp26 + 4064.0 } else { self.fRec15[1] };
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp26 + 3456.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = self.fRec16[0] - self.fRec15[0];
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec17[1] };
			let mut fTemp28: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp27) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 50.5) as i32)) as usize] } * if (((fTemp27 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp26 } else { self.fRec18[1] };
			let mut fTemp29: F32 = F32::max(5076.0, self.fRec18[0]);
			let mut fTemp30: F32 = self.fRec15[0] - fTemp29;
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp30) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 83.5) as i32)) as usize] } * if (((fTemp30 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp29)) + 2.0) } else { 0.96 }))));
			let mut fTemp32: F32 = fTemp31 + fTemp28;
			let mut fTemp33: F32 = self.fRec18[0] - self.fRec16[0];
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 42.5) as i32)) as usize] } * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec16[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp32 + fTemp34;
			self.fRec19[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp35, self.fRec19[1] + 1.0) };
			let mut iTemp36: i32 = ((self.fRec19[0] < fTemp32) as i32);
			let mut fTemp37: F32 = (self.fRec19[0] - fTemp32) / fTemp34;
			let mut iTemp38: i32 = ((self.fRec19[0] < fTemp31) as i32);
			let mut fTemp39: F32 = (self.fRec19[0] - fTemp31) / fTemp28;
			let mut fTemp40: F32 = self.fRec19[0] / fTemp31;
			let mut fTemp41: F32 = if (iTemp36 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp29 } else { if (iTemp38 as i32 != 0) { fTemp29 + fTemp30 * if (((self.fRec15[0] > fTemp29) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec15[0] } } } else { if (iTemp36 as i32 != 0) { self.fRec15[0] + fTemp27 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec16[0] } } } else { if (((self.fRec19[0] < fTemp35) as i32) as i32 != 0) { self.fRec16[0] + fTemp33 * if (((self.fRec18[0] > self.fRec16[0]) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec18[0] } };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 9e+01));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4064.0 } else { self.fRec20[1] };
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3744.0 } else { self.fRec21[1] };
			let mut fTemp46: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 78.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec22[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp49: F32 = self.fRec20[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 96.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 60.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec23[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec23[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec23[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec23[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec23[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec23[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec23[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec20[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec20[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec20[0] + fTemp46 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec21[0] } } } else { if (((self.fRec23[0] < fTemp54) as i32) as i32 != 0) { self.fRec21[0] + fTemp52 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec22[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst1 } else { self.iRec26[1] };
			let mut fTemp64: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iTemp65) as usize] };
			let mut fTemp67: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + fSlow18 * fSlow17 * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) };
			self.fRec24[0] = fTemp67 - F32::floor(fTemp67);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { 7904.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 39.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 99.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 0.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp83) as usize] };
			let mut fTemp85: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec32[1] + self.fConst4 };
			self.fRec32[0] = fTemp85 - F32::floor(fTemp85);
			self.fRec27[0] = 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec32[0] + 24.347826 * self.fRec27[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84));
			let mut fTemp86: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fConst7 + self.fRec33[1] };
			self.fRec33[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst9 };
			self.fRec34[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = fSlow19 * (0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec34[0] + 2.0 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec33[0] + 17.391304 * (self.fRec27[0] + 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * self.fRec24[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24)) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp88;
			let mut fTemp89: F32 = self.fRec1[1] + fSlow3 * fTemp88 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp89;
			let mut fTemp90: F32 = self.fRec2[1] + fSlow3 * fTemp89 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp90;
			let mut fTemp91: F32 = self.fRec3[1] + fSlow3 * fTemp90 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp91;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp91;
			self.fRec0[0] = self.fConst15 * self.fRec5[1] - self.fConst14 * (self.fConst12 * self.fRec0[1] - self.fConst11 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Clap2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Clap2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Clap2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = 0.11 * self.fHslider2;
		let mut fSlow9: F32 = self.fHslider3;
		let mut fSlow10: F32 = fSlow9 + -73.0;
		let mut fSlow11: F32 = F32::min(99.0, 2.5656567 * F32::max(0.0, F32::abs(fSlow10)) + (99.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow10))));
		let mut fSlow12: F32 = 0.42857143 * (0.33333334 * fSlow9 + 1.0);
		let mut fSlow13: F32 = F32::powf(2.0, 0.083333336 * (fSlow9 + -69.0));
		let mut fSlow14: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow13, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow15: i32 = ((fSlow14) as i32);
		let mut fSlow16: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iSlow15) as usize] };
		let mut fSlow17: F32 = fSlow16 + (fSlow14 - ((iSlow15) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iSlow15, 1)) as usize] } - fSlow16);
		let mut fSlow18: F32 = self.fConst2 * fSlow13;
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Clap2_faustpower4_f(fSlow1) * fSlow4 / DSP_Clap2_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider4;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider5 + 3.0));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider6 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Clap2_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 94.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec9[1] };
			let mut fTemp7: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec11[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 80.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp10: F32 = self.fRec7[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 71.5 - fSlow8) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec12[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 56.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec13[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec13[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec13[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec13[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec13[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec13[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec13[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec7[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec7[0] + fTemp7 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec9[0] } } } else { if (((self.fRec13[0] < fTemp16) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec12[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec12[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp23) as usize] };
			let mut fTemp25: F32 = F32::max(0.0, F32::min(127.0, fSlow11 + fTemp4));
			let mut fTemp26: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp25) * (fTemp25 + 28.0);
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp26 + 4064.0 } else { self.fRec15[1] };
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp26 + 3456.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = self.fRec16[0] - self.fRec15[0];
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec17[1] };
			let mut fTemp28: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp27) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 50.5) as i32)) as usize] } * if (((fTemp27 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp26 } else { self.fRec18[1] };
			let mut fTemp29: F32 = F32::max(5076.0, self.fRec18[0]);
			let mut fTemp30: F32 = self.fRec15[0] - fTemp29;
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp30) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 83.5) as i32)) as usize] } * if (((fTemp30 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp29)) + 2.0) } else { 0.96 }))));
			let mut fTemp32: F32 = fTemp31 + fTemp28;
			let mut fTemp33: F32 = self.fRec18[0] - self.fRec16[0];
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 42.5) as i32)) as usize] } * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec16[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp32 + fTemp34;
			self.fRec19[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp35, self.fRec19[1] + 1.0) };
			let mut iTemp36: i32 = ((self.fRec19[0] < fTemp32) as i32);
			let mut fTemp37: F32 = (self.fRec19[0] - fTemp32) / fTemp34;
			let mut iTemp38: i32 = ((self.fRec19[0] < fTemp31) as i32);
			let mut fTemp39: F32 = (self.fRec19[0] - fTemp31) / fTemp28;
			let mut fTemp40: F32 = self.fRec19[0] / fTemp31;
			let mut fTemp41: F32 = if (iTemp36 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp29 } else { if (iTemp38 as i32 != 0) { fTemp29 + fTemp30 * if (((self.fRec15[0] > fTemp29) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec15[0] } } } else { if (iTemp36 as i32 != 0) { self.fRec15[0] + fTemp27 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec16[0] } } } else { if (((self.fRec19[0] < fTemp35) as i32) as i32 != 0) { self.fRec16[0] + fTemp33 * if (((self.fRec18[0] > self.fRec16[0]) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec18[0] } };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 9e+01));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4064.0 } else { self.fRec20[1] };
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3744.0 } else { self.fRec21[1] };
			let mut fTemp46: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 78.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec22[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp49: F32 = self.fRec20[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 96.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 60.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec23[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec23[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec23[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec23[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec23[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec23[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec23[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec20[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec20[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec20[0] + fTemp46 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec21[0] } } } else { if (((self.fRec23[0] < fTemp54) as i32) as i32 != 0) { self.fRec21[0] + fTemp52 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec22[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst1 } else { self.iRec26[1] };
			let mut fTemp64: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iTemp65) as usize] };
			let mut fTemp67: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + fSlow18 * fSlow17 * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) };
			self.fRec24[0] = fTemp67 - F32::floor(fTemp67);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { 7904.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 39.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 99.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 0.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp83) as usize] };
			let mut fTemp85: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec32[1] + self.fConst4 };
			self.fRec32[0] = fTemp85 - F32::floor(fTemp85);
			self.fRec27[0] = 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec32[0] + 24.347826 * self.fRec27[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84));
			let mut fTemp86: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fConst7 + self.fRec33[1] };
			self.fRec33[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst9 };
			self.fRec34[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = fSlow19 * (0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec34[0] + 2.0 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec33[0] + 17.391304 * (self.fRec27[0] + 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * self.fRec24[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24)) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp88;
			let mut fTemp89: F32 = self.fRec1[1] + fSlow3 * fTemp88 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp89;
			let mut fTemp90: F32 = self.fRec2[1] + fSlow3 * fTemp89 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp90;
			let mut fTemp91: F32 = self.fRec3[1] + fSlow3 * fTemp90 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp91;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp91;
			self.fRec0[0] = self.fConst15 * self.fRec5[1] - self.fConst14 * (self.fConst12 * self.fRec0[1] - self.fConst11 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Clap2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Clap2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Clap2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = 0.11 * self.fHslider2;
		let mut fSlow9: F32 = self.fHslider3;
		let mut fSlow10: F32 = fSlow9 + -73.0;
		let mut fSlow11: F32 = F32::min(99.0, 2.5656567 * F32::max(0.0, F32::abs(fSlow10)) + (99.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow10))));
		let mut fSlow12: F32 = 0.42857143 * (0.33333334 * fSlow9 + 1.0);
		let mut fSlow13: F32 = F32::powf(2.0, 0.083333336 * (fSlow9 + -69.0));
		let mut fSlow14: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow13, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow15: i32 = ((fSlow14) as i32);
		let mut fSlow16: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iSlow15) as usize] };
		let mut fSlow17: F32 = fSlow16 + (fSlow14 - ((iSlow15) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iSlow15, 1)) as usize] } - fSlow16);
		let mut fSlow18: F32 = self.fConst2 * fSlow13;
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Clap2_faustpower4_f(fSlow1) * fSlow4 / DSP_Clap2_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider4;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider5 + 3.0));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider6 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Clap2_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 94.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec9[1] };
			let mut fTemp7: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec11[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 80.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp10: F32 = self.fRec7[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 71.5 - fSlow8) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec12[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 56.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec13[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec13[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec13[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec13[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec13[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec13[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec13[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec7[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec7[0] + fTemp7 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec9[0] } } } else { if (((self.fRec13[0] < fTemp16) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec12[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec12[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp23) as usize] };
			let mut fTemp25: F32 = F32::max(0.0, F32::min(127.0, fSlow11 + fTemp4));
			let mut fTemp26: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp25) * (fTemp25 + 28.0);
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp26 + 4064.0 } else { self.fRec15[1] };
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp26 + 3456.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = self.fRec16[0] - self.fRec15[0];
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec17[1] };
			let mut fTemp28: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp27) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 50.5) as i32)) as usize] } * if (((fTemp27 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp26 } else { self.fRec18[1] };
			let mut fTemp29: F32 = F32::max(5076.0, self.fRec18[0]);
			let mut fTemp30: F32 = self.fRec15[0] - fTemp29;
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp30) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 83.5) as i32)) as usize] } * if (((fTemp30 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp29)) + 2.0) } else { 0.96 }))));
			let mut fTemp32: F32 = fTemp31 + fTemp28;
			let mut fTemp33: F32 = self.fRec18[0] - self.fRec16[0];
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 42.5) as i32)) as usize] } * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec16[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp32 + fTemp34;
			self.fRec19[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp35, self.fRec19[1] + 1.0) };
			let mut iTemp36: i32 = ((self.fRec19[0] < fTemp32) as i32);
			let mut fTemp37: F32 = (self.fRec19[0] - fTemp32) / fTemp34;
			let mut iTemp38: i32 = ((self.fRec19[0] < fTemp31) as i32);
			let mut fTemp39: F32 = (self.fRec19[0] - fTemp31) / fTemp28;
			let mut fTemp40: F32 = self.fRec19[0] / fTemp31;
			let mut fTemp41: F32 = if (iTemp36 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp29 } else { if (iTemp38 as i32 != 0) { fTemp29 + fTemp30 * if (((self.fRec15[0] > fTemp29) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec15[0] } } } else { if (iTemp36 as i32 != 0) { self.fRec15[0] + fTemp27 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec16[0] } } } else { if (((self.fRec19[0] < fTemp35) as i32) as i32 != 0) { self.fRec16[0] + fTemp33 * if (((self.fRec18[0] > self.fRec16[0]) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec18[0] } };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 9e+01));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4064.0 } else { self.fRec20[1] };
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3744.0 } else { self.fRec21[1] };
			let mut fTemp46: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 78.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec22[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp49: F32 = self.fRec20[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 96.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 60.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec23[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec23[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec23[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec23[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec23[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec23[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec23[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec20[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec20[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec20[0] + fTemp46 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec21[0] } } } else { if (((self.fRec23[0] < fTemp54) as i32) as i32 != 0) { self.fRec21[0] + fTemp52 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec22[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst1 } else { self.iRec26[1] };
			let mut fTemp64: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iTemp65) as usize] };
			let mut fTemp67: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + fSlow18 * fSlow17 * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) };
			self.fRec24[0] = fTemp67 - F32::floor(fTemp67);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { 7904.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 39.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 99.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 0.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp83) as usize] };
			let mut fTemp85: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec32[1] + self.fConst4 };
			self.fRec32[0] = fTemp85 - F32::floor(fTemp85);
			self.fRec27[0] = 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec32[0] + 24.347826 * self.fRec27[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84));
			let mut fTemp86: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fConst7 + self.fRec33[1] };
			self.fRec33[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst9 };
			self.fRec34[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = fSlow19 * (0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec34[0] + 2.0 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec33[0] + 17.391304 * (self.fRec27[0] + 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * self.fRec24[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24)) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp88;
			let mut fTemp89: F32 = self.fRec1[1] + fSlow3 * fTemp88 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp89;
			let mut fTemp90: F32 = self.fRec2[1] + fSlow3 * fTemp89 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp90;
			let mut fTemp91: F32 = self.fRec3[1] + fSlow3 * fTemp90 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp91;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp91;
			self.fRec0[0] = self.fConst15 * self.fRec5[1] - self.fConst14 * (self.fConst12 * self.fRec0[1] - self.fConst11 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Clap2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Clap2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Clap2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = 0.11 * self.fHslider2;
		let mut fSlow9: F32 = self.fHslider3;
		let mut fSlow10: F32 = fSlow9 + -73.0;
		let mut fSlow11: F32 = F32::min(99.0, 2.5656567 * F32::max(0.0, F32::abs(fSlow10)) + (99.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow10))));
		let mut fSlow12: F32 = 0.42857143 * (0.33333334 * fSlow9 + 1.0);
		let mut fSlow13: F32 = F32::powf(2.0, 0.083333336 * (fSlow9 + -69.0));
		let mut fSlow14: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow13, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow15: i32 = ((fSlow14) as i32);
		let mut fSlow16: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iSlow15) as usize] };
		let mut fSlow17: F32 = fSlow16 + (fSlow14 - ((iSlow15) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iSlow15, 1)) as usize] } - fSlow16);
		let mut fSlow18: F32 = self.fConst2 * fSlow13;
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Clap2_faustpower4_f(fSlow1) * fSlow4 / DSP_Clap2_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider4;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider5 + 3.0));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider6 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Clap2_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 94.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec9[1] };
			let mut fTemp7: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec11[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 80.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp10: F32 = self.fRec7[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 71.5 - fSlow8) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec12[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 56.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec13[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec13[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec13[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec13[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec13[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec13[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec13[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec7[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec7[0] + fTemp7 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec9[0] } } } else { if (((self.fRec13[0] < fTemp16) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec12[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec12[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp23) as usize] };
			let mut fTemp25: F32 = F32::max(0.0, F32::min(127.0, fSlow11 + fTemp4));
			let mut fTemp26: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp25) * (fTemp25 + 28.0);
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp26 + 4064.0 } else { self.fRec15[1] };
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp26 + 3456.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = self.fRec16[0] - self.fRec15[0];
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec17[1] };
			let mut fTemp28: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp27) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 50.5) as i32)) as usize] } * if (((fTemp27 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp26 } else { self.fRec18[1] };
			let mut fTemp29: F32 = F32::max(5076.0, self.fRec18[0]);
			let mut fTemp30: F32 = self.fRec15[0] - fTemp29;
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp30) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 83.5) as i32)) as usize] } * if (((fTemp30 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp29)) + 2.0) } else { 0.96 }))));
			let mut fTemp32: F32 = fTemp31 + fTemp28;
			let mut fTemp33: F32 = self.fRec18[0] - self.fRec16[0];
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec17[0] + 42.5) as i32)) as usize] } * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec16[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp32 + fTemp34;
			self.fRec19[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp35, self.fRec19[1] + 1.0) };
			let mut iTemp36: i32 = ((self.fRec19[0] < fTemp32) as i32);
			let mut fTemp37: F32 = (self.fRec19[0] - fTemp32) / fTemp34;
			let mut iTemp38: i32 = ((self.fRec19[0] < fTemp31) as i32);
			let mut fTemp39: F32 = (self.fRec19[0] - fTemp31) / fTemp28;
			let mut fTemp40: F32 = self.fRec19[0] / fTemp31;
			let mut fTemp41: F32 = if (iTemp36 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp29 } else { if (iTemp38 as i32 != 0) { fTemp29 + fTemp30 * if (((self.fRec15[0] > fTemp29) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec15[0] } } } else { if (iTemp36 as i32 != 0) { self.fRec15[0] + fTemp27 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec16[0] } } } else { if (((self.fRec19[0] < fTemp35) as i32) as i32 != 0) { self.fRec16[0] + fTemp33 * if (((self.fRec18[0] > self.fRec16[0]) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec18[0] } };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 9e+01));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4064.0 } else { self.fRec20[1] };
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3744.0 } else { self.fRec21[1] };
			let mut fTemp46: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 78.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec22[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp49: F32 = self.fRec20[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 96.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 60.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec23[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec23[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec23[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec23[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec23[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec23[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec23[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec20[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec20[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec20[0] + fTemp46 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec21[0] } } } else { if (((self.fRec23[0] < fTemp54) as i32) as i32 != 0) { self.fRec21[0] + fTemp52 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec22[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst1 } else { self.iRec26[1] };
			let mut fTemp64: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl3DSP_Clap2SIG3[(iTemp65) as usize] };
			let mut fTemp67: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + fSlow18 * fSlow17 * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl3DSP_Clap2SIG3[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) };
			self.fRec24[0] = fTemp67 - F32::floor(fTemp67);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { 7904.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 39.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 99.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_Clap2SIG1[(((self.fRec11[0] + 0.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_Clap2SIG0[(iTemp83) as usize] };
			let mut fTemp85: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec32[1] + self.fConst4 };
			self.fRec32[0] = fTemp85 - F32::floor(fTemp85);
			self.fRec27[0] = 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec32[0] + 24.347826 * self.fRec27[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84));
			let mut fTemp86: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fConst7 + self.fRec33[1] };
			self.fRec33[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst9 };
			self.fRec34[0] = fTemp87 - F32::floor(fTemp87);
			let mut fTemp88: F32 = fSlow19 * (0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec34[0] + 2.0 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * (self.fRec33[0] + 17.391304 * (self.fRec27[0] + 0.115 * unsafe { ftbl2DSP_Clap2SIG2[(((1024.0 * self.fRec24[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Clap2SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24)) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp88;
			let mut fTemp89: F32 = self.fRec1[1] + fSlow3 * fTemp88 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp89;
			let mut fTemp90: F32 = self.fRec2[1] + fSlow3 * fTemp89 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp90;
			let mut fTemp91: F32 = self.fRec3[1] + fSlow3 * fTemp90 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp91;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp91;
			self.fRec0[0] = self.fConst15 * self.fRec5[1] - self.fConst14 * (self.fConst12 * self.fRec0[1] - self.fConst11 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
