// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Cymbal3 -pn processCymbal3 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Cymbal3SIG0 {
	iRec7: [i32;2],
}

impl DSP_Cymbal3SIG0 {
	
	fn get_num_inputsDSP_Cymbal3SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cymbal3SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cymbal3SIG0(&mut self, sample_rate: i32) {
		for l3 in 0..2 {
			self.iRec7[(l3) as usize] = 0;
		}
	}
	
	fn fillDSP_Cymbal3SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec7[0] = i32::wrapping_add(self.iRec7[1], 1);
			let mut fTemp1: F32 = ((i32::wrapping_add(self.iRec7[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp1))))) * (((((7.2e+03 - fTemp1) < 3824.0) as i32)) as F32);
			self.iRec7[1] = self.iRec7[0];
		}
	}

}


pub fn newDSP_Cymbal3SIG0() -> DSP_Cymbal3SIG0 { 
	DSP_Cymbal3SIG0 {
		iRec7: [0;2],
	}
}

pub struct DSP_Cymbal3SIG1 {
	iRec12: [i32;2],
}

impl DSP_Cymbal3SIG1 {
	
	fn get_num_inputsDSP_Cymbal3SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cymbal3SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cymbal3SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec12[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Cymbal3SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec12[0] = i32::wrapping_add(self.iRec12[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec12[0], -1)) as F32));
			self.iRec12[1] = self.iRec12[0];
		}
	}

}


pub fn newDSP_Cymbal3SIG1() -> DSP_Cymbal3SIG1 { 
	DSP_Cymbal3SIG1 {
		iRec12: [0;2],
	}
}

pub struct DSP_Cymbal3SIG2 {
	iVec3: [i32;2],
	iRec15: [i32;2],
}

impl DSP_Cymbal3SIG2 {
	
	fn get_num_inputsDSP_Cymbal3SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cymbal3SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cymbal3SIG2(&mut self, sample_rate: i32) {
		for l12 in 0..2 {
			self.iVec3[(l12) as usize] = 0;
		}
		for l13 in 0..2 {
			self.iRec15[(l13) as usize] = 0;
		}
	}
	
	fn fillDSP_Cymbal3SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec15[0] = (i32::wrapping_add(self.iVec3[1], self.iRec15[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec15[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec15[1] = self.iRec15[0];
		}
	}

}


pub fn newDSP_Cymbal3SIG2() -> DSP_Cymbal3SIG2 { 
	DSP_Cymbal3SIG2 {
		iVec3: [0;2],
		iRec15: [0;2],
	}
}

pub struct DSP_Cymbal3SIG3 {
	iRec28: [i32;2],
}

impl DSP_Cymbal3SIG3 {
	
	fn get_num_inputsDSP_Cymbal3SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cymbal3SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cymbal3SIG3(&mut self, sample_rate: i32) {
		for l24 in 0..2 {
			self.iRec28[(l24) as usize] = 0;
		}
	}
	
	fn fillDSP_Cymbal3SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec28[0] = i32::wrapping_add(self.iRec28[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec28[0], -1)) as F32) + -128.0));
			self.iRec28[1] = self.iRec28[0];
		}
	}

}


pub fn newDSP_Cymbal3SIG3() -> DSP_Cymbal3SIG3 { 
	DSP_Cymbal3SIG3 {
		iRec28: [0;2],
	}
}
static mut ftbl0DSP_Cymbal3SIG0: [F32;16384] = [0.0;16384];
static mut ftbl1DSP_Cymbal3SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Cymbal3SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Cymbal3SIG3: [F32;4096] = [0.0;4096];
fn DSP_Cymbal3_faustpower4_f(value: F32) -> F32 {
	return value * value * value * value;
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Cymbal3 {
	fEntry0: F32,
	fVec0: [F32;2],
	iVec1: [i32;2],
	iRec1: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst1: F32,
	fHslider0: F32,
	fButton0: F32,
	fVec2: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec13: [F32;2],
	fHslider1: F32,
	fConst2: F32,
	fRec14: [F32;2],
	fRec9: [F32;2],
	fRec8: [F32;2],
	fRec18: [F32;2],
	fRec19: [F32;2],
	fConst3: F32,
	fRec20: [F32;2],
	fRec17: [F32;2],
	fRec16: [F32;2],
	fRec24: [F32;2],
	fRec25: [F32;2],
	fRec26: [F32;2],
	fRec23: [F32;2],
	fRec22: [F32;2],
	fConst6: F32,
	fRec27: [F32;2],
	fRec21: [F32;2],
	fConst9: F32,
	fRec29: [F32;2],
	fRec32: [F32;2],
	fRec33: [F32;2],
	fRec35: [F32;2],
	fRec34: [F32;2],
	fRec31: [F32;2],
	fRec30: [F32;2],
	fConst11: F32,
	fRec36: [F32;2],
	fConst13: F32,
	fRec37: [F32;2],
	fRec2: [F32;2],
	fRec3: [F32;2],
	fRec4: [F32;2],
	fRec5: [F32;2],
	fVec4: [F32;2],
	fConst15: F32,
	fConst16: F32,
	fConst18: F32,
	fConst19: F32,
	fRec0: [F32;2],
	fHslider2: F32,
	fHslider3: F32,
	fHslider4: F32,
}

impl FaustDsp for DSP_Cymbal3 {
	type T = F32;
		
	fn new() -> DSP_Cymbal3 { 
		DSP_Cymbal3 {
			fEntry0: 0.0,
			fVec0: [0.0;2],
			iVec1: [0;2],
			iRec1: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst1: 0.0,
			fHslider0: 0.0,
			fButton0: 0.0,
			fVec2: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec13: [0.0;2],
			fHslider1: 0.0,
			fConst2: 0.0,
			fRec14: [0.0;2],
			fRec9: [0.0;2],
			fRec8: [0.0;2],
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fConst3: 0.0,
			fRec20: [0.0;2],
			fRec17: [0.0;2],
			fRec16: [0.0;2],
			fRec24: [0.0;2],
			fRec25: [0.0;2],
			fRec26: [0.0;2],
			fRec23: [0.0;2],
			fRec22: [0.0;2],
			fConst6: 0.0,
			fRec27: [0.0;2],
			fRec21: [0.0;2],
			fConst9: 0.0,
			fRec29: [0.0;2],
			fRec32: [0.0;2],
			fRec33: [0.0;2],
			fRec35: [0.0;2],
			fRec34: [0.0;2],
			fRec31: [0.0;2],
			fRec30: [0.0;2],
			fConst11: 0.0,
			fRec36: [0.0;2],
			fConst13: 0.0,
			fRec37: [0.0;2],
			fRec2: [0.0;2],
			fRec3: [0.0;2],
			fRec4: [0.0;2],
			fRec5: [0.0;2],
			fVec4: [0.0;2],
			fConst15: 0.0,
			fConst16: 0.0,
			fConst18: 0.0,
			fConst19: 0.0,
			fRec0: [0.0;2],
			fHslider2: 0.0,
			fHslider3: 0.0,
			fHslider4: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Cymbal3 -pn processCymbal3 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("envelopes.lib/ar:author", "Yann Orlarey, Stéphane Letz");
		m.declare("envelopes.lib/author", "GRAME");
		m.declare("envelopes.lib/copyright", "GRAME");
		m.declare("envelopes.lib/license", "LGPL with exception");
		m.declare("envelopes.lib/name", "Faust Envelope Library");
		m.declare("envelopes.lib/version", "1.2.0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
		m.declare("vaeffects.lib/moogLadder:author", "Dario Sanfilippo");
		m.declare("vaeffects.lib/moogLadder:license", "MIT-style STK-4.3 license");
		m.declare("vaeffects.lib/name", "Faust Virtual Analog Filter Effect Library");
		m.declare("vaeffects.lib/version", "1.2.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Cymbal3SIG0 = newDSP_Cymbal3SIG0();
		sig0.instance_initDSP_Cymbal3SIG0(sample_rate);
		sig0.fillDSP_Cymbal3SIG0(16384, unsafe { &mut ftbl0DSP_Cymbal3SIG0 });
		let mut sig1: DSP_Cymbal3SIG1 = newDSP_Cymbal3SIG1();
		sig1.instance_initDSP_Cymbal3SIG1(sample_rate);
		sig1.fillDSP_Cymbal3SIG1(144, unsafe { &mut ftbl1DSP_Cymbal3SIG1 });
		let mut sig2: DSP_Cymbal3SIG2 = newDSP_Cymbal3SIG2();
		sig2.instance_initDSP_Cymbal3SIG2(sample_rate);
		sig2.fillDSP_Cymbal3SIG2(1024, unsafe { &mut ftbl2DSP_Cymbal3SIG2 });
		let mut sig3: DSP_Cymbal3SIG3 = newDSP_Cymbal3SIG3();
		sig3.instance_initDSP_Cymbal3SIG3(sample_rate);
		sig3.fillDSP_Cymbal3SIG3(4096, unsafe { &mut ftbl3DSP_Cymbal3SIG3 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 9e+01;
		self.fButton0 = 0.0;
		self.fHslider1 = 5e+01;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.fVec0[(l0) as usize] = 0.0;
		}
		for l1 in 0..2 {
			self.iVec1[(l1) as usize] = 0;
		}
		for l2 in 0..2 {
			self.iRec1[(l2) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fVec2[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec10[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec11[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec13[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec14[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec9[(l10) as usize] = 0.0;
		}
		for l11 in 0..2 {
			self.fRec8[(l11) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec18[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec19[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec20[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec17[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec16[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec24[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec25[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec26[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec23[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec22[(l23) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec27[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec21[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec29[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec32[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec33[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec35[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec34[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec31[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec30[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec36[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec37[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec2[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec3[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec4[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec5[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fVec4[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec0[(l41) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		self.fConst1 = 1.0 / F32::max(1.0, 0.02 * self.fConst0);
		self.fConst2 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst3 = 2.0 * self.fConst2;
		let mut fConst4: F32 = unsafe { ftbl3DSP_Cymbal3SIG3[2576] };
		let mut fConst5: F32 = 1e+03 / self.fConst0;
		self.fConst6 = fConst5 * (fConst4 + 0.7381199 * (unsafe { ftbl3DSP_Cymbal3SIG3[2577] } - fConst4));
		let mut fConst7: F32 = unsafe { ftbl3DSP_Cymbal3SIG3[2602] };
		let mut fConst8: F32 = 1e+02 / self.fConst0;
		self.fConst9 = fConst8 * (fConst7 + 0.24357149 * (unsafe { ftbl3DSP_Cymbal3SIG3[2603] } - fConst7));
		let mut fConst10: F32 = unsafe { ftbl3DSP_Cymbal3SIG3[2085] };
		self.fConst11 = fConst8 * (fConst10 + 0.75817734 * (unsafe { ftbl3DSP_Cymbal3SIG3[2086] } - fConst10));
		let mut fConst12: F32 = unsafe { ftbl3DSP_Cymbal3SIG3[2570] };
		self.fConst13 = fConst5 * (fConst12 + 0.36175704 * (unsafe { ftbl3DSP_Cymbal3SIG3[2571] } - fConst12));
		let mut fConst14: F32 = F32::tan(62.831852 / self.fConst0);
		self.fConst15 = 1.0 / fConst14;
		self.fConst16 = 1.0 - self.fConst15;
		let mut fConst17: F32 = self.fConst15 + 1.0;
		self.fConst18 = 1.0 / fConst17;
		self.fConst19 = 0.0 - 1.0 / (fConst14 * fConst17);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Cymbal3::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Choke", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "5", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Decay");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Decay", ParamIndex(3), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "7", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Tone");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Tone", ParamIndex(4), 9e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(5)), "8", "");
		ui_interface.declare(Some(ParamIndex(5)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(5)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(5), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_button("gate", ParamIndex(6));
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			6 => Some(self.fButton0),
			0 => Some(self.fEntry0),
			4 => Some(self.fHslider0),
			3 => Some(self.fHslider1),
			2 => Some(self.fHslider2),
			1 => Some(self.fHslider3),
			5 => Some(self.fHslider4),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			6 => { self.fButton0 = value }
			0 => { self.fEntry0 = value }
			4 => { self.fHslider0 = value }
			3 => { self.fHslider1 = value }
			2 => { self.fHslider2 = value }
			1 => { self.fHslider3 = value }
			5 => { self.fHslider4 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fButton0;
		let mut iSlow8: i32 = ((fSlow7 > 0.0) as i32);
		let mut iSlow9: i32 = ((iSlow8 > 0) as i32);
		let mut fSlow10: F32 = 0.2 * self.fHslider1;
		let mut iSlow11: i32 = (((((fSlow7 == 0.0) as i32)) > 0) as i32);
		let mut fSlow12: F32 = ((iSlow8) as F32);
		let mut fSlow13: F32 = 1.0 / (0.16465649 * (DSP_Cymbal3_faustpower4_f(fSlow2) * fSlow5 / DSP_Cymbal3_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow14: F32 = 2.0 * fSlow4;
		let mut fSlow15: F32 = 0.01 * self.fHslider2;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + 6.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider4 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = i32::wrapping_sub(1, ((fSlow7 > self.fVec2[1]) as i32));
			self.fRec10[0] = if (iTemp2 as i32 != 0) { 7.84e+03 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp2 as i32 != 0) { 3776.0 } else { self.fRec11[1] };
			let mut fTemp3: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec13[0] = if (iTemp2 as i32 != 0) { 0.0 } else { self.fRec13[1] };
			let mut fTemp4: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 99.5) as i32)) as usize] };
			let mut fTemp5: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp3) / (fTemp4 * if (((fTemp3 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp6: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp7: F32 = self.fRec10[0] - fTemp6;
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 50.5 - fSlow10) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp6)) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = fTemp8 + fTemp5;
			self.fRec14[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst2 + fTemp9, self.fRec14[1] + 1.0) };
			let mut iTemp10: i32 = ((self.fRec14[0] < fTemp9) as i32);
			let mut iTemp11: i32 = ((self.fRec14[0] < fTemp8) as i32);
			let mut fTemp12: F32 = (self.fRec14[0] - fTemp8) / fTemp5;
			let mut fTemp13: F32 = self.fRec14[0] / fTemp8;
			self.fRec9[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp10 as i32 != 0) { if (iTemp11 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp6 } else { if (iTemp11 as i32 != 0) { fTemp6 + fTemp7 * if (((self.fRec10[0] > fTemp6) as i32) as i32 != 0) { F32::powf(fTemp13, 0.33333334) } else { fTemp13 } } else { self.fRec10[0] } } } else { if (iTemp10 as i32 != 0) { self.fRec10[0] + fTemp3 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp12, 0.33333334) } else { fTemp12 } } else { self.fRec11[0] } } } else { self.fRec11[0] } } else { self.fRec9[1] };
			let mut fTemp14: F32 = self.fRec11[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (fTemp4 * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			self.fRec8[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp15, self.fRec8[1] + 1.0) };
			let mut fTemp16: F32 = self.fRec8[0] / fTemp15;
			let mut fTemp17: F32 = if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { self.fRec9[0] } else { if (((self.fRec8[0] < fTemp15) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec11[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp16, 0.33333334) } else { fTemp16 } } else { self.fRec11[0] } };
			let mut iTemp18: i32 = ((fTemp17) as i32);
			let mut fTemp19: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp18) as usize] };
			self.fRec18[0] = if (iTemp2 as i32 != 0) { 3648.0 } else { self.fRec18[1] };
			let mut fTemp20: F32 = F32::max(5076.0, self.fRec18[0]);
			self.fRec19[0] = if (iTemp2 as i32 != 0) { 7712.0 } else { self.fRec19[1] };
			let mut fTemp21: F32 = self.fRec19[0] - fTemp20;
			let mut fTemp22: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp21) / (fTemp4 * if (((fTemp21 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp20)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp22, self.fRec20[1] + 1.0) };
			let mut iTemp23: i32 = ((self.fRec20[0] < fTemp22) as i32);
			let mut fTemp24: F32 = self.fRec20[0] / fTemp22;
			self.fRec17[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec20[0] < (self.fConst2 + fTemp22)) as i32) as i32 != 0) { if (iTemp23 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp20 } else { if (iTemp23 as i32 != 0) { fTemp20 + fTemp21 * if (((self.fRec19[0] > fTemp20) as i32) as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] } } else { self.fRec17[1] };
			let mut fTemp25: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp26: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 0.5) as i32)) as usize] };
			let mut fTemp27: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (fTemp26 * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp27, self.fRec16[1] + 1.0) };
			let mut fTemp28: F32 = self.fRec16[0] / fTemp27;
			let mut fTemp29: F32 = if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { self.fRec17[0] } else { if (((self.fRec16[0] < fTemp27) as i32) as i32 != 0) { self.fRec17[0] + fTemp25 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp28, 0.33333334) } else { fTemp28 } } else { self.fRec18[0] } };
			let mut iTemp30: i32 = ((fTemp29) as i32);
			let mut fTemp31: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp30) as usize] };
			self.fRec24[0] = if (iTemp2 as i32 != 0) { 3712.0 } else { self.fRec24[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec24[0]);
			self.fRec25[0] = if (iTemp2 as i32 != 0) { 7776.0 } else { self.fRec25[1] };
			let mut fTemp33: F32 = self.fRec25[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp4 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			self.fRec26[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp34, self.fRec26[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec26[0] < fTemp34) as i32);
			let mut fTemp36: F32 = self.fRec26[0] / fTemp34;
			self.fRec23[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec26[0] < (self.fConst2 + fTemp34)) as i32) as i32 != 0) { if (iTemp35 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp35 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec25[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec25[0] } } } else { self.fRec25[0] } } else { self.fRec25[0] } } else { self.fRec23[1] };
			let mut fTemp37: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp37) / (fTemp26 * if (((fTemp37 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp38, self.fRec22[1] + 1.0) };
			let mut fTemp39: F32 = self.fRec22[0] / fTemp38;
			let mut fTemp40: F32 = if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { self.fRec23[0] } else { if (((self.fRec22[0] < fTemp38) as i32) as i32 != 0) { self.fRec23[0] + fTemp37 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec24[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp41) as usize] };
			let mut iTemp43: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp44: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst6 };
			self.fRec27[0] = fTemp44 - F32::floor(fTemp44);
			self.fRec21[0] = 0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec27[0] + 24.347826 * self.fRec21[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42));
			let mut fTemp45: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst9 };
			self.fRec29[0] = fTemp45 - F32::floor(fTemp45);
			self.fRec32[0] = if (iTemp2 as i32 != 0) { 5984.0 } else { self.fRec32[1] };
			self.fRec33[0] = if (iTemp2 as i32 != 0) { 8128.0 } else { self.fRec33[1] };
			let mut fTemp46: F32 = self.fRec33[0] - self.fRec32[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (fTemp4 * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec32[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec33[0]);
			let mut fTemp49: F32 = self.fRec32[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (fTemp4 * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			self.fRec35[0] = if (iTemp2 as i32 != 0) { 6.88e+03 } else { self.fRec35[1] };
			let mut fTemp52: F32 = self.fRec35[0] - self.fRec33[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 62.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec34[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec34[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec34[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec34[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec34[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec34[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec34[0] / fTemp50;
			self.fRec31[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec32[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec32[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec32[0] + fTemp46 * if (((self.fRec33[0] > self.fRec32[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec33[0] } } } else { if (((self.fRec34[0] < fTemp54) as i32) as i32 != 0) { self.fRec33[0] + fTemp52 * if (((self.fRec35[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec35[0] } } } else { self.fRec31[1] };
			let mut fTemp60: F32 = self.fRec33[0] - self.fRec31[0];
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp26 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec30[1] + 1.0) };
			let mut fTemp62: F32 = self.fRec30[0] / fTemp61;
			let mut fTemp63: F32 = if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { self.fRec31[0] } else { if (((self.fRec30[0] < fTemp61) as i32) as i32 != 0) { self.fRec31[0] + fTemp60 * if (((self.fRec33[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec33[0] } };
			let mut iTemp64: i32 = ((fTemp63) as i32);
			let mut fTemp65: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp64) as usize] };
			let mut fTemp66: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst11 };
			self.fRec36[0] = fTemp66 - F32::floor(fTemp66);
			let mut fTemp67: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst13 };
			self.fRec37[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow13 * (0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec37[0] + 2.0 * (unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * self.fRec36[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp65 + (fTemp63 - ((iTemp64) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp64, 1)) as usize] } - fTemp65)) + unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * self.fRec21[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp31 + (fTemp29 - ((iTemp30) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp30, 1)) as usize] } - fTemp31))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp19 + (fTemp17 - ((iTemp18) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp18, 1)) as usize] } - fTemp19)) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow14 * fTemp68;
			let mut fTemp69: F32 = self.fRec2[1] + fSlow4 * fTemp68 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow14 * fTemp69;
			let mut fTemp70: F32 = self.fRec3[1] + fSlow4 * fTemp69 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow14 * fTemp70;
			let mut fTemp71: F32 = self.fRec4[1] + fSlow4 * fTemp70 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow14 * fTemp71;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp71;
			let mut fTemp72: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec4[0] = fTemp72;
			self.fRec0[0] = self.fConst19 * self.fVec4[1] - self.fConst18 * (self.fConst16 * self.fRec0[1] - self.fConst15 * fTemp72);
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Cymbal3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Cymbal3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cymbal3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fButton0;
		let mut iSlow8: i32 = ((fSlow7 > 0.0) as i32);
		let mut iSlow9: i32 = ((iSlow8 > 0) as i32);
		let mut fSlow10: F32 = 0.2 * self.fHslider1;
		let mut iSlow11: i32 = (((((fSlow7 == 0.0) as i32)) > 0) as i32);
		let mut fSlow12: F32 = ((iSlow8) as F32);
		let mut fSlow13: F32 = 1.0 / (0.16465649 * (DSP_Cymbal3_faustpower4_f(fSlow2) * fSlow5 / DSP_Cymbal3_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow14: F32 = 2.0 * fSlow4;
		let mut fSlow15: F32 = 0.01 * self.fHslider2;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + 6.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider4 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = i32::wrapping_sub(1, ((fSlow7 > self.fVec2[1]) as i32));
			self.fRec10[0] = if (iTemp2 as i32 != 0) { 7.84e+03 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp2 as i32 != 0) { 3776.0 } else { self.fRec11[1] };
			let mut fTemp3: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec13[0] = if (iTemp2 as i32 != 0) { 0.0 } else { self.fRec13[1] };
			let mut fTemp4: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 99.5) as i32)) as usize] };
			let mut fTemp5: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp3) / (fTemp4 * if (((fTemp3 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp6: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp7: F32 = self.fRec10[0] - fTemp6;
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 50.5 - fSlow10) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp6)) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = fTemp8 + fTemp5;
			self.fRec14[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst2 + fTemp9, self.fRec14[1] + 1.0) };
			let mut iTemp10: i32 = ((self.fRec14[0] < fTemp9) as i32);
			let mut iTemp11: i32 = ((self.fRec14[0] < fTemp8) as i32);
			let mut fTemp12: F32 = (self.fRec14[0] - fTemp8) / fTemp5;
			let mut fTemp13: F32 = self.fRec14[0] / fTemp8;
			self.fRec9[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp10 as i32 != 0) { if (iTemp11 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp6 } else { if (iTemp11 as i32 != 0) { fTemp6 + fTemp7 * if (((self.fRec10[0] > fTemp6) as i32) as i32 != 0) { F32::powf(fTemp13, 0.33333334) } else { fTemp13 } } else { self.fRec10[0] } } } else { if (iTemp10 as i32 != 0) { self.fRec10[0] + fTemp3 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp12, 0.33333334) } else { fTemp12 } } else { self.fRec11[0] } } } else { self.fRec11[0] } } else { self.fRec9[1] };
			let mut fTemp14: F32 = self.fRec11[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (fTemp4 * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			self.fRec8[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp15, self.fRec8[1] + 1.0) };
			let mut fTemp16: F32 = self.fRec8[0] / fTemp15;
			let mut fTemp17: F32 = if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { self.fRec9[0] } else { if (((self.fRec8[0] < fTemp15) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec11[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp16, 0.33333334) } else { fTemp16 } } else { self.fRec11[0] } };
			let mut iTemp18: i32 = ((fTemp17) as i32);
			let mut fTemp19: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp18) as usize] };
			self.fRec18[0] = if (iTemp2 as i32 != 0) { 3648.0 } else { self.fRec18[1] };
			let mut fTemp20: F32 = F32::max(5076.0, self.fRec18[0]);
			self.fRec19[0] = if (iTemp2 as i32 != 0) { 7712.0 } else { self.fRec19[1] };
			let mut fTemp21: F32 = self.fRec19[0] - fTemp20;
			let mut fTemp22: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp21) / (fTemp4 * if (((fTemp21 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp20)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp22, self.fRec20[1] + 1.0) };
			let mut iTemp23: i32 = ((self.fRec20[0] < fTemp22) as i32);
			let mut fTemp24: F32 = self.fRec20[0] / fTemp22;
			self.fRec17[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec20[0] < (self.fConst2 + fTemp22)) as i32) as i32 != 0) { if (iTemp23 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp20 } else { if (iTemp23 as i32 != 0) { fTemp20 + fTemp21 * if (((self.fRec19[0] > fTemp20) as i32) as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] } } else { self.fRec17[1] };
			let mut fTemp25: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp26: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 0.5) as i32)) as usize] };
			let mut fTemp27: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (fTemp26 * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp27, self.fRec16[1] + 1.0) };
			let mut fTemp28: F32 = self.fRec16[0] / fTemp27;
			let mut fTemp29: F32 = if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { self.fRec17[0] } else { if (((self.fRec16[0] < fTemp27) as i32) as i32 != 0) { self.fRec17[0] + fTemp25 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp28, 0.33333334) } else { fTemp28 } } else { self.fRec18[0] } };
			let mut iTemp30: i32 = ((fTemp29) as i32);
			let mut fTemp31: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp30) as usize] };
			self.fRec24[0] = if (iTemp2 as i32 != 0) { 3712.0 } else { self.fRec24[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec24[0]);
			self.fRec25[0] = if (iTemp2 as i32 != 0) { 7776.0 } else { self.fRec25[1] };
			let mut fTemp33: F32 = self.fRec25[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp4 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			self.fRec26[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp34, self.fRec26[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec26[0] < fTemp34) as i32);
			let mut fTemp36: F32 = self.fRec26[0] / fTemp34;
			self.fRec23[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec26[0] < (self.fConst2 + fTemp34)) as i32) as i32 != 0) { if (iTemp35 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp35 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec25[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec25[0] } } } else { self.fRec25[0] } } else { self.fRec25[0] } } else { self.fRec23[1] };
			let mut fTemp37: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp37) / (fTemp26 * if (((fTemp37 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp38, self.fRec22[1] + 1.0) };
			let mut fTemp39: F32 = self.fRec22[0] / fTemp38;
			let mut fTemp40: F32 = if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { self.fRec23[0] } else { if (((self.fRec22[0] < fTemp38) as i32) as i32 != 0) { self.fRec23[0] + fTemp37 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec24[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp41) as usize] };
			let mut iTemp43: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp44: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst6 };
			self.fRec27[0] = fTemp44 - F32::floor(fTemp44);
			self.fRec21[0] = 0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec27[0] + 24.347826 * self.fRec21[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42));
			let mut fTemp45: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst9 };
			self.fRec29[0] = fTemp45 - F32::floor(fTemp45);
			self.fRec32[0] = if (iTemp2 as i32 != 0) { 5984.0 } else { self.fRec32[1] };
			self.fRec33[0] = if (iTemp2 as i32 != 0) { 8128.0 } else { self.fRec33[1] };
			let mut fTemp46: F32 = self.fRec33[0] - self.fRec32[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (fTemp4 * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec32[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec33[0]);
			let mut fTemp49: F32 = self.fRec32[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (fTemp4 * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			self.fRec35[0] = if (iTemp2 as i32 != 0) { 6.88e+03 } else { self.fRec35[1] };
			let mut fTemp52: F32 = self.fRec35[0] - self.fRec33[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 62.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec34[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec34[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec34[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec34[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec34[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec34[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec34[0] / fTemp50;
			self.fRec31[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec32[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec32[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec32[0] + fTemp46 * if (((self.fRec33[0] > self.fRec32[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec33[0] } } } else { if (((self.fRec34[0] < fTemp54) as i32) as i32 != 0) { self.fRec33[0] + fTemp52 * if (((self.fRec35[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec35[0] } } } else { self.fRec31[1] };
			let mut fTemp60: F32 = self.fRec33[0] - self.fRec31[0];
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp26 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec30[1] + 1.0) };
			let mut fTemp62: F32 = self.fRec30[0] / fTemp61;
			let mut fTemp63: F32 = if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { self.fRec31[0] } else { if (((self.fRec30[0] < fTemp61) as i32) as i32 != 0) { self.fRec31[0] + fTemp60 * if (((self.fRec33[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec33[0] } };
			let mut iTemp64: i32 = ((fTemp63) as i32);
			let mut fTemp65: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp64) as usize] };
			let mut fTemp66: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst11 };
			self.fRec36[0] = fTemp66 - F32::floor(fTemp66);
			let mut fTemp67: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst13 };
			self.fRec37[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow13 * (0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec37[0] + 2.0 * (unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * self.fRec36[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp65 + (fTemp63 - ((iTemp64) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp64, 1)) as usize] } - fTemp65)) + unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * self.fRec21[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp31 + (fTemp29 - ((iTemp30) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp30, 1)) as usize] } - fTemp31))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp19 + (fTemp17 - ((iTemp18) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp18, 1)) as usize] } - fTemp19)) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow14 * fTemp68;
			let mut fTemp69: F32 = self.fRec2[1] + fSlow4 * fTemp68 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow14 * fTemp69;
			let mut fTemp70: F32 = self.fRec3[1] + fSlow4 * fTemp69 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow14 * fTemp70;
			let mut fTemp71: F32 = self.fRec4[1] + fSlow4 * fTemp70 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow14 * fTemp71;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp71;
			let mut fTemp72: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec4[0] = fTemp72;
			self.fRec0[0] = self.fConst19 * self.fVec4[1] - self.fConst18 * (self.fConst16 * self.fRec0[1] - self.fConst15 * fTemp72);
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cymbal3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Cymbal3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cymbal3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fButton0;
		let mut iSlow8: i32 = ((fSlow7 > 0.0) as i32);
		let mut iSlow9: i32 = ((iSlow8 > 0) as i32);
		let mut fSlow10: F32 = 0.2 * self.fHslider1;
		let mut iSlow11: i32 = (((((fSlow7 == 0.0) as i32)) > 0) as i32);
		let mut fSlow12: F32 = ((iSlow8) as F32);
		let mut fSlow13: F32 = 1.0 / (0.16465649 * (DSP_Cymbal3_faustpower4_f(fSlow2) * fSlow5 / DSP_Cymbal3_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow14: F32 = 2.0 * fSlow4;
		let mut fSlow15: F32 = 0.01 * self.fHslider2;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + 6.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider4 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = i32::wrapping_sub(1, ((fSlow7 > self.fVec2[1]) as i32));
			self.fRec10[0] = if (iTemp2 as i32 != 0) { 7.84e+03 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp2 as i32 != 0) { 3776.0 } else { self.fRec11[1] };
			let mut fTemp3: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec13[0] = if (iTemp2 as i32 != 0) { 0.0 } else { self.fRec13[1] };
			let mut fTemp4: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 99.5) as i32)) as usize] };
			let mut fTemp5: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp3) / (fTemp4 * if (((fTemp3 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp6: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp7: F32 = self.fRec10[0] - fTemp6;
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 50.5 - fSlow10) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp6)) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = fTemp8 + fTemp5;
			self.fRec14[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst2 + fTemp9, self.fRec14[1] + 1.0) };
			let mut iTemp10: i32 = ((self.fRec14[0] < fTemp9) as i32);
			let mut iTemp11: i32 = ((self.fRec14[0] < fTemp8) as i32);
			let mut fTemp12: F32 = (self.fRec14[0] - fTemp8) / fTemp5;
			let mut fTemp13: F32 = self.fRec14[0] / fTemp8;
			self.fRec9[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp10 as i32 != 0) { if (iTemp11 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp6 } else { if (iTemp11 as i32 != 0) { fTemp6 + fTemp7 * if (((self.fRec10[0] > fTemp6) as i32) as i32 != 0) { F32::powf(fTemp13, 0.33333334) } else { fTemp13 } } else { self.fRec10[0] } } } else { if (iTemp10 as i32 != 0) { self.fRec10[0] + fTemp3 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp12, 0.33333334) } else { fTemp12 } } else { self.fRec11[0] } } } else { self.fRec11[0] } } else { self.fRec9[1] };
			let mut fTemp14: F32 = self.fRec11[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (fTemp4 * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			self.fRec8[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp15, self.fRec8[1] + 1.0) };
			let mut fTemp16: F32 = self.fRec8[0] / fTemp15;
			let mut fTemp17: F32 = if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { self.fRec9[0] } else { if (((self.fRec8[0] < fTemp15) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec11[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp16, 0.33333334) } else { fTemp16 } } else { self.fRec11[0] } };
			let mut iTemp18: i32 = ((fTemp17) as i32);
			let mut fTemp19: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp18) as usize] };
			self.fRec18[0] = if (iTemp2 as i32 != 0) { 3648.0 } else { self.fRec18[1] };
			let mut fTemp20: F32 = F32::max(5076.0, self.fRec18[0]);
			self.fRec19[0] = if (iTemp2 as i32 != 0) { 7712.0 } else { self.fRec19[1] };
			let mut fTemp21: F32 = self.fRec19[0] - fTemp20;
			let mut fTemp22: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp21) / (fTemp4 * if (((fTemp21 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp20)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp22, self.fRec20[1] + 1.0) };
			let mut iTemp23: i32 = ((self.fRec20[0] < fTemp22) as i32);
			let mut fTemp24: F32 = self.fRec20[0] / fTemp22;
			self.fRec17[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec20[0] < (self.fConst2 + fTemp22)) as i32) as i32 != 0) { if (iTemp23 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp20 } else { if (iTemp23 as i32 != 0) { fTemp20 + fTemp21 * if (((self.fRec19[0] > fTemp20) as i32) as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] } } else { self.fRec17[1] };
			let mut fTemp25: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp26: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 0.5) as i32)) as usize] };
			let mut fTemp27: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (fTemp26 * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp27, self.fRec16[1] + 1.0) };
			let mut fTemp28: F32 = self.fRec16[0] / fTemp27;
			let mut fTemp29: F32 = if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { self.fRec17[0] } else { if (((self.fRec16[0] < fTemp27) as i32) as i32 != 0) { self.fRec17[0] + fTemp25 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp28, 0.33333334) } else { fTemp28 } } else { self.fRec18[0] } };
			let mut iTemp30: i32 = ((fTemp29) as i32);
			let mut fTemp31: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp30) as usize] };
			self.fRec24[0] = if (iTemp2 as i32 != 0) { 3712.0 } else { self.fRec24[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec24[0]);
			self.fRec25[0] = if (iTemp2 as i32 != 0) { 7776.0 } else { self.fRec25[1] };
			let mut fTemp33: F32 = self.fRec25[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp4 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			self.fRec26[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp34, self.fRec26[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec26[0] < fTemp34) as i32);
			let mut fTemp36: F32 = self.fRec26[0] / fTemp34;
			self.fRec23[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec26[0] < (self.fConst2 + fTemp34)) as i32) as i32 != 0) { if (iTemp35 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp35 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec25[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec25[0] } } } else { self.fRec25[0] } } else { self.fRec25[0] } } else { self.fRec23[1] };
			let mut fTemp37: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp37) / (fTemp26 * if (((fTemp37 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp38, self.fRec22[1] + 1.0) };
			let mut fTemp39: F32 = self.fRec22[0] / fTemp38;
			let mut fTemp40: F32 = if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { self.fRec23[0] } else { if (((self.fRec22[0] < fTemp38) as i32) as i32 != 0) { self.fRec23[0] + fTemp37 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec24[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp41) as usize] };
			let mut iTemp43: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp44: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst6 };
			self.fRec27[0] = fTemp44 - F32::floor(fTemp44);
			self.fRec21[0] = 0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec27[0] + 24.347826 * self.fRec21[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42));
			let mut fTemp45: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst9 };
			self.fRec29[0] = fTemp45 - F32::floor(fTemp45);
			self.fRec32[0] = if (iTemp2 as i32 != 0) { 5984.0 } else { self.fRec32[1] };
			self.fRec33[0] = if (iTemp2 as i32 != 0) { 8128.0 } else { self.fRec33[1] };
			let mut fTemp46: F32 = self.fRec33[0] - self.fRec32[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (fTemp4 * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec32[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec33[0]);
			let mut fTemp49: F32 = self.fRec32[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (fTemp4 * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			self.fRec35[0] = if (iTemp2 as i32 != 0) { 6.88e+03 } else { self.fRec35[1] };
			let mut fTemp52: F32 = self.fRec35[0] - self.fRec33[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 62.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec34[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec34[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec34[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec34[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec34[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec34[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec34[0] / fTemp50;
			self.fRec31[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec32[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec32[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec32[0] + fTemp46 * if (((self.fRec33[0] > self.fRec32[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec33[0] } } } else { if (((self.fRec34[0] < fTemp54) as i32) as i32 != 0) { self.fRec33[0] + fTemp52 * if (((self.fRec35[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec35[0] } } } else { self.fRec31[1] };
			let mut fTemp60: F32 = self.fRec33[0] - self.fRec31[0];
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp26 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec30[1] + 1.0) };
			let mut fTemp62: F32 = self.fRec30[0] / fTemp61;
			let mut fTemp63: F32 = if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { self.fRec31[0] } else { if (((self.fRec30[0] < fTemp61) as i32) as i32 != 0) { self.fRec31[0] + fTemp60 * if (((self.fRec33[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec33[0] } };
			let mut iTemp64: i32 = ((fTemp63) as i32);
			let mut fTemp65: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp64) as usize] };
			let mut fTemp66: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst11 };
			self.fRec36[0] = fTemp66 - F32::floor(fTemp66);
			let mut fTemp67: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst13 };
			self.fRec37[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow13 * (0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec37[0] + 2.0 * (unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * self.fRec36[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp65 + (fTemp63 - ((iTemp64) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp64, 1)) as usize] } - fTemp65)) + unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * self.fRec21[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp31 + (fTemp29 - ((iTemp30) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp30, 1)) as usize] } - fTemp31))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp19 + (fTemp17 - ((iTemp18) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp18, 1)) as usize] } - fTemp19)) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow14 * fTemp68;
			let mut fTemp69: F32 = self.fRec2[1] + fSlow4 * fTemp68 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow14 * fTemp69;
			let mut fTemp70: F32 = self.fRec3[1] + fSlow4 * fTemp69 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow14 * fTemp70;
			let mut fTemp71: F32 = self.fRec4[1] + fSlow4 * fTemp70 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow14 * fTemp71;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp71;
			let mut fTemp72: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec4[0] = fTemp72;
			self.fRec0[0] = self.fConst19 * self.fVec4[1] - self.fConst18 * (self.fConst16 * self.fRec0[1] - self.fConst15 * fTemp72);
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cymbal3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Cymbal3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cymbal3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fButton0;
		let mut iSlow8: i32 = ((fSlow7 > 0.0) as i32);
		let mut iSlow9: i32 = ((iSlow8 > 0) as i32);
		let mut fSlow10: F32 = 0.2 * self.fHslider1;
		let mut iSlow11: i32 = (((((fSlow7 == 0.0) as i32)) > 0) as i32);
		let mut fSlow12: F32 = ((iSlow8) as F32);
		let mut fSlow13: F32 = 1.0 / (0.16465649 * (DSP_Cymbal3_faustpower4_f(fSlow2) * fSlow5 / DSP_Cymbal3_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow14: F32 = 2.0 * fSlow4;
		let mut fSlow15: F32 = 0.01 * self.fHslider2;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + 6.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider4 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = i32::wrapping_sub(1, ((fSlow7 > self.fVec2[1]) as i32));
			self.fRec10[0] = if (iTemp2 as i32 != 0) { 7.84e+03 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp2 as i32 != 0) { 3776.0 } else { self.fRec11[1] };
			let mut fTemp3: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec13[0] = if (iTemp2 as i32 != 0) { 0.0 } else { self.fRec13[1] };
			let mut fTemp4: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 99.5) as i32)) as usize] };
			let mut fTemp5: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp3) / (fTemp4 * if (((fTemp3 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp6: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp7: F32 = self.fRec10[0] - fTemp6;
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 50.5 - fSlow10) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp6)) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = fTemp8 + fTemp5;
			self.fRec14[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst2 + fTemp9, self.fRec14[1] + 1.0) };
			let mut iTemp10: i32 = ((self.fRec14[0] < fTemp9) as i32);
			let mut iTemp11: i32 = ((self.fRec14[0] < fTemp8) as i32);
			let mut fTemp12: F32 = (self.fRec14[0] - fTemp8) / fTemp5;
			let mut fTemp13: F32 = self.fRec14[0] / fTemp8;
			self.fRec9[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp10 as i32 != 0) { if (iTemp11 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp6 } else { if (iTemp11 as i32 != 0) { fTemp6 + fTemp7 * if (((self.fRec10[0] > fTemp6) as i32) as i32 != 0) { F32::powf(fTemp13, 0.33333334) } else { fTemp13 } } else { self.fRec10[0] } } } else { if (iTemp10 as i32 != 0) { self.fRec10[0] + fTemp3 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp12, 0.33333334) } else { fTemp12 } } else { self.fRec11[0] } } } else { self.fRec11[0] } } else { self.fRec9[1] };
			let mut fTemp14: F32 = self.fRec11[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (fTemp4 * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			self.fRec8[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp15, self.fRec8[1] + 1.0) };
			let mut fTemp16: F32 = self.fRec8[0] / fTemp15;
			let mut fTemp17: F32 = if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { self.fRec9[0] } else { if (((self.fRec8[0] < fTemp15) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec11[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp16, 0.33333334) } else { fTemp16 } } else { self.fRec11[0] } };
			let mut iTemp18: i32 = ((fTemp17) as i32);
			let mut fTemp19: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp18) as usize] };
			self.fRec18[0] = if (iTemp2 as i32 != 0) { 3648.0 } else { self.fRec18[1] };
			let mut fTemp20: F32 = F32::max(5076.0, self.fRec18[0]);
			self.fRec19[0] = if (iTemp2 as i32 != 0) { 7712.0 } else { self.fRec19[1] };
			let mut fTemp21: F32 = self.fRec19[0] - fTemp20;
			let mut fTemp22: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp21) / (fTemp4 * if (((fTemp21 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp20)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp22, self.fRec20[1] + 1.0) };
			let mut iTemp23: i32 = ((self.fRec20[0] < fTemp22) as i32);
			let mut fTemp24: F32 = self.fRec20[0] / fTemp22;
			self.fRec17[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec20[0] < (self.fConst2 + fTemp22)) as i32) as i32 != 0) { if (iTemp23 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp20 } else { if (iTemp23 as i32 != 0) { fTemp20 + fTemp21 * if (((self.fRec19[0] > fTemp20) as i32) as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] } } else { self.fRec17[1] };
			let mut fTemp25: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp26: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 0.5) as i32)) as usize] };
			let mut fTemp27: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (fTemp26 * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp27, self.fRec16[1] + 1.0) };
			let mut fTemp28: F32 = self.fRec16[0] / fTemp27;
			let mut fTemp29: F32 = if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { self.fRec17[0] } else { if (((self.fRec16[0] < fTemp27) as i32) as i32 != 0) { self.fRec17[0] + fTemp25 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp28, 0.33333334) } else { fTemp28 } } else { self.fRec18[0] } };
			let mut iTemp30: i32 = ((fTemp29) as i32);
			let mut fTemp31: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp30) as usize] };
			self.fRec24[0] = if (iTemp2 as i32 != 0) { 3712.0 } else { self.fRec24[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec24[0]);
			self.fRec25[0] = if (iTemp2 as i32 != 0) { 7776.0 } else { self.fRec25[1] };
			let mut fTemp33: F32 = self.fRec25[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp4 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			self.fRec26[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp34, self.fRec26[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec26[0] < fTemp34) as i32);
			let mut fTemp36: F32 = self.fRec26[0] / fTemp34;
			self.fRec23[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec26[0] < (self.fConst2 + fTemp34)) as i32) as i32 != 0) { if (iTemp35 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp35 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec25[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec25[0] } } } else { self.fRec25[0] } } else { self.fRec25[0] } } else { self.fRec23[1] };
			let mut fTemp37: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp37) / (fTemp26 * if (((fTemp37 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp38, self.fRec22[1] + 1.0) };
			let mut fTemp39: F32 = self.fRec22[0] / fTemp38;
			let mut fTemp40: F32 = if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { self.fRec23[0] } else { if (((self.fRec22[0] < fTemp38) as i32) as i32 != 0) { self.fRec23[0] + fTemp37 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec24[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp41) as usize] };
			let mut iTemp43: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp44: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst6 };
			self.fRec27[0] = fTemp44 - F32::floor(fTemp44);
			self.fRec21[0] = 0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec27[0] + 24.347826 * self.fRec21[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42));
			let mut fTemp45: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst9 };
			self.fRec29[0] = fTemp45 - F32::floor(fTemp45);
			self.fRec32[0] = if (iTemp2 as i32 != 0) { 5984.0 } else { self.fRec32[1] };
			self.fRec33[0] = if (iTemp2 as i32 != 0) { 8128.0 } else { self.fRec33[1] };
			let mut fTemp46: F32 = self.fRec33[0] - self.fRec32[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (fTemp4 * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec32[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec33[0]);
			let mut fTemp49: F32 = self.fRec32[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (fTemp4 * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			self.fRec35[0] = if (iTemp2 as i32 != 0) { 6.88e+03 } else { self.fRec35[1] };
			let mut fTemp52: F32 = self.fRec35[0] - self.fRec33[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 62.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec34[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec34[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec34[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec34[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec34[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec34[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec34[0] / fTemp50;
			self.fRec31[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec32[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec32[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec32[0] + fTemp46 * if (((self.fRec33[0] > self.fRec32[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec33[0] } } } else { if (((self.fRec34[0] < fTemp54) as i32) as i32 != 0) { self.fRec33[0] + fTemp52 * if (((self.fRec35[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec35[0] } } } else { self.fRec31[1] };
			let mut fTemp60: F32 = self.fRec33[0] - self.fRec31[0];
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp26 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec30[1] + 1.0) };
			let mut fTemp62: F32 = self.fRec30[0] / fTemp61;
			let mut fTemp63: F32 = if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { self.fRec31[0] } else { if (((self.fRec30[0] < fTemp61) as i32) as i32 != 0) { self.fRec31[0] + fTemp60 * if (((self.fRec33[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec33[0] } };
			let mut iTemp64: i32 = ((fTemp63) as i32);
			let mut fTemp65: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp64) as usize] };
			let mut fTemp66: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst11 };
			self.fRec36[0] = fTemp66 - F32::floor(fTemp66);
			let mut fTemp67: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst13 };
			self.fRec37[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow13 * (0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec37[0] + 2.0 * (unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * self.fRec36[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp65 + (fTemp63 - ((iTemp64) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp64, 1)) as usize] } - fTemp65)) + unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * self.fRec21[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp31 + (fTemp29 - ((iTemp30) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp30, 1)) as usize] } - fTemp31))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp19 + (fTemp17 - ((iTemp18) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp18, 1)) as usize] } - fTemp19)) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow14 * fTemp68;
			let mut fTemp69: F32 = self.fRec2[1] + fSlow4 * fTemp68 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow14 * fTemp69;
			let mut fTemp70: F32 = self.fRec3[1] + fSlow4 * fTemp69 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow14 * fTemp70;
			let mut fTemp71: F32 = self.fRec4[1] + fSlow4 * fTemp70 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow14 * fTemp71;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp71;
			let mut fTemp72: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec4[0] = fTemp72;
			self.fRec0[0] = self.fConst19 * self.fVec4[1] - self.fConst18 * (self.fConst16 * self.fRec0[1] - self.fConst15 * fTemp72);
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cymbal3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Cymbal3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cymbal3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fButton0;
		let mut iSlow8: i32 = ((fSlow7 > 0.0) as i32);
		let mut iSlow9: i32 = ((iSlow8 > 0) as i32);
		let mut fSlow10: F32 = 0.2 * self.fHslider1;
		let mut iSlow11: i32 = (((((fSlow7 == 0.0) as i32)) > 0) as i32);
		let mut fSlow12: F32 = ((iSlow8) as F32);
		let mut fSlow13: F32 = 1.0 / (0.16465649 * (DSP_Cymbal3_faustpower4_f(fSlow2) * fSlow5 / DSP_Cymbal3_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow14: F32 = 2.0 * fSlow4;
		let mut fSlow15: F32 = 0.01 * self.fHslider2;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + 6.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider4 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = i32::wrapping_sub(1, ((fSlow7 > self.fVec2[1]) as i32));
			self.fRec10[0] = if (iTemp2 as i32 != 0) { 7.84e+03 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp2 as i32 != 0) { 3776.0 } else { self.fRec11[1] };
			let mut fTemp3: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec13[0] = if (iTemp2 as i32 != 0) { 0.0 } else { self.fRec13[1] };
			let mut fTemp4: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 99.5) as i32)) as usize] };
			let mut fTemp5: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp3) / (fTemp4 * if (((fTemp3 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp6: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp7: F32 = self.fRec10[0] - fTemp6;
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 50.5 - fSlow10) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp6)) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = fTemp8 + fTemp5;
			self.fRec14[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst2 + fTemp9, self.fRec14[1] + 1.0) };
			let mut iTemp10: i32 = ((self.fRec14[0] < fTemp9) as i32);
			let mut iTemp11: i32 = ((self.fRec14[0] < fTemp8) as i32);
			let mut fTemp12: F32 = (self.fRec14[0] - fTemp8) / fTemp5;
			let mut fTemp13: F32 = self.fRec14[0] / fTemp8;
			self.fRec9[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp10 as i32 != 0) { if (iTemp11 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp6 } else { if (iTemp11 as i32 != 0) { fTemp6 + fTemp7 * if (((self.fRec10[0] > fTemp6) as i32) as i32 != 0) { F32::powf(fTemp13, 0.33333334) } else { fTemp13 } } else { self.fRec10[0] } } } else { if (iTemp10 as i32 != 0) { self.fRec10[0] + fTemp3 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp12, 0.33333334) } else { fTemp12 } } else { self.fRec11[0] } } } else { self.fRec11[0] } } else { self.fRec9[1] };
			let mut fTemp14: F32 = self.fRec11[0] - self.fRec9[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (fTemp4 * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			self.fRec8[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp15, self.fRec8[1] + 1.0) };
			let mut fTemp16: F32 = self.fRec8[0] / fTemp15;
			let mut fTemp17: F32 = if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { self.fRec9[0] } else { if (((self.fRec8[0] < fTemp15) as i32) as i32 != 0) { self.fRec9[0] + fTemp14 * if (((self.fRec11[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp16, 0.33333334) } else { fTemp16 } } else { self.fRec11[0] } };
			let mut iTemp18: i32 = ((fTemp17) as i32);
			let mut fTemp19: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp18) as usize] };
			self.fRec18[0] = if (iTemp2 as i32 != 0) { 3648.0 } else { self.fRec18[1] };
			let mut fTemp20: F32 = F32::max(5076.0, self.fRec18[0]);
			self.fRec19[0] = if (iTemp2 as i32 != 0) { 7712.0 } else { self.fRec19[1] };
			let mut fTemp21: F32 = self.fRec19[0] - fTemp20;
			let mut fTemp22: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp21) / (fTemp4 * if (((fTemp21 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp20)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp22, self.fRec20[1] + 1.0) };
			let mut iTemp23: i32 = ((self.fRec20[0] < fTemp22) as i32);
			let mut fTemp24: F32 = self.fRec20[0] / fTemp22;
			self.fRec17[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec20[0] < (self.fConst2 + fTemp22)) as i32) as i32 != 0) { if (iTemp23 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp20 } else { if (iTemp23 as i32 != 0) { fTemp20 + fTemp21 * if (((self.fRec19[0] > fTemp20) as i32) as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] } } else { self.fRec17[1] };
			let mut fTemp25: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp26: F32 = unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 0.5) as i32)) as usize] };
			let mut fTemp27: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (fTemp26 * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp27, self.fRec16[1] + 1.0) };
			let mut fTemp28: F32 = self.fRec16[0] / fTemp27;
			let mut fTemp29: F32 = if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { self.fRec17[0] } else { if (((self.fRec16[0] < fTemp27) as i32) as i32 != 0) { self.fRec17[0] + fTemp25 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp28, 0.33333334) } else { fTemp28 } } else { self.fRec18[0] } };
			let mut iTemp30: i32 = ((fTemp29) as i32);
			let mut fTemp31: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp30) as usize] };
			self.fRec24[0] = if (iTemp2 as i32 != 0) { 3712.0 } else { self.fRec24[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec24[0]);
			self.fRec25[0] = if (iTemp2 as i32 != 0) { 7776.0 } else { self.fRec25[1] };
			let mut fTemp33: F32 = self.fRec25[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp4 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			self.fRec26[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp34, self.fRec26[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec26[0] < fTemp34) as i32);
			let mut fTemp36: F32 = self.fRec26[0] / fTemp34;
			self.fRec23[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (((self.fRec26[0] < (self.fConst2 + fTemp34)) as i32) as i32 != 0) { if (iTemp35 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp35 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec25[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec25[0] } } } else { self.fRec25[0] } } else { self.fRec25[0] } } else { self.fRec23[1] };
			let mut fTemp37: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp37) / (fTemp26 * if (((fTemp37 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec22[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp38, self.fRec22[1] + 1.0) };
			let mut fTemp39: F32 = self.fRec22[0] / fTemp38;
			let mut fTemp40: F32 = if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { self.fRec23[0] } else { if (((self.fRec22[0] < fTemp38) as i32) as i32 != 0) { self.fRec23[0] + fTemp37 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec24[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp41) as usize] };
			let mut iTemp43: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp44: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst6 };
			self.fRec27[0] = fTemp44 - F32::floor(fTemp44);
			self.fRec21[0] = 0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec27[0] + 24.347826 * self.fRec21[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42));
			let mut fTemp45: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst9 };
			self.fRec29[0] = fTemp45 - F32::floor(fTemp45);
			self.fRec32[0] = if (iTemp2 as i32 != 0) { 5984.0 } else { self.fRec32[1] };
			self.fRec33[0] = if (iTemp2 as i32 != 0) { 8128.0 } else { self.fRec33[1] };
			let mut fTemp46: F32 = self.fRec33[0] - self.fRec32[0];
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (fTemp4 * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec32[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec33[0]);
			let mut fTemp49: F32 = self.fRec32[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (fTemp4 * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			self.fRec35[0] = if (iTemp2 as i32 != 0) { 6.88e+03 } else { self.fRec35[1] };
			let mut fTemp52: F32 = self.fRec35[0] - self.fRec33[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Cymbal3SIG1[(((self.fRec13[0] + 62.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec34[0] = if (iSlow11 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec34[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec34[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec34[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec34[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec34[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec34[0] / fTemp50;
			self.fRec31[0] = if (iSlow8 as i32 != 0) { fSlow12 * if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec32[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec32[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec32[0] + fTemp46 * if (((self.fRec33[0] > self.fRec32[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec33[0] } } } else { if (((self.fRec34[0] < fTemp54) as i32) as i32 != 0) { self.fRec33[0] + fTemp52 * if (((self.fRec35[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec35[0] } } } else { self.fRec31[1] };
			let mut fTemp60: F32 = self.fRec33[0] - self.fRec31[0];
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp26 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iSlow9 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec30[1] + 1.0) };
			let mut fTemp62: F32 = self.fRec30[0] / fTemp61;
			let mut fTemp63: F32 = if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { self.fRec31[0] } else { if (((self.fRec30[0] < fTemp61) as i32) as i32 != 0) { self.fRec31[0] + fTemp60 * if (((self.fRec33[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec33[0] } };
			let mut iTemp64: i32 = ((fTemp63) as i32);
			let mut fTemp65: F32 = unsafe { ftbl0DSP_Cymbal3SIG0[(iTemp64) as usize] };
			let mut fTemp66: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst11 };
			self.fRec36[0] = fTemp66 - F32::floor(fTemp66);
			let mut fTemp67: F32 = if (iTemp43 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst13 };
			self.fRec37[0] = fTemp67 - F32::floor(fTemp67);
			let mut fTemp68: F32 = fSlow13 * (0.115 * unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec37[0] + 2.0 * (unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * self.fRec36[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp65 + (fTemp63 - ((iTemp64) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp64, 1)) as usize] } - fTemp65)) + unsafe { ftbl2DSP_Cymbal3SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * self.fRec21[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp31 + (fTemp29 - ((iTemp30) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp30, 1)) as usize] } - fTemp31))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp19 + (fTemp17 - ((iTemp18) as F32)) * (unsafe { ftbl0DSP_Cymbal3SIG0[(i32::wrapping_add(iTemp18, 1)) as usize] } - fTemp19)) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow14 * fTemp68;
			let mut fTemp69: F32 = self.fRec2[1] + fSlow4 * fTemp68 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow14 * fTemp69;
			let mut fTemp70: F32 = self.fRec3[1] + fSlow4 * fTemp69 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow14 * fTemp70;
			let mut fTemp71: F32 = self.fRec4[1] + fSlow4 * fTemp70 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow14 * fTemp71;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp71;
			let mut fTemp72: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec4[0] = fTemp72;
			self.fRec0[0] = self.fConst19 * self.fVec4[1] - self.fConst18 * (self.fConst16 * self.fRec0[1] - self.fConst15 * fTemp72);
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
