// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Rimshot1 -pn processRimshot1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Rimshot1SIG0 {
	iRec1: [i32;2],
}

impl DSP_Rimshot1SIG0 {
	
	fn get_num_inputsDSP_Rimshot1SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot1SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot1SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot1SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Rimshot1SIG0() -> DSP_Rimshot1SIG0 { 
	DSP_Rimshot1SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Rimshot1SIG1 {
	iRec5: [i32;2],
}

impl DSP_Rimshot1SIG1 {
	
	fn get_num_inputsDSP_Rimshot1SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot1SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot1SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot1SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Rimshot1SIG1() -> DSP_Rimshot1SIG1 { 
	DSP_Rimshot1SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Rimshot1SIG2 {
	iVec3: [i32;2],
	iRec8: [i32;2],
}

impl DSP_Rimshot1SIG2 {
	
	fn get_num_inputsDSP_Rimshot1SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot1SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot1SIG2(&mut self, sample_rate: i32) {
		for l10 in 0..2 {
			self.iVec3[(l10) as usize] = 0;
		}
		for l11 in 0..2 {
			self.iRec8[(l11) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot1SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec8[0] = (i32::wrapping_add(self.iVec3[1], self.iRec8[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec8[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec8[1] = self.iRec8[0];
		}
	}

}


pub fn newDSP_Rimshot1SIG2() -> DSP_Rimshot1SIG2 { 
	DSP_Rimshot1SIG2 {
		iVec3: [0;2],
		iRec8: [0;2],
	}
}

pub struct DSP_Rimshot1SIG3 {
	iRec16: [i32;2],
}

impl DSP_Rimshot1SIG3 {
	
	fn get_num_inputsDSP_Rimshot1SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot1SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot1SIG3(&mut self, sample_rate: i32) {
		for l18 in 0..2 {
			self.iRec16[(l18) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot1SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec16[0] = i32::wrapping_add(self.iRec16[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec16[0], -1)) as F32) + -128.0));
			self.iRec16[1] = self.iRec16[0];
		}
	}

}


pub fn newDSP_Rimshot1SIG3() -> DSP_Rimshot1SIG3 { 
	DSP_Rimshot1SIG3 {
		iRec16: [0;2],
	}
}
static mut ftbl0DSP_Rimshot1SIG0: [F32;16384] = [0.0;16384];
fn DSP_Rimshot1_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Rimshot1SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Rimshot1SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Rimshot1SIG3: [F32;4096] = [0.0;4096];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Rimshot1 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fRec2: [F32;2],
	fRec4: [F32;2],
	fRec6: [F32;2],
	fConst5: F32,
	fRec7: [F32;2],
	fRec9: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fRec13: [F32;2],
	fRec14: [F32;2],
	fConst8: F32,
	fRec15: [F32;2],
	fConst11: F32,
	fRec17: [F32;2],
	fConst14: F32,
	fRec18: [F32;2],
	fRec19: [F32;2],
	fRec20: [F32;2],
	fRec21: [F32;2],
	fRec22: [F32;2],
	fRec23: [F32;2],
	fRec24: [F32;2],
	fConst16: F32,
	fRec25: [F32;2],
	fConst17: F32,
	fRec27: [F32;2],
	fConst18: F32,
	fRec28: [F32;2],
	fRec26: [F32;2],
	fConst20: F32,
	fRec29: [F32;2],
	fVec4: [F32;2],
	fConst21: F32,
	fConst22: F32,
	fRec0: [F32;2],
	fHslider1: F32,
	fHslider2: F32,
	fHslider3: F32,
}

impl FaustDsp for DSP_Rimshot1 {
	type T = F32;
		
	fn new() -> DSP_Rimshot1 { 
		DSP_Rimshot1 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fRec6: [0.0;2],
			fConst5: 0.0,
			fRec7: [0.0;2],
			fRec9: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fConst8: 0.0,
			fRec15: [0.0;2],
			fConst11: 0.0,
			fRec17: [0.0;2],
			fConst14: 0.0,
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fRec20: [0.0;2],
			fRec21: [0.0;2],
			fRec22: [0.0;2],
			fRec23: [0.0;2],
			fRec24: [0.0;2],
			fConst16: 0.0,
			fRec25: [0.0;2],
			fConst17: 0.0,
			fRec27: [0.0;2],
			fConst18: 0.0,
			fRec28: [0.0;2],
			fRec26: [0.0;2],
			fConst20: 0.0,
			fRec29: [0.0;2],
			fVec4: [0.0;2],
			fConst21: 0.0,
			fConst22: 0.0,
			fRec0: [0.0;2],
			fHslider1: 0.0,
			fHslider2: 0.0,
			fHslider3: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Rimshot1 -pn processRimshot1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Rimshot1SIG0 = newDSP_Rimshot1SIG0();
		sig0.instance_initDSP_Rimshot1SIG0(sample_rate);
		sig0.fillDSP_Rimshot1SIG0(16384, unsafe { &mut ftbl0DSP_Rimshot1SIG0 });
		let mut sig1: DSP_Rimshot1SIG1 = newDSP_Rimshot1SIG1();
		sig1.instance_initDSP_Rimshot1SIG1(sample_rate);
		sig1.fillDSP_Rimshot1SIG1(144, unsafe { &mut ftbl1DSP_Rimshot1SIG1 });
		let mut sig2: DSP_Rimshot1SIG2 = newDSP_Rimshot1SIG2();
		sig2.instance_initDSP_Rimshot1SIG2(sample_rate);
		sig2.fillDSP_Rimshot1SIG2(1024, unsafe { &mut ftbl2DSP_Rimshot1SIG2 });
		let mut sig3: DSP_Rimshot1SIG3 = newDSP_Rimshot1SIG3();
		sig3.instance_initDSP_Rimshot1SIG3(sample_rate);
		sig3.fillDSP_Rimshot1SIG3(4096, unsafe { &mut ftbl3DSP_Rimshot1SIG3 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l12 in 0..2 {
			self.fRec9[(l12) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec15[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec17[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec18[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec19[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec20[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec21[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec22[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec23[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec24[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec25[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec27[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec28[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec26[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec29[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fVec4[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec0[(l34) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.fConst5 = F32::max(1.0, 0.001 * self.fConst0);
		let mut fConst6: F32 = unsafe { ftbl3DSP_Rimshot1SIG3[2066] };
		let mut fConst7: F32 = 1e+02 / self.fConst0;
		self.fConst8 = fConst7 * (fConst6 + 0.6290887 * (unsafe { ftbl3DSP_Rimshot1SIG3[2067] } - fConst6));
		let mut fConst9: F32 = unsafe { ftbl3DSP_Rimshot1SIG3[2678] };
		let mut fConst10: F32 = fConst9 + 0.7599262 * (unsafe { ftbl3DSP_Rimshot1SIG3[2679] } - fConst9);
		self.fConst11 = 1e+01 / self.fConst0 * fConst10;
		let mut fConst12: F32 = unsafe { ftbl3DSP_Rimshot1SIG3[2111] };
		let mut fConst13: F32 = 1.0 / self.fConst0;
		self.fConst14 = fConst13 * (fConst12 + 0.2636289 * (unsafe { ftbl3DSP_Rimshot1SIG3[2112] } - fConst12));
		let mut fConst15: F32 = unsafe { ftbl3DSP_Rimshot1SIG3[2245] };
		self.fConst16 = fConst13 * (fConst15 + 0.1672496 * (unsafe { ftbl3DSP_Rimshot1SIG3[2246] } - fConst15));
		self.fConst17 = 2.0 * self.fConst5;
		self.fConst18 = fConst7 * fConst10;
		let mut fConst19: F32 = unsafe { ftbl3DSP_Rimshot1SIG3[2047] };
		self.fConst20 = 1e+03 / self.fConst0 * (fConst19 + 0.5 * (unsafe { ftbl3DSP_Rimshot1SIG3[2048] } - fConst19));
		self.fConst21 = 1.0 / (fConst1 * fConst3);
		self.fConst22 = 0.0 - self.fConst21;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Rimshot1::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "8", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(3), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(4), 0.0, 0.0, 1.0, 0.01);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			4 => Some(self.fHslider0),
			2 => Some(self.fHslider1),
			1 => Some(self.fHslider2),
			3 => Some(self.fHslider3),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			4 => { self.fHslider0 = value }
			2 => { self.fHslider1 = value }
			1 => { self.fHslider2 = value }
			3 => { self.fHslider3 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = 0.01 * self.fHslider1;
		let mut fSlow3: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider2 + 1.5));
		let mut fSlow4: F32 = fSlow3 * F32::min(1.0, 1.0 - fSlow2);
		let mut fSlow5: F32 = fSlow3 * F32::min(1.0, fSlow2 + 1.0);
		let mut fSlow6: F32 = 0.01 * self.fHslider3 * fSlow3;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 54.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp13, self.fRec7[1] + 1.0) };
			let mut iTemp15: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp12) as i32);
			let mut fTemp17: F32 = (self.fRec7[0] - fTemp12) / fTemp8;
			let mut fTemp18: F32 = self.fRec7[0] / fTemp12;
			let mut fTemp19: F32 = if (iTemp15 as i32 != 0) { if (iTemp16 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp16 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec2[0] } } } else { if (iTemp15 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp17, 0.33333334) } else { fTemp17 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp20: i32 = ((fTemp19) as i32);
			let mut fTemp21: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp20) as usize] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { 7424.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { 3.36e+03 } else { self.fRec10[1] };
			let mut fTemp22: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp23: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp22) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp22 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp24: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp25: F32 = self.fRec9[0] - fTemp24;
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp24)) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = fTemp26 + fTemp23;
			self.fRec11[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp27, self.fRec11[1] + 1.0) };
			let mut iTemp28: i32 = ((self.fRec11[0] < fTemp27) as i32);
			let mut iTemp29: i32 = ((self.fRec11[0] < fTemp26) as i32);
			let mut fTemp30: F32 = (self.fRec11[0] - fTemp26) / fTemp23;
			let mut fTemp31: F32 = self.fRec11[0] / fTemp26;
			let mut fTemp32: F32 = if (iTemp28 as i32 != 0) { if (iTemp29 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp24 } else { if (iTemp29 as i32 != 0) { fTemp24 + fTemp25 * if (((self.fRec9[0] > fTemp24) as i32) as i32 != 0) { F32::powf(fTemp31, 0.33333334) } else { fTemp31 } } else { self.fRec9[0] } } } else { if (iTemp28 as i32 != 0) { self.fRec9[0] + fTemp22 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp30, 0.33333334) } else { fTemp30 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp33: i32 = ((fTemp32) as i32);
			let mut fTemp34: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp33) as usize] };
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec13[1] };
			let mut fTemp35: F32 = self.fRec13[0] - self.fRec12[0];
			let mut fTemp36: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp37: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp38: F32 = self.fRec12[0] - fTemp37;
			let mut fTemp39: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp38) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 93.5) as i32)) as usize] } * if (((fTemp38 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp37)) + 2.0) } else { 0.96 }))));
			let mut fTemp40: F32 = fTemp39 + fTemp36;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp40, self.fRec14[1] + 1.0) };
			let mut iTemp41: i32 = ((self.fRec14[0] < fTemp40) as i32);
			let mut iTemp42: i32 = ((self.fRec14[0] < fTemp39) as i32);
			let mut fTemp43: F32 = (self.fRec14[0] - fTemp39) / fTemp36;
			let mut fTemp44: F32 = self.fRec14[0] / fTemp39;
			let mut fTemp45: F32 = if (iTemp41 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp37 } else { if (iTemp42 as i32 != 0) { fTemp37 + fTemp38 * if (((self.fRec12[0] > fTemp37) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec12[0] } } } else { if (iTemp41 as i32 != 0) { self.fRec12[0] + fTemp35 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp49: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec15[1] + self.fConst8 };
			self.fRec15[0] = fTemp49 - F32::floor(fTemp49);
			let mut fTemp50: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + self.fConst11 };
			self.fRec17[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst14 };
			self.fRec18[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp53: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp52) * (fTemp52 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp53 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp53 } else { self.fRec20[1] };
			let mut fTemp54: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp55: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp54) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp54 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp56: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp57: F32 = self.fRec19[0] - fTemp56;
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp11 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp56)) + 2.0) } else { 0.96 }))));
			let mut fTemp59: F32 = fTemp58 + fTemp55;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp59, self.fRec21[1] + 1.0) };
			let mut iTemp60: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp58) as i32);
			let mut fTemp62: F32 = (self.fRec21[0] - fTemp58) / fTemp55;
			let mut fTemp63: F32 = self.fRec21[0] / fTemp58;
			let mut fTemp64: F32 = if (iTemp60 as i32 != 0) { if (iTemp61 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp56 } else { if (iTemp61 as i32 != 0) { fTemp56 + fTemp57 * if (((self.fRec19[0] > fTemp56) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec19[0] } } } else { if (iTemp60 as i32 != 0) { self.fRec19[0] + fTemp54 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp65) as usize] };
			let mut fTemp67: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 92.0));
			let mut fTemp68: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp67) * (fTemp67 + 28.0);
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp68 + 4064.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp68 } else { self.fRec23[1] };
			let mut fTemp69: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp70: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp69) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 59.5) as i32)) as usize] } * if (((fTemp69 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp71: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp72: F32 = self.fRec22[0] - fTemp71;
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp72) / (fTemp11 * if (((fTemp72 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp71)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp70;
			let mut fTemp75: F32 = self.fRec22[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 64.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec24[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec24[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec24[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec24[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec24[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec24[0] - fTemp73) / fTemp70;
			let mut fTemp82: F32 = self.fRec24[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp71 } else { if (iTemp80 as i32 != 0) { fTemp71 + fTemp72 * if (((self.fRec22[0] > fTemp71) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp69 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec24[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec22[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec22[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst16 };
			self.fRec25[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp88: F32 = self.fRec12[0] - fTemp87;
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (fTemp11 * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp87)) + 2.0) } else { 0.96 }))));
			self.fRec27[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst17 + fTemp89, self.fRec27[1] + 1.0) };
			let mut iTemp90: i32 = ((self.fRec27[0] < fTemp89) as i32);
			let mut fTemp91: F32 = self.fRec27[0] / fTemp89;
			let mut fTemp92: F32 = if (((self.fRec27[0] < (self.fConst5 + fTemp89)) as i32) as i32 != 0) { if (iTemp90 as i32 != 0) { if (((self.fRec27[0] < 0.0) as i32) as i32 != 0) { fTemp87 } else { if (iTemp90 as i32 != 0) { fTemp87 + fTemp88 * if (((self.fRec12[0] > fTemp87) as i32) as i32 != 0) { F32::powf(fTemp91, 0.33333334) } else { fTemp91 } } else { self.fRec12[0] } } } else { self.fRec12[0] } } else { self.fRec12[0] };
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp93) as usize] };
			let mut fTemp95: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec28[1] + self.fConst18 };
			self.fRec28[0] = fTemp95 - F32::floor(fTemp95);
			self.fRec26[0] = 0.161 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec28[0] + 17.391304 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst20 };
			self.fRec29[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * (self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec25[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) + unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp34 + (fTemp32 - ((iTemp33) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp33, 1)) as usize] } - fTemp34)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp21 + (fTemp19 - ((iTemp20) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp20, 1)) as usize] } - fTemp21));
			self.fVec4[0] = fTemp97;
			self.fRec0[0] = 0.115 * (self.fConst21 * fTemp97 + self.fConst22 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow4 * self.fRec0[0];
			*output1 = fSlow5 * self.fRec0[0];
			*output2 = fSlow6 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec29[1] = self.fRec29[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Rimshot1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Rimshot1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = 0.01 * self.fHslider1;
		let mut fSlow3: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider2 + 1.5));
		let mut fSlow4: F32 = fSlow3 * F32::min(1.0, 1.0 - fSlow2);
		let mut fSlow5: F32 = fSlow3 * F32::min(1.0, fSlow2 + 1.0);
		let mut fSlow6: F32 = 0.01 * self.fHslider3 * fSlow3;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 54.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp13, self.fRec7[1] + 1.0) };
			let mut iTemp15: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp12) as i32);
			let mut fTemp17: F32 = (self.fRec7[0] - fTemp12) / fTemp8;
			let mut fTemp18: F32 = self.fRec7[0] / fTemp12;
			let mut fTemp19: F32 = if (iTemp15 as i32 != 0) { if (iTemp16 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp16 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec2[0] } } } else { if (iTemp15 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp17, 0.33333334) } else { fTemp17 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp20: i32 = ((fTemp19) as i32);
			let mut fTemp21: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp20) as usize] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { 7424.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { 3.36e+03 } else { self.fRec10[1] };
			let mut fTemp22: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp23: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp22) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp22 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp24: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp25: F32 = self.fRec9[0] - fTemp24;
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp24)) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = fTemp26 + fTemp23;
			self.fRec11[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp27, self.fRec11[1] + 1.0) };
			let mut iTemp28: i32 = ((self.fRec11[0] < fTemp27) as i32);
			let mut iTemp29: i32 = ((self.fRec11[0] < fTemp26) as i32);
			let mut fTemp30: F32 = (self.fRec11[0] - fTemp26) / fTemp23;
			let mut fTemp31: F32 = self.fRec11[0] / fTemp26;
			let mut fTemp32: F32 = if (iTemp28 as i32 != 0) { if (iTemp29 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp24 } else { if (iTemp29 as i32 != 0) { fTemp24 + fTemp25 * if (((self.fRec9[0] > fTemp24) as i32) as i32 != 0) { F32::powf(fTemp31, 0.33333334) } else { fTemp31 } } else { self.fRec9[0] } } } else { if (iTemp28 as i32 != 0) { self.fRec9[0] + fTemp22 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp30, 0.33333334) } else { fTemp30 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp33: i32 = ((fTemp32) as i32);
			let mut fTemp34: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp33) as usize] };
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec13[1] };
			let mut fTemp35: F32 = self.fRec13[0] - self.fRec12[0];
			let mut fTemp36: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp37: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp38: F32 = self.fRec12[0] - fTemp37;
			let mut fTemp39: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp38) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 93.5) as i32)) as usize] } * if (((fTemp38 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp37)) + 2.0) } else { 0.96 }))));
			let mut fTemp40: F32 = fTemp39 + fTemp36;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp40, self.fRec14[1] + 1.0) };
			let mut iTemp41: i32 = ((self.fRec14[0] < fTemp40) as i32);
			let mut iTemp42: i32 = ((self.fRec14[0] < fTemp39) as i32);
			let mut fTemp43: F32 = (self.fRec14[0] - fTemp39) / fTemp36;
			let mut fTemp44: F32 = self.fRec14[0] / fTemp39;
			let mut fTemp45: F32 = if (iTemp41 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp37 } else { if (iTemp42 as i32 != 0) { fTemp37 + fTemp38 * if (((self.fRec12[0] > fTemp37) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec12[0] } } } else { if (iTemp41 as i32 != 0) { self.fRec12[0] + fTemp35 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp49: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec15[1] + self.fConst8 };
			self.fRec15[0] = fTemp49 - F32::floor(fTemp49);
			let mut fTemp50: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + self.fConst11 };
			self.fRec17[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst14 };
			self.fRec18[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp53: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp52) * (fTemp52 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp53 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp53 } else { self.fRec20[1] };
			let mut fTemp54: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp55: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp54) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp54 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp56: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp57: F32 = self.fRec19[0] - fTemp56;
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp11 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp56)) + 2.0) } else { 0.96 }))));
			let mut fTemp59: F32 = fTemp58 + fTemp55;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp59, self.fRec21[1] + 1.0) };
			let mut iTemp60: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp58) as i32);
			let mut fTemp62: F32 = (self.fRec21[0] - fTemp58) / fTemp55;
			let mut fTemp63: F32 = self.fRec21[0] / fTemp58;
			let mut fTemp64: F32 = if (iTemp60 as i32 != 0) { if (iTemp61 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp56 } else { if (iTemp61 as i32 != 0) { fTemp56 + fTemp57 * if (((self.fRec19[0] > fTemp56) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec19[0] } } } else { if (iTemp60 as i32 != 0) { self.fRec19[0] + fTemp54 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp65) as usize] };
			let mut fTemp67: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 92.0));
			let mut fTemp68: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp67) * (fTemp67 + 28.0);
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp68 + 4064.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp68 } else { self.fRec23[1] };
			let mut fTemp69: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp70: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp69) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 59.5) as i32)) as usize] } * if (((fTemp69 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp71: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp72: F32 = self.fRec22[0] - fTemp71;
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp72) / (fTemp11 * if (((fTemp72 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp71)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp70;
			let mut fTemp75: F32 = self.fRec22[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 64.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec24[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec24[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec24[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec24[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec24[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec24[0] - fTemp73) / fTemp70;
			let mut fTemp82: F32 = self.fRec24[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp71 } else { if (iTemp80 as i32 != 0) { fTemp71 + fTemp72 * if (((self.fRec22[0] > fTemp71) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp69 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec24[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec22[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec22[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst16 };
			self.fRec25[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp88: F32 = self.fRec12[0] - fTemp87;
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (fTemp11 * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp87)) + 2.0) } else { 0.96 }))));
			self.fRec27[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst17 + fTemp89, self.fRec27[1] + 1.0) };
			let mut iTemp90: i32 = ((self.fRec27[0] < fTemp89) as i32);
			let mut fTemp91: F32 = self.fRec27[0] / fTemp89;
			let mut fTemp92: F32 = if (((self.fRec27[0] < (self.fConst5 + fTemp89)) as i32) as i32 != 0) { if (iTemp90 as i32 != 0) { if (((self.fRec27[0] < 0.0) as i32) as i32 != 0) { fTemp87 } else { if (iTemp90 as i32 != 0) { fTemp87 + fTemp88 * if (((self.fRec12[0] > fTemp87) as i32) as i32 != 0) { F32::powf(fTemp91, 0.33333334) } else { fTemp91 } } else { self.fRec12[0] } } } else { self.fRec12[0] } } else { self.fRec12[0] };
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp93) as usize] };
			let mut fTemp95: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec28[1] + self.fConst18 };
			self.fRec28[0] = fTemp95 - F32::floor(fTemp95);
			self.fRec26[0] = 0.161 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec28[0] + 17.391304 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst20 };
			self.fRec29[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * (self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec25[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) + unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp34 + (fTemp32 - ((iTemp33) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp33, 1)) as usize] } - fTemp34)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp21 + (fTemp19 - ((iTemp20) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp20, 1)) as usize] } - fTemp21));
			self.fVec4[0] = fTemp97;
			self.fRec0[0] = 0.115 * (self.fConst21 * fTemp97 + self.fConst22 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow4 * self.fRec0[0];
			*output1 = fSlow5 * self.fRec0[0];
			*output2 = fSlow6 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec29[1] = self.fRec29[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Rimshot1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = 0.01 * self.fHslider1;
		let mut fSlow3: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider2 + 1.5));
		let mut fSlow4: F32 = fSlow3 * F32::min(1.0, 1.0 - fSlow2);
		let mut fSlow5: F32 = fSlow3 * F32::min(1.0, fSlow2 + 1.0);
		let mut fSlow6: F32 = 0.01 * self.fHslider3 * fSlow3;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 54.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp13, self.fRec7[1] + 1.0) };
			let mut iTemp15: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp12) as i32);
			let mut fTemp17: F32 = (self.fRec7[0] - fTemp12) / fTemp8;
			let mut fTemp18: F32 = self.fRec7[0] / fTemp12;
			let mut fTemp19: F32 = if (iTemp15 as i32 != 0) { if (iTemp16 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp16 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec2[0] } } } else { if (iTemp15 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp17, 0.33333334) } else { fTemp17 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp20: i32 = ((fTemp19) as i32);
			let mut fTemp21: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp20) as usize] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { 7424.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { 3.36e+03 } else { self.fRec10[1] };
			let mut fTemp22: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp23: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp22) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp22 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp24: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp25: F32 = self.fRec9[0] - fTemp24;
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp24)) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = fTemp26 + fTemp23;
			self.fRec11[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp27, self.fRec11[1] + 1.0) };
			let mut iTemp28: i32 = ((self.fRec11[0] < fTemp27) as i32);
			let mut iTemp29: i32 = ((self.fRec11[0] < fTemp26) as i32);
			let mut fTemp30: F32 = (self.fRec11[0] - fTemp26) / fTemp23;
			let mut fTemp31: F32 = self.fRec11[0] / fTemp26;
			let mut fTemp32: F32 = if (iTemp28 as i32 != 0) { if (iTemp29 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp24 } else { if (iTemp29 as i32 != 0) { fTemp24 + fTemp25 * if (((self.fRec9[0] > fTemp24) as i32) as i32 != 0) { F32::powf(fTemp31, 0.33333334) } else { fTemp31 } } else { self.fRec9[0] } } } else { if (iTemp28 as i32 != 0) { self.fRec9[0] + fTemp22 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp30, 0.33333334) } else { fTemp30 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp33: i32 = ((fTemp32) as i32);
			let mut fTemp34: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp33) as usize] };
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec13[1] };
			let mut fTemp35: F32 = self.fRec13[0] - self.fRec12[0];
			let mut fTemp36: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp37: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp38: F32 = self.fRec12[0] - fTemp37;
			let mut fTemp39: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp38) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 93.5) as i32)) as usize] } * if (((fTemp38 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp37)) + 2.0) } else { 0.96 }))));
			let mut fTemp40: F32 = fTemp39 + fTemp36;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp40, self.fRec14[1] + 1.0) };
			let mut iTemp41: i32 = ((self.fRec14[0] < fTemp40) as i32);
			let mut iTemp42: i32 = ((self.fRec14[0] < fTemp39) as i32);
			let mut fTemp43: F32 = (self.fRec14[0] - fTemp39) / fTemp36;
			let mut fTemp44: F32 = self.fRec14[0] / fTemp39;
			let mut fTemp45: F32 = if (iTemp41 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp37 } else { if (iTemp42 as i32 != 0) { fTemp37 + fTemp38 * if (((self.fRec12[0] > fTemp37) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec12[0] } } } else { if (iTemp41 as i32 != 0) { self.fRec12[0] + fTemp35 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp49: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec15[1] + self.fConst8 };
			self.fRec15[0] = fTemp49 - F32::floor(fTemp49);
			let mut fTemp50: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + self.fConst11 };
			self.fRec17[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst14 };
			self.fRec18[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp53: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp52) * (fTemp52 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp53 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp53 } else { self.fRec20[1] };
			let mut fTemp54: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp55: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp54) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp54 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp56: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp57: F32 = self.fRec19[0] - fTemp56;
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp11 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp56)) + 2.0) } else { 0.96 }))));
			let mut fTemp59: F32 = fTemp58 + fTemp55;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp59, self.fRec21[1] + 1.0) };
			let mut iTemp60: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp58) as i32);
			let mut fTemp62: F32 = (self.fRec21[0] - fTemp58) / fTemp55;
			let mut fTemp63: F32 = self.fRec21[0] / fTemp58;
			let mut fTemp64: F32 = if (iTemp60 as i32 != 0) { if (iTemp61 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp56 } else { if (iTemp61 as i32 != 0) { fTemp56 + fTemp57 * if (((self.fRec19[0] > fTemp56) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec19[0] } } } else { if (iTemp60 as i32 != 0) { self.fRec19[0] + fTemp54 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp65) as usize] };
			let mut fTemp67: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 92.0));
			let mut fTemp68: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp67) * (fTemp67 + 28.0);
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp68 + 4064.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp68 } else { self.fRec23[1] };
			let mut fTemp69: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp70: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp69) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 59.5) as i32)) as usize] } * if (((fTemp69 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp71: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp72: F32 = self.fRec22[0] - fTemp71;
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp72) / (fTemp11 * if (((fTemp72 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp71)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp70;
			let mut fTemp75: F32 = self.fRec22[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 64.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec24[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec24[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec24[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec24[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec24[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec24[0] - fTemp73) / fTemp70;
			let mut fTemp82: F32 = self.fRec24[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp71 } else { if (iTemp80 as i32 != 0) { fTemp71 + fTemp72 * if (((self.fRec22[0] > fTemp71) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp69 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec24[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec22[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec22[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst16 };
			self.fRec25[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp88: F32 = self.fRec12[0] - fTemp87;
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (fTemp11 * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp87)) + 2.0) } else { 0.96 }))));
			self.fRec27[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst17 + fTemp89, self.fRec27[1] + 1.0) };
			let mut iTemp90: i32 = ((self.fRec27[0] < fTemp89) as i32);
			let mut fTemp91: F32 = self.fRec27[0] / fTemp89;
			let mut fTemp92: F32 = if (((self.fRec27[0] < (self.fConst5 + fTemp89)) as i32) as i32 != 0) { if (iTemp90 as i32 != 0) { if (((self.fRec27[0] < 0.0) as i32) as i32 != 0) { fTemp87 } else { if (iTemp90 as i32 != 0) { fTemp87 + fTemp88 * if (((self.fRec12[0] > fTemp87) as i32) as i32 != 0) { F32::powf(fTemp91, 0.33333334) } else { fTemp91 } } else { self.fRec12[0] } } } else { self.fRec12[0] } } else { self.fRec12[0] };
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp93) as usize] };
			let mut fTemp95: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec28[1] + self.fConst18 };
			self.fRec28[0] = fTemp95 - F32::floor(fTemp95);
			self.fRec26[0] = 0.161 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec28[0] + 17.391304 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst20 };
			self.fRec29[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * (self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec25[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) + unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp34 + (fTemp32 - ((iTemp33) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp33, 1)) as usize] } - fTemp34)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp21 + (fTemp19 - ((iTemp20) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp20, 1)) as usize] } - fTemp21));
			self.fVec4[0] = fTemp97;
			self.fRec0[0] = 0.115 * (self.fConst21 * fTemp97 + self.fConst22 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow4 * self.fRec0[0];
			*output1 = fSlow5 * self.fRec0[0];
			*output2 = fSlow6 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec29[1] = self.fRec29[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Rimshot1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = 0.01 * self.fHslider1;
		let mut fSlow3: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider2 + 1.5));
		let mut fSlow4: F32 = fSlow3 * F32::min(1.0, 1.0 - fSlow2);
		let mut fSlow5: F32 = fSlow3 * F32::min(1.0, fSlow2 + 1.0);
		let mut fSlow6: F32 = 0.01 * self.fHslider3 * fSlow3;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 54.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp13, self.fRec7[1] + 1.0) };
			let mut iTemp15: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp12) as i32);
			let mut fTemp17: F32 = (self.fRec7[0] - fTemp12) / fTemp8;
			let mut fTemp18: F32 = self.fRec7[0] / fTemp12;
			let mut fTemp19: F32 = if (iTemp15 as i32 != 0) { if (iTemp16 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp16 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec2[0] } } } else { if (iTemp15 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp17, 0.33333334) } else { fTemp17 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp20: i32 = ((fTemp19) as i32);
			let mut fTemp21: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp20) as usize] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { 7424.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { 3.36e+03 } else { self.fRec10[1] };
			let mut fTemp22: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp23: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp22) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp22 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp24: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp25: F32 = self.fRec9[0] - fTemp24;
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp24)) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = fTemp26 + fTemp23;
			self.fRec11[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp27, self.fRec11[1] + 1.0) };
			let mut iTemp28: i32 = ((self.fRec11[0] < fTemp27) as i32);
			let mut iTemp29: i32 = ((self.fRec11[0] < fTemp26) as i32);
			let mut fTemp30: F32 = (self.fRec11[0] - fTemp26) / fTemp23;
			let mut fTemp31: F32 = self.fRec11[0] / fTemp26;
			let mut fTemp32: F32 = if (iTemp28 as i32 != 0) { if (iTemp29 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp24 } else { if (iTemp29 as i32 != 0) { fTemp24 + fTemp25 * if (((self.fRec9[0] > fTemp24) as i32) as i32 != 0) { F32::powf(fTemp31, 0.33333334) } else { fTemp31 } } else { self.fRec9[0] } } } else { if (iTemp28 as i32 != 0) { self.fRec9[0] + fTemp22 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp30, 0.33333334) } else { fTemp30 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp33: i32 = ((fTemp32) as i32);
			let mut fTemp34: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp33) as usize] };
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec13[1] };
			let mut fTemp35: F32 = self.fRec13[0] - self.fRec12[0];
			let mut fTemp36: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp37: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp38: F32 = self.fRec12[0] - fTemp37;
			let mut fTemp39: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp38) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 93.5) as i32)) as usize] } * if (((fTemp38 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp37)) + 2.0) } else { 0.96 }))));
			let mut fTemp40: F32 = fTemp39 + fTemp36;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp40, self.fRec14[1] + 1.0) };
			let mut iTemp41: i32 = ((self.fRec14[0] < fTemp40) as i32);
			let mut iTemp42: i32 = ((self.fRec14[0] < fTemp39) as i32);
			let mut fTemp43: F32 = (self.fRec14[0] - fTemp39) / fTemp36;
			let mut fTemp44: F32 = self.fRec14[0] / fTemp39;
			let mut fTemp45: F32 = if (iTemp41 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp37 } else { if (iTemp42 as i32 != 0) { fTemp37 + fTemp38 * if (((self.fRec12[0] > fTemp37) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec12[0] } } } else { if (iTemp41 as i32 != 0) { self.fRec12[0] + fTemp35 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp49: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec15[1] + self.fConst8 };
			self.fRec15[0] = fTemp49 - F32::floor(fTemp49);
			let mut fTemp50: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + self.fConst11 };
			self.fRec17[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst14 };
			self.fRec18[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp53: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp52) * (fTemp52 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp53 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp53 } else { self.fRec20[1] };
			let mut fTemp54: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp55: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp54) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp54 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp56: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp57: F32 = self.fRec19[0] - fTemp56;
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp11 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp56)) + 2.0) } else { 0.96 }))));
			let mut fTemp59: F32 = fTemp58 + fTemp55;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp59, self.fRec21[1] + 1.0) };
			let mut iTemp60: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp58) as i32);
			let mut fTemp62: F32 = (self.fRec21[0] - fTemp58) / fTemp55;
			let mut fTemp63: F32 = self.fRec21[0] / fTemp58;
			let mut fTemp64: F32 = if (iTemp60 as i32 != 0) { if (iTemp61 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp56 } else { if (iTemp61 as i32 != 0) { fTemp56 + fTemp57 * if (((self.fRec19[0] > fTemp56) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec19[0] } } } else { if (iTemp60 as i32 != 0) { self.fRec19[0] + fTemp54 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp65) as usize] };
			let mut fTemp67: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 92.0));
			let mut fTemp68: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp67) * (fTemp67 + 28.0);
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp68 + 4064.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp68 } else { self.fRec23[1] };
			let mut fTemp69: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp70: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp69) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 59.5) as i32)) as usize] } * if (((fTemp69 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp71: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp72: F32 = self.fRec22[0] - fTemp71;
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp72) / (fTemp11 * if (((fTemp72 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp71)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp70;
			let mut fTemp75: F32 = self.fRec22[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 64.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec24[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec24[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec24[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec24[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec24[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec24[0] - fTemp73) / fTemp70;
			let mut fTemp82: F32 = self.fRec24[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp71 } else { if (iTemp80 as i32 != 0) { fTemp71 + fTemp72 * if (((self.fRec22[0] > fTemp71) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp69 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec24[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec22[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec22[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst16 };
			self.fRec25[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp88: F32 = self.fRec12[0] - fTemp87;
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (fTemp11 * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp87)) + 2.0) } else { 0.96 }))));
			self.fRec27[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst17 + fTemp89, self.fRec27[1] + 1.0) };
			let mut iTemp90: i32 = ((self.fRec27[0] < fTemp89) as i32);
			let mut fTemp91: F32 = self.fRec27[0] / fTemp89;
			let mut fTemp92: F32 = if (((self.fRec27[0] < (self.fConst5 + fTemp89)) as i32) as i32 != 0) { if (iTemp90 as i32 != 0) { if (((self.fRec27[0] < 0.0) as i32) as i32 != 0) { fTemp87 } else { if (iTemp90 as i32 != 0) { fTemp87 + fTemp88 * if (((self.fRec12[0] > fTemp87) as i32) as i32 != 0) { F32::powf(fTemp91, 0.33333334) } else { fTemp91 } } else { self.fRec12[0] } } } else { self.fRec12[0] } } else { self.fRec12[0] };
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp93) as usize] };
			let mut fTemp95: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec28[1] + self.fConst18 };
			self.fRec28[0] = fTemp95 - F32::floor(fTemp95);
			self.fRec26[0] = 0.161 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec28[0] + 17.391304 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst20 };
			self.fRec29[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * (self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec25[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) + unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp34 + (fTemp32 - ((iTemp33) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp33, 1)) as usize] } - fTemp34)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp21 + (fTemp19 - ((iTemp20) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp20, 1)) as usize] } - fTemp21));
			self.fVec4[0] = fTemp97;
			self.fRec0[0] = 0.115 * (self.fConst21 * fTemp97 + self.fConst22 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow4 * self.fRec0[0];
			*output1 = fSlow5 * self.fRec0[0];
			*output2 = fSlow6 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec29[1] = self.fRec29[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Rimshot1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = 0.01 * self.fHslider1;
		let mut fSlow3: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider2 + 1.5));
		let mut fSlow4: F32 = fSlow3 * F32::min(1.0, 1.0 - fSlow2);
		let mut fSlow5: F32 = fSlow3 * F32::min(1.0, fSlow2 + 1.0);
		let mut fSlow6: F32 = 0.01 * self.fHslider3 * fSlow3;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 54.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp13, self.fRec7[1] + 1.0) };
			let mut iTemp15: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp12) as i32);
			let mut fTemp17: F32 = (self.fRec7[0] - fTemp12) / fTemp8;
			let mut fTemp18: F32 = self.fRec7[0] / fTemp12;
			let mut fTemp19: F32 = if (iTemp15 as i32 != 0) { if (iTemp16 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp16 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec2[0] } } } else { if (iTemp15 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp17, 0.33333334) } else { fTemp17 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp20: i32 = ((fTemp19) as i32);
			let mut fTemp21: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp20) as usize] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { 7424.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { 3.36e+03 } else { self.fRec10[1] };
			let mut fTemp22: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp23: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp22) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp22 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp24: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp25: F32 = self.fRec9[0] - fTemp24;
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp24)) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = fTemp26 + fTemp23;
			self.fRec11[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp27, self.fRec11[1] + 1.0) };
			let mut iTemp28: i32 = ((self.fRec11[0] < fTemp27) as i32);
			let mut iTemp29: i32 = ((self.fRec11[0] < fTemp26) as i32);
			let mut fTemp30: F32 = (self.fRec11[0] - fTemp26) / fTemp23;
			let mut fTemp31: F32 = self.fRec11[0] / fTemp26;
			let mut fTemp32: F32 = if (iTemp28 as i32 != 0) { if (iTemp29 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp24 } else { if (iTemp29 as i32 != 0) { fTemp24 + fTemp25 * if (((self.fRec9[0] > fTemp24) as i32) as i32 != 0) { F32::powf(fTemp31, 0.33333334) } else { fTemp31 } } else { self.fRec9[0] } } } else { if (iTemp28 as i32 != 0) { self.fRec9[0] + fTemp22 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp30, 0.33333334) } else { fTemp30 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp33: i32 = ((fTemp32) as i32);
			let mut fTemp34: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp33) as usize] };
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec13[1] };
			let mut fTemp35: F32 = self.fRec13[0] - self.fRec12[0];
			let mut fTemp36: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp37: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp38: F32 = self.fRec12[0] - fTemp37;
			let mut fTemp39: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp38) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 93.5) as i32)) as usize] } * if (((fTemp38 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp37)) + 2.0) } else { 0.96 }))));
			let mut fTemp40: F32 = fTemp39 + fTemp36;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp40, self.fRec14[1] + 1.0) };
			let mut iTemp41: i32 = ((self.fRec14[0] < fTemp40) as i32);
			let mut iTemp42: i32 = ((self.fRec14[0] < fTemp39) as i32);
			let mut fTemp43: F32 = (self.fRec14[0] - fTemp39) / fTemp36;
			let mut fTemp44: F32 = self.fRec14[0] / fTemp39;
			let mut fTemp45: F32 = if (iTemp41 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp37 } else { if (iTemp42 as i32 != 0) { fTemp37 + fTemp38 * if (((self.fRec12[0] > fTemp37) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec12[0] } } } else { if (iTemp41 as i32 != 0) { self.fRec12[0] + fTemp35 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp49: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec15[1] + self.fConst8 };
			self.fRec15[0] = fTemp49 - F32::floor(fTemp49);
			let mut fTemp50: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + self.fConst11 };
			self.fRec17[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst14 };
			self.fRec18[0] = fTemp51 - F32::floor(fTemp51);
			let mut fTemp52: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp53: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp52) * (fTemp52 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp53 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp53 } else { self.fRec20[1] };
			let mut fTemp54: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp55: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp54) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp54 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp56: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp57: F32 = self.fRec19[0] - fTemp56;
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp11 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp56)) + 2.0) } else { 0.96 }))));
			let mut fTemp59: F32 = fTemp58 + fTemp55;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp59, self.fRec21[1] + 1.0) };
			let mut iTemp60: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp58) as i32);
			let mut fTemp62: F32 = (self.fRec21[0] - fTemp58) / fTemp55;
			let mut fTemp63: F32 = self.fRec21[0] / fTemp58;
			let mut fTemp64: F32 = if (iTemp60 as i32 != 0) { if (iTemp61 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp56 } else { if (iTemp61 as i32 != 0) { fTemp56 + fTemp57 * if (((self.fRec19[0] > fTemp56) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec19[0] } } } else { if (iTemp60 as i32 != 0) { self.fRec19[0] + fTemp54 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp65: i32 = ((fTemp64) as i32);
			let mut fTemp66: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp65) as usize] };
			let mut fTemp67: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 92.0));
			let mut fTemp68: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp67) * (fTemp67 + 28.0);
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp68 + 4064.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp68 } else { self.fRec23[1] };
			let mut fTemp69: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp70: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp69) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 59.5) as i32)) as usize] } * if (((fTemp69 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp71: F32 = F32::max(5076.0, self.fRec22[0]);
			let mut fTemp72: F32 = self.fRec22[0] - fTemp71;
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp72) / (fTemp11 * if (((fTemp72 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp71)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp70;
			let mut fTemp75: F32 = self.fRec22[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Rimshot1SIG1[(((self.fRec6[0] + 64.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec24[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec24[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec24[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec24[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec24[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec24[0] - fTemp73) / fTemp70;
			let mut fTemp82: F32 = self.fRec24[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp71 } else { if (iTemp80 as i32 != 0) { fTemp71 + fTemp72 * if (((self.fRec22[0] > fTemp71) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp69 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec24[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec22[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec22[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst16 };
			self.fRec25[0] = fTemp86 - F32::floor(fTemp86);
			let mut fTemp87: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp88: F32 = self.fRec12[0] - fTemp87;
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (fTemp11 * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp87)) + 2.0) } else { 0.96 }))));
			self.fRec27[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst17 + fTemp89, self.fRec27[1] + 1.0) };
			let mut iTemp90: i32 = ((self.fRec27[0] < fTemp89) as i32);
			let mut fTemp91: F32 = self.fRec27[0] / fTemp89;
			let mut fTemp92: F32 = if (((self.fRec27[0] < (self.fConst5 + fTemp89)) as i32) as i32 != 0) { if (iTemp90 as i32 != 0) { if (((self.fRec27[0] < 0.0) as i32) as i32 != 0) { fTemp87 } else { if (iTemp90 as i32 != 0) { fTemp87 + fTemp88 * if (((self.fRec12[0] > fTemp87) as i32) as i32 != 0) { F32::powf(fTemp91, 0.33333334) } else { fTemp91 } } else { self.fRec12[0] } } } else { self.fRec12[0] } } else { self.fRec12[0] };
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl0DSP_Rimshot1SIG0[(iTemp93) as usize] };
			let mut fTemp95: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec28[1] + self.fConst18 };
			self.fRec28[0] = fTemp95 - F32::floor(fTemp95);
			self.fRec26[0] = 0.161 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec28[0] + 17.391304 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec29[1] + self.fConst20 };
			self.fRec29[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec29[0] + 17.391304 * (self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec25[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp66 + (fTemp64 - ((iTemp65) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp65, 1)) as usize] } - fTemp66)) + unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp34 + (fTemp32 - ((iTemp33) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp33, 1)) as usize] } - fTemp34)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp21 + (fTemp19 - ((iTemp20) as F32)) * (unsafe { ftbl0DSP_Rimshot1SIG0[(i32::wrapping_add(iTemp20, 1)) as usize] } - fTemp21));
			self.fVec4[0] = fTemp97;
			self.fRec0[0] = 0.115 * (self.fConst21 * fTemp97 + self.fConst22 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow4 * self.fRec0[0];
			*output1 = fSlow5 * self.fRec0[0];
			*output2 = fSlow6 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec29[1] = self.fRec29[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
