// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Rimshot2 -pn processRimshot2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Rimshot2SIG0 {
	iRec1: [i32;2],
}

impl DSP_Rimshot2SIG0 {
	
	fn get_num_inputsDSP_Rimshot2SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot2SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot2SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot2SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Rimshot2SIG0() -> DSP_Rimshot2SIG0 { 
	DSP_Rimshot2SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Rimshot2SIG1 {
	iRec5: [i32;2],
}

impl DSP_Rimshot2SIG1 {
	
	fn get_num_inputsDSP_Rimshot2SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot2SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot2SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot2SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Rimshot2SIG1() -> DSP_Rimshot2SIG1 { 
	DSP_Rimshot2SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Rimshot2SIG2 {
	iVec3: [i32;2],
	iRec9: [i32;2],
}

impl DSP_Rimshot2SIG2 {
	
	fn get_num_inputsDSP_Rimshot2SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot2SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot2SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec9[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot2SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec9[0] = (i32::wrapping_add(self.iVec3[1], self.iRec9[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec9[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec9[1] = self.iRec9[0];
		}
	}

}


pub fn newDSP_Rimshot2SIG2() -> DSP_Rimshot2SIG2 { 
	DSP_Rimshot2SIG2 {
		iVec3: [0;2],
		iRec9: [0;2],
	}
}

pub struct DSP_Rimshot2SIG3 {
	iRec15: [i32;2],
}

impl DSP_Rimshot2SIG3 {
	
	fn get_num_inputsDSP_Rimshot2SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot2SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot2SIG3(&mut self, sample_rate: i32) {
		for l17 in 0..2 {
			self.iRec15[(l17) as usize] = 0;
		}
	}
	
	fn fillDSP_Rimshot2SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec15[0] = i32::wrapping_add(self.iRec15[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec15[0], -1)) as F32) + -128.0));
			self.iRec15[1] = self.iRec15[0];
		}
	}

}


pub fn newDSP_Rimshot2SIG3() -> DSP_Rimshot2SIG3 { 
	DSP_Rimshot2SIG3 {
		iRec15: [0;2],
	}
}
static mut iDSP_Rimshot2SIG4Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Rimshot2SIG4 {
	iDSP_Rimshot2SIG4Wave0_idx: i32,
}

impl DSP_Rimshot2SIG4 {
	
	fn get_num_inputsDSP_Rimshot2SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Rimshot2SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Rimshot2SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Rimshot2SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Rimshot2SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Rimshot2SIG4Wave0[(self.iDSP_Rimshot2SIG4Wave0_idx) as usize] };
			self.iDSP_Rimshot2SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Rimshot2SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Rimshot2SIG4() -> DSP_Rimshot2SIG4 { 
	DSP_Rimshot2SIG4 {
		iDSP_Rimshot2SIG4Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Rimshot2SIG0: [F32;16384] = [0.0;16384];
fn DSP_Rimshot2_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Rimshot2SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Rimshot2SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Rimshot2SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Rimshot2SIG4: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Rimshot2 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fRec2: [F32;2],
	fRec4: [F32;2],
	fHslider1: F32,
	fRec6: [F32;2],
	fRec7: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fRec13: [F32;2],
	iConst5: i32,
	iRec16: [i32;2],
	fConst6: F32,
	fRec14: [F32;2],
	fConst7: F32,
	fRec17: [F32;2],
	fRec19: [F32;2],
	fRec20: [F32;2],
	fRec21: [F32;2],
	fRec22: [F32;2],
	fRec18: [F32;2],
	fVec4: [F32;2],
	fConst8: F32,
	fConst9: F32,
	fRec0: [F32;2],
	fHslider2: F32,
	fHslider3: F32,
	fHslider4: F32,
}

impl FaustDsp for DSP_Rimshot2 {
	type T = F32;
		
	fn new() -> DSP_Rimshot2 { 
		DSP_Rimshot2 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fHslider1: 0.0,
			fRec6: [0.0;2],
			fRec7: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			iConst5: 0,
			iRec16: [0;2],
			fConst6: 0.0,
			fRec14: [0.0;2],
			fConst7: 0.0,
			fRec17: [0.0;2],
			fRec19: [0.0;2],
			fRec20: [0.0;2],
			fRec21: [0.0;2],
			fRec22: [0.0;2],
			fRec18: [0.0;2],
			fVec4: [0.0;2],
			fConst8: 0.0,
			fConst9: 0.0,
			fRec0: [0.0;2],
			fHslider2: 0.0,
			fHslider3: 0.0,
			fHslider4: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Rimshot2 -pn processRimshot2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Rimshot2SIG0 = newDSP_Rimshot2SIG0();
		sig0.instance_initDSP_Rimshot2SIG0(sample_rate);
		sig0.fillDSP_Rimshot2SIG0(16384, unsafe { &mut ftbl0DSP_Rimshot2SIG0 });
		let mut sig1: DSP_Rimshot2SIG1 = newDSP_Rimshot2SIG1();
		sig1.instance_initDSP_Rimshot2SIG1(sample_rate);
		sig1.fillDSP_Rimshot2SIG1(144, unsafe { &mut ftbl1DSP_Rimshot2SIG1 });
		let mut sig2: DSP_Rimshot2SIG2 = newDSP_Rimshot2SIG2();
		sig2.instance_initDSP_Rimshot2SIG2(sample_rate);
		sig2.fillDSP_Rimshot2SIG2(1024, unsafe { &mut ftbl2DSP_Rimshot2SIG2 });
		let mut sig3: DSP_Rimshot2SIG3 = newDSP_Rimshot2SIG3();
		sig3.instance_initDSP_Rimshot2SIG3(sample_rate);
		sig3.fillDSP_Rimshot2SIG3(4096, unsafe { &mut ftbl3DSP_Rimshot2SIG3 });
		let mut sig4: DSP_Rimshot2SIG4 = newDSP_Rimshot2SIG4();
		sig4.instance_initDSP_Rimshot2SIG4(sample_rate);
		sig4.fillDSP_Rimshot2SIG4(100, unsafe { &mut itbl4DSP_Rimshot2SIG4 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 36.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec8[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.iRec16[(l18) as usize] = 0;
		}
		for l19 in 0..2 {
			self.fRec14[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec17[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec19[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec20[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec21[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec22[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec18[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fVec4[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec0[(l27) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.iConst5 = unsafe { itbl4DSP_Rimshot2SIG4[50] };
		self.fConst6 = 305.8 / self.fConst0;
		self.fConst7 = 23733.6 / self.fConst0;
		self.fConst8 = 1.0 / (fConst1 * fConst3);
		self.fConst9 = 0.0 - self.fConst8;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Rimshot2::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "8", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(3), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(4), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(5), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			4 => Some(self.fHslider0),
			5 => Some(self.fHslider1),
			2 => Some(self.fHslider2),
			1 => Some(self.fHslider3),
			3 => Some(self.fHslider4),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			4 => { self.fHslider0 = value }
			5 => { self.fHslider1 = value }
			2 => { self.fHslider2 = value }
			1 => { self.fHslider3 = value }
			3 => { self.fHslider4 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider1;
		let mut fSlow3: F32 = 0.14285715 * (0.33333334 * (fSlow2 + -21.0) + 1.0);
		let mut fSlow4: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -9e+01));
		let mut fSlow5: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow4, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow6: i32 = ((fSlow5) as i32);
		let mut fSlow7: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iSlow6) as usize] };
		let mut fSlow8: F32 = fSlow7 + (fSlow5 - ((iSlow6) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iSlow6, 1)) as usize] } - fSlow7);
		let mut fSlow9: F32 = self.fConst6 * fSlow4;
		let mut fSlow10: F32 = self.fConst7 * fSlow4;
		let mut fSlow11: F32 = 0.01 * self.fHslider2;
		let mut fSlow12: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + -2.0));
		let mut fSlow13: F32 = fSlow12 * F32::min(1.0, 1.0 - fSlow11);
		let mut fSlow14: F32 = fSlow12 * F32::min(1.0, fSlow11 + 1.0);
		let mut fSlow15: F32 = 0.01 * self.fHslider4 * fSlow12;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3.84e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25);
			let mut fTemp27: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 99.0));
			let mut fTemp28: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp27) * (fTemp27 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp28 + 3744.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp28 + 2432.0 } else { self.fRec11[1] };
			let mut fTemp29: F32 = self.fRec11[0] - self.fRec10[0];
			let mut fTemp30: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 72.5) as i32)) as usize] };
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp29) / (fTemp30 * if (((fTemp29 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp28 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp33: F32 = self.fRec10[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp11 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp34 + fTemp31;
			let mut fTemp36: F32 = self.fRec12[0] - self.fRec11[0];
			let mut fTemp37: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 20.5) as i32)) as usize] };
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp36) / (fTemp37 * if (((fTemp36 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp39: F32 = fTemp35 + fTemp38;
			self.fRec13[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp39, self.fRec13[1] + 1.0) };
			let mut iTemp40: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp41: F32 = (self.fRec13[0] - fTemp35) / fTemp38;
			let mut iTemp42: i32 = ((self.fRec13[0] < fTemp34) as i32);
			let mut fTemp43: F32 = (self.fRec13[0] - fTemp34) / fTemp31;
			let mut fTemp44: F32 = self.fRec13[0] / fTemp34;
			let mut fTemp45: F32 = if (iTemp40 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp42 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec10[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec10[0] } } } else { if (iTemp40 as i32 != 0) { self.fRec10[0] + fTemp29 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec11[0] } } } else { if (((self.fRec13[0] < fTemp39) as i32) as i32 != 0) { self.fRec11[0] + fTemp36 * if (((self.fRec12[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec12[0] } };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec16[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec16[1] };
			let mut fTemp49: F32 = 15.996094 * (0.4 * ((self.iRec16[0]) as F32) + 128.0);
			let mut iTemp50: i32 = ((fTemp49) as i32);
			let mut fTemp51: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iTemp50) as usize] };
			let mut fTemp52: F32 = fSlow8 * (fTemp51 + (fTemp49 - ((iTemp50) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iTemp50, 1)) as usize] } - fTemp51));
			let mut fTemp53: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec14[1] + fSlow9 * fTemp52 };
			self.fRec14[0] = fTemp53 - F32::floor(fTemp53);
			let mut fTemp54: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + fSlow10 * fTemp52 };
			self.fRec17[0] = fTemp54 - F32::floor(fTemp54);
			let mut fTemp55: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp56: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp55) * (fTemp55 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp56 + 3744.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp56 + 2432.0 } else { self.fRec20[1] };
			let mut fTemp57: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp30 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp56 } else { self.fRec21[1] };
			let mut fTemp59: F32 = F32::max(5076.0, self.fRec21[0]);
			let mut fTemp60: F32 = self.fRec19[0] - fTemp59;
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp11 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp59)) + 2.0) } else { 0.96 }))));
			let mut fTemp62: F32 = fTemp61 + fTemp58;
			let mut fTemp63: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp64: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp63) / (fTemp37 * if (((fTemp63 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp65: F32 = fTemp62 + fTemp64;
			self.fRec22[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp65, self.fRec22[1] + 1.0) };
			let mut iTemp66: i32 = ((self.fRec22[0] < fTemp62) as i32);
			let mut fTemp67: F32 = (self.fRec22[0] - fTemp62) / fTemp64;
			let mut iTemp68: i32 = ((self.fRec22[0] < fTemp61) as i32);
			let mut fTemp69: F32 = (self.fRec22[0] - fTemp61) / fTemp58;
			let mut fTemp70: F32 = self.fRec22[0] / fTemp61;
			let mut fTemp71: F32 = if (iTemp66 as i32 != 0) { if (iTemp68 as i32 != 0) { if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { fTemp59 } else { if (iTemp68 as i32 != 0) { fTemp59 + fTemp60 * if (((self.fRec19[0] > fTemp59) as i32) as i32 != 0) { F32::powf(fTemp70, 0.33333334) } else { fTemp70 } } else { self.fRec19[0] } } } else { if (iTemp66 as i32 != 0) { self.fRec19[0] + fTemp57 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp69, 0.33333334) } else { fTemp69 } } else { self.fRec20[0] } } } else { if (((self.fRec22[0] < fTemp65) as i32) as i32 != 0) { self.fRec20[0] + fTemp63 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp67, 0.33333334) } else { fTemp67 } } else { self.fRec21[0] } };
			let mut iTemp72: i32 = ((fTemp71) as i32);
			let mut fTemp73: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp72) as usize] };
			self.fRec18[0] = 0.115 * fTemp26 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec14[0] + 13.913043 * self.fRec18[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp73 + (fTemp71 - ((iTemp72) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp72, 1)) as usize] } - fTemp73)) + 1e+01)) as i32) % 1024) as usize] };
			let mut fTemp74: F32 = self.fRec18[0] + 0.23 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * self.fRec14[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * fTemp26;
			self.fVec4[0] = fTemp74;
			self.fRec0[0] = 0.5 * (self.fConst8 * fTemp74 + self.fConst9 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow13 * self.fRec0[0];
			*output1 = fSlow14 * self.fRec0[0];
			*output2 = fSlow15 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.iRec16[1] = self.iRec16[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec18[1] = self.fRec18[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Rimshot2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Rimshot2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider1;
		let mut fSlow3: F32 = 0.14285715 * (0.33333334 * (fSlow2 + -21.0) + 1.0);
		let mut fSlow4: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -9e+01));
		let mut fSlow5: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow4, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow6: i32 = ((fSlow5) as i32);
		let mut fSlow7: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iSlow6) as usize] };
		let mut fSlow8: F32 = fSlow7 + (fSlow5 - ((iSlow6) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iSlow6, 1)) as usize] } - fSlow7);
		let mut fSlow9: F32 = self.fConst6 * fSlow4;
		let mut fSlow10: F32 = self.fConst7 * fSlow4;
		let mut fSlow11: F32 = 0.01 * self.fHslider2;
		let mut fSlow12: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + -2.0));
		let mut fSlow13: F32 = fSlow12 * F32::min(1.0, 1.0 - fSlow11);
		let mut fSlow14: F32 = fSlow12 * F32::min(1.0, fSlow11 + 1.0);
		let mut fSlow15: F32 = 0.01 * self.fHslider4 * fSlow12;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3.84e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25);
			let mut fTemp27: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 99.0));
			let mut fTemp28: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp27) * (fTemp27 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp28 + 3744.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp28 + 2432.0 } else { self.fRec11[1] };
			let mut fTemp29: F32 = self.fRec11[0] - self.fRec10[0];
			let mut fTemp30: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 72.5) as i32)) as usize] };
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp29) / (fTemp30 * if (((fTemp29 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp28 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp33: F32 = self.fRec10[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp11 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp34 + fTemp31;
			let mut fTemp36: F32 = self.fRec12[0] - self.fRec11[0];
			let mut fTemp37: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 20.5) as i32)) as usize] };
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp36) / (fTemp37 * if (((fTemp36 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp39: F32 = fTemp35 + fTemp38;
			self.fRec13[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp39, self.fRec13[1] + 1.0) };
			let mut iTemp40: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp41: F32 = (self.fRec13[0] - fTemp35) / fTemp38;
			let mut iTemp42: i32 = ((self.fRec13[0] < fTemp34) as i32);
			let mut fTemp43: F32 = (self.fRec13[0] - fTemp34) / fTemp31;
			let mut fTemp44: F32 = self.fRec13[0] / fTemp34;
			let mut fTemp45: F32 = if (iTemp40 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp42 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec10[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec10[0] } } } else { if (iTemp40 as i32 != 0) { self.fRec10[0] + fTemp29 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec11[0] } } } else { if (((self.fRec13[0] < fTemp39) as i32) as i32 != 0) { self.fRec11[0] + fTemp36 * if (((self.fRec12[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec12[0] } };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec16[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec16[1] };
			let mut fTemp49: F32 = 15.996094 * (0.4 * ((self.iRec16[0]) as F32) + 128.0);
			let mut iTemp50: i32 = ((fTemp49) as i32);
			let mut fTemp51: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iTemp50) as usize] };
			let mut fTemp52: F32 = fSlow8 * (fTemp51 + (fTemp49 - ((iTemp50) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iTemp50, 1)) as usize] } - fTemp51));
			let mut fTemp53: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec14[1] + fSlow9 * fTemp52 };
			self.fRec14[0] = fTemp53 - F32::floor(fTemp53);
			let mut fTemp54: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + fSlow10 * fTemp52 };
			self.fRec17[0] = fTemp54 - F32::floor(fTemp54);
			let mut fTemp55: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp56: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp55) * (fTemp55 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp56 + 3744.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp56 + 2432.0 } else { self.fRec20[1] };
			let mut fTemp57: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp30 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp56 } else { self.fRec21[1] };
			let mut fTemp59: F32 = F32::max(5076.0, self.fRec21[0]);
			let mut fTemp60: F32 = self.fRec19[0] - fTemp59;
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp11 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp59)) + 2.0) } else { 0.96 }))));
			let mut fTemp62: F32 = fTemp61 + fTemp58;
			let mut fTemp63: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp64: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp63) / (fTemp37 * if (((fTemp63 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp65: F32 = fTemp62 + fTemp64;
			self.fRec22[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp65, self.fRec22[1] + 1.0) };
			let mut iTemp66: i32 = ((self.fRec22[0] < fTemp62) as i32);
			let mut fTemp67: F32 = (self.fRec22[0] - fTemp62) / fTemp64;
			let mut iTemp68: i32 = ((self.fRec22[0] < fTemp61) as i32);
			let mut fTemp69: F32 = (self.fRec22[0] - fTemp61) / fTemp58;
			let mut fTemp70: F32 = self.fRec22[0] / fTemp61;
			let mut fTemp71: F32 = if (iTemp66 as i32 != 0) { if (iTemp68 as i32 != 0) { if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { fTemp59 } else { if (iTemp68 as i32 != 0) { fTemp59 + fTemp60 * if (((self.fRec19[0] > fTemp59) as i32) as i32 != 0) { F32::powf(fTemp70, 0.33333334) } else { fTemp70 } } else { self.fRec19[0] } } } else { if (iTemp66 as i32 != 0) { self.fRec19[0] + fTemp57 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp69, 0.33333334) } else { fTemp69 } } else { self.fRec20[0] } } } else { if (((self.fRec22[0] < fTemp65) as i32) as i32 != 0) { self.fRec20[0] + fTemp63 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp67, 0.33333334) } else { fTemp67 } } else { self.fRec21[0] } };
			let mut iTemp72: i32 = ((fTemp71) as i32);
			let mut fTemp73: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp72) as usize] };
			self.fRec18[0] = 0.115 * fTemp26 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec14[0] + 13.913043 * self.fRec18[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp73 + (fTemp71 - ((iTemp72) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp72, 1)) as usize] } - fTemp73)) + 1e+01)) as i32) % 1024) as usize] };
			let mut fTemp74: F32 = self.fRec18[0] + 0.23 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * self.fRec14[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * fTemp26;
			self.fVec4[0] = fTemp74;
			self.fRec0[0] = 0.5 * (self.fConst8 * fTemp74 + self.fConst9 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow13 * self.fRec0[0];
			*output1 = fSlow14 * self.fRec0[0];
			*output2 = fSlow15 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.iRec16[1] = self.iRec16[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec18[1] = self.fRec18[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Rimshot2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider1;
		let mut fSlow3: F32 = 0.14285715 * (0.33333334 * (fSlow2 + -21.0) + 1.0);
		let mut fSlow4: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -9e+01));
		let mut fSlow5: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow4, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow6: i32 = ((fSlow5) as i32);
		let mut fSlow7: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iSlow6) as usize] };
		let mut fSlow8: F32 = fSlow7 + (fSlow5 - ((iSlow6) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iSlow6, 1)) as usize] } - fSlow7);
		let mut fSlow9: F32 = self.fConst6 * fSlow4;
		let mut fSlow10: F32 = self.fConst7 * fSlow4;
		let mut fSlow11: F32 = 0.01 * self.fHslider2;
		let mut fSlow12: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + -2.0));
		let mut fSlow13: F32 = fSlow12 * F32::min(1.0, 1.0 - fSlow11);
		let mut fSlow14: F32 = fSlow12 * F32::min(1.0, fSlow11 + 1.0);
		let mut fSlow15: F32 = 0.01 * self.fHslider4 * fSlow12;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3.84e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25);
			let mut fTemp27: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 99.0));
			let mut fTemp28: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp27) * (fTemp27 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp28 + 3744.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp28 + 2432.0 } else { self.fRec11[1] };
			let mut fTemp29: F32 = self.fRec11[0] - self.fRec10[0];
			let mut fTemp30: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 72.5) as i32)) as usize] };
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp29) / (fTemp30 * if (((fTemp29 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp28 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp33: F32 = self.fRec10[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp11 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp34 + fTemp31;
			let mut fTemp36: F32 = self.fRec12[0] - self.fRec11[0];
			let mut fTemp37: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 20.5) as i32)) as usize] };
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp36) / (fTemp37 * if (((fTemp36 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp39: F32 = fTemp35 + fTemp38;
			self.fRec13[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp39, self.fRec13[1] + 1.0) };
			let mut iTemp40: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp41: F32 = (self.fRec13[0] - fTemp35) / fTemp38;
			let mut iTemp42: i32 = ((self.fRec13[0] < fTemp34) as i32);
			let mut fTemp43: F32 = (self.fRec13[0] - fTemp34) / fTemp31;
			let mut fTemp44: F32 = self.fRec13[0] / fTemp34;
			let mut fTemp45: F32 = if (iTemp40 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp42 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec10[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec10[0] } } } else { if (iTemp40 as i32 != 0) { self.fRec10[0] + fTemp29 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec11[0] } } } else { if (((self.fRec13[0] < fTemp39) as i32) as i32 != 0) { self.fRec11[0] + fTemp36 * if (((self.fRec12[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec12[0] } };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec16[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec16[1] };
			let mut fTemp49: F32 = 15.996094 * (0.4 * ((self.iRec16[0]) as F32) + 128.0);
			let mut iTemp50: i32 = ((fTemp49) as i32);
			let mut fTemp51: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iTemp50) as usize] };
			let mut fTemp52: F32 = fSlow8 * (fTemp51 + (fTemp49 - ((iTemp50) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iTemp50, 1)) as usize] } - fTemp51));
			let mut fTemp53: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec14[1] + fSlow9 * fTemp52 };
			self.fRec14[0] = fTemp53 - F32::floor(fTemp53);
			let mut fTemp54: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + fSlow10 * fTemp52 };
			self.fRec17[0] = fTemp54 - F32::floor(fTemp54);
			let mut fTemp55: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp56: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp55) * (fTemp55 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp56 + 3744.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp56 + 2432.0 } else { self.fRec20[1] };
			let mut fTemp57: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp30 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp56 } else { self.fRec21[1] };
			let mut fTemp59: F32 = F32::max(5076.0, self.fRec21[0]);
			let mut fTemp60: F32 = self.fRec19[0] - fTemp59;
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp11 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp59)) + 2.0) } else { 0.96 }))));
			let mut fTemp62: F32 = fTemp61 + fTemp58;
			let mut fTemp63: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp64: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp63) / (fTemp37 * if (((fTemp63 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp65: F32 = fTemp62 + fTemp64;
			self.fRec22[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp65, self.fRec22[1] + 1.0) };
			let mut iTemp66: i32 = ((self.fRec22[0] < fTemp62) as i32);
			let mut fTemp67: F32 = (self.fRec22[0] - fTemp62) / fTemp64;
			let mut iTemp68: i32 = ((self.fRec22[0] < fTemp61) as i32);
			let mut fTemp69: F32 = (self.fRec22[0] - fTemp61) / fTemp58;
			let mut fTemp70: F32 = self.fRec22[0] / fTemp61;
			let mut fTemp71: F32 = if (iTemp66 as i32 != 0) { if (iTemp68 as i32 != 0) { if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { fTemp59 } else { if (iTemp68 as i32 != 0) { fTemp59 + fTemp60 * if (((self.fRec19[0] > fTemp59) as i32) as i32 != 0) { F32::powf(fTemp70, 0.33333334) } else { fTemp70 } } else { self.fRec19[0] } } } else { if (iTemp66 as i32 != 0) { self.fRec19[0] + fTemp57 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp69, 0.33333334) } else { fTemp69 } } else { self.fRec20[0] } } } else { if (((self.fRec22[0] < fTemp65) as i32) as i32 != 0) { self.fRec20[0] + fTemp63 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp67, 0.33333334) } else { fTemp67 } } else { self.fRec21[0] } };
			let mut iTemp72: i32 = ((fTemp71) as i32);
			let mut fTemp73: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp72) as usize] };
			self.fRec18[0] = 0.115 * fTemp26 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec14[0] + 13.913043 * self.fRec18[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp73 + (fTemp71 - ((iTemp72) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp72, 1)) as usize] } - fTemp73)) + 1e+01)) as i32) % 1024) as usize] };
			let mut fTemp74: F32 = self.fRec18[0] + 0.23 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * self.fRec14[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * fTemp26;
			self.fVec4[0] = fTemp74;
			self.fRec0[0] = 0.5 * (self.fConst8 * fTemp74 + self.fConst9 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow13 * self.fRec0[0];
			*output1 = fSlow14 * self.fRec0[0];
			*output2 = fSlow15 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.iRec16[1] = self.iRec16[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec18[1] = self.fRec18[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Rimshot2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider1;
		let mut fSlow3: F32 = 0.14285715 * (0.33333334 * (fSlow2 + -21.0) + 1.0);
		let mut fSlow4: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -9e+01));
		let mut fSlow5: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow4, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow6: i32 = ((fSlow5) as i32);
		let mut fSlow7: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iSlow6) as usize] };
		let mut fSlow8: F32 = fSlow7 + (fSlow5 - ((iSlow6) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iSlow6, 1)) as usize] } - fSlow7);
		let mut fSlow9: F32 = self.fConst6 * fSlow4;
		let mut fSlow10: F32 = self.fConst7 * fSlow4;
		let mut fSlow11: F32 = 0.01 * self.fHslider2;
		let mut fSlow12: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + -2.0));
		let mut fSlow13: F32 = fSlow12 * F32::min(1.0, 1.0 - fSlow11);
		let mut fSlow14: F32 = fSlow12 * F32::min(1.0, fSlow11 + 1.0);
		let mut fSlow15: F32 = 0.01 * self.fHslider4 * fSlow12;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3.84e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25);
			let mut fTemp27: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 99.0));
			let mut fTemp28: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp27) * (fTemp27 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp28 + 3744.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp28 + 2432.0 } else { self.fRec11[1] };
			let mut fTemp29: F32 = self.fRec11[0] - self.fRec10[0];
			let mut fTemp30: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 72.5) as i32)) as usize] };
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp29) / (fTemp30 * if (((fTemp29 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp28 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp33: F32 = self.fRec10[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp11 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp34 + fTemp31;
			let mut fTemp36: F32 = self.fRec12[0] - self.fRec11[0];
			let mut fTemp37: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 20.5) as i32)) as usize] };
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp36) / (fTemp37 * if (((fTemp36 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp39: F32 = fTemp35 + fTemp38;
			self.fRec13[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp39, self.fRec13[1] + 1.0) };
			let mut iTemp40: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp41: F32 = (self.fRec13[0] - fTemp35) / fTemp38;
			let mut iTemp42: i32 = ((self.fRec13[0] < fTemp34) as i32);
			let mut fTemp43: F32 = (self.fRec13[0] - fTemp34) / fTemp31;
			let mut fTemp44: F32 = self.fRec13[0] / fTemp34;
			let mut fTemp45: F32 = if (iTemp40 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp42 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec10[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec10[0] } } } else { if (iTemp40 as i32 != 0) { self.fRec10[0] + fTemp29 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec11[0] } } } else { if (((self.fRec13[0] < fTemp39) as i32) as i32 != 0) { self.fRec11[0] + fTemp36 * if (((self.fRec12[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec12[0] } };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec16[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec16[1] };
			let mut fTemp49: F32 = 15.996094 * (0.4 * ((self.iRec16[0]) as F32) + 128.0);
			let mut iTemp50: i32 = ((fTemp49) as i32);
			let mut fTemp51: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iTemp50) as usize] };
			let mut fTemp52: F32 = fSlow8 * (fTemp51 + (fTemp49 - ((iTemp50) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iTemp50, 1)) as usize] } - fTemp51));
			let mut fTemp53: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec14[1] + fSlow9 * fTemp52 };
			self.fRec14[0] = fTemp53 - F32::floor(fTemp53);
			let mut fTemp54: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + fSlow10 * fTemp52 };
			self.fRec17[0] = fTemp54 - F32::floor(fTemp54);
			let mut fTemp55: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp56: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp55) * (fTemp55 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp56 + 3744.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp56 + 2432.0 } else { self.fRec20[1] };
			let mut fTemp57: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp30 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp56 } else { self.fRec21[1] };
			let mut fTemp59: F32 = F32::max(5076.0, self.fRec21[0]);
			let mut fTemp60: F32 = self.fRec19[0] - fTemp59;
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp11 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp59)) + 2.0) } else { 0.96 }))));
			let mut fTemp62: F32 = fTemp61 + fTemp58;
			let mut fTemp63: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp64: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp63) / (fTemp37 * if (((fTemp63 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp65: F32 = fTemp62 + fTemp64;
			self.fRec22[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp65, self.fRec22[1] + 1.0) };
			let mut iTemp66: i32 = ((self.fRec22[0] < fTemp62) as i32);
			let mut fTemp67: F32 = (self.fRec22[0] - fTemp62) / fTemp64;
			let mut iTemp68: i32 = ((self.fRec22[0] < fTemp61) as i32);
			let mut fTemp69: F32 = (self.fRec22[0] - fTemp61) / fTemp58;
			let mut fTemp70: F32 = self.fRec22[0] / fTemp61;
			let mut fTemp71: F32 = if (iTemp66 as i32 != 0) { if (iTemp68 as i32 != 0) { if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { fTemp59 } else { if (iTemp68 as i32 != 0) { fTemp59 + fTemp60 * if (((self.fRec19[0] > fTemp59) as i32) as i32 != 0) { F32::powf(fTemp70, 0.33333334) } else { fTemp70 } } else { self.fRec19[0] } } } else { if (iTemp66 as i32 != 0) { self.fRec19[0] + fTemp57 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp69, 0.33333334) } else { fTemp69 } } else { self.fRec20[0] } } } else { if (((self.fRec22[0] < fTemp65) as i32) as i32 != 0) { self.fRec20[0] + fTemp63 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp67, 0.33333334) } else { fTemp67 } } else { self.fRec21[0] } };
			let mut iTemp72: i32 = ((fTemp71) as i32);
			let mut fTemp73: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp72) as usize] };
			self.fRec18[0] = 0.115 * fTemp26 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec14[0] + 13.913043 * self.fRec18[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp73 + (fTemp71 - ((iTemp72) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp72, 1)) as usize] } - fTemp73)) + 1e+01)) as i32) % 1024) as usize] };
			let mut fTemp74: F32 = self.fRec18[0] + 0.23 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * self.fRec14[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * fTemp26;
			self.fVec4[0] = fTemp74;
			self.fRec0[0] = 0.5 * (self.fConst8 * fTemp74 + self.fConst9 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow13 * self.fRec0[0];
			*output1 = fSlow14 * self.fRec0[0];
			*output2 = fSlow15 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.iRec16[1] = self.iRec16[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec18[1] = self.fRec18[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Rimshot2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Rimshot2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Rimshot2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider1;
		let mut fSlow3: F32 = 0.14285715 * (0.33333334 * (fSlow2 + -21.0) + 1.0);
		let mut fSlow4: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -9e+01));
		let mut fSlow5: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow4, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow6: i32 = ((fSlow5) as i32);
		let mut fSlow7: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iSlow6) as usize] };
		let mut fSlow8: F32 = fSlow7 + (fSlow5 - ((iSlow6) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iSlow6, 1)) as usize] } - fSlow7);
		let mut fSlow9: F32 = self.fConst6 * fSlow4;
		let mut fSlow10: F32 = self.fConst7 * fSlow4;
		let mut fSlow11: F32 = 0.01 * self.fHslider2;
		let mut fSlow12: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider3 + -2.0));
		let mut fSlow13: F32 = fSlow12 * F32::min(1.0, 1.0 - fSlow11);
		let mut fSlow14: F32 = fSlow12 * F32::min(1.0, fSlow11 + 1.0);
		let mut fSlow15: F32 = 0.01 * self.fHslider4 * fSlow12;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Rimshot2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3.84e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 61.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25);
			let mut fTemp27: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 99.0));
			let mut fTemp28: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp27) * (fTemp27 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp28 + 3744.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp28 + 2432.0 } else { self.fRec11[1] };
			let mut fTemp29: F32 = self.fRec11[0] - self.fRec10[0];
			let mut fTemp30: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 72.5) as i32)) as usize] };
			let mut fTemp31: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp29) / (fTemp30 * if (((fTemp29 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp28 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(5076.0, self.fRec12[0]);
			let mut fTemp33: F32 = self.fRec10[0] - fTemp32;
			let mut fTemp34: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp33) / (fTemp11 * if (((fTemp33 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp32)) + 2.0) } else { 0.96 }))));
			let mut fTemp35: F32 = fTemp34 + fTemp31;
			let mut fTemp36: F32 = self.fRec12[0] - self.fRec11[0];
			let mut fTemp37: F32 = unsafe { ftbl1DSP_Rimshot2SIG1[(((self.fRec6[0] + 20.5) as i32)) as usize] };
			let mut fTemp38: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp36) / (fTemp37 * if (((fTemp36 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp39: F32 = fTemp35 + fTemp38;
			self.fRec13[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp39, self.fRec13[1] + 1.0) };
			let mut iTemp40: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp41: F32 = (self.fRec13[0] - fTemp35) / fTemp38;
			let mut iTemp42: i32 = ((self.fRec13[0] < fTemp34) as i32);
			let mut fTemp43: F32 = (self.fRec13[0] - fTemp34) / fTemp31;
			let mut fTemp44: F32 = self.fRec13[0] / fTemp34;
			let mut fTemp45: F32 = if (iTemp40 as i32 != 0) { if (iTemp42 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp32 } else { if (iTemp42 as i32 != 0) { fTemp32 + fTemp33 * if (((self.fRec10[0] > fTemp32) as i32) as i32 != 0) { F32::powf(fTemp44, 0.33333334) } else { fTemp44 } } else { self.fRec10[0] } } } else { if (iTemp40 as i32 != 0) { self.fRec10[0] + fTemp29 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp43, 0.33333334) } else { fTemp43 } } else { self.fRec11[0] } } } else { if (((self.fRec13[0] < fTemp39) as i32) as i32 != 0) { self.fRec11[0] + fTemp36 * if (((self.fRec12[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec12[0] } };
			let mut iTemp46: i32 = ((fTemp45) as i32);
			let mut fTemp47: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp46) as usize] };
			let mut iTemp48: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec16[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec16[1] };
			let mut fTemp49: F32 = 15.996094 * (0.4 * ((self.iRec16[0]) as F32) + 128.0);
			let mut iTemp50: i32 = ((fTemp49) as i32);
			let mut fTemp51: F32 = unsafe { ftbl3DSP_Rimshot2SIG3[(iTemp50) as usize] };
			let mut fTemp52: F32 = fSlow8 * (fTemp51 + (fTemp49 - ((iTemp50) as F32)) * (unsafe { ftbl3DSP_Rimshot2SIG3[(i32::wrapping_add(iTemp50, 1)) as usize] } - fTemp51));
			let mut fTemp53: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec14[1] + fSlow9 * fTemp52 };
			self.fRec14[0] = fTemp53 - F32::floor(fTemp53);
			let mut fTemp54: F32 = if (iTemp48 as i32 != 0) { 0.0 } else { self.fRec17[1] + fSlow10 * fTemp52 };
			self.fRec17[0] = fTemp54 - F32::floor(fTemp54);
			let mut fTemp55: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 99.0));
			let mut fTemp56: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp55) * (fTemp55 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp56 + 3744.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp56 + 2432.0 } else { self.fRec20[1] };
			let mut fTemp57: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp58: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp57) / (fTemp30 * if (((fTemp57 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp56 } else { self.fRec21[1] };
			let mut fTemp59: F32 = F32::max(5076.0, self.fRec21[0]);
			let mut fTemp60: F32 = self.fRec19[0] - fTemp59;
			let mut fTemp61: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp60) / (fTemp11 * if (((fTemp60 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp59)) + 2.0) } else { 0.96 }))));
			let mut fTemp62: F32 = fTemp61 + fTemp58;
			let mut fTemp63: F32 = self.fRec21[0] - self.fRec20[0];
			let mut fTemp64: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp63) / (fTemp37 * if (((fTemp63 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec20[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp65: F32 = fTemp62 + fTemp64;
			self.fRec22[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp65, self.fRec22[1] + 1.0) };
			let mut iTemp66: i32 = ((self.fRec22[0] < fTemp62) as i32);
			let mut fTemp67: F32 = (self.fRec22[0] - fTemp62) / fTemp64;
			let mut iTemp68: i32 = ((self.fRec22[0] < fTemp61) as i32);
			let mut fTemp69: F32 = (self.fRec22[0] - fTemp61) / fTemp58;
			let mut fTemp70: F32 = self.fRec22[0] / fTemp61;
			let mut fTemp71: F32 = if (iTemp66 as i32 != 0) { if (iTemp68 as i32 != 0) { if (((self.fRec22[0] < 0.0) as i32) as i32 != 0) { fTemp59 } else { if (iTemp68 as i32 != 0) { fTemp59 + fTemp60 * if (((self.fRec19[0] > fTemp59) as i32) as i32 != 0) { F32::powf(fTemp70, 0.33333334) } else { fTemp70 } } else { self.fRec19[0] } } } else { if (iTemp66 as i32 != 0) { self.fRec19[0] + fTemp57 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp69, 0.33333334) } else { fTemp69 } } else { self.fRec20[0] } } } else { if (((self.fRec22[0] < fTemp65) as i32) as i32 != 0) { self.fRec20[0] + fTemp63 * if (((self.fRec21[0] > self.fRec20[0]) as i32) as i32 != 0) { F32::powf(fTemp67, 0.33333334) } else { fTemp67 } } else { self.fRec21[0] } };
			let mut iTemp72: i32 = ((fTemp71) as i32);
			let mut fTemp73: F32 = unsafe { ftbl0DSP_Rimshot2SIG0[(iTemp72) as usize] };
			self.fRec18[0] = 0.115 * fTemp26 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec14[0] + 13.913043 * self.fRec18[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp73 + (fTemp71 - ((iTemp72) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp72, 1)) as usize] } - fTemp73)) + 1e+01)) as i32) % 1024) as usize] };
			let mut fTemp74: F32 = self.fRec18[0] + 0.23 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * (self.fRec17[0] + 2.0 * unsafe { ftbl2DSP_Rimshot2SIG2[(((1024.0 * self.fRec14[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp47 + (fTemp45 - ((iTemp46) as F32)) * (unsafe { ftbl0DSP_Rimshot2SIG0[(i32::wrapping_add(iTemp46, 1)) as usize] } - fTemp47)) + 1e+01)) as i32) % 1024) as usize] } * fTemp26;
			self.fVec4[0] = fTemp74;
			self.fRec0[0] = 0.5 * (self.fConst8 * fTemp74 + self.fConst9 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow13 * self.fRec0[0];
			*output1 = fSlow14 * self.fRec0[0];
			*output2 = fSlow15 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.iRec16[1] = self.iRec16[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec18[1] = self.fRec18[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
