// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Cowbell1 -pn processCowbell1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Cowbell1SIG0 {
	iRec1: [i32;2],
}

impl DSP_Cowbell1SIG0 {
	
	fn get_num_inputsDSP_Cowbell1SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cowbell1SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cowbell1SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Cowbell1SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Cowbell1SIG0() -> DSP_Cowbell1SIG0 { 
	DSP_Cowbell1SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Cowbell1SIG1 {
	iRec5: [i32;2],
}

impl DSP_Cowbell1SIG1 {
	
	fn get_num_inputsDSP_Cowbell1SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cowbell1SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cowbell1SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Cowbell1SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Cowbell1SIG1() -> DSP_Cowbell1SIG1 { 
	DSP_Cowbell1SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Cowbell1SIG2 {
	iVec3: [i32;2],
	iRec9: [i32;2],
}

impl DSP_Cowbell1SIG2 {
	
	fn get_num_inputsDSP_Cowbell1SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cowbell1SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cowbell1SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec9[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Cowbell1SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec9[0] = (i32::wrapping_add(self.iVec3[1], self.iRec9[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec9[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec9[1] = self.iRec9[0];
		}
	}

}


pub fn newDSP_Cowbell1SIG2() -> DSP_Cowbell1SIG2 { 
	DSP_Cowbell1SIG2 {
		iVec3: [0;2],
		iRec9: [0;2],
	}
}

pub struct DSP_Cowbell1SIG3 {
	iRec16: [i32;2],
}

impl DSP_Cowbell1SIG3 {
	
	fn get_num_inputsDSP_Cowbell1SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cowbell1SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cowbell1SIG3(&mut self, sample_rate: i32) {
		for l18 in 0..2 {
			self.iRec16[(l18) as usize] = 0;
		}
	}
	
	fn fillDSP_Cowbell1SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec16[0] = i32::wrapping_add(self.iRec16[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec16[0], -1)) as F32) + -128.0));
			self.iRec16[1] = self.iRec16[0];
		}
	}

}


pub fn newDSP_Cowbell1SIG3() -> DSP_Cowbell1SIG3 { 
	DSP_Cowbell1SIG3 {
		iRec16: [0;2],
	}
}
static mut iDSP_Cowbell1SIG4Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Cowbell1SIG4 {
	iDSP_Cowbell1SIG4Wave0_idx: i32,
}

impl DSP_Cowbell1SIG4 {
	
	fn get_num_inputsDSP_Cowbell1SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Cowbell1SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Cowbell1SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Cowbell1SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Cowbell1SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Cowbell1SIG4Wave0[(self.iDSP_Cowbell1SIG4Wave0_idx) as usize] };
			self.iDSP_Cowbell1SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Cowbell1SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Cowbell1SIG4() -> DSP_Cowbell1SIG4 { 
	DSP_Cowbell1SIG4 {
		iDSP_Cowbell1SIG4Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Cowbell1SIG0: [F32;16384] = [0.0;16384];
fn DSP_Cowbell1_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Cowbell1SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Cowbell1SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Cowbell1SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Cowbell1SIG4: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Cowbell1 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fRec2: [F32;2],
	fRec4: [F32;2],
	fHslider1: F32,
	fHslider2: F32,
	fRec6: [F32;2],
	fRec7: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fRec13: [F32;2],
	fRec14: [F32;2],
	iConst5: i32,
	iRec17: [i32;2],
	fConst6: F32,
	fRec15: [F32;2],
	fConst7: F32,
	fRec18: [F32;2],
	fRec19: [F32;2],
	fRec20: [F32;2],
	fConst8: F32,
	fRec21: [F32;2],
	fRec22: [F32;2],
	fRec23: [F32;2],
	fRec24: [F32;2],
	fRec25: [F32;2],
	fRec26: [F32;2],
	fConst9: F32,
	fRec27: [F32;2],
	fRec28: [F32;2],
	fRec29: [F32;2],
	fRec31: [F32;2],
	fRec30: [F32;2],
	fRec33: [F32;2],
	fRec34: [F32;2],
	fRec35: [F32;2],
	fRec36: [F32;2],
	fConst10: F32,
	fRec37: [F32;2],
	fRec32: [F32;2],
	fConst12: F32,
	fRec38: [F32;2],
	fVec4: [F32;2],
	fConst13: F32,
	fConst14: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_Cowbell1 {
	type T = F32;
		
	fn new() -> DSP_Cowbell1 { 
		DSP_Cowbell1 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fHslider1: 0.0,
			fHslider2: 0.0,
			fRec6: [0.0;2],
			fRec7: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			iConst5: 0,
			iRec17: [0;2],
			fConst6: 0.0,
			fRec15: [0.0;2],
			fConst7: 0.0,
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fRec20: [0.0;2],
			fConst8: 0.0,
			fRec21: [0.0;2],
			fRec22: [0.0;2],
			fRec23: [0.0;2],
			fRec24: [0.0;2],
			fRec25: [0.0;2],
			fRec26: [0.0;2],
			fConst9: 0.0,
			fRec27: [0.0;2],
			fRec28: [0.0;2],
			fRec29: [0.0;2],
			fRec31: [0.0;2],
			fRec30: [0.0;2],
			fRec33: [0.0;2],
			fRec34: [0.0;2],
			fRec35: [0.0;2],
			fRec36: [0.0;2],
			fConst10: 0.0,
			fRec37: [0.0;2],
			fRec32: [0.0;2],
			fConst12: 0.0,
			fRec38: [0.0;2],
			fVec4: [0.0;2],
			fConst13: 0.0,
			fConst14: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Cowbell1 -pn processCowbell1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Cowbell1SIG0 = newDSP_Cowbell1SIG0();
		sig0.instance_initDSP_Cowbell1SIG0(sample_rate);
		sig0.fillDSP_Cowbell1SIG0(16384, unsafe { &mut ftbl0DSP_Cowbell1SIG0 });
		let mut sig1: DSP_Cowbell1SIG1 = newDSP_Cowbell1SIG1();
		sig1.instance_initDSP_Cowbell1SIG1(sample_rate);
		sig1.fillDSP_Cowbell1SIG1(144, unsafe { &mut ftbl1DSP_Cowbell1SIG1 });
		let mut sig2: DSP_Cowbell1SIG2 = newDSP_Cowbell1SIG2();
		sig2.instance_initDSP_Cowbell1SIG2(sample_rate);
		sig2.fillDSP_Cowbell1SIG2(1024, unsafe { &mut ftbl2DSP_Cowbell1SIG2 });
		let mut sig3: DSP_Cowbell1SIG3 = newDSP_Cowbell1SIG3();
		sig3.instance_initDSP_Cowbell1SIG3(sample_rate);
		sig3.fillDSP_Cowbell1SIG3(4096, unsafe { &mut ftbl3DSP_Cowbell1SIG3 });
		let mut sig4: DSP_Cowbell1SIG4 = newDSP_Cowbell1SIG4();
		sig4.instance_initDSP_Cowbell1SIG4(sample_rate);
		sig4.fillDSP_Cowbell1SIG4(100, unsafe { &mut itbl4DSP_Cowbell1SIG4 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 36.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec8[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.iRec17[(l19) as usize] = 0;
		}
		for l20 in 0..2 {
			self.fRec15[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec18[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec19[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec20[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec21[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec22[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec23[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec24[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec25[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec26[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec27[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec28[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec29[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec31[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec30[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec33[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec34[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec35[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec36[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec37[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec32[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec38[(l41) as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fVec4[(l42) as usize] = 0.0;
		}
		for l43 in 0..2 {
			self.fRec0[(l43) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.iConst5 = unsafe { itbl4DSP_Cowbell1SIG4[50] };
		self.fConst6 = 2.64e+03 / self.fConst0;
		self.fConst7 = 4.4e+02 / self.fConst0;
		self.fConst8 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst9 = 1.32e+03 / self.fConst0;
		self.fConst10 = 9.68e+03 / self.fConst0;
		let mut fConst11: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[2557] };
		self.fConst12 = 1e+01 / self.fConst0 * (fConst11 + 0.60903126 * (unsafe { ftbl3DSP_Cowbell1SIG3[2558] } - fConst11));
		self.fConst13 = 1.0 / (fConst1 * fConst3);
		self.fConst14 = 0.0 - self.fConst13;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Cowbell1::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "8", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(4), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(6), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			5 => Some(self.fHslider0),
			6 => Some(self.fHslider1),
			3 => Some(self.fHslider2),
			2 => Some(self.fHslider3),
			1 => Some(self.fHslider4),
			4 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			5 => { self.fHslider0 = value }
			6 => { self.fHslider1 = value }
			3 => { self.fHslider2 = value }
			2 => { self.fHslider3 = value }
			1 => { self.fHslider4 = value }
			4 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * fSlow2 + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.42857143 * fSlow3;
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -69.0));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst6 * fSlow6;
		let mut fSlow12: F32 = self.fConst7 * fSlow6;
		let mut fSlow13: F32 = self.fConst9 * fSlow6;
		let mut fSlow14: F32 = 0.060606062 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -17.0)));
		let mut fSlow15: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 87.0)));
		let mut fSlow16: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow15) * (fSlow15 + 28.0);
		let mut fSlow17: F32 = fSlow16 + 4064.0;
		let mut fSlow18: F32 = fSlow16 + 3968.0;
		let mut fSlow19: F32 = fSlow16 + 4e+03;
		let mut fSlow20: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 93.0)));
		let mut fSlow21: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow20) * (fSlow20 + 28.0);
		let mut fSlow22: F32 = fSlow21 + 4064.0;
		let mut fSlow23: F32 = fSlow21 + 3968.0;
		let mut fSlow24: F32 = fSlow21 + 3744.0;
		let mut fSlow25: F32 = self.fConst10 * fSlow6;
		let mut fSlow26: F32 = 0.01 * self.fHslider3;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow28: F32 = fSlow27 * F32::min(1.0, 1.0 - fSlow26);
		let mut fSlow29: F32 = fSlow27 * F32::min(1.0, fSlow26 + 1.0);
		let mut fSlow30: F32 = 0.01 * self.fHslider5 * fSlow27;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Cowbell1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 50.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 55.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			let mut fTemp27: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp26) * (fTemp26 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3392.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3296.0 } else { self.fRec11[1] };
			let mut fTemp28: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 80.5) as i32)) as usize] } * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp27 } else { self.fRec13[1] };
			let mut fTemp30: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp31: F32 = self.fRec10[0] - fTemp30;
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp30)) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = fTemp32 + fTemp29;
			let mut fTemp34: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp33 + fTemp35;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp36, self.fRec14[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp33) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp33) / fTemp35;
			let mut iTemp39: i32 = ((self.fRec14[0] < fTemp32) as i32);
			let mut fTemp40: F32 = (self.fRec14[0] - fTemp32) / fTemp29;
			let mut fTemp41: F32 = self.fRec14[0] / fTemp32;
			let mut fTemp42: F32 = if (iTemp37 as i32 != 0) { if (iTemp39 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp30 } else { if (iTemp39 as i32 != 0) { fTemp30 + fTemp31 * if (((self.fRec10[0] > fTemp30) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp28 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp36) as i32) as i32 != 0) { self.fRec11[0] + fTemp34 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec13[0] } };
			let mut iTemp43: i32 = ((fTemp42) as i32);
			let mut fTemp44: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp43) as usize] };
			let mut iTemp45: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec17[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec17[1] };
			let mut fTemp46: F32 = 15.996094 * (0.4 * ((self.iRec17[0]) as F32) + 128.0);
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iTemp47) as usize] };
			let mut fTemp49: F32 = fSlow10 * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48));
			let mut fTemp50: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec15[1] + fSlow11 * fTemp49 };
			self.fRec15[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] };
			let mut fTemp52: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec18[1] + fSlow12 * fTemp49 };
			self.fRec18[0] = fTemp52 - F32::floor(fTemp52);
			let mut fTemp53: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 93.0));
			let mut fTemp54: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp53) * (fTemp53 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp54 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp54 } else { self.fRec20[1] };
			let mut fTemp55: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp58: F32 = self.fRec19[0] - fTemp57;
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (fTemp11 * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp57)) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp59 + fTemp56;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst8 + fTemp60, self.fRec21[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp60) as i32);
			let mut iTemp62: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut fTemp63: F32 = (self.fRec21[0] - fTemp59) / fTemp56;
			let mut fTemp64: F32 = self.fRec21[0] / fTemp59;
			let mut fTemp65: F32 = if (iTemp61 as i32 != 0) { if (iTemp62 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp57 } else { if (iTemp62 as i32 != 0) { fTemp57 + fTemp58 * if (((self.fRec19[0] > fTemp57) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec19[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec19[0] + fTemp55 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp66: i32 = ((fTemp65) as i32);
			let mut fTemp67: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp66) as usize] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { 7.84e+03 } else { self.fRec23[1] };
			let mut fTemp68: F32 = self.fRec23[0] - self.fRec22[0];
			self.fRec24[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec24[1] };
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 76.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec25[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp71: F32 = self.fRec22[0] - fTemp70;
			let mut fTemp72: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 99.5) as i32)) as usize] };
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (fTemp72 * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp69;
			let mut fTemp75: F32 = self.fRec25[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 50.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec26[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec26[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec26[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec26[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec26[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec26[0] - fTemp73) / fTemp69;
			let mut fTemp82: F32 = self.fRec26[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp80 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec22[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp68 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec26[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec25[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec25[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow13 * fTemp49 };
			self.fRec27[0] = fTemp86 - F32::floor(fTemp86);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow17 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { fSlow18 } else { self.fRec29[1] };
			let mut fTemp87: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 98.5) as i32)) as usize] } * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp90: F32 = self.fRec28[0] - fTemp89;
			let mut fTemp91: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp90) / (fTemp72 * if (((fTemp90 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp89)) + 2.0) } else { 0.96 }))));
			let mut fTemp92: F32 = fTemp91 + fTemp88;
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fSlow19 } else { self.fRec31[1] };
			let mut fTemp93: F32 = self.fRec31[0] - self.fRec29[0];
			let mut fTemp94: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp93) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 44.5) as i32)) as usize] } * if (((fTemp93 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp95: F32 = fTemp92 + fTemp94;
			self.fRec30[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp95, self.fRec30[1] + 1.0) };
			let mut iTemp96: i32 = ((self.fRec30[0] < fTemp92) as i32);
			let mut fTemp97: F32 = (self.fRec30[0] - fTemp92) / fTemp94;
			let mut iTemp98: i32 = ((self.fRec30[0] < fTemp91) as i32);
			let mut fTemp99: F32 = (self.fRec30[0] - fTemp91) / fTemp88;
			let mut fTemp100: F32 = self.fRec30[0] / fTemp91;
			let mut fTemp101: F32 = if (iTemp96 as i32 != 0) { if (iTemp98 as i32 != 0) { if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { fTemp89 } else { if (iTemp98 as i32 != 0) { fTemp89 + fTemp90 * if (((self.fRec28[0] > fTemp89) as i32) as i32 != 0) { F32::powf(fTemp100, 0.33333334) } else { fTemp100 } } else { self.fRec28[0] } } } else { if (iTemp96 as i32 != 0) { self.fRec28[0] + fTemp87 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp99, 0.33333334) } else { fTemp99 } } else { self.fRec29[0] } } } else { if (((self.fRec30[0] < fTemp95) as i32) as i32 != 0) { self.fRec29[0] + fTemp93 * if (((self.fRec31[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp97, 0.33333334) } else { fTemp97 } } else { self.fRec31[0] } };
			let mut iTemp102: i32 = ((fTemp101) as i32);
			let mut fTemp103: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp102) as usize] };
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fSlow22 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fSlow23 } else { self.fRec34[1] };
			let mut fTemp104: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp105: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp104) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 66.5) as i32)) as usize] } * if (((fTemp104 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fSlow24 } else { self.fRec35[1] };
			let mut fTemp106: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp107: F32 = self.fRec33[0] - fTemp106;
			let mut fTemp108: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp107) / (fTemp72 * if (((fTemp107 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp106)) + 2.0) } else { 0.96 }))));
			let mut fTemp109: F32 = fTemp108 + fTemp105;
			let mut fTemp110: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp111: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp110) / (fTemp72 * if (((fTemp110 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp112: F32 = fTemp109 + fTemp111;
			self.fRec36[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp112, self.fRec36[1] + 1.0) };
			let mut iTemp113: i32 = ((self.fRec36[0] < fTemp109) as i32);
			let mut fTemp114: F32 = (self.fRec36[0] - fTemp109) / fTemp111;
			let mut iTemp115: i32 = ((self.fRec36[0] < fTemp108) as i32);
			let mut fTemp116: F32 = (self.fRec36[0] - fTemp108) / fTemp105;
			let mut fTemp117: F32 = self.fRec36[0] / fTemp108;
			let mut fTemp118: F32 = if (iTemp113 as i32 != 0) { if (iTemp115 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp106 } else { if (iTemp115 as i32 != 0) { fTemp106 + fTemp107 * if (((self.fRec33[0] > fTemp106) as i32) as i32 != 0) { F32::powf(fTemp117, 0.33333334) } else { fTemp117 } } else { self.fRec33[0] } } } else { if (iTemp113 as i32 != 0) { self.fRec33[0] + fTemp104 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp116, 0.33333334) } else { fTemp116 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp112) as i32) as i32 != 0) { self.fRec34[0] + fTemp110 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp114, 0.33333334) } else { fTemp114 } } else { self.fRec35[0] } };
			let mut iTemp119: i32 = ((fTemp118) as i32);
			let mut fTemp120: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp119) as usize] };
			let mut fTemp121: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec37[1] + fSlow25 * fTemp49 };
			self.fRec37[0] = fTemp121 - F32::floor(fTemp121);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec37[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp120 + (fTemp118 - ((iTemp119) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp119, 1)) as usize] } - fTemp120));
			let mut fTemp122: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec38[1] + self.fConst12 };
			self.fRec38[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec38[0] + 17.391304 * (self.fRec32[0] + 0.115 * (fTemp51 * (fTemp103 + (fTemp101 - ((iTemp102) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp102, 1)) as usize] } - fTemp103)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp67 + (fTemp65 - ((iTemp66) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp66, 1)) as usize] } - fTemp67)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * fTemp51 * (fTemp44 + (fTemp42 - ((iTemp43) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp43, 1)) as usize] } - fTemp44)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25));
			self.fVec4[0] = fTemp123;
			self.fRec0[0] = 0.115 * (self.fConst13 * fTemp123 + self.fConst14 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow28 * self.fRec0[0];
			*output1 = fSlow29 * self.fRec0[0];
			*output2 = fSlow30 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.iRec17[1] = self.iRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec38[1] = self.fRec38[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Cowbell1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Cowbell1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cowbell1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * fSlow2 + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.42857143 * fSlow3;
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -69.0));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst6 * fSlow6;
		let mut fSlow12: F32 = self.fConst7 * fSlow6;
		let mut fSlow13: F32 = self.fConst9 * fSlow6;
		let mut fSlow14: F32 = 0.060606062 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -17.0)));
		let mut fSlow15: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 87.0)));
		let mut fSlow16: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow15) * (fSlow15 + 28.0);
		let mut fSlow17: F32 = fSlow16 + 4064.0;
		let mut fSlow18: F32 = fSlow16 + 3968.0;
		let mut fSlow19: F32 = fSlow16 + 4e+03;
		let mut fSlow20: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 93.0)));
		let mut fSlow21: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow20) * (fSlow20 + 28.0);
		let mut fSlow22: F32 = fSlow21 + 4064.0;
		let mut fSlow23: F32 = fSlow21 + 3968.0;
		let mut fSlow24: F32 = fSlow21 + 3744.0;
		let mut fSlow25: F32 = self.fConst10 * fSlow6;
		let mut fSlow26: F32 = 0.01 * self.fHslider3;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow28: F32 = fSlow27 * F32::min(1.0, 1.0 - fSlow26);
		let mut fSlow29: F32 = fSlow27 * F32::min(1.0, fSlow26 + 1.0);
		let mut fSlow30: F32 = 0.01 * self.fHslider5 * fSlow27;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Cowbell1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 50.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 55.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			let mut fTemp27: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp26) * (fTemp26 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3392.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3296.0 } else { self.fRec11[1] };
			let mut fTemp28: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 80.5) as i32)) as usize] } * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp27 } else { self.fRec13[1] };
			let mut fTemp30: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp31: F32 = self.fRec10[0] - fTemp30;
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp30)) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = fTemp32 + fTemp29;
			let mut fTemp34: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp33 + fTemp35;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp36, self.fRec14[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp33) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp33) / fTemp35;
			let mut iTemp39: i32 = ((self.fRec14[0] < fTemp32) as i32);
			let mut fTemp40: F32 = (self.fRec14[0] - fTemp32) / fTemp29;
			let mut fTemp41: F32 = self.fRec14[0] / fTemp32;
			let mut fTemp42: F32 = if (iTemp37 as i32 != 0) { if (iTemp39 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp30 } else { if (iTemp39 as i32 != 0) { fTemp30 + fTemp31 * if (((self.fRec10[0] > fTemp30) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp28 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp36) as i32) as i32 != 0) { self.fRec11[0] + fTemp34 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec13[0] } };
			let mut iTemp43: i32 = ((fTemp42) as i32);
			let mut fTemp44: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp43) as usize] };
			let mut iTemp45: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec17[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec17[1] };
			let mut fTemp46: F32 = 15.996094 * (0.4 * ((self.iRec17[0]) as F32) + 128.0);
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iTemp47) as usize] };
			let mut fTemp49: F32 = fSlow10 * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48));
			let mut fTemp50: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec15[1] + fSlow11 * fTemp49 };
			self.fRec15[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] };
			let mut fTemp52: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec18[1] + fSlow12 * fTemp49 };
			self.fRec18[0] = fTemp52 - F32::floor(fTemp52);
			let mut fTemp53: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 93.0));
			let mut fTemp54: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp53) * (fTemp53 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp54 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp54 } else { self.fRec20[1] };
			let mut fTemp55: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp58: F32 = self.fRec19[0] - fTemp57;
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (fTemp11 * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp57)) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp59 + fTemp56;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst8 + fTemp60, self.fRec21[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp60) as i32);
			let mut iTemp62: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut fTemp63: F32 = (self.fRec21[0] - fTemp59) / fTemp56;
			let mut fTemp64: F32 = self.fRec21[0] / fTemp59;
			let mut fTemp65: F32 = if (iTemp61 as i32 != 0) { if (iTemp62 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp57 } else { if (iTemp62 as i32 != 0) { fTemp57 + fTemp58 * if (((self.fRec19[0] > fTemp57) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec19[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec19[0] + fTemp55 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp66: i32 = ((fTemp65) as i32);
			let mut fTemp67: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp66) as usize] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { 7.84e+03 } else { self.fRec23[1] };
			let mut fTemp68: F32 = self.fRec23[0] - self.fRec22[0];
			self.fRec24[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec24[1] };
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 76.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec25[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp71: F32 = self.fRec22[0] - fTemp70;
			let mut fTemp72: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 99.5) as i32)) as usize] };
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (fTemp72 * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp69;
			let mut fTemp75: F32 = self.fRec25[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 50.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec26[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec26[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec26[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec26[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec26[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec26[0] - fTemp73) / fTemp69;
			let mut fTemp82: F32 = self.fRec26[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp80 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec22[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp68 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec26[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec25[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec25[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow13 * fTemp49 };
			self.fRec27[0] = fTemp86 - F32::floor(fTemp86);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow17 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { fSlow18 } else { self.fRec29[1] };
			let mut fTemp87: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 98.5) as i32)) as usize] } * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp90: F32 = self.fRec28[0] - fTemp89;
			let mut fTemp91: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp90) / (fTemp72 * if (((fTemp90 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp89)) + 2.0) } else { 0.96 }))));
			let mut fTemp92: F32 = fTemp91 + fTemp88;
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fSlow19 } else { self.fRec31[1] };
			let mut fTemp93: F32 = self.fRec31[0] - self.fRec29[0];
			let mut fTemp94: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp93) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 44.5) as i32)) as usize] } * if (((fTemp93 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp95: F32 = fTemp92 + fTemp94;
			self.fRec30[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp95, self.fRec30[1] + 1.0) };
			let mut iTemp96: i32 = ((self.fRec30[0] < fTemp92) as i32);
			let mut fTemp97: F32 = (self.fRec30[0] - fTemp92) / fTemp94;
			let mut iTemp98: i32 = ((self.fRec30[0] < fTemp91) as i32);
			let mut fTemp99: F32 = (self.fRec30[0] - fTemp91) / fTemp88;
			let mut fTemp100: F32 = self.fRec30[0] / fTemp91;
			let mut fTemp101: F32 = if (iTemp96 as i32 != 0) { if (iTemp98 as i32 != 0) { if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { fTemp89 } else { if (iTemp98 as i32 != 0) { fTemp89 + fTemp90 * if (((self.fRec28[0] > fTemp89) as i32) as i32 != 0) { F32::powf(fTemp100, 0.33333334) } else { fTemp100 } } else { self.fRec28[0] } } } else { if (iTemp96 as i32 != 0) { self.fRec28[0] + fTemp87 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp99, 0.33333334) } else { fTemp99 } } else { self.fRec29[0] } } } else { if (((self.fRec30[0] < fTemp95) as i32) as i32 != 0) { self.fRec29[0] + fTemp93 * if (((self.fRec31[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp97, 0.33333334) } else { fTemp97 } } else { self.fRec31[0] } };
			let mut iTemp102: i32 = ((fTemp101) as i32);
			let mut fTemp103: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp102) as usize] };
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fSlow22 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fSlow23 } else { self.fRec34[1] };
			let mut fTemp104: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp105: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp104) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 66.5) as i32)) as usize] } * if (((fTemp104 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fSlow24 } else { self.fRec35[1] };
			let mut fTemp106: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp107: F32 = self.fRec33[0] - fTemp106;
			let mut fTemp108: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp107) / (fTemp72 * if (((fTemp107 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp106)) + 2.0) } else { 0.96 }))));
			let mut fTemp109: F32 = fTemp108 + fTemp105;
			let mut fTemp110: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp111: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp110) / (fTemp72 * if (((fTemp110 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp112: F32 = fTemp109 + fTemp111;
			self.fRec36[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp112, self.fRec36[1] + 1.0) };
			let mut iTemp113: i32 = ((self.fRec36[0] < fTemp109) as i32);
			let mut fTemp114: F32 = (self.fRec36[0] - fTemp109) / fTemp111;
			let mut iTemp115: i32 = ((self.fRec36[0] < fTemp108) as i32);
			let mut fTemp116: F32 = (self.fRec36[0] - fTemp108) / fTemp105;
			let mut fTemp117: F32 = self.fRec36[0] / fTemp108;
			let mut fTemp118: F32 = if (iTemp113 as i32 != 0) { if (iTemp115 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp106 } else { if (iTemp115 as i32 != 0) { fTemp106 + fTemp107 * if (((self.fRec33[0] > fTemp106) as i32) as i32 != 0) { F32::powf(fTemp117, 0.33333334) } else { fTemp117 } } else { self.fRec33[0] } } } else { if (iTemp113 as i32 != 0) { self.fRec33[0] + fTemp104 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp116, 0.33333334) } else { fTemp116 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp112) as i32) as i32 != 0) { self.fRec34[0] + fTemp110 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp114, 0.33333334) } else { fTemp114 } } else { self.fRec35[0] } };
			let mut iTemp119: i32 = ((fTemp118) as i32);
			let mut fTemp120: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp119) as usize] };
			let mut fTemp121: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec37[1] + fSlow25 * fTemp49 };
			self.fRec37[0] = fTemp121 - F32::floor(fTemp121);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec37[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp120 + (fTemp118 - ((iTemp119) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp119, 1)) as usize] } - fTemp120));
			let mut fTemp122: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec38[1] + self.fConst12 };
			self.fRec38[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec38[0] + 17.391304 * (self.fRec32[0] + 0.115 * (fTemp51 * (fTemp103 + (fTemp101 - ((iTemp102) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp102, 1)) as usize] } - fTemp103)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp67 + (fTemp65 - ((iTemp66) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp66, 1)) as usize] } - fTemp67)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * fTemp51 * (fTemp44 + (fTemp42 - ((iTemp43) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp43, 1)) as usize] } - fTemp44)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25));
			self.fVec4[0] = fTemp123;
			self.fRec0[0] = 0.115 * (self.fConst13 * fTemp123 + self.fConst14 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow28 * self.fRec0[0];
			*output1 = fSlow29 * self.fRec0[0];
			*output2 = fSlow30 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.iRec17[1] = self.iRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec38[1] = self.fRec38[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cowbell1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Cowbell1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cowbell1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * fSlow2 + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.42857143 * fSlow3;
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -69.0));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst6 * fSlow6;
		let mut fSlow12: F32 = self.fConst7 * fSlow6;
		let mut fSlow13: F32 = self.fConst9 * fSlow6;
		let mut fSlow14: F32 = 0.060606062 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -17.0)));
		let mut fSlow15: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 87.0)));
		let mut fSlow16: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow15) * (fSlow15 + 28.0);
		let mut fSlow17: F32 = fSlow16 + 4064.0;
		let mut fSlow18: F32 = fSlow16 + 3968.0;
		let mut fSlow19: F32 = fSlow16 + 4e+03;
		let mut fSlow20: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 93.0)));
		let mut fSlow21: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow20) * (fSlow20 + 28.0);
		let mut fSlow22: F32 = fSlow21 + 4064.0;
		let mut fSlow23: F32 = fSlow21 + 3968.0;
		let mut fSlow24: F32 = fSlow21 + 3744.0;
		let mut fSlow25: F32 = self.fConst10 * fSlow6;
		let mut fSlow26: F32 = 0.01 * self.fHslider3;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow28: F32 = fSlow27 * F32::min(1.0, 1.0 - fSlow26);
		let mut fSlow29: F32 = fSlow27 * F32::min(1.0, fSlow26 + 1.0);
		let mut fSlow30: F32 = 0.01 * self.fHslider5 * fSlow27;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Cowbell1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 50.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 55.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			let mut fTemp27: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp26) * (fTemp26 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3392.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3296.0 } else { self.fRec11[1] };
			let mut fTemp28: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 80.5) as i32)) as usize] } * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp27 } else { self.fRec13[1] };
			let mut fTemp30: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp31: F32 = self.fRec10[0] - fTemp30;
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp30)) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = fTemp32 + fTemp29;
			let mut fTemp34: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp33 + fTemp35;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp36, self.fRec14[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp33) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp33) / fTemp35;
			let mut iTemp39: i32 = ((self.fRec14[0] < fTemp32) as i32);
			let mut fTemp40: F32 = (self.fRec14[0] - fTemp32) / fTemp29;
			let mut fTemp41: F32 = self.fRec14[0] / fTemp32;
			let mut fTemp42: F32 = if (iTemp37 as i32 != 0) { if (iTemp39 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp30 } else { if (iTemp39 as i32 != 0) { fTemp30 + fTemp31 * if (((self.fRec10[0] > fTemp30) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp28 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp36) as i32) as i32 != 0) { self.fRec11[0] + fTemp34 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec13[0] } };
			let mut iTemp43: i32 = ((fTemp42) as i32);
			let mut fTemp44: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp43) as usize] };
			let mut iTemp45: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec17[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec17[1] };
			let mut fTemp46: F32 = 15.996094 * (0.4 * ((self.iRec17[0]) as F32) + 128.0);
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iTemp47) as usize] };
			let mut fTemp49: F32 = fSlow10 * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48));
			let mut fTemp50: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec15[1] + fSlow11 * fTemp49 };
			self.fRec15[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] };
			let mut fTemp52: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec18[1] + fSlow12 * fTemp49 };
			self.fRec18[0] = fTemp52 - F32::floor(fTemp52);
			let mut fTemp53: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 93.0));
			let mut fTemp54: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp53) * (fTemp53 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp54 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp54 } else { self.fRec20[1] };
			let mut fTemp55: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp58: F32 = self.fRec19[0] - fTemp57;
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (fTemp11 * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp57)) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp59 + fTemp56;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst8 + fTemp60, self.fRec21[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp60) as i32);
			let mut iTemp62: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut fTemp63: F32 = (self.fRec21[0] - fTemp59) / fTemp56;
			let mut fTemp64: F32 = self.fRec21[0] / fTemp59;
			let mut fTemp65: F32 = if (iTemp61 as i32 != 0) { if (iTemp62 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp57 } else { if (iTemp62 as i32 != 0) { fTemp57 + fTemp58 * if (((self.fRec19[0] > fTemp57) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec19[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec19[0] + fTemp55 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp66: i32 = ((fTemp65) as i32);
			let mut fTemp67: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp66) as usize] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { 7.84e+03 } else { self.fRec23[1] };
			let mut fTemp68: F32 = self.fRec23[0] - self.fRec22[0];
			self.fRec24[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec24[1] };
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 76.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec25[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp71: F32 = self.fRec22[0] - fTemp70;
			let mut fTemp72: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 99.5) as i32)) as usize] };
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (fTemp72 * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp69;
			let mut fTemp75: F32 = self.fRec25[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 50.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec26[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec26[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec26[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec26[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec26[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec26[0] - fTemp73) / fTemp69;
			let mut fTemp82: F32 = self.fRec26[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp80 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec22[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp68 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec26[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec25[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec25[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow13 * fTemp49 };
			self.fRec27[0] = fTemp86 - F32::floor(fTemp86);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow17 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { fSlow18 } else { self.fRec29[1] };
			let mut fTemp87: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 98.5) as i32)) as usize] } * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp90: F32 = self.fRec28[0] - fTemp89;
			let mut fTemp91: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp90) / (fTemp72 * if (((fTemp90 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp89)) + 2.0) } else { 0.96 }))));
			let mut fTemp92: F32 = fTemp91 + fTemp88;
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fSlow19 } else { self.fRec31[1] };
			let mut fTemp93: F32 = self.fRec31[0] - self.fRec29[0];
			let mut fTemp94: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp93) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 44.5) as i32)) as usize] } * if (((fTemp93 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp95: F32 = fTemp92 + fTemp94;
			self.fRec30[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp95, self.fRec30[1] + 1.0) };
			let mut iTemp96: i32 = ((self.fRec30[0] < fTemp92) as i32);
			let mut fTemp97: F32 = (self.fRec30[0] - fTemp92) / fTemp94;
			let mut iTemp98: i32 = ((self.fRec30[0] < fTemp91) as i32);
			let mut fTemp99: F32 = (self.fRec30[0] - fTemp91) / fTemp88;
			let mut fTemp100: F32 = self.fRec30[0] / fTemp91;
			let mut fTemp101: F32 = if (iTemp96 as i32 != 0) { if (iTemp98 as i32 != 0) { if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { fTemp89 } else { if (iTemp98 as i32 != 0) { fTemp89 + fTemp90 * if (((self.fRec28[0] > fTemp89) as i32) as i32 != 0) { F32::powf(fTemp100, 0.33333334) } else { fTemp100 } } else { self.fRec28[0] } } } else { if (iTemp96 as i32 != 0) { self.fRec28[0] + fTemp87 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp99, 0.33333334) } else { fTemp99 } } else { self.fRec29[0] } } } else { if (((self.fRec30[0] < fTemp95) as i32) as i32 != 0) { self.fRec29[0] + fTemp93 * if (((self.fRec31[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp97, 0.33333334) } else { fTemp97 } } else { self.fRec31[0] } };
			let mut iTemp102: i32 = ((fTemp101) as i32);
			let mut fTemp103: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp102) as usize] };
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fSlow22 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fSlow23 } else { self.fRec34[1] };
			let mut fTemp104: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp105: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp104) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 66.5) as i32)) as usize] } * if (((fTemp104 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fSlow24 } else { self.fRec35[1] };
			let mut fTemp106: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp107: F32 = self.fRec33[0] - fTemp106;
			let mut fTemp108: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp107) / (fTemp72 * if (((fTemp107 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp106)) + 2.0) } else { 0.96 }))));
			let mut fTemp109: F32 = fTemp108 + fTemp105;
			let mut fTemp110: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp111: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp110) / (fTemp72 * if (((fTemp110 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp112: F32 = fTemp109 + fTemp111;
			self.fRec36[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp112, self.fRec36[1] + 1.0) };
			let mut iTemp113: i32 = ((self.fRec36[0] < fTemp109) as i32);
			let mut fTemp114: F32 = (self.fRec36[0] - fTemp109) / fTemp111;
			let mut iTemp115: i32 = ((self.fRec36[0] < fTemp108) as i32);
			let mut fTemp116: F32 = (self.fRec36[0] - fTemp108) / fTemp105;
			let mut fTemp117: F32 = self.fRec36[0] / fTemp108;
			let mut fTemp118: F32 = if (iTemp113 as i32 != 0) { if (iTemp115 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp106 } else { if (iTemp115 as i32 != 0) { fTemp106 + fTemp107 * if (((self.fRec33[0] > fTemp106) as i32) as i32 != 0) { F32::powf(fTemp117, 0.33333334) } else { fTemp117 } } else { self.fRec33[0] } } } else { if (iTemp113 as i32 != 0) { self.fRec33[0] + fTemp104 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp116, 0.33333334) } else { fTemp116 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp112) as i32) as i32 != 0) { self.fRec34[0] + fTemp110 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp114, 0.33333334) } else { fTemp114 } } else { self.fRec35[0] } };
			let mut iTemp119: i32 = ((fTemp118) as i32);
			let mut fTemp120: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp119) as usize] };
			let mut fTemp121: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec37[1] + fSlow25 * fTemp49 };
			self.fRec37[0] = fTemp121 - F32::floor(fTemp121);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec37[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp120 + (fTemp118 - ((iTemp119) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp119, 1)) as usize] } - fTemp120));
			let mut fTemp122: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec38[1] + self.fConst12 };
			self.fRec38[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec38[0] + 17.391304 * (self.fRec32[0] + 0.115 * (fTemp51 * (fTemp103 + (fTemp101 - ((iTemp102) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp102, 1)) as usize] } - fTemp103)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp67 + (fTemp65 - ((iTemp66) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp66, 1)) as usize] } - fTemp67)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * fTemp51 * (fTemp44 + (fTemp42 - ((iTemp43) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp43, 1)) as usize] } - fTemp44)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25));
			self.fVec4[0] = fTemp123;
			self.fRec0[0] = 0.115 * (self.fConst13 * fTemp123 + self.fConst14 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow28 * self.fRec0[0];
			*output1 = fSlow29 * self.fRec0[0];
			*output2 = fSlow30 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.iRec17[1] = self.iRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec38[1] = self.fRec38[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cowbell1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Cowbell1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cowbell1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * fSlow2 + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.42857143 * fSlow3;
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -69.0));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst6 * fSlow6;
		let mut fSlow12: F32 = self.fConst7 * fSlow6;
		let mut fSlow13: F32 = self.fConst9 * fSlow6;
		let mut fSlow14: F32 = 0.060606062 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -17.0)));
		let mut fSlow15: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 87.0)));
		let mut fSlow16: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow15) * (fSlow15 + 28.0);
		let mut fSlow17: F32 = fSlow16 + 4064.0;
		let mut fSlow18: F32 = fSlow16 + 3968.0;
		let mut fSlow19: F32 = fSlow16 + 4e+03;
		let mut fSlow20: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 93.0)));
		let mut fSlow21: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow20) * (fSlow20 + 28.0);
		let mut fSlow22: F32 = fSlow21 + 4064.0;
		let mut fSlow23: F32 = fSlow21 + 3968.0;
		let mut fSlow24: F32 = fSlow21 + 3744.0;
		let mut fSlow25: F32 = self.fConst10 * fSlow6;
		let mut fSlow26: F32 = 0.01 * self.fHslider3;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow28: F32 = fSlow27 * F32::min(1.0, 1.0 - fSlow26);
		let mut fSlow29: F32 = fSlow27 * F32::min(1.0, fSlow26 + 1.0);
		let mut fSlow30: F32 = 0.01 * self.fHslider5 * fSlow27;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Cowbell1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 50.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 55.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			let mut fTemp27: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp26) * (fTemp26 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3392.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3296.0 } else { self.fRec11[1] };
			let mut fTemp28: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 80.5) as i32)) as usize] } * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp27 } else { self.fRec13[1] };
			let mut fTemp30: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp31: F32 = self.fRec10[0] - fTemp30;
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp30)) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = fTemp32 + fTemp29;
			let mut fTemp34: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp33 + fTemp35;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp36, self.fRec14[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp33) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp33) / fTemp35;
			let mut iTemp39: i32 = ((self.fRec14[0] < fTemp32) as i32);
			let mut fTemp40: F32 = (self.fRec14[0] - fTemp32) / fTemp29;
			let mut fTemp41: F32 = self.fRec14[0] / fTemp32;
			let mut fTemp42: F32 = if (iTemp37 as i32 != 0) { if (iTemp39 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp30 } else { if (iTemp39 as i32 != 0) { fTemp30 + fTemp31 * if (((self.fRec10[0] > fTemp30) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp28 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp36) as i32) as i32 != 0) { self.fRec11[0] + fTemp34 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec13[0] } };
			let mut iTemp43: i32 = ((fTemp42) as i32);
			let mut fTemp44: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp43) as usize] };
			let mut iTemp45: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec17[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec17[1] };
			let mut fTemp46: F32 = 15.996094 * (0.4 * ((self.iRec17[0]) as F32) + 128.0);
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iTemp47) as usize] };
			let mut fTemp49: F32 = fSlow10 * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48));
			let mut fTemp50: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec15[1] + fSlow11 * fTemp49 };
			self.fRec15[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] };
			let mut fTemp52: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec18[1] + fSlow12 * fTemp49 };
			self.fRec18[0] = fTemp52 - F32::floor(fTemp52);
			let mut fTemp53: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 93.0));
			let mut fTemp54: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp53) * (fTemp53 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp54 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp54 } else { self.fRec20[1] };
			let mut fTemp55: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp58: F32 = self.fRec19[0] - fTemp57;
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (fTemp11 * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp57)) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp59 + fTemp56;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst8 + fTemp60, self.fRec21[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp60) as i32);
			let mut iTemp62: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut fTemp63: F32 = (self.fRec21[0] - fTemp59) / fTemp56;
			let mut fTemp64: F32 = self.fRec21[0] / fTemp59;
			let mut fTemp65: F32 = if (iTemp61 as i32 != 0) { if (iTemp62 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp57 } else { if (iTemp62 as i32 != 0) { fTemp57 + fTemp58 * if (((self.fRec19[0] > fTemp57) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec19[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec19[0] + fTemp55 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp66: i32 = ((fTemp65) as i32);
			let mut fTemp67: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp66) as usize] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { 7.84e+03 } else { self.fRec23[1] };
			let mut fTemp68: F32 = self.fRec23[0] - self.fRec22[0];
			self.fRec24[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec24[1] };
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 76.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec25[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp71: F32 = self.fRec22[0] - fTemp70;
			let mut fTemp72: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 99.5) as i32)) as usize] };
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (fTemp72 * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp69;
			let mut fTemp75: F32 = self.fRec25[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 50.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec26[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec26[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec26[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec26[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec26[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec26[0] - fTemp73) / fTemp69;
			let mut fTemp82: F32 = self.fRec26[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp80 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec22[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp68 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec26[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec25[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec25[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow13 * fTemp49 };
			self.fRec27[0] = fTemp86 - F32::floor(fTemp86);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow17 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { fSlow18 } else { self.fRec29[1] };
			let mut fTemp87: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 98.5) as i32)) as usize] } * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp90: F32 = self.fRec28[0] - fTemp89;
			let mut fTemp91: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp90) / (fTemp72 * if (((fTemp90 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp89)) + 2.0) } else { 0.96 }))));
			let mut fTemp92: F32 = fTemp91 + fTemp88;
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fSlow19 } else { self.fRec31[1] };
			let mut fTemp93: F32 = self.fRec31[0] - self.fRec29[0];
			let mut fTemp94: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp93) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 44.5) as i32)) as usize] } * if (((fTemp93 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp95: F32 = fTemp92 + fTemp94;
			self.fRec30[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp95, self.fRec30[1] + 1.0) };
			let mut iTemp96: i32 = ((self.fRec30[0] < fTemp92) as i32);
			let mut fTemp97: F32 = (self.fRec30[0] - fTemp92) / fTemp94;
			let mut iTemp98: i32 = ((self.fRec30[0] < fTemp91) as i32);
			let mut fTemp99: F32 = (self.fRec30[0] - fTemp91) / fTemp88;
			let mut fTemp100: F32 = self.fRec30[0] / fTemp91;
			let mut fTemp101: F32 = if (iTemp96 as i32 != 0) { if (iTemp98 as i32 != 0) { if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { fTemp89 } else { if (iTemp98 as i32 != 0) { fTemp89 + fTemp90 * if (((self.fRec28[0] > fTemp89) as i32) as i32 != 0) { F32::powf(fTemp100, 0.33333334) } else { fTemp100 } } else { self.fRec28[0] } } } else { if (iTemp96 as i32 != 0) { self.fRec28[0] + fTemp87 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp99, 0.33333334) } else { fTemp99 } } else { self.fRec29[0] } } } else { if (((self.fRec30[0] < fTemp95) as i32) as i32 != 0) { self.fRec29[0] + fTemp93 * if (((self.fRec31[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp97, 0.33333334) } else { fTemp97 } } else { self.fRec31[0] } };
			let mut iTemp102: i32 = ((fTemp101) as i32);
			let mut fTemp103: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp102) as usize] };
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fSlow22 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fSlow23 } else { self.fRec34[1] };
			let mut fTemp104: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp105: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp104) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 66.5) as i32)) as usize] } * if (((fTemp104 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fSlow24 } else { self.fRec35[1] };
			let mut fTemp106: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp107: F32 = self.fRec33[0] - fTemp106;
			let mut fTemp108: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp107) / (fTemp72 * if (((fTemp107 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp106)) + 2.0) } else { 0.96 }))));
			let mut fTemp109: F32 = fTemp108 + fTemp105;
			let mut fTemp110: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp111: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp110) / (fTemp72 * if (((fTemp110 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp112: F32 = fTemp109 + fTemp111;
			self.fRec36[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp112, self.fRec36[1] + 1.0) };
			let mut iTemp113: i32 = ((self.fRec36[0] < fTemp109) as i32);
			let mut fTemp114: F32 = (self.fRec36[0] - fTemp109) / fTemp111;
			let mut iTemp115: i32 = ((self.fRec36[0] < fTemp108) as i32);
			let mut fTemp116: F32 = (self.fRec36[0] - fTemp108) / fTemp105;
			let mut fTemp117: F32 = self.fRec36[0] / fTemp108;
			let mut fTemp118: F32 = if (iTemp113 as i32 != 0) { if (iTemp115 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp106 } else { if (iTemp115 as i32 != 0) { fTemp106 + fTemp107 * if (((self.fRec33[0] > fTemp106) as i32) as i32 != 0) { F32::powf(fTemp117, 0.33333334) } else { fTemp117 } } else { self.fRec33[0] } } } else { if (iTemp113 as i32 != 0) { self.fRec33[0] + fTemp104 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp116, 0.33333334) } else { fTemp116 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp112) as i32) as i32 != 0) { self.fRec34[0] + fTemp110 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp114, 0.33333334) } else { fTemp114 } } else { self.fRec35[0] } };
			let mut iTemp119: i32 = ((fTemp118) as i32);
			let mut fTemp120: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp119) as usize] };
			let mut fTemp121: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec37[1] + fSlow25 * fTemp49 };
			self.fRec37[0] = fTemp121 - F32::floor(fTemp121);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec37[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp120 + (fTemp118 - ((iTemp119) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp119, 1)) as usize] } - fTemp120));
			let mut fTemp122: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec38[1] + self.fConst12 };
			self.fRec38[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec38[0] + 17.391304 * (self.fRec32[0] + 0.115 * (fTemp51 * (fTemp103 + (fTemp101 - ((iTemp102) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp102, 1)) as usize] } - fTemp103)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp67 + (fTemp65 - ((iTemp66) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp66, 1)) as usize] } - fTemp67)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * fTemp51 * (fTemp44 + (fTemp42 - ((iTemp43) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp43, 1)) as usize] } - fTemp44)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25));
			self.fVec4[0] = fTemp123;
			self.fRec0[0] = 0.115 * (self.fConst13 * fTemp123 + self.fConst14 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow28 * self.fRec0[0];
			*output1 = fSlow29 * self.fRec0[0];
			*output2 = fSlow30 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.iRec17[1] = self.iRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec38[1] = self.fRec38[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Cowbell1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Cowbell1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Cowbell1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * fSlow2 + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.42857143 * fSlow3;
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -69.0));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst6 * fSlow6;
		let mut fSlow12: F32 = self.fConst7 * fSlow6;
		let mut fSlow13: F32 = self.fConst9 * fSlow6;
		let mut fSlow14: F32 = 0.060606062 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -17.0)));
		let mut fSlow15: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 87.0)));
		let mut fSlow16: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow15) * (fSlow15 + 28.0);
		let mut fSlow17: F32 = fSlow16 + 4064.0;
		let mut fSlow18: F32 = fSlow16 + 3968.0;
		let mut fSlow19: F32 = fSlow16 + 4e+03;
		let mut fSlow20: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, fSlow14 + 93.0)));
		let mut fSlow21: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow20) * (fSlow20 + 28.0);
		let mut fSlow22: F32 = fSlow21 + 4064.0;
		let mut fSlow23: F32 = fSlow21 + 3968.0;
		let mut fSlow24: F32 = fSlow21 + 3744.0;
		let mut fSlow25: F32 = self.fConst10 * fSlow6;
		let mut fSlow26: F32 = 0.01 * self.fHslider3;
		let mut fSlow27: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow28: F32 = fSlow27 * F32::min(1.0, 1.0 - fSlow26);
		let mut fSlow29: F32 = fSlow27 * F32::min(1.0, fSlow26 + 1.0);
		let mut fSlow30: F32 = 0.01 * self.fHslider5 * fSlow27;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Cowbell1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 50.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] };
			let mut fTemp12: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (fTemp11 * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp13: F32 = fTemp12 + fTemp8;
			let mut iTemp14: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp15: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp16: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp15) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 55.5) as i32)) as usize] } * if (((fTemp15 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp17: F32 = fTemp13 + fTemp16;
			self.fRec8[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp17, self.fRec8[1] + 1.0) };
			let mut iTemp18: i32 = ((self.fRec8[0] < fTemp13) as i32);
			let mut fTemp19: F32 = (self.fRec8[0] - fTemp13) / fTemp16;
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp12) / fTemp8;
			let mut fTemp22: F32 = self.fRec8[0] / fTemp12;
			let mut fTemp23: F32 = if (iTemp18 as i32 != 0) { if (iTemp20 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp20 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec2[0] } } } else { if (iTemp18 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp17) as i32) as i32 != 0) { self.fRec4[0] + fTemp15 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } };
			let mut iTemp24: i32 = ((fTemp23) as i32);
			let mut fTemp25: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp24) as usize] };
			let mut fTemp26: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			let mut fTemp27: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp26) * (fTemp26 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3392.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp27 + 3296.0 } else { self.fRec11[1] };
			let mut fTemp28: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 80.5) as i32)) as usize] } * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp27 } else { self.fRec13[1] };
			let mut fTemp30: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp31: F32 = self.fRec10[0] - fTemp30;
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp30)) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = fTemp32 + fTemp29;
			let mut fTemp34: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp33 + fTemp35;
			self.fRec14[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp36, self.fRec14[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp33) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp33) / fTemp35;
			let mut iTemp39: i32 = ((self.fRec14[0] < fTemp32) as i32);
			let mut fTemp40: F32 = (self.fRec14[0] - fTemp32) / fTemp29;
			let mut fTemp41: F32 = self.fRec14[0] / fTemp32;
			let mut fTemp42: F32 = if (iTemp37 as i32 != 0) { if (iTemp39 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp30 } else { if (iTemp39 as i32 != 0) { fTemp30 + fTemp31 * if (((self.fRec10[0] > fTemp30) as i32) as i32 != 0) { F32::powf(fTemp41, 0.33333334) } else { fTemp41 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp28 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp36) as i32) as i32 != 0) { self.fRec11[0] + fTemp34 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec13[0] } };
			let mut iTemp43: i32 = ((fTemp42) as i32);
			let mut fTemp44: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp43) as usize] };
			let mut iTemp45: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec17[0] = if (iTemp3 as i32 != 0) { self.iConst5 } else { self.iRec17[1] };
			let mut fTemp46: F32 = 15.996094 * (0.4 * ((self.iRec17[0]) as F32) + 128.0);
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl3DSP_Cowbell1SIG3[(iTemp47) as usize] };
			let mut fTemp49: F32 = fSlow10 * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl3DSP_Cowbell1SIG3[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48));
			let mut fTemp50: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec15[1] + fSlow11 * fTemp49 };
			self.fRec15[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec15[0] + 1.024e+04) as i32) % 1024) as usize] };
			let mut fTemp52: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec18[1] + fSlow12 * fTemp49 };
			self.fRec18[0] = fTemp52 - F32::floor(fTemp52);
			let mut fTemp53: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 93.0));
			let mut fTemp54: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp53) * (fTemp53 + 28.0);
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp54 + 4064.0 } else { self.fRec19[1] };
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp54 } else { self.fRec20[1] };
			let mut fTemp55: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec6[0] + 65.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp58: F32 = self.fRec19[0] - fTemp57;
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (fTemp11 * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp57)) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp59 + fTemp56;
			self.fRec21[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(self.fConst8 + fTemp60, self.fRec21[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec21[0] < fTemp60) as i32);
			let mut iTemp62: i32 = ((self.fRec21[0] < fTemp59) as i32);
			let mut fTemp63: F32 = (self.fRec21[0] - fTemp59) / fTemp56;
			let mut fTemp64: F32 = self.fRec21[0] / fTemp59;
			let mut fTemp65: F32 = if (iTemp61 as i32 != 0) { if (iTemp62 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp57 } else { if (iTemp62 as i32 != 0) { fTemp57 + fTemp58 * if (((self.fRec19[0] > fTemp57) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec19[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec19[0] + fTemp55 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec20[0] } } } else { self.fRec20[0] };
			let mut iTemp66: i32 = ((fTemp65) as i32);
			let mut fTemp67: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp66) as usize] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec22[1] };
			self.fRec23[0] = if (iTemp3 as i32 != 0) { 7.84e+03 } else { self.fRec23[1] };
			let mut fTemp68: F32 = self.fRec23[0] - self.fRec22[0];
			self.fRec24[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec24[1] };
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 76.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec25[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp71: F32 = self.fRec22[0] - fTemp70;
			let mut fTemp72: F32 = unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 99.5) as i32)) as usize] };
			let mut fTemp73: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (fTemp72 * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp74: F32 = fTemp73 + fTemp69;
			let mut fTemp75: F32 = self.fRec25[0] - self.fRec23[0];
			let mut fTemp76: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp75) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 50.5) as i32)) as usize] } * if (((fTemp75 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp77: F32 = fTemp74 + fTemp76;
			self.fRec26[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp77, self.fRec26[1] + 1.0) };
			let mut iTemp78: i32 = ((self.fRec26[0] < fTemp74) as i32);
			let mut fTemp79: F32 = (self.fRec26[0] - fTemp74) / fTemp76;
			let mut iTemp80: i32 = ((self.fRec26[0] < fTemp73) as i32);
			let mut fTemp81: F32 = (self.fRec26[0] - fTemp73) / fTemp69;
			let mut fTemp82: F32 = self.fRec26[0] / fTemp73;
			let mut fTemp83: F32 = if (iTemp78 as i32 != 0) { if (iTemp80 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp80 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec22[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp82, 0.33333334) } else { fTemp82 } } else { self.fRec22[0] } } } else { if (iTemp78 as i32 != 0) { self.fRec22[0] + fTemp68 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec23[0] } } } else { if (((self.fRec26[0] < fTemp77) as i32) as i32 != 0) { self.fRec23[0] + fTemp75 * if (((self.fRec25[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp79, 0.33333334) } else { fTemp79 } } else { self.fRec25[0] } };
			let mut iTemp84: i32 = ((fTemp83) as i32);
			let mut fTemp85: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp84) as usize] };
			let mut fTemp86: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow13 * fTemp49 };
			self.fRec27[0] = fTemp86 - F32::floor(fTemp86);
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow17 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp3 as i32 != 0) { fSlow18 } else { self.fRec29[1] };
			let mut fTemp87: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 98.5) as i32)) as usize] } * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp90: F32 = self.fRec28[0] - fTemp89;
			let mut fTemp91: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp90) / (fTemp72 * if (((fTemp90 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp89)) + 2.0) } else { 0.96 }))));
			let mut fTemp92: F32 = fTemp91 + fTemp88;
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fSlow19 } else { self.fRec31[1] };
			let mut fTemp93: F32 = self.fRec31[0] - self.fRec29[0];
			let mut fTemp94: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp93) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 44.5) as i32)) as usize] } * if (((fTemp93 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp95: F32 = fTemp92 + fTemp94;
			self.fRec30[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp95, self.fRec30[1] + 1.0) };
			let mut iTemp96: i32 = ((self.fRec30[0] < fTemp92) as i32);
			let mut fTemp97: F32 = (self.fRec30[0] - fTemp92) / fTemp94;
			let mut iTemp98: i32 = ((self.fRec30[0] < fTemp91) as i32);
			let mut fTemp99: F32 = (self.fRec30[0] - fTemp91) / fTemp88;
			let mut fTemp100: F32 = self.fRec30[0] / fTemp91;
			let mut fTemp101: F32 = if (iTemp96 as i32 != 0) { if (iTemp98 as i32 != 0) { if (((self.fRec30[0] < 0.0) as i32) as i32 != 0) { fTemp89 } else { if (iTemp98 as i32 != 0) { fTemp89 + fTemp90 * if (((self.fRec28[0] > fTemp89) as i32) as i32 != 0) { F32::powf(fTemp100, 0.33333334) } else { fTemp100 } } else { self.fRec28[0] } } } else { if (iTemp96 as i32 != 0) { self.fRec28[0] + fTemp87 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp99, 0.33333334) } else { fTemp99 } } else { self.fRec29[0] } } } else { if (((self.fRec30[0] < fTemp95) as i32) as i32 != 0) { self.fRec29[0] + fTemp93 * if (((self.fRec31[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp97, 0.33333334) } else { fTemp97 } } else { self.fRec31[0] } };
			let mut iTemp102: i32 = ((fTemp101) as i32);
			let mut fTemp103: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp102) as usize] };
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fSlow22 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fSlow23 } else { self.fRec34[1] };
			let mut fTemp104: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp105: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp104) / (unsafe { ftbl1DSP_Cowbell1SIG1[(((self.fRec24[0] + 66.5) as i32)) as usize] } * if (((fTemp104 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fSlow24 } else { self.fRec35[1] };
			let mut fTemp106: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp107: F32 = self.fRec33[0] - fTemp106;
			let mut fTemp108: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp107) / (fTemp72 * if (((fTemp107 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp106)) + 2.0) } else { 0.96 }))));
			let mut fTemp109: F32 = fTemp108 + fTemp105;
			let mut fTemp110: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp111: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp110) / (fTemp72 * if (((fTemp110 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp112: F32 = fTemp109 + fTemp111;
			self.fRec36[0] = if (iTemp14 as i32 != 0) { 0.0 } else { F32::min(fTemp112, self.fRec36[1] + 1.0) };
			let mut iTemp113: i32 = ((self.fRec36[0] < fTemp109) as i32);
			let mut fTemp114: F32 = (self.fRec36[0] - fTemp109) / fTemp111;
			let mut iTemp115: i32 = ((self.fRec36[0] < fTemp108) as i32);
			let mut fTemp116: F32 = (self.fRec36[0] - fTemp108) / fTemp105;
			let mut fTemp117: F32 = self.fRec36[0] / fTemp108;
			let mut fTemp118: F32 = if (iTemp113 as i32 != 0) { if (iTemp115 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp106 } else { if (iTemp115 as i32 != 0) { fTemp106 + fTemp107 * if (((self.fRec33[0] > fTemp106) as i32) as i32 != 0) { F32::powf(fTemp117, 0.33333334) } else { fTemp117 } } else { self.fRec33[0] } } } else { if (iTemp113 as i32 != 0) { self.fRec33[0] + fTemp104 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp116, 0.33333334) } else { fTemp116 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp112) as i32) as i32 != 0) { self.fRec34[0] + fTemp110 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp114, 0.33333334) } else { fTemp114 } } else { self.fRec35[0] } };
			let mut iTemp119: i32 = ((fTemp118) as i32);
			let mut fTemp120: F32 = unsafe { ftbl0DSP_Cowbell1SIG0[(iTemp119) as usize] };
			let mut fTemp121: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec37[1] + fSlow25 * fTemp49 };
			self.fRec37[0] = fTemp121 - F32::floor(fTemp121);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec37[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp120 + (fTemp118 - ((iTemp119) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp119, 1)) as usize] } - fTemp120));
			let mut fTemp122: F32 = if (iTemp45 as i32 != 0) { 0.0 } else { self.fRec38[1] + self.fConst12 };
			self.fRec38[0] = fTemp122 - F32::floor(fTemp122);
			let mut fTemp123: F32 = unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec38[0] + 17.391304 * (self.fRec32[0] + 0.115 * (fTemp51 * (fTemp103 + (fTemp101 - ((iTemp102) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp102, 1)) as usize] } - fTemp103)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp85 + (fTemp83 - ((iTemp84) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp84, 1)) as usize] } - fTemp85)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp67 + (fTemp65 - ((iTemp66) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp66, 1)) as usize] } - fTemp67)) + unsafe { ftbl2DSP_Cowbell1SIG2[(((1024.0 * (self.fRec18[0] + 2.0 * fTemp51 * (fTemp44 + (fTemp42 - ((iTemp43) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp43, 1)) as usize] } - fTemp44)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp25 + (fTemp23 - ((iTemp24) as F32)) * (unsafe { ftbl0DSP_Cowbell1SIG0[(i32::wrapping_add(iTemp24, 1)) as usize] } - fTemp25));
			self.fVec4[0] = fTemp123;
			self.fRec0[0] = 0.115 * (self.fConst13 * fTemp123 + self.fConst14 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow28 * self.fRec0[0];
			*output1 = fSlow29 * self.fRec0[0];
			*output2 = fSlow30 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.iRec17[1] = self.iRec17[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec38[1] = self.fRec38[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
