// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_HihatOpen -pn processHihatOpen -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_HihatOpenSIG0 {
	iRec7: [i32;2],
}

impl DSP_HihatOpenSIG0 {
	
	fn get_num_inputsDSP_HihatOpenSIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_HihatOpenSIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_HihatOpenSIG0(&mut self, sample_rate: i32) {
		for l3 in 0..2 {
			self.iRec7[(l3) as usize] = 0;
		}
	}
	
	fn fillDSP_HihatOpenSIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec7[0] = i32::wrapping_add(self.iRec7[1], 1);
			let mut fTemp1: F32 = ((i32::wrapping_add(self.iRec7[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp1))))) * (((((7.2e+03 - fTemp1) < 3824.0) as i32)) as F32);
			self.iRec7[1] = self.iRec7[0];
		}
	}

}


pub fn newDSP_HihatOpenSIG0() -> DSP_HihatOpenSIG0 { 
	DSP_HihatOpenSIG0 {
		iRec7: [0;2],
	}
}

pub struct DSP_HihatOpenSIG1 {
	iRec11: [i32;2],
}

impl DSP_HihatOpenSIG1 {
	
	fn get_num_inputsDSP_HihatOpenSIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_HihatOpenSIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_HihatOpenSIG1(&mut self, sample_rate: i32) {
		for l9 in 0..2 {
			self.iRec11[(l9) as usize] = 0;
		}
	}
	
	fn fillDSP_HihatOpenSIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec11[0] = i32::wrapping_add(self.iRec11[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec11[0], -1)) as F32));
			self.iRec11[1] = self.iRec11[0];
		}
	}

}


pub fn newDSP_HihatOpenSIG1() -> DSP_HihatOpenSIG1 { 
	DSP_HihatOpenSIG1 {
		iRec11: [0;2],
	}
}

pub struct DSP_HihatOpenSIG2 {
	iVec4: [i32;2],
	iRec15: [i32;2],
}

impl DSP_HihatOpenSIG2 {
	
	fn get_num_inputsDSP_HihatOpenSIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_HihatOpenSIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_HihatOpenSIG2(&mut self, sample_rate: i32) {
		for l13 in 0..2 {
			self.iVec4[(l13) as usize] = 0;
		}
		for l14 in 0..2 {
			self.iRec15[(l14) as usize] = 0;
		}
	}
	
	fn fillDSP_HihatOpenSIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec4[0] = 1;
			self.iRec15[0] = (i32::wrapping_add(self.iVec4[1], self.iRec15[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec15[0]) as F32));
			self.iVec4[1] = self.iVec4[0];
			self.iRec15[1] = self.iRec15[0];
		}
	}

}


pub fn newDSP_HihatOpenSIG2() -> DSP_HihatOpenSIG2 { 
	DSP_HihatOpenSIG2 {
		iVec4: [0;2],
		iRec15: [0;2],
	}
}

pub struct DSP_HihatOpenSIG3 {
	iRec22: [i32;2],
}

impl DSP_HihatOpenSIG3 {
	
	fn get_num_inputsDSP_HihatOpenSIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_HihatOpenSIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_HihatOpenSIG3(&mut self, sample_rate: i32) {
		for l20 in 0..2 {
			self.iRec22[(l20) as usize] = 0;
		}
	}
	
	fn fillDSP_HihatOpenSIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec22[0] = i32::wrapping_add(self.iRec22[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec22[0], -1)) as F32) + -128.0));
			self.iRec22[1] = self.iRec22[0];
		}
	}

}


pub fn newDSP_HihatOpenSIG3() -> DSP_HihatOpenSIG3 { 
	DSP_HihatOpenSIG3 {
		iRec22: [0;2],
	}
}
static mut ftbl0DSP_HihatOpenSIG0: [F32;16384] = [0.0;16384];
fn DSP_HihatOpen_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_HihatOpenSIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_HihatOpenSIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_HihatOpenSIG3: [F32;4096] = [0.0;4096];
fn DSP_HihatOpen_faustpower4_f(value: F32) -> F32 {
	return value * value * value * value;
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_HihatOpen {
	fEntry0: F32,
	fVec0: [F32;2],
	iVec1: [i32;2],
	iRec1: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst1: F32,
	fHslider0: F32,
	fEntry1: F32,
	fVec2: [F32;2],
	iVec3: [i32;2],
	fHslider1: F32,
	fRec9: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fHslider2: F32,
	fRec12: [F32;2],
	fRec13: [F32;2],
	fRec14: [F32;2],
	fRec16: [F32;2],
	fRec17: [F32;2],
	fConst2: F32,
	fRec18: [F32;2],
	fRec19: [F32;2],
	fConst3: F32,
	fRec20: [F32;2],
	fConst6: F32,
	fRec21: [F32;2],
	fConst8: F32,
	fRec23: [F32;2],
	fRec24: [F32;2],
	fRec25: [F32;2],
	fConst10: F32,
	fRec26: [F32;2],
	fConst12: F32,
	fRec27: [F32;2],
	fRec28: [F32;2],
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fRec33: [F32;2],
	fRec34: [F32;2],
	fConst14: F32,
	fRec35: [F32;2],
	fRec32: [F32;2],
	fConst16: F32,
	fRec36: [F32;2],
	fRec2: [F32;2],
	fRec3: [F32;2],
	fRec4: [F32;2],
	fRec5: [F32;2],
	fVec5: [F32;2],
	fConst18: F32,
	fConst19: F32,
	fConst21: F32,
	fConst22: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_HihatOpen {
	type T = F32;
		
	fn new() -> DSP_HihatOpen { 
		DSP_HihatOpen {
			fEntry0: 0.0,
			fVec0: [0.0;2],
			iVec1: [0;2],
			iRec1: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst1: 0.0,
			fHslider0: 0.0,
			fEntry1: 0.0,
			fVec2: [0.0;2],
			iVec3: [0;2],
			fHslider1: 0.0,
			fRec9: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fHslider2: 0.0,
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fConst2: 0.0,
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fConst3: 0.0,
			fRec20: [0.0;2],
			fConst6: 0.0,
			fRec21: [0.0;2],
			fConst8: 0.0,
			fRec23: [0.0;2],
			fRec24: [0.0;2],
			fRec25: [0.0;2],
			fConst10: 0.0,
			fRec26: [0.0;2],
			fConst12: 0.0,
			fRec27: [0.0;2],
			fRec28: [0.0;2],
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fRec33: [0.0;2],
			fRec34: [0.0;2],
			fConst14: 0.0,
			fRec35: [0.0;2],
			fRec32: [0.0;2],
			fConst16: 0.0,
			fRec36: [0.0;2],
			fRec2: [0.0;2],
			fRec3: [0.0;2],
			fRec4: [0.0;2],
			fRec5: [0.0;2],
			fVec5: [0.0;2],
			fConst18: 0.0,
			fConst19: 0.0,
			fConst21: 0.0,
			fConst22: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_HihatOpen -pn processHihatOpen -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("envelopes.lib/ar:author", "Yann Orlarey, Stéphane Letz");
		m.declare("envelopes.lib/author", "GRAME");
		m.declare("envelopes.lib/copyright", "GRAME");
		m.declare("envelopes.lib/license", "LGPL with exception");
		m.declare("envelopes.lib/name", "Faust Envelope Library");
		m.declare("envelopes.lib/version", "1.2.0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
		m.declare("vaeffects.lib/moogLadder:author", "Dario Sanfilippo");
		m.declare("vaeffects.lib/moogLadder:license", "MIT-style STK-4.3 license");
		m.declare("vaeffects.lib/name", "Faust Virtual Analog Filter Effect Library");
		m.declare("vaeffects.lib/version", "1.2.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_HihatOpenSIG0 = newDSP_HihatOpenSIG0();
		sig0.instance_initDSP_HihatOpenSIG0(sample_rate);
		sig0.fillDSP_HihatOpenSIG0(16384, unsafe { &mut ftbl0DSP_HihatOpenSIG0 });
		let mut sig1: DSP_HihatOpenSIG1 = newDSP_HihatOpenSIG1();
		sig1.instance_initDSP_HihatOpenSIG1(sample_rate);
		sig1.fillDSP_HihatOpenSIG1(144, unsafe { &mut ftbl1DSP_HihatOpenSIG1 });
		let mut sig2: DSP_HihatOpenSIG2 = newDSP_HihatOpenSIG2();
		sig2.instance_initDSP_HihatOpenSIG2(sample_rate);
		sig2.fillDSP_HihatOpenSIG2(1024, unsafe { &mut ftbl2DSP_HihatOpenSIG2 });
		let mut sig3: DSP_HihatOpenSIG3 = newDSP_HihatOpenSIG3();
		sig3.instance_initDSP_HihatOpenSIG3(sample_rate);
		sig3.fillDSP_HihatOpenSIG3(4096, unsafe { &mut ftbl3DSP_HihatOpenSIG3 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 9e+01;
		self.fEntry1 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 5e+01;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.fVec0[(l0) as usize] = 0.0;
		}
		for l1 in 0..2 {
			self.iVec1[(l1) as usize] = 0;
		}
		for l2 in 0..2 {
			self.iRec1[(l2) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fVec2[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.iVec3[(l5) as usize] = 0;
		}
		for l6 in 0..2 {
			self.fRec9[(l6) as usize] = 0.0;
		}
		for l7 in 0..2 {
			self.fRec8[(l7) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec10[(l8) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec12[(l10) as usize] = 0.0;
		}
		for l11 in 0..2 {
			self.fRec13[(l11) as usize] = 0.0;
		}
		for l12 in 0..2 {
			self.fRec14[(l12) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec16[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec17[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec18[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec19[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec20[(l19) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec21[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec23[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec24[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec25[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec26[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec27[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec28[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec29[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec30[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec31[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec33[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec34[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec35[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec32[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec36[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec2[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec3[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec4[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec5[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fVec5[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec0[(l41) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		self.fConst1 = 1.0 / F32::max(1.0, 0.02 * self.fConst0);
		self.fConst2 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst3 = 2.0 * self.fConst2;
		let mut fConst4: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2595] };
		let mut fConst5: F32 = 1e+03 / self.fConst0;
		self.fConst6 = fConst5 * (fConst4 + 0.8672086 * (unsafe { ftbl3DSP_HihatOpenSIG3[2596] } - fConst4));
		let mut fConst7: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2277] };
		self.fConst8 = fConst5 * (fConst7 + 0.049064063 * (unsafe { ftbl3DSP_HihatOpenSIG3[2278] } - fConst7));
		let mut fConst9: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2468] };
		self.fConst10 = fConst5 * (fConst9 + 0.33995077 * (unsafe { ftbl3DSP_HihatOpenSIG3[2469] } - fConst9));
		let mut fConst11: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2570] };
		self.fConst12 = fConst5 * (fConst11 + 0.36175704 * (unsafe { ftbl3DSP_HihatOpenSIG3[2571] } - fConst11));
		let mut fConst13: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2678] };
		self.fConst14 = fConst5 * (fConst13 + 0.7599262 * (unsafe { ftbl3DSP_HihatOpenSIG3[2679] } - fConst13));
		let mut fConst15: F32 = unsafe { ftbl3DSP_HihatOpenSIG3[2047] };
		self.fConst16 = 1.0 / self.fConst0 * (fConst15 + 0.5 * (unsafe { ftbl3DSP_HihatOpenSIG3[2048] } - fConst15));
		let mut fConst17: F32 = F32::tan(62.831852 / self.fConst0);
		self.fConst18 = 1.0 / fConst17;
		self.fConst19 = 1.0 - self.fConst18;
		let mut fConst20: F32 = self.fConst18 + 1.0;
		self.fConst21 = 1.0 / fConst20;
		self.fConst22 = 0.0 - 1.0 / (fConst17 * fConst20);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_HihatOpen::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Choke", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_num_entry("Trigger", ParamIndex(1), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(2)), "1", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(2), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(3)), "2", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(3), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "5", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Decay");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Decay", ParamIndex(4), 5e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(5)), "7", "");
		ui_interface.declare(Some(ParamIndex(5)), "export", "Tone");
		ui_interface.declare(Some(ParamIndex(5)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Tone", ParamIndex(5), 9e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(6)), "8", "");
		ui_interface.declare(Some(ParamIndex(6)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(6)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(6), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(7), 0.0, 0.0, 1.0, 0.01);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			1 => Some(self.fEntry1),
			5 => Some(self.fHslider0),
			7 => Some(self.fHslider1),
			4 => Some(self.fHslider2),
			3 => Some(self.fHslider3),
			2 => Some(self.fHslider4),
			6 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			1 => { self.fEntry1 = value }
			5 => { self.fHslider0 = value }
			7 => { self.fHslider1 = value }
			4 => { self.fHslider2 = value }
			3 => { self.fHslider3 = value }
			2 => { self.fHslider4 = value }
			6 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fEntry1;
		let mut fSlow8: F32 = self.fHslider1;
		let mut fSlow9: F32 = self.fHslider2;
		let mut fSlow10: F32 = 0.08 * fSlow9;
		let mut fSlow11: F32 = 0.11 * fSlow9;
		let mut fSlow12: F32 = 1.0 / (0.16465649 * (DSP_HihatOpen_faustpower4_f(fSlow2) * fSlow5 / DSP_HihatOpen_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow13: F32 = 2.0 * fSlow4;
		let mut fSlow14: F32 = 0.01 * self.fHslider3;
		let mut fSlow15: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.0));
		let mut fSlow16: F32 = fSlow15 * F32::min(1.0, 1.0 - fSlow14);
		let mut fSlow17: F32 = fSlow15 * F32::min(1.0, fSlow14 + 1.0);
		let mut fSlow18: F32 = 0.01 * self.fHslider5 * fSlow15;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = ((fSlow7 > self.fVec2[1]) as i32);
			self.iVec3[0] = iTemp2;
			let mut iTemp3: i32 = ((iTemp2 > self.iVec3[1]) as i32);
			let mut iTemp4: i32 = i32::wrapping_sub(1, iTemp3);
			self.fRec9[0] = if (iTemp2 as i32 != 0) { fSlow7 } else { self.fRec9[1] };
			let mut fTemp5: F32 = 106.0 * (1.0 - DSP_HihatOpen_faustpower2_f(1.0 - F32::max(fSlow8, self.fRec9[0]))) + -99.0;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec8[0] = if (iTemp4 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec8[1] };
			self.fRec10[0] = if (iTemp4 as i32 != 0) { fTemp7 + 3.52e+03 } else { self.fRec10[1] };
			let mut fTemp8: F32 = self.fRec10[0] - self.fRec8[0];
			self.fRec12[0] = if (iTemp4 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 63.5 - fSlow10) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec8[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp4 as i32 != 0) { fTemp7 } else { self.fRec13[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp11: F32 = self.fRec8[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp3 > 0) as i32);
			let mut fTemp16: F32 = self.fRec13[0] - self.fRec10[0];
			let mut fTemp17: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp16) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 56.5 - fSlow11) as i32)) as usize] } * if (((fTemp16 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp18: F32 = fTemp14 + fTemp17;
			self.fRec14[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp18, self.fRec14[1] + 1.0) };
			let mut iTemp19: i32 = ((self.fRec14[0] < fTemp14) as i32);
			let mut fTemp20: F32 = (self.fRec14[0] - fTemp14) / fTemp17;
			let mut iTemp21: i32 = ((self.fRec14[0] < fTemp13) as i32);
			let mut fTemp22: F32 = (self.fRec14[0] - fTemp13) / fTemp9;
			let mut fTemp23: F32 = self.fRec14[0] / fTemp13;
			let mut fTemp24: F32 = if (iTemp19 as i32 != 0) { if (iTemp21 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp21 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec8[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec8[0] } } } else { if (iTemp19 as i32 != 0) { self.fRec8[0] + fTemp8 * if (((self.fRec10[0] > self.fRec8[0]) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec10[0] } } } else { if (((self.fRec14[0] < fTemp18) as i32) as i32 != 0) { self.fRec10[0] + fTemp16 * if (((self.fRec13[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec13[0] } };
			let mut iTemp25: i32 = ((fTemp24) as i32);
			let mut fTemp26: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp25) as usize] };
			self.fRec16[0] = if (iTemp4 as i32 != 0) { 4064.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec16[0]);
			self.fRec17[0] = if (iTemp4 as i32 != 0) { 8128.0 } else { self.fRec17[1] };
			let mut fTemp28: F32 = self.fRec17[0] - fTemp27;
			let mut fTemp29: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0);
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp31: F32 = self.fRec16[0] - self.fRec17[0];
			let mut fTemp32: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0);
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 32.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp34: F32 = self.fConst2 + fTemp30 + fTemp33;
			self.fRec18[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec18[1] + 1.0) };
			let mut fTemp35: F32 = (self.fRec18[0] - fTemp30 - self.fConst2) / fTemp33;
			let mut iTemp36: i32 = ((self.fRec18[0] < fTemp30) as i32);
			let mut fTemp37: F32 = self.fRec18[0] / fTemp30;
			let mut fTemp38: F32 = if (((self.fRec18[0] < (self.fConst2 + fTemp30)) as i32) as i32 != 0) { if (iTemp36 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp36 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec17[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec18[0] < fTemp34) as i32) as i32 != 0) { self.fRec17[0] + fTemp31 * if (((self.fRec16[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec16[0] } };
			let mut iTemp39: i32 = ((fTemp38) as i32);
			let mut fTemp40: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp39) as usize] };
			self.fRec19[0] = if (iTemp4 as i32 != 0) { 7968.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = F32::max(5076.0, self.fRec19[0]);
			let mut fTemp42: F32 = self.fRec19[0] - fTemp41;
			let mut fTemp43: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp42) / (fTemp12 * if (((fTemp42 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp41)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp43, self.fRec20[1] + 1.0) };
			let mut iTemp44: i32 = ((self.fRec20[0] < fTemp43) as i32);
			let mut fTemp45: F32 = self.fRec20[0] / fTemp43;
			let mut fTemp46: F32 = if (((self.fRec20[0] < (self.fConst2 + fTemp43)) as i32) as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp41 } else { if (iTemp44 as i32 != 0) { fTemp41 + fTemp42 * if (((self.fRec19[0] > fTemp41) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] };
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp47) as usize] };
			let mut iTemp49: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp50: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst6 };
			self.fRec21[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec23[1] + self.fConst8 };
			self.fRec23[0] = fTemp51 - F32::floor(fTemp51);
			self.fRec24[0] = if (iTemp4 as i32 != 0) { 6.88e+03 } else { self.fRec24[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec24[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp12 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = self.fRec24[0] - self.fRec17[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 85.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp57: F32 = self.fConst2 + fTemp54 + fTemp56;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp57, self.fRec25[1] + 1.0) };
			let mut fTemp58: F32 = (self.fRec25[0] - fTemp54 - self.fConst2) / fTemp56;
			let mut iTemp59: i32 = ((self.fRec25[0] < fTemp54) as i32);
			let mut fTemp60: F32 = self.fRec25[0] / fTemp54;
			let mut fTemp61: F32 = if (((self.fRec25[0] < (self.fConst2 + fTemp54)) as i32) as i32 != 0) { if (iTemp59 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp59 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp60, 0.33333334) } else { fTemp60 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec25[0] < fTemp57) as i32) as i32 != 0) { self.fRec17[0] + fTemp55 * if (((self.fRec24[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec24[0] } };
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst10 };
			self.fRec26[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst12 };
			self.fRec27[0] = fTemp65 - F32::floor(fTemp65);
			let mut fTemp66: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp5 + 88.0));
			let mut fTemp67: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp66) * (fTemp66 + 28.0);
			self.fRec28[0] = if (iTemp4 as i32 != 0) { fTemp67 + 4064.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp4 as i32 != 0) { fTemp67 + 1224.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 66.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp4 as i32 != 0) { fTemp67 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 92.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 58.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp83) as usize] };
			self.fRec33[0] = if (iTemp4 as i32 != 0) { 7584.0 } else { self.fRec33[1] };
			let mut fTemp85: F32 = self.fRec33[0] - fTemp27;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp12 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp87: F32 = self.fRec16[0] - self.fRec33[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (fTemp12 * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = self.fConst2 + fTemp86 + fTemp88;
			self.fRec34[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp89, self.fRec34[1] + 1.0) };
			let mut fTemp90: F32 = (self.fRec34[0] - fTemp86 - self.fConst2) / fTemp88;
			let mut iTemp91: i32 = ((self.fRec34[0] < fTemp86) as i32);
			let mut fTemp92: F32 = self.fRec34[0] / fTemp86;
			let mut fTemp93: F32 = if (((self.fRec34[0] < (self.fConst2 + fTemp86)) as i32) as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp91 as i32 != 0) { fTemp27 + fTemp85 * if (((self.fRec33[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec33[0] } } } else { self.fRec33[0] } } else { if (((self.fRec34[0] < fTemp89) as i32) as i32 != 0) { self.fRec33[0] + fTemp87 * if (((self.fRec16[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec16[0] } };
			let mut iTemp94: i32 = ((fTemp93) as i32);
			let mut fTemp95: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp94) as usize] };
			let mut fTemp96: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec35[1] + self.fConst14 };
			self.fRec35[0] = fTemp96 - F32::floor(fTemp96);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec35[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp95 + (fTemp93 - ((iTemp94) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp94, 1)) as usize] } - fTemp95));
			let mut fTemp97: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst16 };
			self.fRec36[0] = fTemp97 - F32::floor(fTemp97);
			let mut fTemp98: F32 = fSlow12 * (0.115 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec36[0] + 17.391304 * self.fRec32[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec27[0] + 2.0 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec26[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec23[0] + 2.0 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec21[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp40 + (fTemp38 - ((iTemp39) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp39, 1)) as usize] } - fTemp40))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp26 + (fTemp24 - ((iTemp25) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp25, 1)) as usize] } - fTemp26))) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow13 * fTemp98;
			let mut fTemp99: F32 = self.fRec2[1] + fSlow4 * fTemp98 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow13 * fTemp99;
			let mut fTemp100: F32 = self.fRec3[1] + fSlow4 * fTemp99 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow13 * fTemp100;
			let mut fTemp101: F32 = self.fRec4[1] + fSlow4 * fTemp100 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow13 * fTemp101;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp101;
			let mut fTemp102: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec5[0] = fTemp102;
			self.fRec0[0] = self.fConst22 * self.fVec5[1] - self.fConst21 * (self.fConst19 * self.fRec0[1] - self.fConst18 * fTemp102);
			*output0 = fSlow16 * self.fRec0[0];
			*output1 = fSlow17 * self.fRec0[0];
			*output2 = fSlow18 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec5[1] = self.fVec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_HihatOpen {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_HihatOpen as FaustDsp>::T]], outputs: &mut[&mut[<DSP_HihatOpen as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fEntry1;
		let mut fSlow8: F32 = self.fHslider1;
		let mut fSlow9: F32 = self.fHslider2;
		let mut fSlow10: F32 = 0.08 * fSlow9;
		let mut fSlow11: F32 = 0.11 * fSlow9;
		let mut fSlow12: F32 = 1.0 / (0.16465649 * (DSP_HihatOpen_faustpower4_f(fSlow2) * fSlow5 / DSP_HihatOpen_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow13: F32 = 2.0 * fSlow4;
		let mut fSlow14: F32 = 0.01 * self.fHslider3;
		let mut fSlow15: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.0));
		let mut fSlow16: F32 = fSlow15 * F32::min(1.0, 1.0 - fSlow14);
		let mut fSlow17: F32 = fSlow15 * F32::min(1.0, fSlow14 + 1.0);
		let mut fSlow18: F32 = 0.01 * self.fHslider5 * fSlow15;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = ((fSlow7 > self.fVec2[1]) as i32);
			self.iVec3[0] = iTemp2;
			let mut iTemp3: i32 = ((iTemp2 > self.iVec3[1]) as i32);
			let mut iTemp4: i32 = i32::wrapping_sub(1, iTemp3);
			self.fRec9[0] = if (iTemp2 as i32 != 0) { fSlow7 } else { self.fRec9[1] };
			let mut fTemp5: F32 = 106.0 * (1.0 - DSP_HihatOpen_faustpower2_f(1.0 - F32::max(fSlow8, self.fRec9[0]))) + -99.0;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec8[0] = if (iTemp4 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec8[1] };
			self.fRec10[0] = if (iTemp4 as i32 != 0) { fTemp7 + 3.52e+03 } else { self.fRec10[1] };
			let mut fTemp8: F32 = self.fRec10[0] - self.fRec8[0];
			self.fRec12[0] = if (iTemp4 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 63.5 - fSlow10) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec8[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp4 as i32 != 0) { fTemp7 } else { self.fRec13[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp11: F32 = self.fRec8[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp3 > 0) as i32);
			let mut fTemp16: F32 = self.fRec13[0] - self.fRec10[0];
			let mut fTemp17: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp16) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 56.5 - fSlow11) as i32)) as usize] } * if (((fTemp16 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp18: F32 = fTemp14 + fTemp17;
			self.fRec14[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp18, self.fRec14[1] + 1.0) };
			let mut iTemp19: i32 = ((self.fRec14[0] < fTemp14) as i32);
			let mut fTemp20: F32 = (self.fRec14[0] - fTemp14) / fTemp17;
			let mut iTemp21: i32 = ((self.fRec14[0] < fTemp13) as i32);
			let mut fTemp22: F32 = (self.fRec14[0] - fTemp13) / fTemp9;
			let mut fTemp23: F32 = self.fRec14[0] / fTemp13;
			let mut fTemp24: F32 = if (iTemp19 as i32 != 0) { if (iTemp21 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp21 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec8[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec8[0] } } } else { if (iTemp19 as i32 != 0) { self.fRec8[0] + fTemp8 * if (((self.fRec10[0] > self.fRec8[0]) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec10[0] } } } else { if (((self.fRec14[0] < fTemp18) as i32) as i32 != 0) { self.fRec10[0] + fTemp16 * if (((self.fRec13[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec13[0] } };
			let mut iTemp25: i32 = ((fTemp24) as i32);
			let mut fTemp26: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp25) as usize] };
			self.fRec16[0] = if (iTemp4 as i32 != 0) { 4064.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec16[0]);
			self.fRec17[0] = if (iTemp4 as i32 != 0) { 8128.0 } else { self.fRec17[1] };
			let mut fTemp28: F32 = self.fRec17[0] - fTemp27;
			let mut fTemp29: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0);
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp31: F32 = self.fRec16[0] - self.fRec17[0];
			let mut fTemp32: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0);
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 32.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp34: F32 = self.fConst2 + fTemp30 + fTemp33;
			self.fRec18[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec18[1] + 1.0) };
			let mut fTemp35: F32 = (self.fRec18[0] - fTemp30 - self.fConst2) / fTemp33;
			let mut iTemp36: i32 = ((self.fRec18[0] < fTemp30) as i32);
			let mut fTemp37: F32 = self.fRec18[0] / fTemp30;
			let mut fTemp38: F32 = if (((self.fRec18[0] < (self.fConst2 + fTemp30)) as i32) as i32 != 0) { if (iTemp36 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp36 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec17[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec18[0] < fTemp34) as i32) as i32 != 0) { self.fRec17[0] + fTemp31 * if (((self.fRec16[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec16[0] } };
			let mut iTemp39: i32 = ((fTemp38) as i32);
			let mut fTemp40: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp39) as usize] };
			self.fRec19[0] = if (iTemp4 as i32 != 0) { 7968.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = F32::max(5076.0, self.fRec19[0]);
			let mut fTemp42: F32 = self.fRec19[0] - fTemp41;
			let mut fTemp43: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp42) / (fTemp12 * if (((fTemp42 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp41)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp43, self.fRec20[1] + 1.0) };
			let mut iTemp44: i32 = ((self.fRec20[0] < fTemp43) as i32);
			let mut fTemp45: F32 = self.fRec20[0] / fTemp43;
			let mut fTemp46: F32 = if (((self.fRec20[0] < (self.fConst2 + fTemp43)) as i32) as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp41 } else { if (iTemp44 as i32 != 0) { fTemp41 + fTemp42 * if (((self.fRec19[0] > fTemp41) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] };
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp47) as usize] };
			let mut iTemp49: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp50: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst6 };
			self.fRec21[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec23[1] + self.fConst8 };
			self.fRec23[0] = fTemp51 - F32::floor(fTemp51);
			self.fRec24[0] = if (iTemp4 as i32 != 0) { 6.88e+03 } else { self.fRec24[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec24[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp12 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = self.fRec24[0] - self.fRec17[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 85.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp57: F32 = self.fConst2 + fTemp54 + fTemp56;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp57, self.fRec25[1] + 1.0) };
			let mut fTemp58: F32 = (self.fRec25[0] - fTemp54 - self.fConst2) / fTemp56;
			let mut iTemp59: i32 = ((self.fRec25[0] < fTemp54) as i32);
			let mut fTemp60: F32 = self.fRec25[0] / fTemp54;
			let mut fTemp61: F32 = if (((self.fRec25[0] < (self.fConst2 + fTemp54)) as i32) as i32 != 0) { if (iTemp59 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp59 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp60, 0.33333334) } else { fTemp60 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec25[0] < fTemp57) as i32) as i32 != 0) { self.fRec17[0] + fTemp55 * if (((self.fRec24[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec24[0] } };
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst10 };
			self.fRec26[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst12 };
			self.fRec27[0] = fTemp65 - F32::floor(fTemp65);
			let mut fTemp66: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp5 + 88.0));
			let mut fTemp67: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp66) * (fTemp66 + 28.0);
			self.fRec28[0] = if (iTemp4 as i32 != 0) { fTemp67 + 4064.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp4 as i32 != 0) { fTemp67 + 1224.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 66.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp4 as i32 != 0) { fTemp67 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 92.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 58.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp83) as usize] };
			self.fRec33[0] = if (iTemp4 as i32 != 0) { 7584.0 } else { self.fRec33[1] };
			let mut fTemp85: F32 = self.fRec33[0] - fTemp27;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp12 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp87: F32 = self.fRec16[0] - self.fRec33[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (fTemp12 * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = self.fConst2 + fTemp86 + fTemp88;
			self.fRec34[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp89, self.fRec34[1] + 1.0) };
			let mut fTemp90: F32 = (self.fRec34[0] - fTemp86 - self.fConst2) / fTemp88;
			let mut iTemp91: i32 = ((self.fRec34[0] < fTemp86) as i32);
			let mut fTemp92: F32 = self.fRec34[0] / fTemp86;
			let mut fTemp93: F32 = if (((self.fRec34[0] < (self.fConst2 + fTemp86)) as i32) as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp91 as i32 != 0) { fTemp27 + fTemp85 * if (((self.fRec33[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec33[0] } } } else { self.fRec33[0] } } else { if (((self.fRec34[0] < fTemp89) as i32) as i32 != 0) { self.fRec33[0] + fTemp87 * if (((self.fRec16[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec16[0] } };
			let mut iTemp94: i32 = ((fTemp93) as i32);
			let mut fTemp95: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp94) as usize] };
			let mut fTemp96: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec35[1] + self.fConst14 };
			self.fRec35[0] = fTemp96 - F32::floor(fTemp96);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec35[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp95 + (fTemp93 - ((iTemp94) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp94, 1)) as usize] } - fTemp95));
			let mut fTemp97: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst16 };
			self.fRec36[0] = fTemp97 - F32::floor(fTemp97);
			let mut fTemp98: F32 = fSlow12 * (0.115 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec36[0] + 17.391304 * self.fRec32[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec27[0] + 2.0 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec26[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec23[0] + 2.0 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec21[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp40 + (fTemp38 - ((iTemp39) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp39, 1)) as usize] } - fTemp40))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp26 + (fTemp24 - ((iTemp25) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp25, 1)) as usize] } - fTemp26))) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow13 * fTemp98;
			let mut fTemp99: F32 = self.fRec2[1] + fSlow4 * fTemp98 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow13 * fTemp99;
			let mut fTemp100: F32 = self.fRec3[1] + fSlow4 * fTemp99 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow13 * fTemp100;
			let mut fTemp101: F32 = self.fRec4[1] + fSlow4 * fTemp100 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow13 * fTemp101;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp101;
			let mut fTemp102: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec5[0] = fTemp102;
			self.fRec0[0] = self.fConst22 * self.fVec5[1] - self.fConst21 * (self.fConst19 * self.fRec0[1] - self.fConst18 * fTemp102);
			*output0 = fSlow16 * self.fRec0[0];
			*output1 = fSlow17 * self.fRec0[0];
			*output2 = fSlow18 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec5[1] = self.fVec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_HihatOpen {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_HihatOpen as FaustDsp>::T]], outputs: &mut[&mut[<DSP_HihatOpen as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fEntry1;
		let mut fSlow8: F32 = self.fHslider1;
		let mut fSlow9: F32 = self.fHslider2;
		let mut fSlow10: F32 = 0.08 * fSlow9;
		let mut fSlow11: F32 = 0.11 * fSlow9;
		let mut fSlow12: F32 = 1.0 / (0.16465649 * (DSP_HihatOpen_faustpower4_f(fSlow2) * fSlow5 / DSP_HihatOpen_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow13: F32 = 2.0 * fSlow4;
		let mut fSlow14: F32 = 0.01 * self.fHslider3;
		let mut fSlow15: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.0));
		let mut fSlow16: F32 = fSlow15 * F32::min(1.0, 1.0 - fSlow14);
		let mut fSlow17: F32 = fSlow15 * F32::min(1.0, fSlow14 + 1.0);
		let mut fSlow18: F32 = 0.01 * self.fHslider5 * fSlow15;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = ((fSlow7 > self.fVec2[1]) as i32);
			self.iVec3[0] = iTemp2;
			let mut iTemp3: i32 = ((iTemp2 > self.iVec3[1]) as i32);
			let mut iTemp4: i32 = i32::wrapping_sub(1, iTemp3);
			self.fRec9[0] = if (iTemp2 as i32 != 0) { fSlow7 } else { self.fRec9[1] };
			let mut fTemp5: F32 = 106.0 * (1.0 - DSP_HihatOpen_faustpower2_f(1.0 - F32::max(fSlow8, self.fRec9[0]))) + -99.0;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec8[0] = if (iTemp4 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec8[1] };
			self.fRec10[0] = if (iTemp4 as i32 != 0) { fTemp7 + 3.52e+03 } else { self.fRec10[1] };
			let mut fTemp8: F32 = self.fRec10[0] - self.fRec8[0];
			self.fRec12[0] = if (iTemp4 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 63.5 - fSlow10) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec8[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp4 as i32 != 0) { fTemp7 } else { self.fRec13[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp11: F32 = self.fRec8[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp3 > 0) as i32);
			let mut fTemp16: F32 = self.fRec13[0] - self.fRec10[0];
			let mut fTemp17: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp16) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 56.5 - fSlow11) as i32)) as usize] } * if (((fTemp16 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp18: F32 = fTemp14 + fTemp17;
			self.fRec14[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp18, self.fRec14[1] + 1.0) };
			let mut iTemp19: i32 = ((self.fRec14[0] < fTemp14) as i32);
			let mut fTemp20: F32 = (self.fRec14[0] - fTemp14) / fTemp17;
			let mut iTemp21: i32 = ((self.fRec14[0] < fTemp13) as i32);
			let mut fTemp22: F32 = (self.fRec14[0] - fTemp13) / fTemp9;
			let mut fTemp23: F32 = self.fRec14[0] / fTemp13;
			let mut fTemp24: F32 = if (iTemp19 as i32 != 0) { if (iTemp21 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp21 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec8[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec8[0] } } } else { if (iTemp19 as i32 != 0) { self.fRec8[0] + fTemp8 * if (((self.fRec10[0] > self.fRec8[0]) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec10[0] } } } else { if (((self.fRec14[0] < fTemp18) as i32) as i32 != 0) { self.fRec10[0] + fTemp16 * if (((self.fRec13[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec13[0] } };
			let mut iTemp25: i32 = ((fTemp24) as i32);
			let mut fTemp26: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp25) as usize] };
			self.fRec16[0] = if (iTemp4 as i32 != 0) { 4064.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec16[0]);
			self.fRec17[0] = if (iTemp4 as i32 != 0) { 8128.0 } else { self.fRec17[1] };
			let mut fTemp28: F32 = self.fRec17[0] - fTemp27;
			let mut fTemp29: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0);
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp31: F32 = self.fRec16[0] - self.fRec17[0];
			let mut fTemp32: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0);
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 32.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp34: F32 = self.fConst2 + fTemp30 + fTemp33;
			self.fRec18[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec18[1] + 1.0) };
			let mut fTemp35: F32 = (self.fRec18[0] - fTemp30 - self.fConst2) / fTemp33;
			let mut iTemp36: i32 = ((self.fRec18[0] < fTemp30) as i32);
			let mut fTemp37: F32 = self.fRec18[0] / fTemp30;
			let mut fTemp38: F32 = if (((self.fRec18[0] < (self.fConst2 + fTemp30)) as i32) as i32 != 0) { if (iTemp36 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp36 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec17[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec18[0] < fTemp34) as i32) as i32 != 0) { self.fRec17[0] + fTemp31 * if (((self.fRec16[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec16[0] } };
			let mut iTemp39: i32 = ((fTemp38) as i32);
			let mut fTemp40: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp39) as usize] };
			self.fRec19[0] = if (iTemp4 as i32 != 0) { 7968.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = F32::max(5076.0, self.fRec19[0]);
			let mut fTemp42: F32 = self.fRec19[0] - fTemp41;
			let mut fTemp43: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp42) / (fTemp12 * if (((fTemp42 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp41)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp43, self.fRec20[1] + 1.0) };
			let mut iTemp44: i32 = ((self.fRec20[0] < fTemp43) as i32);
			let mut fTemp45: F32 = self.fRec20[0] / fTemp43;
			let mut fTemp46: F32 = if (((self.fRec20[0] < (self.fConst2 + fTemp43)) as i32) as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp41 } else { if (iTemp44 as i32 != 0) { fTemp41 + fTemp42 * if (((self.fRec19[0] > fTemp41) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] };
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp47) as usize] };
			let mut iTemp49: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp50: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst6 };
			self.fRec21[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec23[1] + self.fConst8 };
			self.fRec23[0] = fTemp51 - F32::floor(fTemp51);
			self.fRec24[0] = if (iTemp4 as i32 != 0) { 6.88e+03 } else { self.fRec24[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec24[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp12 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = self.fRec24[0] - self.fRec17[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 85.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp57: F32 = self.fConst2 + fTemp54 + fTemp56;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp57, self.fRec25[1] + 1.0) };
			let mut fTemp58: F32 = (self.fRec25[0] - fTemp54 - self.fConst2) / fTemp56;
			let mut iTemp59: i32 = ((self.fRec25[0] < fTemp54) as i32);
			let mut fTemp60: F32 = self.fRec25[0] / fTemp54;
			let mut fTemp61: F32 = if (((self.fRec25[0] < (self.fConst2 + fTemp54)) as i32) as i32 != 0) { if (iTemp59 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp59 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp60, 0.33333334) } else { fTemp60 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec25[0] < fTemp57) as i32) as i32 != 0) { self.fRec17[0] + fTemp55 * if (((self.fRec24[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec24[0] } };
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst10 };
			self.fRec26[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst12 };
			self.fRec27[0] = fTemp65 - F32::floor(fTemp65);
			let mut fTemp66: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp5 + 88.0));
			let mut fTemp67: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp66) * (fTemp66 + 28.0);
			self.fRec28[0] = if (iTemp4 as i32 != 0) { fTemp67 + 4064.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp4 as i32 != 0) { fTemp67 + 1224.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 66.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp4 as i32 != 0) { fTemp67 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 92.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 58.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp83) as usize] };
			self.fRec33[0] = if (iTemp4 as i32 != 0) { 7584.0 } else { self.fRec33[1] };
			let mut fTemp85: F32 = self.fRec33[0] - fTemp27;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp12 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp87: F32 = self.fRec16[0] - self.fRec33[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (fTemp12 * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = self.fConst2 + fTemp86 + fTemp88;
			self.fRec34[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp89, self.fRec34[1] + 1.0) };
			let mut fTemp90: F32 = (self.fRec34[0] - fTemp86 - self.fConst2) / fTemp88;
			let mut iTemp91: i32 = ((self.fRec34[0] < fTemp86) as i32);
			let mut fTemp92: F32 = self.fRec34[0] / fTemp86;
			let mut fTemp93: F32 = if (((self.fRec34[0] < (self.fConst2 + fTemp86)) as i32) as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp91 as i32 != 0) { fTemp27 + fTemp85 * if (((self.fRec33[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec33[0] } } } else { self.fRec33[0] } } else { if (((self.fRec34[0] < fTemp89) as i32) as i32 != 0) { self.fRec33[0] + fTemp87 * if (((self.fRec16[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec16[0] } };
			let mut iTemp94: i32 = ((fTemp93) as i32);
			let mut fTemp95: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp94) as usize] };
			let mut fTemp96: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec35[1] + self.fConst14 };
			self.fRec35[0] = fTemp96 - F32::floor(fTemp96);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec35[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp95 + (fTemp93 - ((iTemp94) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp94, 1)) as usize] } - fTemp95));
			let mut fTemp97: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst16 };
			self.fRec36[0] = fTemp97 - F32::floor(fTemp97);
			let mut fTemp98: F32 = fSlow12 * (0.115 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec36[0] + 17.391304 * self.fRec32[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec27[0] + 2.0 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec26[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec23[0] + 2.0 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec21[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp40 + (fTemp38 - ((iTemp39) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp39, 1)) as usize] } - fTemp40))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp26 + (fTemp24 - ((iTemp25) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp25, 1)) as usize] } - fTemp26))) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow13 * fTemp98;
			let mut fTemp99: F32 = self.fRec2[1] + fSlow4 * fTemp98 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow13 * fTemp99;
			let mut fTemp100: F32 = self.fRec3[1] + fSlow4 * fTemp99 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow13 * fTemp100;
			let mut fTemp101: F32 = self.fRec4[1] + fSlow4 * fTemp100 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow13 * fTemp101;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp101;
			let mut fTemp102: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec5[0] = fTemp102;
			self.fRec0[0] = self.fConst22 * self.fVec5[1] - self.fConst21 * (self.fConst19 * self.fRec0[1] - self.fConst18 * fTemp102);
			*output0 = fSlow16 * self.fRec0[0];
			*output1 = fSlow17 * self.fRec0[0];
			*output2 = fSlow18 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec5[1] = self.fVec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_HihatOpen {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_HihatOpen as FaustDsp>::T]], outputs: &mut[&mut[<DSP_HihatOpen as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fEntry1;
		let mut fSlow8: F32 = self.fHslider1;
		let mut fSlow9: F32 = self.fHslider2;
		let mut fSlow10: F32 = 0.08 * fSlow9;
		let mut fSlow11: F32 = 0.11 * fSlow9;
		let mut fSlow12: F32 = 1.0 / (0.16465649 * (DSP_HihatOpen_faustpower4_f(fSlow2) * fSlow5 / DSP_HihatOpen_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow13: F32 = 2.0 * fSlow4;
		let mut fSlow14: F32 = 0.01 * self.fHslider3;
		let mut fSlow15: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.0));
		let mut fSlow16: F32 = fSlow15 * F32::min(1.0, 1.0 - fSlow14);
		let mut fSlow17: F32 = fSlow15 * F32::min(1.0, fSlow14 + 1.0);
		let mut fSlow18: F32 = 0.01 * self.fHslider5 * fSlow15;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = ((fSlow7 > self.fVec2[1]) as i32);
			self.iVec3[0] = iTemp2;
			let mut iTemp3: i32 = ((iTemp2 > self.iVec3[1]) as i32);
			let mut iTemp4: i32 = i32::wrapping_sub(1, iTemp3);
			self.fRec9[0] = if (iTemp2 as i32 != 0) { fSlow7 } else { self.fRec9[1] };
			let mut fTemp5: F32 = 106.0 * (1.0 - DSP_HihatOpen_faustpower2_f(1.0 - F32::max(fSlow8, self.fRec9[0]))) + -99.0;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec8[0] = if (iTemp4 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec8[1] };
			self.fRec10[0] = if (iTemp4 as i32 != 0) { fTemp7 + 3.52e+03 } else { self.fRec10[1] };
			let mut fTemp8: F32 = self.fRec10[0] - self.fRec8[0];
			self.fRec12[0] = if (iTemp4 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 63.5 - fSlow10) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec8[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp4 as i32 != 0) { fTemp7 } else { self.fRec13[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp11: F32 = self.fRec8[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp3 > 0) as i32);
			let mut fTemp16: F32 = self.fRec13[0] - self.fRec10[0];
			let mut fTemp17: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp16) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 56.5 - fSlow11) as i32)) as usize] } * if (((fTemp16 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp18: F32 = fTemp14 + fTemp17;
			self.fRec14[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp18, self.fRec14[1] + 1.0) };
			let mut iTemp19: i32 = ((self.fRec14[0] < fTemp14) as i32);
			let mut fTemp20: F32 = (self.fRec14[0] - fTemp14) / fTemp17;
			let mut iTemp21: i32 = ((self.fRec14[0] < fTemp13) as i32);
			let mut fTemp22: F32 = (self.fRec14[0] - fTemp13) / fTemp9;
			let mut fTemp23: F32 = self.fRec14[0] / fTemp13;
			let mut fTemp24: F32 = if (iTemp19 as i32 != 0) { if (iTemp21 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp21 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec8[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec8[0] } } } else { if (iTemp19 as i32 != 0) { self.fRec8[0] + fTemp8 * if (((self.fRec10[0] > self.fRec8[0]) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec10[0] } } } else { if (((self.fRec14[0] < fTemp18) as i32) as i32 != 0) { self.fRec10[0] + fTemp16 * if (((self.fRec13[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec13[0] } };
			let mut iTemp25: i32 = ((fTemp24) as i32);
			let mut fTemp26: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp25) as usize] };
			self.fRec16[0] = if (iTemp4 as i32 != 0) { 4064.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec16[0]);
			self.fRec17[0] = if (iTemp4 as i32 != 0) { 8128.0 } else { self.fRec17[1] };
			let mut fTemp28: F32 = self.fRec17[0] - fTemp27;
			let mut fTemp29: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0);
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp31: F32 = self.fRec16[0] - self.fRec17[0];
			let mut fTemp32: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0);
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 32.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp34: F32 = self.fConst2 + fTemp30 + fTemp33;
			self.fRec18[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec18[1] + 1.0) };
			let mut fTemp35: F32 = (self.fRec18[0] - fTemp30 - self.fConst2) / fTemp33;
			let mut iTemp36: i32 = ((self.fRec18[0] < fTemp30) as i32);
			let mut fTemp37: F32 = self.fRec18[0] / fTemp30;
			let mut fTemp38: F32 = if (((self.fRec18[0] < (self.fConst2 + fTemp30)) as i32) as i32 != 0) { if (iTemp36 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp36 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec17[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec18[0] < fTemp34) as i32) as i32 != 0) { self.fRec17[0] + fTemp31 * if (((self.fRec16[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec16[0] } };
			let mut iTemp39: i32 = ((fTemp38) as i32);
			let mut fTemp40: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp39) as usize] };
			self.fRec19[0] = if (iTemp4 as i32 != 0) { 7968.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = F32::max(5076.0, self.fRec19[0]);
			let mut fTemp42: F32 = self.fRec19[0] - fTemp41;
			let mut fTemp43: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp42) / (fTemp12 * if (((fTemp42 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp41)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp43, self.fRec20[1] + 1.0) };
			let mut iTemp44: i32 = ((self.fRec20[0] < fTemp43) as i32);
			let mut fTemp45: F32 = self.fRec20[0] / fTemp43;
			let mut fTemp46: F32 = if (((self.fRec20[0] < (self.fConst2 + fTemp43)) as i32) as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp41 } else { if (iTemp44 as i32 != 0) { fTemp41 + fTemp42 * if (((self.fRec19[0] > fTemp41) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] };
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp47) as usize] };
			let mut iTemp49: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp50: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst6 };
			self.fRec21[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec23[1] + self.fConst8 };
			self.fRec23[0] = fTemp51 - F32::floor(fTemp51);
			self.fRec24[0] = if (iTemp4 as i32 != 0) { 6.88e+03 } else { self.fRec24[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec24[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp12 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = self.fRec24[0] - self.fRec17[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 85.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp57: F32 = self.fConst2 + fTemp54 + fTemp56;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp57, self.fRec25[1] + 1.0) };
			let mut fTemp58: F32 = (self.fRec25[0] - fTemp54 - self.fConst2) / fTemp56;
			let mut iTemp59: i32 = ((self.fRec25[0] < fTemp54) as i32);
			let mut fTemp60: F32 = self.fRec25[0] / fTemp54;
			let mut fTemp61: F32 = if (((self.fRec25[0] < (self.fConst2 + fTemp54)) as i32) as i32 != 0) { if (iTemp59 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp59 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp60, 0.33333334) } else { fTemp60 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec25[0] < fTemp57) as i32) as i32 != 0) { self.fRec17[0] + fTemp55 * if (((self.fRec24[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec24[0] } };
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst10 };
			self.fRec26[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst12 };
			self.fRec27[0] = fTemp65 - F32::floor(fTemp65);
			let mut fTemp66: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp5 + 88.0));
			let mut fTemp67: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp66) * (fTemp66 + 28.0);
			self.fRec28[0] = if (iTemp4 as i32 != 0) { fTemp67 + 4064.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp4 as i32 != 0) { fTemp67 + 1224.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 66.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp4 as i32 != 0) { fTemp67 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 92.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 58.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp83) as usize] };
			self.fRec33[0] = if (iTemp4 as i32 != 0) { 7584.0 } else { self.fRec33[1] };
			let mut fTemp85: F32 = self.fRec33[0] - fTemp27;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp12 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp87: F32 = self.fRec16[0] - self.fRec33[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (fTemp12 * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = self.fConst2 + fTemp86 + fTemp88;
			self.fRec34[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp89, self.fRec34[1] + 1.0) };
			let mut fTemp90: F32 = (self.fRec34[0] - fTemp86 - self.fConst2) / fTemp88;
			let mut iTemp91: i32 = ((self.fRec34[0] < fTemp86) as i32);
			let mut fTemp92: F32 = self.fRec34[0] / fTemp86;
			let mut fTemp93: F32 = if (((self.fRec34[0] < (self.fConst2 + fTemp86)) as i32) as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp91 as i32 != 0) { fTemp27 + fTemp85 * if (((self.fRec33[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec33[0] } } } else { self.fRec33[0] } } else { if (((self.fRec34[0] < fTemp89) as i32) as i32 != 0) { self.fRec33[0] + fTemp87 * if (((self.fRec16[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec16[0] } };
			let mut iTemp94: i32 = ((fTemp93) as i32);
			let mut fTemp95: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp94) as usize] };
			let mut fTemp96: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec35[1] + self.fConst14 };
			self.fRec35[0] = fTemp96 - F32::floor(fTemp96);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec35[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp95 + (fTemp93 - ((iTemp94) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp94, 1)) as usize] } - fTemp95));
			let mut fTemp97: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst16 };
			self.fRec36[0] = fTemp97 - F32::floor(fTemp97);
			let mut fTemp98: F32 = fSlow12 * (0.115 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec36[0] + 17.391304 * self.fRec32[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec27[0] + 2.0 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec26[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec23[0] + 2.0 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec21[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp40 + (fTemp38 - ((iTemp39) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp39, 1)) as usize] } - fTemp40))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp26 + (fTemp24 - ((iTemp25) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp25, 1)) as usize] } - fTemp26))) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow13 * fTemp98;
			let mut fTemp99: F32 = self.fRec2[1] + fSlow4 * fTemp98 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow13 * fTemp99;
			let mut fTemp100: F32 = self.fRec3[1] + fSlow4 * fTemp99 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow13 * fTemp100;
			let mut fTemp101: F32 = self.fRec4[1] + fSlow4 * fTemp100 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow13 * fTemp101;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp101;
			let mut fTemp102: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec5[0] = fTemp102;
			self.fRec0[0] = self.fConst22 * self.fVec5[1] - self.fConst21 * (self.fConst19 * self.fRec0[1] - self.fConst18 * fTemp102);
			*output0 = fSlow16 * self.fRec0[0];
			*output1 = fSlow17 * self.fRec0[0];
			*output2 = fSlow18 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec5[1] = self.fVec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_HihatOpen {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_HihatOpen as FaustDsp>::T]], outputs: &mut[&mut[<DSP_HihatOpen as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = F32::tan(0.0155508835 * fSlow1);
		let mut fSlow3: F32 = fSlow2 + 1.0;
		let mut fSlow4: F32 = fSlow2 / fSlow3;
		let mut fSlow5: F32 = 2.293 - 0.0227007 * fSlow1;
		let mut fSlow6: F32 = 0.16465649 * fSlow5 * (1.0 - fSlow4);
		let mut fSlow7: F32 = self.fEntry1;
		let mut fSlow8: F32 = self.fHslider1;
		let mut fSlow9: F32 = self.fHslider2;
		let mut fSlow10: F32 = 0.08 * fSlow9;
		let mut fSlow11: F32 = 0.11 * fSlow9;
		let mut fSlow12: F32 = 1.0 / (0.16465649 * (DSP_HihatOpen_faustpower4_f(fSlow2) * fSlow5 / DSP_HihatOpen_faustpower4_f(fSlow3)) + 1.0);
		let mut fSlow13: F32 = 2.0 * fSlow4;
		let mut fSlow14: F32 = 0.01 * self.fHslider3;
		let mut fSlow15: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.0));
		let mut fSlow16: F32 = fSlow15 * F32::min(1.0, 1.0 - fSlow14);
		let mut fSlow17: F32 = fSlow15 * F32::min(1.0, fSlow14 + 1.0);
		let mut fSlow18: F32 = 0.01 * self.fHslider5 * fSlow15;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			self.iRec1[0] = i32::wrapping_add(i32::wrapping_mul(i32::wrapping_add(self.iRec1[1], ((self.iRec1[1] > 0) as i32)), ((fSlow0 <= self.fVec0[1]) as i32)), ((fSlow0 > self.fVec0[1]) as i32));
			let mut fTemp0: F32 = ((self.iRec1[0]) as F32);
			self.fVec2[0] = fSlow7;
			let mut iTemp2: i32 = ((fSlow7 > self.fVec2[1]) as i32);
			self.iVec3[0] = iTemp2;
			let mut iTemp3: i32 = ((iTemp2 > self.iVec3[1]) as i32);
			let mut iTemp4: i32 = i32::wrapping_sub(1, iTemp3);
			self.fRec9[0] = if (iTemp2 as i32 != 0) { fSlow7 } else { self.fRec9[1] };
			let mut fTemp5: F32 = 106.0 * (1.0 - DSP_HihatOpen_faustpower2_f(1.0 - F32::max(fSlow8, self.fRec9[0]))) + -99.0;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec8[0] = if (iTemp4 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec8[1] };
			self.fRec10[0] = if (iTemp4 as i32 != 0) { fTemp7 + 3.52e+03 } else { self.fRec10[1] };
			let mut fTemp8: F32 = self.fRec10[0] - self.fRec8[0];
			self.fRec12[0] = if (iTemp4 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 63.5 - fSlow10) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec8[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp4 as i32 != 0) { fTemp7 } else { self.fRec13[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp11: F32 = self.fRec8[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp3 > 0) as i32);
			let mut fTemp16: F32 = self.fRec13[0] - self.fRec10[0];
			let mut fTemp17: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp16) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 56.5 - fSlow11) as i32)) as usize] } * if (((fTemp16 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp18: F32 = fTemp14 + fTemp17;
			self.fRec14[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp18, self.fRec14[1] + 1.0) };
			let mut iTemp19: i32 = ((self.fRec14[0] < fTemp14) as i32);
			let mut fTemp20: F32 = (self.fRec14[0] - fTemp14) / fTemp17;
			let mut iTemp21: i32 = ((self.fRec14[0] < fTemp13) as i32);
			let mut fTemp22: F32 = (self.fRec14[0] - fTemp13) / fTemp9;
			let mut fTemp23: F32 = self.fRec14[0] / fTemp13;
			let mut fTemp24: F32 = if (iTemp19 as i32 != 0) { if (iTemp21 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp21 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec8[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec8[0] } } } else { if (iTemp19 as i32 != 0) { self.fRec8[0] + fTemp8 * if (((self.fRec10[0] > self.fRec8[0]) as i32) as i32 != 0) { F32::powf(fTemp22, 0.33333334) } else { fTemp22 } } else { self.fRec10[0] } } } else { if (((self.fRec14[0] < fTemp18) as i32) as i32 != 0) { self.fRec10[0] + fTemp16 * if (((self.fRec13[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec13[0] } };
			let mut iTemp25: i32 = ((fTemp24) as i32);
			let mut fTemp26: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp25) as usize] };
			self.fRec16[0] = if (iTemp4 as i32 != 0) { 4064.0 } else { self.fRec16[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec16[0]);
			self.fRec17[0] = if (iTemp4 as i32 != 0) { 8128.0 } else { self.fRec17[1] };
			let mut fTemp28: F32 = self.fRec17[0] - fTemp27;
			let mut fTemp29: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0);
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp31: F32 = self.fRec16[0] - self.fRec17[0];
			let mut fTemp32: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0);
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 32.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp34: F32 = self.fConst2 + fTemp30 + fTemp33;
			self.fRec18[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec18[1] + 1.0) };
			let mut fTemp35: F32 = (self.fRec18[0] - fTemp30 - self.fConst2) / fTemp33;
			let mut iTemp36: i32 = ((self.fRec18[0] < fTemp30) as i32);
			let mut fTemp37: F32 = self.fRec18[0] / fTemp30;
			let mut fTemp38: F32 = if (((self.fRec18[0] < (self.fConst2 + fTemp30)) as i32) as i32 != 0) { if (iTemp36 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp36 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec17[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp37, 0.33333334) } else { fTemp37 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec18[0] < fTemp34) as i32) as i32 != 0) { self.fRec17[0] + fTemp31 * if (((self.fRec16[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec16[0] } };
			let mut iTemp39: i32 = ((fTemp38) as i32);
			let mut fTemp40: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp39) as usize] };
			self.fRec19[0] = if (iTemp4 as i32 != 0) { 7968.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = F32::max(5076.0, self.fRec19[0]);
			let mut fTemp42: F32 = self.fRec19[0] - fTemp41;
			let mut fTemp43: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp42) / (fTemp12 * if (((fTemp42 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp41)) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst3 + fTemp43, self.fRec20[1] + 1.0) };
			let mut iTemp44: i32 = ((self.fRec20[0] < fTemp43) as i32);
			let mut fTemp45: F32 = self.fRec20[0] / fTemp43;
			let mut fTemp46: F32 = if (((self.fRec20[0] < (self.fConst2 + fTemp43)) as i32) as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec20[0] < 0.0) as i32) as i32 != 0) { fTemp41 } else { if (iTemp44 as i32 != 0) { fTemp41 + fTemp42 * if (((self.fRec19[0] > fTemp41) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec19[0] } } } else { self.fRec19[0] } } else { self.fRec19[0] };
			let mut iTemp47: i32 = ((fTemp46) as i32);
			let mut fTemp48: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp47) as usize] };
			let mut iTemp49: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			let mut fTemp50: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst6 };
			self.fRec21[0] = fTemp50 - F32::floor(fTemp50);
			let mut fTemp51: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec23[1] + self.fConst8 };
			self.fRec23[0] = fTemp51 - F32::floor(fTemp51);
			self.fRec24[0] = if (iTemp4 as i32 != 0) { 6.88e+03 } else { self.fRec24[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec24[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp12 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = self.fRec24[0] - self.fRec17[0];
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 85.5) as i32)) as usize] } * if (((fTemp55 > 0.0) as i32) as i32 != 0) { fTemp32 } else { 0.96 }))));
			let mut fTemp57: F32 = self.fConst2 + fTemp54 + fTemp56;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp57, self.fRec25[1] + 1.0) };
			let mut fTemp58: F32 = (self.fRec25[0] - fTemp54 - self.fConst2) / fTemp56;
			let mut iTemp59: i32 = ((self.fRec25[0] < fTemp54) as i32);
			let mut fTemp60: F32 = self.fRec25[0] / fTemp54;
			let mut fTemp61: F32 = if (((self.fRec25[0] < (self.fConst2 + fTemp54)) as i32) as i32 != 0) { if (iTemp59 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp59 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp60, 0.33333334) } else { fTemp60 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { if (((self.fRec25[0] < fTemp57) as i32) as i32 != 0) { self.fRec17[0] + fTemp55 * if (((self.fRec24[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec24[0] } };
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst10 };
			self.fRec26[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec27[1] + self.fConst12 };
			self.fRec27[0] = fTemp65 - F32::floor(fTemp65);
			let mut fTemp66: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp5 + 88.0));
			let mut fTemp67: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp66) * (fTemp66 + 28.0);
			self.fRec28[0] = if (iTemp4 as i32 != 0) { fTemp67 + 4064.0 } else { self.fRec28[1] };
			self.fRec29[0] = if (iTemp4 as i32 != 0) { fTemp67 + 1224.0 } else { self.fRec29[1] };
			let mut fTemp68: F32 = self.fRec29[0] - self.fRec28[0];
			let mut fTemp69: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp68) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 66.5) as i32)) as usize] } * if (((fTemp68 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec28[0])) + 2.0) } else { 0.96 }))));
			self.fRec30[0] = if (iTemp4 as i32 != 0) { fTemp67 } else { self.fRec30[1] };
			let mut fTemp70: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp71: F32 = self.fRec28[0] - fTemp70;
			let mut fTemp72: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp71) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 92.5) as i32)) as usize] } * if (((fTemp71 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp70)) + 2.0) } else { 0.96 }))));
			let mut fTemp73: F32 = fTemp72 + fTemp69;
			let mut fTemp74: F32 = self.fRec30[0] - self.fRec29[0];
			let mut fTemp75: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp74) / (unsafe { ftbl1DSP_HihatOpenSIG1[(((self.fRec12[0] + 58.5) as i32)) as usize] } * if (((fTemp74 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec29[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp76: F32 = fTemp73 + fTemp75;
			self.fRec31[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp76, self.fRec31[1] + 1.0) };
			let mut iTemp77: i32 = ((self.fRec31[0] < fTemp73) as i32);
			let mut fTemp78: F32 = (self.fRec31[0] - fTemp73) / fTemp75;
			let mut iTemp79: i32 = ((self.fRec31[0] < fTemp72) as i32);
			let mut fTemp80: F32 = (self.fRec31[0] - fTemp72) / fTemp69;
			let mut fTemp81: F32 = self.fRec31[0] / fTemp72;
			let mut fTemp82: F32 = if (iTemp77 as i32 != 0) { if (iTemp79 as i32 != 0) { if (((self.fRec31[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp79 as i32 != 0) { fTemp70 + fTemp71 * if (((self.fRec28[0] > fTemp70) as i32) as i32 != 0) { F32::powf(fTemp81, 0.33333334) } else { fTemp81 } } else { self.fRec28[0] } } } else { if (iTemp77 as i32 != 0) { self.fRec28[0] + fTemp68 * if (((self.fRec29[0] > self.fRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { self.fRec29[0] } } } else { if (((self.fRec31[0] < fTemp76) as i32) as i32 != 0) { self.fRec29[0] + fTemp74 * if (((self.fRec30[0] > self.fRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp78, 0.33333334) } else { fTemp78 } } else { self.fRec30[0] } };
			let mut iTemp83: i32 = ((fTemp82) as i32);
			let mut fTemp84: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp83) as usize] };
			self.fRec33[0] = if (iTemp4 as i32 != 0) { 7584.0 } else { self.fRec33[1] };
			let mut fTemp85: F32 = self.fRec33[0] - fTemp27;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp12 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { fTemp29 } else { 0.96 }))));
			let mut fTemp87: F32 = self.fRec16[0] - self.fRec33[0];
			let mut fTemp88: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp87) / (fTemp12 * if (((fTemp87 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp89: F32 = self.fConst2 + fTemp86 + fTemp88;
			self.fRec34[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp89, self.fRec34[1] + 1.0) };
			let mut fTemp90: F32 = (self.fRec34[0] - fTemp86 - self.fConst2) / fTemp88;
			let mut iTemp91: i32 = ((self.fRec34[0] < fTemp86) as i32);
			let mut fTemp92: F32 = self.fRec34[0] / fTemp86;
			let mut fTemp93: F32 = if (((self.fRec34[0] < (self.fConst2 + fTemp86)) as i32) as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec34[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp91 as i32 != 0) { fTemp27 + fTemp85 * if (((self.fRec33[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec33[0] } } } else { self.fRec33[0] } } else { if (((self.fRec34[0] < fTemp89) as i32) as i32 != 0) { self.fRec33[0] + fTemp87 * if (((self.fRec16[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec16[0] } };
			let mut iTemp94: i32 = ((fTemp93) as i32);
			let mut fTemp95: F32 = unsafe { ftbl0DSP_HihatOpenSIG0[(iTemp94) as usize] };
			let mut fTemp96: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec35[1] + self.fConst14 };
			self.fRec35[0] = fTemp96 - F32::floor(fTemp96);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec35[0] + 24.347826 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp95 + (fTemp93 - ((iTemp94) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp94, 1)) as usize] } - fTemp95));
			let mut fTemp97: F32 = if (iTemp49 as i32 != 0) { 0.0 } else { self.fRec36[1] + self.fConst16 };
			self.fRec36[0] = fTemp97 - F32::floor(fTemp97);
			let mut fTemp98: F32 = fSlow12 * (0.115 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec36[0] + 17.391304 * self.fRec32[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp84 + (fTemp82 - ((iTemp83) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp83, 1)) as usize] } - fTemp84)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec27[0] + 2.0 * (unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec26[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) + unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * (self.fRec23[0] + 2.0 * unsafe { ftbl2DSP_HihatOpenSIG2[(((1024.0 * self.fRec21[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp48 + (fTemp46 - ((iTemp47) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp47, 1)) as usize] } - fTemp48)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp40 + (fTemp38 - ((iTemp39) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp39, 1)) as usize] } - fTemp40))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp26 + (fTemp24 - ((iTemp25) as F32)) * (unsafe { ftbl0DSP_HihatOpenSIG0[(i32::wrapping_add(iTemp25, 1)) as usize] } - fTemp26))) - fSlow6 * (self.fRec5[1] + fSlow4 * (self.fRec4[1] + fSlow4 * (self.fRec3[1] + fSlow4 * self.fRec2[1])))) - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow13 * fTemp98;
			let mut fTemp99: F32 = self.fRec2[1] + fSlow4 * fTemp98 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow13 * fTemp99;
			let mut fTemp100: F32 = self.fRec3[1] + fSlow4 * fTemp99 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow13 * fTemp100;
			let mut fTemp101: F32 = self.fRec4[1] + fSlow4 * fTemp100 - self.fRec5[1];
			self.fRec5[0] = self.fRec5[1] + fSlow13 * fTemp101;
			let mut fRec6: F32 = self.fRec5[1] + fSlow4 * fTemp101;
			let mut fTemp102: F32 = fRec6 * (fSlow0 * (F32::max(0.0, F32::min(fTemp0, self.fConst1 * (1.0 - fTemp0) + 1.0)) + -1.0) + 1.0);
			self.fVec5[0] = fTemp102;
			self.fRec0[0] = self.fConst22 * self.fVec5[1] - self.fConst21 * (self.fConst19 * self.fRec0[1] - self.fConst18 * fTemp102);
			*output0 = fSlow16 * self.fRec0[0];
			*output1 = fSlow17 * self.fRec0[0];
			*output2 = fSlow18 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iRec1[1] = self.iRec1[0];
			self.fVec2[1] = self.fVec2[0];
			self.iVec3[1] = self.iVec3[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fVec5[1] = self.fVec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
