// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Snare -pn processSnare -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_SnareSIG0 {
	iRec6: [i32;2],
}

impl DSP_SnareSIG0 {
	
	fn get_num_inputsDSP_SnareSIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec6[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_SnareSIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec6[0] = i32::wrapping_add(self.iRec6[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec6[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec6[1] = self.iRec6[0];
		}
	}

}


pub fn newDSP_SnareSIG0() -> DSP_SnareSIG0 { 
	DSP_SnareSIG0 {
		iRec6: [0;2],
	}
}

pub struct DSP_SnareSIG1 {
	iRec10: [i32;2],
}

impl DSP_SnareSIG1 {
	
	fn get_num_inputsDSP_SnareSIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec10[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_SnareSIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec10[0] = i32::wrapping_add(self.iRec10[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec10[0], -1)) as F32));
			self.iRec10[1] = self.iRec10[0];
		}
	}

}


pub fn newDSP_SnareSIG1() -> DSP_SnareSIG1 { 
	DSP_SnareSIG1 {
		iRec10: [0;2],
	}
}

pub struct DSP_SnareSIG2 {
	iVec3: [i32;2],
	iRec13: [i32;2],
}

impl DSP_SnareSIG2 {
	
	fn get_num_inputsDSP_SnareSIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG2(&mut self, sample_rate: i32) {
		for l10 in 0..2 {
			self.iVec3[(l10) as usize] = 0;
		}
		for l11 in 0..2 {
			self.iRec13[(l11) as usize] = 0;
		}
	}
	
	fn fillDSP_SnareSIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec13[0] = (i32::wrapping_add(self.iVec3[1], self.iRec13[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec13[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec13[1] = self.iRec13[0];
		}
	}

}


pub fn newDSP_SnareSIG2() -> DSP_SnareSIG2 { 
	DSP_SnareSIG2 {
		iVec3: [0;2],
		iRec13: [0;2],
	}
}

pub struct DSP_SnareSIG3 {
	iRec23: [i32;2],
}

impl DSP_SnareSIG3 {
	
	fn get_num_inputsDSP_SnareSIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG3(&mut self, sample_rate: i32) {
		for l20 in 0..2 {
			self.iRec23[(l20) as usize] = 0;
		}
	}
	
	fn fillDSP_SnareSIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec23[0] = i32::wrapping_add(self.iRec23[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec23[0], -1)) as F32) + -128.0));
			self.iRec23[1] = self.iRec23[0];
		}
	}

}


pub fn newDSP_SnareSIG3() -> DSP_SnareSIG3 { 
	DSP_SnareSIG3 {
		iRec23: [0;2],
	}
}
static mut iDSP_SnareSIG4Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_SnareSIG4 {
	iDSP_SnareSIG4Wave0_idx: i32,
}

impl DSP_SnareSIG4 {
	
	fn get_num_inputsDSP_SnareSIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_SnareSIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_SnareSIG4(&mut self, sample_rate: i32) {
		self.iDSP_SnareSIG4Wave0_idx = 0;
	}
	
	fn fillDSP_SnareSIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_SnareSIG4Wave0[(self.iDSP_SnareSIG4Wave0_idx) as usize] };
			self.iDSP_SnareSIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_SnareSIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_SnareSIG4() -> DSP_SnareSIG4 { 
	DSP_SnareSIG4 {
		iDSP_SnareSIG4Wave0_idx: 0,
	}
}
static mut ftbl0DSP_SnareSIG0: [F32;16384] = [0.0;16384];
fn DSP_Snare_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_SnareSIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_SnareSIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_SnareSIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_SnareSIG4: [i32;100] = [0;100];
fn DSP_Snare_faustpower4_f(value: F32) -> F32 {
	return value * value * value * value;
}

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Snare {
	iVec0: [i32;2],
	fHslider0: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider1: F32,
	fRec8: [F32;2],
	fRec7: [F32;2],
	fRec9: [F32;2],
	fHslider2: F32,
	fHslider3: F32,
	fRec11: [F32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst1: F32,
	fRec12: [F32;2],
	fRec14: [F32;2],
	fRec15: [F32;2],
	fRec16: [F32;2],
	fRec17: [F32;2],
	fRec18: [F32;2],
	fRec19: [F32;2],
	fRec20: [F32;2],
	fRec21: [F32;2],
	fConst4: F32,
	fRec22: [F32;2],
	fConst6: F32,
	fRec24: [F32;2],
	iConst7: i32,
	iRec26: [i32;2],
	fConst8: F32,
	fRec25: [F32;2],
	fHslider4: F32,
	fRec27: [F32;2],
	fRec28: [F32;2],
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fRec32: [F32;2],
	fConst10: F32,
	fRec33: [F32;2],
	fRec35: [F32;2],
	fRec36: [F32;2],
	fRec37: [F32;2],
	fRec38: [F32;2],
	fConst12: F32,
	fRec39: [F32;2],
	fRec34: [F32;2],
	fConst14: F32,
	fRec40: [F32;2],
	fRec1: [F32;2],
	fRec2: [F32;2],
	fRec3: [F32;2],
	fRec4: [F32;2],
	fRec5: [F32;2],
	fConst16: F32,
	fConst17: F32,
	fConst19: F32,
	fConst20: F32,
	fRec0: [F32;2],
	fHslider5: F32,
	fHslider6: F32,
	fHslider7: F32,
}

impl FaustDsp for DSP_Snare {
	type T = F32;
		
	fn new() -> DSP_Snare { 
		DSP_Snare {
			iVec0: [0;2],
			fHslider0: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider1: 0.0,
			fRec8: [0.0;2],
			fRec7: [0.0;2],
			fRec9: [0.0;2],
			fHslider2: 0.0,
			fHslider3: 0.0,
			fRec11: [0.0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst1: 0.0,
			fRec12: [0.0;2],
			fRec14: [0.0;2],
			fRec15: [0.0;2],
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fRec20: [0.0;2],
			fRec21: [0.0;2],
			fConst4: 0.0,
			fRec22: [0.0;2],
			fConst6: 0.0,
			fRec24: [0.0;2],
			iConst7: 0,
			iRec26: [0;2],
			fConst8: 0.0,
			fRec25: [0.0;2],
			fHslider4: 0.0,
			fRec27: [0.0;2],
			fRec28: [0.0;2],
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fRec32: [0.0;2],
			fConst10: 0.0,
			fRec33: [0.0;2],
			fRec35: [0.0;2],
			fRec36: [0.0;2],
			fRec37: [0.0;2],
			fRec38: [0.0;2],
			fConst12: 0.0,
			fRec39: [0.0;2],
			fRec34: [0.0;2],
			fConst14: 0.0,
			fRec40: [0.0;2],
			fRec1: [0.0;2],
			fRec2: [0.0;2],
			fRec3: [0.0;2],
			fRec4: [0.0;2],
			fRec5: [0.0;2],
			fConst16: 0.0,
			fConst17: 0.0,
			fConst19: 0.0,
			fConst20: 0.0,
			fRec0: [0.0;2],
			fHslider5: 0.0,
			fHslider6: 0.0,
			fHslider7: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Snare -pn processSnare -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
		m.declare("vaeffects.lib/moogLadder:author", "Dario Sanfilippo");
		m.declare("vaeffects.lib/moogLadder:license", "MIT-style STK-4.3 license");
		m.declare("vaeffects.lib/name", "Faust Virtual Analog Filter Effect Library");
		m.declare("vaeffects.lib/version", "1.2.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_SnareSIG0 = newDSP_SnareSIG0();
		sig0.instance_initDSP_SnareSIG0(sample_rate);
		sig0.fillDSP_SnareSIG0(16384, unsafe { &mut ftbl0DSP_SnareSIG0 });
		let mut sig1: DSP_SnareSIG1 = newDSP_SnareSIG1();
		sig1.instance_initDSP_SnareSIG1(sample_rate);
		sig1.fillDSP_SnareSIG1(144, unsafe { &mut ftbl1DSP_SnareSIG1 });
		let mut sig2: DSP_SnareSIG2 = newDSP_SnareSIG2();
		sig2.instance_initDSP_SnareSIG2(sample_rate);
		sig2.fillDSP_SnareSIG2(1024, unsafe { &mut ftbl2DSP_SnareSIG2 });
		let mut sig3: DSP_SnareSIG3 = newDSP_SnareSIG3();
		sig3.instance_initDSP_SnareSIG3(sample_rate);
		sig3.fillDSP_SnareSIG3(4096, unsafe { &mut ftbl3DSP_SnareSIG3 });
		let mut sig4: DSP_SnareSIG4 = newDSP_SnareSIG4();
		sig4.instance_initDSP_SnareSIG4(sample_rate);
		sig4.fillDSP_SnareSIG4(100, unsafe { &mut itbl4DSP_SnareSIG4 });
	}
	fn instance_reset_params(&mut self) {
		self.fHslider0 = 9e+01;
		self.fEntry0 = 0.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 36.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 75.0;
		self.fHslider5 = 0.0;
		self.fHslider6 = 0.0;
		self.fHslider7 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec8[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec7[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec9[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec11[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec12[(l9) as usize] = 0.0;
		}
		for l12 in 0..2 {
			self.fRec14[(l12) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec15[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec16[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec17[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec18[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec19[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec20[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec21[(l19) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec22[(l21) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec24[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.iRec26[(l23) as usize] = 0;
		}
		for l24 in 0..2 {
			self.fRec25[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec27[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec28[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec29[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec30[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec31[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec32[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec33[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec35[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec36[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec37[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec38[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec39[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec34[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec40[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec1[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec2[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec3[(l41) as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec4[(l42) as usize] = 0.0;
		}
		for l43 in 0..2 {
			self.fRec5[(l43) as usize] = 0.0;
		}
		for l44 in 0..2 {
			self.fRec0[(l44) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		self.fConst1 = F32::max(1.0, 0.001 * self.fConst0);
		let mut fConst2: F32 = unsafe { ftbl3DSP_SnareSIG3[2226] };
		let mut fConst3: F32 = 1e+02 / self.fConst0;
		self.fConst4 = fConst3 * (fConst2 + 0.03816094 * (unsafe { ftbl3DSP_SnareSIG3[2227] } - fConst2));
		let mut fConst5: F32 = unsafe { ftbl3DSP_SnareSIG3[2385] };
		self.fConst6 = 1e+01 / self.fConst0 * (fConst5 + 0.4472332 * (unsafe { ftbl3DSP_SnareSIG3[2386] } - fConst5));
		self.iConst7 = unsafe { itbl4DSP_SnareSIG4[50] };
		self.fConst8 = 264.0 / self.fConst0;
		let mut fConst9: F32 = unsafe { ftbl3DSP_SnareSIG3[2672] };
		self.fConst10 = 1.0 / self.fConst0 * (fConst9 + 0.38356328 * (unsafe { ftbl3DSP_SnareSIG3[2673] } - fConst9));
		let mut fConst11: F32 = unsafe { ftbl3DSP_SnareSIG3[2512] };
		self.fConst12 = 1e+03 / self.fConst0 * (fConst11 + 0.974491 * (unsafe { ftbl3DSP_SnareSIG3[2513] } - fConst11));
		let mut fConst13: F32 = unsafe { ftbl3DSP_SnareSIG3[2308] };
		self.fConst14 = fConst3 * (fConst13 + 0.9308785 * (unsafe { ftbl3DSP_SnareSIG3[2309] } - fConst13));
		let mut fConst15: F32 = F32::tan(62.831852 / self.fConst0);
		self.fConst16 = 1.0 / fConst15;
		self.fConst17 = 1.0 - self.fConst16;
		let mut fConst18: F32 = self.fConst16 + 1.0;
		self.fConst19 = 1.0 / fConst18;
		self.fConst20 = 0.0 - 1.0 / (fConst15 * fConst18);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Snare::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "6", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Snappy");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Snappy", ParamIndex(4), 75.0, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(5)), "7", "");
		ui_interface.declare(Some(ParamIndex(5)), "export", "Tone");
		ui_interface.declare(Some(ParamIndex(5)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Tone", ParamIndex(5), 9e+01, 0.0, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(6)), "8", "");
		ui_interface.declare(Some(ParamIndex(6)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(6)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(6), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(7), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(8), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			5 => Some(self.fHslider0),
			7 => Some(self.fHslider1),
			8 => Some(self.fHslider2),
			3 => Some(self.fHslider3),
			4 => Some(self.fHslider4),
			2 => Some(self.fHslider5),
			1 => Some(self.fHslider6),
			6 => Some(self.fHslider7),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			5 => { self.fHslider0 = value }
			7 => { self.fHslider1 = value }
			8 => { self.fHslider2 = value }
			3 => { self.fHslider3 = value }
			4 => { self.fHslider4 = value }
			2 => { self.fHslider5 = value }
			1 => { self.fHslider6 = value }
			6 => { self.fHslider7 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = self.fHslider3 + self.fHslider2;
		let mut fSlow9: F32 = 0.42857143 * (0.33333334 * (fSlow8 + -3.0) + 1.0);
		let mut fSlow10: F32 = F32::powf(2.0, 0.083333336 * (fSlow8 + -72.0));
		let mut fSlow11: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow10, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow12: i32 = ((fSlow11) as i32);
		let mut fSlow13: F32 = unsafe { ftbl3DSP_SnareSIG3[(iSlow12) as usize] };
		let mut fSlow14: F32 = fSlow13 + (fSlow11 - ((iSlow12) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iSlow12, 1)) as usize] } - fSlow13);
		let mut fSlow15: F32 = self.fConst8 * fSlow10;
		let mut fSlow16: F32 = 29.0 * F32::sqrt(0.01 * self.fHslider4) + 7e+01;
		let mut fSlow17: F32 = F32::min(99.0, fSlow16);
		let mut fSlow18: F32 = ((((fSlow16 > 0.0) as i32)) as F32);
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Snare_faustpower4_f(fSlow1) * fSlow4 / DSP_Snare_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider5;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider6 + 9.5));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider7 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Snare_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0])));
			let mut fTemp5: F32 = fTemp4 + -99.0;
			let mut fTemp6: F32 = 0.5714286 * fTemp5;
			let mut fTemp7: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 95.0));
			let mut fTemp8: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp7) * (fTemp7 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp8 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp8 } else { self.fRec9[1] };
			let mut fTemp9: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec11[1] };
			let mut fTemp10: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp9) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 52.5) as i32)) as usize] } * if (((fTemp9 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp11: F32 = F32::max(5076.0, self.fRec9[0]);
			let mut fTemp12: F32 = self.fRec7[0] - fTemp11;
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp12) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 90.5) as i32)) as usize] } * if (((fTemp12 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp11)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp10;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec12[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp14, self.fRec12[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec12[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec12[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec12[0] - fTemp13) / fTemp10;
			let mut fTemp19: F32 = self.fRec12[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec12[0] < 0.0) as i32) as i32 != 0) { fTemp11 } else { if (iTemp17 as i32 != 0) { fTemp11 + fTemp12 * if (((self.fRec7[0] > fTemp11) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec7[0] + fTemp9 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec9[0] } } } else { self.fRec9[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp5 + 99.0));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec15[1] };
			let mut fTemp25: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec16[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 78.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp28: F32 = self.fRec14[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			self.fRec17[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp31, self.fRec17[1] + 1.0) };
			let mut iTemp32: i32 = ((self.fRec17[0] < fTemp31) as i32);
			let mut iTemp33: i32 = ((self.fRec17[0] < fTemp30) as i32);
			let mut fTemp34: F32 = (self.fRec17[0] - fTemp30) / fTemp26;
			let mut fTemp35: F32 = self.fRec17[0] / fTemp30;
			let mut fTemp36: F32 = if (iTemp32 as i32 != 0) { if (iTemp33 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp33 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec14[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec14[0] } } } else { if (iTemp32 as i32 != 0) { self.fRec14[0] + fTemp25 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec15[0] } } } else { self.fRec15[0] };
			let mut iTemp37: i32 = ((fTemp36) as i32);
			let mut fTemp38: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp37) as usize] };
			let mut fTemp39: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 63.0));
			let mut fTemp40: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp39) * (fTemp39 + 28.0);
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp40 + 4064.0 } else { self.fRec18[1] };
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp40 + 3776.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = self.fRec19[0] - self.fRec18[0];
			let mut fTemp42: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp41) / (fTemp29 * if (((fTemp41 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp40 } else { self.fRec20[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp44: F32 = self.fRec18[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			let mut fTemp46: F32 = fTemp45 + fTemp42;
			let mut fTemp47: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp48: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp47) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 35.5) as i32)) as usize] } * if (((fTemp47 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp49: F32 = fTemp46 + fTemp48;
			self.fRec21[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp49, self.fRec21[1] + 1.0) };
			let mut iTemp50: i32 = ((self.fRec21[0] < fTemp46) as i32);
			let mut fTemp51: F32 = (self.fRec21[0] - fTemp46) / fTemp48;
			let mut iTemp52: i32 = ((self.fRec21[0] < fTemp45) as i32);
			let mut fTemp53: F32 = (self.fRec21[0] - fTemp45) / fTemp42;
			let mut fTemp54: F32 = self.fRec21[0] / fTemp45;
			let mut fTemp55: F32 = if (iTemp50 as i32 != 0) { if (iTemp52 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp52 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec18[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp54, 0.33333334) } else { fTemp54 } } else { self.fRec18[0] } } } else { if (iTemp50 as i32 != 0) { self.fRec18[0] + fTemp41 * if (((self.fRec19[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp53, 0.33333334) } else { fTemp53 } } else { self.fRec19[0] } } } else { if (((self.fRec21[0] < fTemp49) as i32) as i32 != 0) { self.fRec19[0] + fTemp47 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp51, 0.33333334) } else { fTemp51 } } else { self.fRec20[0] } };
			let mut iTemp56: i32 = ((fTemp55) as i32);
			let mut fTemp57: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp56) as usize] };
			let mut iTemp58: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp59: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst4 };
			self.fRec22[0] = fTemp59 - F32::floor(fTemp59);
			let mut fTemp60: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst6 };
			self.fRec24[0] = fTemp60 - F32::floor(fTemp60);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec26[1] };
			let mut fTemp61: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl3DSP_SnareSIG3[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow15 * fSlow14 * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) };
			self.fRec25[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = F32::max(0.0, F32::min(127.0, fSlow17 + 0.85714287 * fTemp5));
			let mut fTemp66: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp65) * (fTemp65 + 28.0);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp66 + 4064.0 } else { self.fRec27[1] };
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fTemp66 } else { self.fRec28[1] };
			let mut fTemp67: F32 = self.fRec28[0] - self.fRec27[0];
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 61.5) as i32)) as usize] } * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp70: F32 = self.fRec27[0] - fTemp69;
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 89.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp69)) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp71 + fTemp68;
			self.fRec29[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp72, self.fRec29[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec29[0] < fTemp72) as i32);
			let mut iTemp74: i32 = ((self.fRec29[0] < fTemp71) as i32);
			let mut fTemp75: F32 = (self.fRec29[0] - fTemp71) / fTemp68;
			let mut fTemp76: F32 = self.fRec29[0] / fTemp71;
			let mut fTemp77: F32 = if (iTemp73 as i32 != 0) { if (iTemp74 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp69 } else { if (iTemp74 as i32 != 0) { fTemp69 + fTemp70 * if (((self.fRec27[0] > fTemp69) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec27[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec27[0] + fTemp67 * if (((self.fRec28[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp75, 0.33333334) } else { fTemp75 } } else { self.fRec28[0] } } } else { self.fRec28[0] };
			let mut iTemp78: i32 = ((fTemp77) as i32);
			let mut fTemp79: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp78) as usize] };
			let mut fTemp80: F32 = F32::max(0.0, F32::min(127.0, fTemp4 + -9.0));
			let mut fTemp81: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp80) * (fTemp80 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp81 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp81 + 3168.0 } else { self.fRec31[1] };
			let mut fTemp82: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (fTemp29 * if (((fTemp82 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp85: F32 = self.fRec30[0] - fTemp84;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp29 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp84)) + 2.0) } else { 0.96 }))));
			let mut fTemp87: F32 = fTemp86 + fTemp83;
			let mut fTemp88: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 50.5) as i32)) as usize] } * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp90: F32 = fTemp87 + fTemp89;
			self.fRec32[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp90, self.fRec32[1] + 1.0) };
			let mut iTemp91: i32 = ((self.fRec32[0] < fTemp87) as i32);
			let mut fTemp92: F32 = (self.fRec32[0] - fTemp87) / fTemp89;
			let mut iTemp93: i32 = ((self.fRec32[0] < fTemp86) as i32);
			let mut fTemp94: F32 = (self.fRec32[0] - fTemp86) / fTemp83;
			let mut fTemp95: F32 = self.fRec32[0] / fTemp86;
			let mut fTemp96: F32 = if (iTemp91 as i32 != 0) { if (iTemp93 as i32 != 0) { if (((self.fRec32[0] < 0.0) as i32) as i32 != 0) { fTemp84 } else { if (iTemp93 as i32 != 0) { fTemp84 + fTemp85 * if (((self.fRec30[0] > fTemp84) as i32) as i32 != 0) { F32::powf(fTemp95, 0.33333334) } else { fTemp95 } } else { self.fRec30[0] } } } else { if (iTemp91 as i32 != 0) { self.fRec30[0] + fTemp82 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp94, 0.33333334) } else { fTemp94 } } else { self.fRec31[0] } } } else { if (((self.fRec32[0] < fTemp90) as i32) as i32 != 0) { self.fRec31[0] + fTemp88 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec30[0] } };
			let mut iTemp97: i32 = ((fTemp96) as i32);
			let mut fTemp98: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp97) as usize] };
			let mut fTemp99: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec33[1] + self.fConst10 };
			self.fRec33[0] = fTemp99 - F32::floor(fTemp99);
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec35[1] };
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 6784.0 } else { self.fRec36[1] };
			let mut fTemp100: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 7.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec37[1] };
			let mut fTemp102: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp103: F32 = self.fRec35[0] - fTemp102;
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp102)) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp104 + fTemp101;
			let mut fTemp106: F32 = self.fRec37[0] - self.fRec36[0];
			let mut fTemp107: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp106) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 0.5) as i32)) as usize] } * if (((fTemp106 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec36[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp108: F32 = fTemp105 + fTemp107;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp108, self.fRec38[1] + 1.0) };
			let mut iTemp109: i32 = ((self.fRec38[0] < fTemp105) as i32);
			let mut fTemp110: F32 = (self.fRec38[0] - fTemp105) / fTemp107;
			let mut iTemp111: i32 = ((self.fRec38[0] < fTemp104) as i32);
			let mut fTemp112: F32 = (self.fRec38[0] - fTemp104) / fTemp101;
			let mut fTemp113: F32 = self.fRec38[0] / fTemp104;
			let mut fTemp114: F32 = if (iTemp109 as i32 != 0) { if (iTemp111 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp102 } else { if (iTemp111 as i32 != 0) { fTemp102 + fTemp103 * if (((self.fRec35[0] > fTemp102) as i32) as i32 != 0) { F32::powf(fTemp113, 0.33333334) } else { fTemp113 } } else { self.fRec35[0] } } } else { if (iTemp109 as i32 != 0) { self.fRec35[0] + fTemp100 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec36[0] } } } else { if (((self.fRec38[0] < fTemp108) as i32) as i32 != 0) { self.fRec36[0] + fTemp106 * if (((self.fRec37[0] > self.fRec36[0]) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec37[0] } };
			let mut iTemp115: i32 = ((fTemp114) as i32);
			let mut fTemp116: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp115) as usize] };
			let mut fTemp117: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst12 };
			self.fRec39[0] = fTemp117 - F32::floor(fTemp117);
			self.fRec34[0] = 0.161 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec39[0] + 17.391304 * self.fRec34[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp116 + (fTemp114 - ((iTemp115) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp115, 1)) as usize] } - fTemp116));
			let mut fTemp118: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec40[1] + self.fConst14 };
			self.fRec40[0] = fTemp118 - F32::floor(fTemp118);
			let mut fTemp119: F32 = fSlow19 * (0.115 * (fSlow18 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec40[0] + 17.391304 * (self.fRec34[0] + 0.115 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec33[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp98 + (fTemp96 - ((iTemp97) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp97, 1)) as usize] } - fTemp98))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp79 + (fTemp77 - ((iTemp78) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp78, 1)) as usize] } - fTemp79)) + unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec22[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp57 + (fTemp55 - ((iTemp56) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp56, 1)) as usize] } - fTemp57)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp38 + (fTemp36 - ((iTemp37) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp37, 1)) as usize] } - fTemp38)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22))) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp119;
			let mut fTemp120: F32 = self.fRec1[1] + fSlow3 * fTemp119 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp120;
			let mut fTemp121: F32 = self.fRec2[1] + fSlow3 * fTemp120 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp121;
			let mut fTemp122: F32 = self.fRec3[1] + fSlow3 * fTemp121 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp122;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp122;
			self.fRec0[0] = self.fConst20 * self.fRec5[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec24[1] = self.fRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Snare {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Snare as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Snare as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = self.fHslider3 + self.fHslider2;
		let mut fSlow9: F32 = 0.42857143 * (0.33333334 * (fSlow8 + -3.0) + 1.0);
		let mut fSlow10: F32 = F32::powf(2.0, 0.083333336 * (fSlow8 + -72.0));
		let mut fSlow11: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow10, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow12: i32 = ((fSlow11) as i32);
		let mut fSlow13: F32 = unsafe { ftbl3DSP_SnareSIG3[(iSlow12) as usize] };
		let mut fSlow14: F32 = fSlow13 + (fSlow11 - ((iSlow12) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iSlow12, 1)) as usize] } - fSlow13);
		let mut fSlow15: F32 = self.fConst8 * fSlow10;
		let mut fSlow16: F32 = 29.0 * F32::sqrt(0.01 * self.fHslider4) + 7e+01;
		let mut fSlow17: F32 = F32::min(99.0, fSlow16);
		let mut fSlow18: F32 = ((((fSlow16 > 0.0) as i32)) as F32);
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Snare_faustpower4_f(fSlow1) * fSlow4 / DSP_Snare_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider5;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider6 + 9.5));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider7 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Snare_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0])));
			let mut fTemp5: F32 = fTemp4 + -99.0;
			let mut fTemp6: F32 = 0.5714286 * fTemp5;
			let mut fTemp7: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 95.0));
			let mut fTemp8: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp7) * (fTemp7 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp8 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp8 } else { self.fRec9[1] };
			let mut fTemp9: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec11[1] };
			let mut fTemp10: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp9) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 52.5) as i32)) as usize] } * if (((fTemp9 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp11: F32 = F32::max(5076.0, self.fRec9[0]);
			let mut fTemp12: F32 = self.fRec7[0] - fTemp11;
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp12) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 90.5) as i32)) as usize] } * if (((fTemp12 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp11)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp10;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec12[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp14, self.fRec12[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec12[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec12[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec12[0] - fTemp13) / fTemp10;
			let mut fTemp19: F32 = self.fRec12[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec12[0] < 0.0) as i32) as i32 != 0) { fTemp11 } else { if (iTemp17 as i32 != 0) { fTemp11 + fTemp12 * if (((self.fRec7[0] > fTemp11) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec7[0] + fTemp9 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec9[0] } } } else { self.fRec9[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp5 + 99.0));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec15[1] };
			let mut fTemp25: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec16[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 78.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp28: F32 = self.fRec14[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			self.fRec17[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp31, self.fRec17[1] + 1.0) };
			let mut iTemp32: i32 = ((self.fRec17[0] < fTemp31) as i32);
			let mut iTemp33: i32 = ((self.fRec17[0] < fTemp30) as i32);
			let mut fTemp34: F32 = (self.fRec17[0] - fTemp30) / fTemp26;
			let mut fTemp35: F32 = self.fRec17[0] / fTemp30;
			let mut fTemp36: F32 = if (iTemp32 as i32 != 0) { if (iTemp33 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp33 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec14[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec14[0] } } } else { if (iTemp32 as i32 != 0) { self.fRec14[0] + fTemp25 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec15[0] } } } else { self.fRec15[0] };
			let mut iTemp37: i32 = ((fTemp36) as i32);
			let mut fTemp38: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp37) as usize] };
			let mut fTemp39: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 63.0));
			let mut fTemp40: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp39) * (fTemp39 + 28.0);
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp40 + 4064.0 } else { self.fRec18[1] };
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp40 + 3776.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = self.fRec19[0] - self.fRec18[0];
			let mut fTemp42: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp41) / (fTemp29 * if (((fTemp41 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp40 } else { self.fRec20[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp44: F32 = self.fRec18[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			let mut fTemp46: F32 = fTemp45 + fTemp42;
			let mut fTemp47: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp48: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp47) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 35.5) as i32)) as usize] } * if (((fTemp47 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp49: F32 = fTemp46 + fTemp48;
			self.fRec21[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp49, self.fRec21[1] + 1.0) };
			let mut iTemp50: i32 = ((self.fRec21[0] < fTemp46) as i32);
			let mut fTemp51: F32 = (self.fRec21[0] - fTemp46) / fTemp48;
			let mut iTemp52: i32 = ((self.fRec21[0] < fTemp45) as i32);
			let mut fTemp53: F32 = (self.fRec21[0] - fTemp45) / fTemp42;
			let mut fTemp54: F32 = self.fRec21[0] / fTemp45;
			let mut fTemp55: F32 = if (iTemp50 as i32 != 0) { if (iTemp52 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp52 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec18[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp54, 0.33333334) } else { fTemp54 } } else { self.fRec18[0] } } } else { if (iTemp50 as i32 != 0) { self.fRec18[0] + fTemp41 * if (((self.fRec19[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp53, 0.33333334) } else { fTemp53 } } else { self.fRec19[0] } } } else { if (((self.fRec21[0] < fTemp49) as i32) as i32 != 0) { self.fRec19[0] + fTemp47 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp51, 0.33333334) } else { fTemp51 } } else { self.fRec20[0] } };
			let mut iTemp56: i32 = ((fTemp55) as i32);
			let mut fTemp57: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp56) as usize] };
			let mut iTemp58: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp59: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst4 };
			self.fRec22[0] = fTemp59 - F32::floor(fTemp59);
			let mut fTemp60: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst6 };
			self.fRec24[0] = fTemp60 - F32::floor(fTemp60);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec26[1] };
			let mut fTemp61: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl3DSP_SnareSIG3[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow15 * fSlow14 * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) };
			self.fRec25[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = F32::max(0.0, F32::min(127.0, fSlow17 + 0.85714287 * fTemp5));
			let mut fTemp66: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp65) * (fTemp65 + 28.0);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp66 + 4064.0 } else { self.fRec27[1] };
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fTemp66 } else { self.fRec28[1] };
			let mut fTemp67: F32 = self.fRec28[0] - self.fRec27[0];
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 61.5) as i32)) as usize] } * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp70: F32 = self.fRec27[0] - fTemp69;
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 89.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp69)) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp71 + fTemp68;
			self.fRec29[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp72, self.fRec29[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec29[0] < fTemp72) as i32);
			let mut iTemp74: i32 = ((self.fRec29[0] < fTemp71) as i32);
			let mut fTemp75: F32 = (self.fRec29[0] - fTemp71) / fTemp68;
			let mut fTemp76: F32 = self.fRec29[0] / fTemp71;
			let mut fTemp77: F32 = if (iTemp73 as i32 != 0) { if (iTemp74 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp69 } else { if (iTemp74 as i32 != 0) { fTemp69 + fTemp70 * if (((self.fRec27[0] > fTemp69) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec27[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec27[0] + fTemp67 * if (((self.fRec28[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp75, 0.33333334) } else { fTemp75 } } else { self.fRec28[0] } } } else { self.fRec28[0] };
			let mut iTemp78: i32 = ((fTemp77) as i32);
			let mut fTemp79: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp78) as usize] };
			let mut fTemp80: F32 = F32::max(0.0, F32::min(127.0, fTemp4 + -9.0));
			let mut fTemp81: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp80) * (fTemp80 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp81 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp81 + 3168.0 } else { self.fRec31[1] };
			let mut fTemp82: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (fTemp29 * if (((fTemp82 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp85: F32 = self.fRec30[0] - fTemp84;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp29 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp84)) + 2.0) } else { 0.96 }))));
			let mut fTemp87: F32 = fTemp86 + fTemp83;
			let mut fTemp88: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 50.5) as i32)) as usize] } * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp90: F32 = fTemp87 + fTemp89;
			self.fRec32[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp90, self.fRec32[1] + 1.0) };
			let mut iTemp91: i32 = ((self.fRec32[0] < fTemp87) as i32);
			let mut fTemp92: F32 = (self.fRec32[0] - fTemp87) / fTemp89;
			let mut iTemp93: i32 = ((self.fRec32[0] < fTemp86) as i32);
			let mut fTemp94: F32 = (self.fRec32[0] - fTemp86) / fTemp83;
			let mut fTemp95: F32 = self.fRec32[0] / fTemp86;
			let mut fTemp96: F32 = if (iTemp91 as i32 != 0) { if (iTemp93 as i32 != 0) { if (((self.fRec32[0] < 0.0) as i32) as i32 != 0) { fTemp84 } else { if (iTemp93 as i32 != 0) { fTemp84 + fTemp85 * if (((self.fRec30[0] > fTemp84) as i32) as i32 != 0) { F32::powf(fTemp95, 0.33333334) } else { fTemp95 } } else { self.fRec30[0] } } } else { if (iTemp91 as i32 != 0) { self.fRec30[0] + fTemp82 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp94, 0.33333334) } else { fTemp94 } } else { self.fRec31[0] } } } else { if (((self.fRec32[0] < fTemp90) as i32) as i32 != 0) { self.fRec31[0] + fTemp88 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec30[0] } };
			let mut iTemp97: i32 = ((fTemp96) as i32);
			let mut fTemp98: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp97) as usize] };
			let mut fTemp99: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec33[1] + self.fConst10 };
			self.fRec33[0] = fTemp99 - F32::floor(fTemp99);
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec35[1] };
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 6784.0 } else { self.fRec36[1] };
			let mut fTemp100: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 7.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec37[1] };
			let mut fTemp102: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp103: F32 = self.fRec35[0] - fTemp102;
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp102)) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp104 + fTemp101;
			let mut fTemp106: F32 = self.fRec37[0] - self.fRec36[0];
			let mut fTemp107: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp106) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 0.5) as i32)) as usize] } * if (((fTemp106 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec36[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp108: F32 = fTemp105 + fTemp107;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp108, self.fRec38[1] + 1.0) };
			let mut iTemp109: i32 = ((self.fRec38[0] < fTemp105) as i32);
			let mut fTemp110: F32 = (self.fRec38[0] - fTemp105) / fTemp107;
			let mut iTemp111: i32 = ((self.fRec38[0] < fTemp104) as i32);
			let mut fTemp112: F32 = (self.fRec38[0] - fTemp104) / fTemp101;
			let mut fTemp113: F32 = self.fRec38[0] / fTemp104;
			let mut fTemp114: F32 = if (iTemp109 as i32 != 0) { if (iTemp111 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp102 } else { if (iTemp111 as i32 != 0) { fTemp102 + fTemp103 * if (((self.fRec35[0] > fTemp102) as i32) as i32 != 0) { F32::powf(fTemp113, 0.33333334) } else { fTemp113 } } else { self.fRec35[0] } } } else { if (iTemp109 as i32 != 0) { self.fRec35[0] + fTemp100 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec36[0] } } } else { if (((self.fRec38[0] < fTemp108) as i32) as i32 != 0) { self.fRec36[0] + fTemp106 * if (((self.fRec37[0] > self.fRec36[0]) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec37[0] } };
			let mut iTemp115: i32 = ((fTemp114) as i32);
			let mut fTemp116: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp115) as usize] };
			let mut fTemp117: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst12 };
			self.fRec39[0] = fTemp117 - F32::floor(fTemp117);
			self.fRec34[0] = 0.161 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec39[0] + 17.391304 * self.fRec34[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp116 + (fTemp114 - ((iTemp115) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp115, 1)) as usize] } - fTemp116));
			let mut fTemp118: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec40[1] + self.fConst14 };
			self.fRec40[0] = fTemp118 - F32::floor(fTemp118);
			let mut fTemp119: F32 = fSlow19 * (0.115 * (fSlow18 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec40[0] + 17.391304 * (self.fRec34[0] + 0.115 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec33[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp98 + (fTemp96 - ((iTemp97) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp97, 1)) as usize] } - fTemp98))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp79 + (fTemp77 - ((iTemp78) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp78, 1)) as usize] } - fTemp79)) + unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec22[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp57 + (fTemp55 - ((iTemp56) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp56, 1)) as usize] } - fTemp57)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp38 + (fTemp36 - ((iTemp37) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp37, 1)) as usize] } - fTemp38)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22))) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp119;
			let mut fTemp120: F32 = self.fRec1[1] + fSlow3 * fTemp119 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp120;
			let mut fTemp121: F32 = self.fRec2[1] + fSlow3 * fTemp120 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp121;
			let mut fTemp122: F32 = self.fRec3[1] + fSlow3 * fTemp121 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp122;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp122;
			self.fRec0[0] = self.fConst20 * self.fRec5[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec24[1] = self.fRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Snare {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Snare as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Snare as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = self.fHslider3 + self.fHslider2;
		let mut fSlow9: F32 = 0.42857143 * (0.33333334 * (fSlow8 + -3.0) + 1.0);
		let mut fSlow10: F32 = F32::powf(2.0, 0.083333336 * (fSlow8 + -72.0));
		let mut fSlow11: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow10, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow12: i32 = ((fSlow11) as i32);
		let mut fSlow13: F32 = unsafe { ftbl3DSP_SnareSIG3[(iSlow12) as usize] };
		let mut fSlow14: F32 = fSlow13 + (fSlow11 - ((iSlow12) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iSlow12, 1)) as usize] } - fSlow13);
		let mut fSlow15: F32 = self.fConst8 * fSlow10;
		let mut fSlow16: F32 = 29.0 * F32::sqrt(0.01 * self.fHslider4) + 7e+01;
		let mut fSlow17: F32 = F32::min(99.0, fSlow16);
		let mut fSlow18: F32 = ((((fSlow16 > 0.0) as i32)) as F32);
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Snare_faustpower4_f(fSlow1) * fSlow4 / DSP_Snare_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider5;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider6 + 9.5));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider7 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Snare_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0])));
			let mut fTemp5: F32 = fTemp4 + -99.0;
			let mut fTemp6: F32 = 0.5714286 * fTemp5;
			let mut fTemp7: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 95.0));
			let mut fTemp8: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp7) * (fTemp7 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp8 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp8 } else { self.fRec9[1] };
			let mut fTemp9: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec11[1] };
			let mut fTemp10: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp9) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 52.5) as i32)) as usize] } * if (((fTemp9 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp11: F32 = F32::max(5076.0, self.fRec9[0]);
			let mut fTemp12: F32 = self.fRec7[0] - fTemp11;
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp12) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 90.5) as i32)) as usize] } * if (((fTemp12 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp11)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp10;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec12[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp14, self.fRec12[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec12[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec12[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec12[0] - fTemp13) / fTemp10;
			let mut fTemp19: F32 = self.fRec12[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec12[0] < 0.0) as i32) as i32 != 0) { fTemp11 } else { if (iTemp17 as i32 != 0) { fTemp11 + fTemp12 * if (((self.fRec7[0] > fTemp11) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec7[0] + fTemp9 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec9[0] } } } else { self.fRec9[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp5 + 99.0));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec15[1] };
			let mut fTemp25: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec16[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 78.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp28: F32 = self.fRec14[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			self.fRec17[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp31, self.fRec17[1] + 1.0) };
			let mut iTemp32: i32 = ((self.fRec17[0] < fTemp31) as i32);
			let mut iTemp33: i32 = ((self.fRec17[0] < fTemp30) as i32);
			let mut fTemp34: F32 = (self.fRec17[0] - fTemp30) / fTemp26;
			let mut fTemp35: F32 = self.fRec17[0] / fTemp30;
			let mut fTemp36: F32 = if (iTemp32 as i32 != 0) { if (iTemp33 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp33 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec14[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec14[0] } } } else { if (iTemp32 as i32 != 0) { self.fRec14[0] + fTemp25 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec15[0] } } } else { self.fRec15[0] };
			let mut iTemp37: i32 = ((fTemp36) as i32);
			let mut fTemp38: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp37) as usize] };
			let mut fTemp39: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 63.0));
			let mut fTemp40: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp39) * (fTemp39 + 28.0);
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp40 + 4064.0 } else { self.fRec18[1] };
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp40 + 3776.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = self.fRec19[0] - self.fRec18[0];
			let mut fTemp42: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp41) / (fTemp29 * if (((fTemp41 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp40 } else { self.fRec20[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp44: F32 = self.fRec18[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			let mut fTemp46: F32 = fTemp45 + fTemp42;
			let mut fTemp47: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp48: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp47) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 35.5) as i32)) as usize] } * if (((fTemp47 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp49: F32 = fTemp46 + fTemp48;
			self.fRec21[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp49, self.fRec21[1] + 1.0) };
			let mut iTemp50: i32 = ((self.fRec21[0] < fTemp46) as i32);
			let mut fTemp51: F32 = (self.fRec21[0] - fTemp46) / fTemp48;
			let mut iTemp52: i32 = ((self.fRec21[0] < fTemp45) as i32);
			let mut fTemp53: F32 = (self.fRec21[0] - fTemp45) / fTemp42;
			let mut fTemp54: F32 = self.fRec21[0] / fTemp45;
			let mut fTemp55: F32 = if (iTemp50 as i32 != 0) { if (iTemp52 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp52 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec18[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp54, 0.33333334) } else { fTemp54 } } else { self.fRec18[0] } } } else { if (iTemp50 as i32 != 0) { self.fRec18[0] + fTemp41 * if (((self.fRec19[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp53, 0.33333334) } else { fTemp53 } } else { self.fRec19[0] } } } else { if (((self.fRec21[0] < fTemp49) as i32) as i32 != 0) { self.fRec19[0] + fTemp47 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp51, 0.33333334) } else { fTemp51 } } else { self.fRec20[0] } };
			let mut iTemp56: i32 = ((fTemp55) as i32);
			let mut fTemp57: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp56) as usize] };
			let mut iTemp58: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp59: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst4 };
			self.fRec22[0] = fTemp59 - F32::floor(fTemp59);
			let mut fTemp60: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst6 };
			self.fRec24[0] = fTemp60 - F32::floor(fTemp60);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec26[1] };
			let mut fTemp61: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl3DSP_SnareSIG3[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow15 * fSlow14 * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) };
			self.fRec25[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = F32::max(0.0, F32::min(127.0, fSlow17 + 0.85714287 * fTemp5));
			let mut fTemp66: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp65) * (fTemp65 + 28.0);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp66 + 4064.0 } else { self.fRec27[1] };
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fTemp66 } else { self.fRec28[1] };
			let mut fTemp67: F32 = self.fRec28[0] - self.fRec27[0];
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 61.5) as i32)) as usize] } * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp70: F32 = self.fRec27[0] - fTemp69;
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 89.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp69)) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp71 + fTemp68;
			self.fRec29[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp72, self.fRec29[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec29[0] < fTemp72) as i32);
			let mut iTemp74: i32 = ((self.fRec29[0] < fTemp71) as i32);
			let mut fTemp75: F32 = (self.fRec29[0] - fTemp71) / fTemp68;
			let mut fTemp76: F32 = self.fRec29[0] / fTemp71;
			let mut fTemp77: F32 = if (iTemp73 as i32 != 0) { if (iTemp74 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp69 } else { if (iTemp74 as i32 != 0) { fTemp69 + fTemp70 * if (((self.fRec27[0] > fTemp69) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec27[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec27[0] + fTemp67 * if (((self.fRec28[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp75, 0.33333334) } else { fTemp75 } } else { self.fRec28[0] } } } else { self.fRec28[0] };
			let mut iTemp78: i32 = ((fTemp77) as i32);
			let mut fTemp79: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp78) as usize] };
			let mut fTemp80: F32 = F32::max(0.0, F32::min(127.0, fTemp4 + -9.0));
			let mut fTemp81: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp80) * (fTemp80 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp81 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp81 + 3168.0 } else { self.fRec31[1] };
			let mut fTemp82: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (fTemp29 * if (((fTemp82 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp85: F32 = self.fRec30[0] - fTemp84;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp29 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp84)) + 2.0) } else { 0.96 }))));
			let mut fTemp87: F32 = fTemp86 + fTemp83;
			let mut fTemp88: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 50.5) as i32)) as usize] } * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp90: F32 = fTemp87 + fTemp89;
			self.fRec32[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp90, self.fRec32[1] + 1.0) };
			let mut iTemp91: i32 = ((self.fRec32[0] < fTemp87) as i32);
			let mut fTemp92: F32 = (self.fRec32[0] - fTemp87) / fTemp89;
			let mut iTemp93: i32 = ((self.fRec32[0] < fTemp86) as i32);
			let mut fTemp94: F32 = (self.fRec32[0] - fTemp86) / fTemp83;
			let mut fTemp95: F32 = self.fRec32[0] / fTemp86;
			let mut fTemp96: F32 = if (iTemp91 as i32 != 0) { if (iTemp93 as i32 != 0) { if (((self.fRec32[0] < 0.0) as i32) as i32 != 0) { fTemp84 } else { if (iTemp93 as i32 != 0) { fTemp84 + fTemp85 * if (((self.fRec30[0] > fTemp84) as i32) as i32 != 0) { F32::powf(fTemp95, 0.33333334) } else { fTemp95 } } else { self.fRec30[0] } } } else { if (iTemp91 as i32 != 0) { self.fRec30[0] + fTemp82 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp94, 0.33333334) } else { fTemp94 } } else { self.fRec31[0] } } } else { if (((self.fRec32[0] < fTemp90) as i32) as i32 != 0) { self.fRec31[0] + fTemp88 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec30[0] } };
			let mut iTemp97: i32 = ((fTemp96) as i32);
			let mut fTemp98: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp97) as usize] };
			let mut fTemp99: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec33[1] + self.fConst10 };
			self.fRec33[0] = fTemp99 - F32::floor(fTemp99);
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec35[1] };
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 6784.0 } else { self.fRec36[1] };
			let mut fTemp100: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 7.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec37[1] };
			let mut fTemp102: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp103: F32 = self.fRec35[0] - fTemp102;
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp102)) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp104 + fTemp101;
			let mut fTemp106: F32 = self.fRec37[0] - self.fRec36[0];
			let mut fTemp107: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp106) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 0.5) as i32)) as usize] } * if (((fTemp106 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec36[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp108: F32 = fTemp105 + fTemp107;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp108, self.fRec38[1] + 1.0) };
			let mut iTemp109: i32 = ((self.fRec38[0] < fTemp105) as i32);
			let mut fTemp110: F32 = (self.fRec38[0] - fTemp105) / fTemp107;
			let mut iTemp111: i32 = ((self.fRec38[0] < fTemp104) as i32);
			let mut fTemp112: F32 = (self.fRec38[0] - fTemp104) / fTemp101;
			let mut fTemp113: F32 = self.fRec38[0] / fTemp104;
			let mut fTemp114: F32 = if (iTemp109 as i32 != 0) { if (iTemp111 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp102 } else { if (iTemp111 as i32 != 0) { fTemp102 + fTemp103 * if (((self.fRec35[0] > fTemp102) as i32) as i32 != 0) { F32::powf(fTemp113, 0.33333334) } else { fTemp113 } } else { self.fRec35[0] } } } else { if (iTemp109 as i32 != 0) { self.fRec35[0] + fTemp100 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec36[0] } } } else { if (((self.fRec38[0] < fTemp108) as i32) as i32 != 0) { self.fRec36[0] + fTemp106 * if (((self.fRec37[0] > self.fRec36[0]) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec37[0] } };
			let mut iTemp115: i32 = ((fTemp114) as i32);
			let mut fTemp116: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp115) as usize] };
			let mut fTemp117: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst12 };
			self.fRec39[0] = fTemp117 - F32::floor(fTemp117);
			self.fRec34[0] = 0.161 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec39[0] + 17.391304 * self.fRec34[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp116 + (fTemp114 - ((iTemp115) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp115, 1)) as usize] } - fTemp116));
			let mut fTemp118: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec40[1] + self.fConst14 };
			self.fRec40[0] = fTemp118 - F32::floor(fTemp118);
			let mut fTemp119: F32 = fSlow19 * (0.115 * (fSlow18 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec40[0] + 17.391304 * (self.fRec34[0] + 0.115 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec33[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp98 + (fTemp96 - ((iTemp97) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp97, 1)) as usize] } - fTemp98))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp79 + (fTemp77 - ((iTemp78) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp78, 1)) as usize] } - fTemp79)) + unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec22[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp57 + (fTemp55 - ((iTemp56) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp56, 1)) as usize] } - fTemp57)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp38 + (fTemp36 - ((iTemp37) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp37, 1)) as usize] } - fTemp38)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22))) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp119;
			let mut fTemp120: F32 = self.fRec1[1] + fSlow3 * fTemp119 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp120;
			let mut fTemp121: F32 = self.fRec2[1] + fSlow3 * fTemp120 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp121;
			let mut fTemp122: F32 = self.fRec3[1] + fSlow3 * fTemp121 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp122;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp122;
			self.fRec0[0] = self.fConst20 * self.fRec5[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec24[1] = self.fRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Snare {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Snare as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Snare as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = self.fHslider3 + self.fHslider2;
		let mut fSlow9: F32 = 0.42857143 * (0.33333334 * (fSlow8 + -3.0) + 1.0);
		let mut fSlow10: F32 = F32::powf(2.0, 0.083333336 * (fSlow8 + -72.0));
		let mut fSlow11: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow10, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow12: i32 = ((fSlow11) as i32);
		let mut fSlow13: F32 = unsafe { ftbl3DSP_SnareSIG3[(iSlow12) as usize] };
		let mut fSlow14: F32 = fSlow13 + (fSlow11 - ((iSlow12) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iSlow12, 1)) as usize] } - fSlow13);
		let mut fSlow15: F32 = self.fConst8 * fSlow10;
		let mut fSlow16: F32 = 29.0 * F32::sqrt(0.01 * self.fHslider4) + 7e+01;
		let mut fSlow17: F32 = F32::min(99.0, fSlow16);
		let mut fSlow18: F32 = ((((fSlow16 > 0.0) as i32)) as F32);
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Snare_faustpower4_f(fSlow1) * fSlow4 / DSP_Snare_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider5;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider6 + 9.5));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider7 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Snare_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0])));
			let mut fTemp5: F32 = fTemp4 + -99.0;
			let mut fTemp6: F32 = 0.5714286 * fTemp5;
			let mut fTemp7: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 95.0));
			let mut fTemp8: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp7) * (fTemp7 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp8 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp8 } else { self.fRec9[1] };
			let mut fTemp9: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec11[1] };
			let mut fTemp10: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp9) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 52.5) as i32)) as usize] } * if (((fTemp9 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp11: F32 = F32::max(5076.0, self.fRec9[0]);
			let mut fTemp12: F32 = self.fRec7[0] - fTemp11;
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp12) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 90.5) as i32)) as usize] } * if (((fTemp12 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp11)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp10;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec12[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp14, self.fRec12[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec12[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec12[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec12[0] - fTemp13) / fTemp10;
			let mut fTemp19: F32 = self.fRec12[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec12[0] < 0.0) as i32) as i32 != 0) { fTemp11 } else { if (iTemp17 as i32 != 0) { fTemp11 + fTemp12 * if (((self.fRec7[0] > fTemp11) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec7[0] + fTemp9 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec9[0] } } } else { self.fRec9[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp5 + 99.0));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec15[1] };
			let mut fTemp25: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec16[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 78.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp28: F32 = self.fRec14[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			self.fRec17[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp31, self.fRec17[1] + 1.0) };
			let mut iTemp32: i32 = ((self.fRec17[0] < fTemp31) as i32);
			let mut iTemp33: i32 = ((self.fRec17[0] < fTemp30) as i32);
			let mut fTemp34: F32 = (self.fRec17[0] - fTemp30) / fTemp26;
			let mut fTemp35: F32 = self.fRec17[0] / fTemp30;
			let mut fTemp36: F32 = if (iTemp32 as i32 != 0) { if (iTemp33 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp33 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec14[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec14[0] } } } else { if (iTemp32 as i32 != 0) { self.fRec14[0] + fTemp25 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec15[0] } } } else { self.fRec15[0] };
			let mut iTemp37: i32 = ((fTemp36) as i32);
			let mut fTemp38: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp37) as usize] };
			let mut fTemp39: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 63.0));
			let mut fTemp40: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp39) * (fTemp39 + 28.0);
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp40 + 4064.0 } else { self.fRec18[1] };
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp40 + 3776.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = self.fRec19[0] - self.fRec18[0];
			let mut fTemp42: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp41) / (fTemp29 * if (((fTemp41 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp40 } else { self.fRec20[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp44: F32 = self.fRec18[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			let mut fTemp46: F32 = fTemp45 + fTemp42;
			let mut fTemp47: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp48: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp47) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 35.5) as i32)) as usize] } * if (((fTemp47 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp49: F32 = fTemp46 + fTemp48;
			self.fRec21[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp49, self.fRec21[1] + 1.0) };
			let mut iTemp50: i32 = ((self.fRec21[0] < fTemp46) as i32);
			let mut fTemp51: F32 = (self.fRec21[0] - fTemp46) / fTemp48;
			let mut iTemp52: i32 = ((self.fRec21[0] < fTemp45) as i32);
			let mut fTemp53: F32 = (self.fRec21[0] - fTemp45) / fTemp42;
			let mut fTemp54: F32 = self.fRec21[0] / fTemp45;
			let mut fTemp55: F32 = if (iTemp50 as i32 != 0) { if (iTemp52 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp52 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec18[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp54, 0.33333334) } else { fTemp54 } } else { self.fRec18[0] } } } else { if (iTemp50 as i32 != 0) { self.fRec18[0] + fTemp41 * if (((self.fRec19[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp53, 0.33333334) } else { fTemp53 } } else { self.fRec19[0] } } } else { if (((self.fRec21[0] < fTemp49) as i32) as i32 != 0) { self.fRec19[0] + fTemp47 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp51, 0.33333334) } else { fTemp51 } } else { self.fRec20[0] } };
			let mut iTemp56: i32 = ((fTemp55) as i32);
			let mut fTemp57: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp56) as usize] };
			let mut iTemp58: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp59: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst4 };
			self.fRec22[0] = fTemp59 - F32::floor(fTemp59);
			let mut fTemp60: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst6 };
			self.fRec24[0] = fTemp60 - F32::floor(fTemp60);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec26[1] };
			let mut fTemp61: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl3DSP_SnareSIG3[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow15 * fSlow14 * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) };
			self.fRec25[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = F32::max(0.0, F32::min(127.0, fSlow17 + 0.85714287 * fTemp5));
			let mut fTemp66: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp65) * (fTemp65 + 28.0);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp66 + 4064.0 } else { self.fRec27[1] };
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fTemp66 } else { self.fRec28[1] };
			let mut fTemp67: F32 = self.fRec28[0] - self.fRec27[0];
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 61.5) as i32)) as usize] } * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp70: F32 = self.fRec27[0] - fTemp69;
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 89.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp69)) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp71 + fTemp68;
			self.fRec29[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp72, self.fRec29[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec29[0] < fTemp72) as i32);
			let mut iTemp74: i32 = ((self.fRec29[0] < fTemp71) as i32);
			let mut fTemp75: F32 = (self.fRec29[0] - fTemp71) / fTemp68;
			let mut fTemp76: F32 = self.fRec29[0] / fTemp71;
			let mut fTemp77: F32 = if (iTemp73 as i32 != 0) { if (iTemp74 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp69 } else { if (iTemp74 as i32 != 0) { fTemp69 + fTemp70 * if (((self.fRec27[0] > fTemp69) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec27[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec27[0] + fTemp67 * if (((self.fRec28[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp75, 0.33333334) } else { fTemp75 } } else { self.fRec28[0] } } } else { self.fRec28[0] };
			let mut iTemp78: i32 = ((fTemp77) as i32);
			let mut fTemp79: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp78) as usize] };
			let mut fTemp80: F32 = F32::max(0.0, F32::min(127.0, fTemp4 + -9.0));
			let mut fTemp81: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp80) * (fTemp80 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp81 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp81 + 3168.0 } else { self.fRec31[1] };
			let mut fTemp82: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (fTemp29 * if (((fTemp82 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp85: F32 = self.fRec30[0] - fTemp84;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp29 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp84)) + 2.0) } else { 0.96 }))));
			let mut fTemp87: F32 = fTemp86 + fTemp83;
			let mut fTemp88: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 50.5) as i32)) as usize] } * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp90: F32 = fTemp87 + fTemp89;
			self.fRec32[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp90, self.fRec32[1] + 1.0) };
			let mut iTemp91: i32 = ((self.fRec32[0] < fTemp87) as i32);
			let mut fTemp92: F32 = (self.fRec32[0] - fTemp87) / fTemp89;
			let mut iTemp93: i32 = ((self.fRec32[0] < fTemp86) as i32);
			let mut fTemp94: F32 = (self.fRec32[0] - fTemp86) / fTemp83;
			let mut fTemp95: F32 = self.fRec32[0] / fTemp86;
			let mut fTemp96: F32 = if (iTemp91 as i32 != 0) { if (iTemp93 as i32 != 0) { if (((self.fRec32[0] < 0.0) as i32) as i32 != 0) { fTemp84 } else { if (iTemp93 as i32 != 0) { fTemp84 + fTemp85 * if (((self.fRec30[0] > fTemp84) as i32) as i32 != 0) { F32::powf(fTemp95, 0.33333334) } else { fTemp95 } } else { self.fRec30[0] } } } else { if (iTemp91 as i32 != 0) { self.fRec30[0] + fTemp82 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp94, 0.33333334) } else { fTemp94 } } else { self.fRec31[0] } } } else { if (((self.fRec32[0] < fTemp90) as i32) as i32 != 0) { self.fRec31[0] + fTemp88 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec30[0] } };
			let mut iTemp97: i32 = ((fTemp96) as i32);
			let mut fTemp98: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp97) as usize] };
			let mut fTemp99: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec33[1] + self.fConst10 };
			self.fRec33[0] = fTemp99 - F32::floor(fTemp99);
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec35[1] };
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 6784.0 } else { self.fRec36[1] };
			let mut fTemp100: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 7.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec37[1] };
			let mut fTemp102: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp103: F32 = self.fRec35[0] - fTemp102;
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp102)) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp104 + fTemp101;
			let mut fTemp106: F32 = self.fRec37[0] - self.fRec36[0];
			let mut fTemp107: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp106) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 0.5) as i32)) as usize] } * if (((fTemp106 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec36[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp108: F32 = fTemp105 + fTemp107;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp108, self.fRec38[1] + 1.0) };
			let mut iTemp109: i32 = ((self.fRec38[0] < fTemp105) as i32);
			let mut fTemp110: F32 = (self.fRec38[0] - fTemp105) / fTemp107;
			let mut iTemp111: i32 = ((self.fRec38[0] < fTemp104) as i32);
			let mut fTemp112: F32 = (self.fRec38[0] - fTemp104) / fTemp101;
			let mut fTemp113: F32 = self.fRec38[0] / fTemp104;
			let mut fTemp114: F32 = if (iTemp109 as i32 != 0) { if (iTemp111 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp102 } else { if (iTemp111 as i32 != 0) { fTemp102 + fTemp103 * if (((self.fRec35[0] > fTemp102) as i32) as i32 != 0) { F32::powf(fTemp113, 0.33333334) } else { fTemp113 } } else { self.fRec35[0] } } } else { if (iTemp109 as i32 != 0) { self.fRec35[0] + fTemp100 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec36[0] } } } else { if (((self.fRec38[0] < fTemp108) as i32) as i32 != 0) { self.fRec36[0] + fTemp106 * if (((self.fRec37[0] > self.fRec36[0]) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec37[0] } };
			let mut iTemp115: i32 = ((fTemp114) as i32);
			let mut fTemp116: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp115) as usize] };
			let mut fTemp117: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst12 };
			self.fRec39[0] = fTemp117 - F32::floor(fTemp117);
			self.fRec34[0] = 0.161 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec39[0] + 17.391304 * self.fRec34[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp116 + (fTemp114 - ((iTemp115) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp115, 1)) as usize] } - fTemp116));
			let mut fTemp118: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec40[1] + self.fConst14 };
			self.fRec40[0] = fTemp118 - F32::floor(fTemp118);
			let mut fTemp119: F32 = fSlow19 * (0.115 * (fSlow18 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec40[0] + 17.391304 * (self.fRec34[0] + 0.115 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec33[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp98 + (fTemp96 - ((iTemp97) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp97, 1)) as usize] } - fTemp98))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp79 + (fTemp77 - ((iTemp78) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp78, 1)) as usize] } - fTemp79)) + unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec22[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp57 + (fTemp55 - ((iTemp56) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp56, 1)) as usize] } - fTemp57)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp38 + (fTemp36 - ((iTemp37) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp37, 1)) as usize] } - fTemp38)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22))) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp119;
			let mut fTemp120: F32 = self.fRec1[1] + fSlow3 * fTemp119 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp120;
			let mut fTemp121: F32 = self.fRec2[1] + fSlow3 * fTemp120 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp121;
			let mut fTemp122: F32 = self.fRec3[1] + fSlow3 * fTemp121 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp122;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp122;
			self.fRec0[0] = self.fConst20 * self.fRec5[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec24[1] = self.fRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Snare {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Snare as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Snare as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fHslider0;
		let mut fSlow1: F32 = F32::tan(0.0155508835 * fSlow0);
		let mut fSlow2: F32 = fSlow1 + 1.0;
		let mut fSlow3: F32 = fSlow1 / fSlow2;
		let mut fSlow4: F32 = 2.293 - 0.0227007 * fSlow0;
		let mut fSlow5: F32 = 0.16465649 * fSlow4 * (1.0 - fSlow3);
		let mut fSlow6: F32 = self.fEntry0;
		let mut fSlow7: F32 = self.fHslider1;
		let mut fSlow8: F32 = self.fHslider3 + self.fHslider2;
		let mut fSlow9: F32 = 0.42857143 * (0.33333334 * (fSlow8 + -3.0) + 1.0);
		let mut fSlow10: F32 = F32::powf(2.0, 0.083333336 * (fSlow8 + -72.0));
		let mut fSlow11: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow10, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow12: i32 = ((fSlow11) as i32);
		let mut fSlow13: F32 = unsafe { ftbl3DSP_SnareSIG3[(iSlow12) as usize] };
		let mut fSlow14: F32 = fSlow13 + (fSlow11 - ((iSlow12) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iSlow12, 1)) as usize] } - fSlow13);
		let mut fSlow15: F32 = self.fConst8 * fSlow10;
		let mut fSlow16: F32 = 29.0 * F32::sqrt(0.01 * self.fHslider4) + 7e+01;
		let mut fSlow17: F32 = F32::min(99.0, fSlow16);
		let mut fSlow18: F32 = ((((fSlow16 > 0.0) as i32)) as F32);
		let mut fSlow19: F32 = 1.0 / (0.16465649 * (DSP_Snare_faustpower4_f(fSlow1) * fSlow4 / DSP_Snare_faustpower4_f(fSlow2)) + 1.0);
		let mut fSlow20: F32 = 2.0 * fSlow3;
		let mut fSlow21: F32 = 0.01 * self.fHslider5;
		let mut fSlow22: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider6 + 9.5));
		let mut fSlow23: F32 = fSlow22 * F32::min(1.0, 1.0 - fSlow21);
		let mut fSlow24: F32 = fSlow22 * F32::min(1.0, fSlow21 + 1.0);
		let mut fSlow25: F32 = 0.01 * self.fHslider7 * fSlow22;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow6;
			let mut iTemp1: i32 = ((fSlow6 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec8[0] = if (iTemp1 as i32 != 0) { fSlow6 } else { self.fRec8[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Snare_faustpower2_f(1.0 - F32::max(fSlow7, self.fRec8[0])));
			let mut fTemp5: F32 = fTemp4 + -99.0;
			let mut fTemp6: F32 = 0.5714286 * fTemp5;
			let mut fTemp7: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 95.0));
			let mut fTemp8: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp7) * (fTemp7 + 28.0);
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp8 + 4064.0 } else { self.fRec7[1] };
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp8 } else { self.fRec9[1] };
			let mut fTemp9: F32 = self.fRec9[0] - self.fRec7[0];
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec11[1] };
			let mut fTemp10: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp9) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 52.5) as i32)) as usize] } * if (((fTemp9 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec7[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp11: F32 = F32::max(5076.0, self.fRec9[0]);
			let mut fTemp12: F32 = self.fRec7[0] - fTemp11;
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp12) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec11[0] + 90.5) as i32)) as usize] } * if (((fTemp12 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp11)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp10;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec12[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp14, self.fRec12[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec12[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec12[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec12[0] - fTemp13) / fTemp10;
			let mut fTemp19: F32 = self.fRec12[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec12[0] < 0.0) as i32) as i32 != 0) { fTemp11 } else { if (iTemp17 as i32 != 0) { fTemp11 + fTemp12 * if (((self.fRec7[0] > fTemp11) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec7[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec7[0] + fTemp9 * if (((self.fRec9[0] > self.fRec7[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec9[0] } } } else { self.fRec9[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp5 + 99.0));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec15[1] };
			let mut fTemp25: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec16[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 78.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp28: F32 = self.fRec14[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			self.fRec17[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp31, self.fRec17[1] + 1.0) };
			let mut iTemp32: i32 = ((self.fRec17[0] < fTemp31) as i32);
			let mut iTemp33: i32 = ((self.fRec17[0] < fTemp30) as i32);
			let mut fTemp34: F32 = (self.fRec17[0] - fTemp30) / fTemp26;
			let mut fTemp35: F32 = self.fRec17[0] / fTemp30;
			let mut fTemp36: F32 = if (iTemp32 as i32 != 0) { if (iTemp33 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp33 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec14[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp35, 0.33333334) } else { fTemp35 } } else { self.fRec14[0] } } } else { if (iTemp32 as i32 != 0) { self.fRec14[0] + fTemp25 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec15[0] } } } else { self.fRec15[0] };
			let mut iTemp37: i32 = ((fTemp36) as i32);
			let mut fTemp38: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp37) as usize] };
			let mut fTemp39: F32 = F32::max(0.0, F32::min(127.0, fTemp6 + 63.0));
			let mut fTemp40: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp39) * (fTemp39 + 28.0);
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fTemp40 + 4064.0 } else { self.fRec18[1] };
			self.fRec19[0] = if (iTemp3 as i32 != 0) { fTemp40 + 3776.0 } else { self.fRec19[1] };
			let mut fTemp41: F32 = self.fRec19[0] - self.fRec18[0];
			let mut fTemp42: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp41) / (fTemp29 * if (((fTemp41 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			self.fRec20[0] = if (iTemp3 as i32 != 0) { fTemp40 } else { self.fRec20[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec20[0]);
			let mut fTemp44: F32 = self.fRec18[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			let mut fTemp46: F32 = fTemp45 + fTemp42;
			let mut fTemp47: F32 = self.fRec20[0] - self.fRec19[0];
			let mut fTemp48: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp47) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 35.5) as i32)) as usize] } * if (((fTemp47 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec19[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp49: F32 = fTemp46 + fTemp48;
			self.fRec21[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp49, self.fRec21[1] + 1.0) };
			let mut iTemp50: i32 = ((self.fRec21[0] < fTemp46) as i32);
			let mut fTemp51: F32 = (self.fRec21[0] - fTemp46) / fTemp48;
			let mut iTemp52: i32 = ((self.fRec21[0] < fTemp45) as i32);
			let mut fTemp53: F32 = (self.fRec21[0] - fTemp45) / fTemp42;
			let mut fTemp54: F32 = self.fRec21[0] / fTemp45;
			let mut fTemp55: F32 = if (iTemp50 as i32 != 0) { if (iTemp52 as i32 != 0) { if (((self.fRec21[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp52 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec18[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp54, 0.33333334) } else { fTemp54 } } else { self.fRec18[0] } } } else { if (iTemp50 as i32 != 0) { self.fRec18[0] + fTemp41 * if (((self.fRec19[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp53, 0.33333334) } else { fTemp53 } } else { self.fRec19[0] } } } else { if (((self.fRec21[0] < fTemp49) as i32) as i32 != 0) { self.fRec19[0] + fTemp47 * if (((self.fRec20[0] > self.fRec19[0]) as i32) as i32 != 0) { F32::powf(fTemp51, 0.33333334) } else { fTemp51 } } else { self.fRec20[0] } };
			let mut iTemp56: i32 = ((fTemp55) as i32);
			let mut fTemp57: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp56) as usize] };
			let mut iTemp58: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp59: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst4 };
			self.fRec22[0] = fTemp59 - F32::floor(fTemp59);
			let mut fTemp60: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst6 };
			self.fRec24[0] = fTemp60 - F32::floor(fTemp60);
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec26[1] };
			let mut fTemp61: F32 = 15.996094 * (0.4 * ((self.iRec26[0]) as F32) + 128.0);
			let mut iTemp62: i32 = ((fTemp61) as i32);
			let mut fTemp63: F32 = unsafe { ftbl3DSP_SnareSIG3[(iTemp62) as usize] };
			let mut fTemp64: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow15 * fSlow14 * (fTemp63 + (fTemp61 - ((iTemp62) as F32)) * (unsafe { ftbl3DSP_SnareSIG3[(i32::wrapping_add(iTemp62, 1)) as usize] } - fTemp63)) };
			self.fRec25[0] = fTemp64 - F32::floor(fTemp64);
			let mut fTemp65: F32 = F32::max(0.0, F32::min(127.0, fSlow17 + 0.85714287 * fTemp5));
			let mut fTemp66: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp65) * (fTemp65 + 28.0);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp66 + 4064.0 } else { self.fRec27[1] };
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fTemp66 } else { self.fRec28[1] };
			let mut fTemp67: F32 = self.fRec28[0] - self.fRec27[0];
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 61.5) as i32)) as usize] } * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = F32::max(5076.0, self.fRec28[0]);
			let mut fTemp70: F32 = self.fRec27[0] - fTemp69;
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 89.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp69)) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp71 + fTemp68;
			self.fRec29[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp72, self.fRec29[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec29[0] < fTemp72) as i32);
			let mut iTemp74: i32 = ((self.fRec29[0] < fTemp71) as i32);
			let mut fTemp75: F32 = (self.fRec29[0] - fTemp71) / fTemp68;
			let mut fTemp76: F32 = self.fRec29[0] / fTemp71;
			let mut fTemp77: F32 = if (iTemp73 as i32 != 0) { if (iTemp74 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp69 } else { if (iTemp74 as i32 != 0) { fTemp69 + fTemp70 * if (((self.fRec27[0] > fTemp69) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec27[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec27[0] + fTemp67 * if (((self.fRec28[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp75, 0.33333334) } else { fTemp75 } } else { self.fRec28[0] } } } else { self.fRec28[0] };
			let mut iTemp78: i32 = ((fTemp77) as i32);
			let mut fTemp79: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp78) as usize] };
			let mut fTemp80: F32 = F32::max(0.0, F32::min(127.0, fTemp4 + -9.0));
			let mut fTemp81: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp80) * (fTemp80 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp81 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp81 + 3168.0 } else { self.fRec31[1] };
			let mut fTemp82: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (fTemp29 * if (((fTemp82 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(5076.0, self.fRec30[0]);
			let mut fTemp85: F32 = self.fRec30[0] - fTemp84;
			let mut fTemp86: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp85) / (fTemp29 * if (((fTemp85 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp84)) + 2.0) } else { 0.96 }))));
			let mut fTemp87: F32 = fTemp86 + fTemp83;
			let mut fTemp88: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp89: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp88) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 50.5) as i32)) as usize] } * if (((fTemp88 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp90: F32 = fTemp87 + fTemp89;
			self.fRec32[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp90, self.fRec32[1] + 1.0) };
			let mut iTemp91: i32 = ((self.fRec32[0] < fTemp87) as i32);
			let mut fTemp92: F32 = (self.fRec32[0] - fTemp87) / fTemp89;
			let mut iTemp93: i32 = ((self.fRec32[0] < fTemp86) as i32);
			let mut fTemp94: F32 = (self.fRec32[0] - fTemp86) / fTemp83;
			let mut fTemp95: F32 = self.fRec32[0] / fTemp86;
			let mut fTemp96: F32 = if (iTemp91 as i32 != 0) { if (iTemp93 as i32 != 0) { if (((self.fRec32[0] < 0.0) as i32) as i32 != 0) { fTemp84 } else { if (iTemp93 as i32 != 0) { fTemp84 + fTemp85 * if (((self.fRec30[0] > fTemp84) as i32) as i32 != 0) { F32::powf(fTemp95, 0.33333334) } else { fTemp95 } } else { self.fRec30[0] } } } else { if (iTemp91 as i32 != 0) { self.fRec30[0] + fTemp82 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp94, 0.33333334) } else { fTemp94 } } else { self.fRec31[0] } } } else { if (((self.fRec32[0] < fTemp90) as i32) as i32 != 0) { self.fRec31[0] + fTemp88 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec30[0] } };
			let mut iTemp97: i32 = ((fTemp96) as i32);
			let mut fTemp98: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp97) as usize] };
			let mut fTemp99: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec33[1] + self.fConst10 };
			self.fRec33[0] = fTemp99 - F32::floor(fTemp99);
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec35[1] };
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 6784.0 } else { self.fRec36[1] };
			let mut fTemp100: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 7.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { 4064.0 } else { self.fRec37[1] };
			let mut fTemp102: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp103: F32 = self.fRec35[0] - fTemp102;
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp102)) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp104 + fTemp101;
			let mut fTemp106: F32 = self.fRec37[0] - self.fRec36[0];
			let mut fTemp107: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp106) / (unsafe { ftbl1DSP_SnareSIG1[(((self.fRec16[0] + 0.5) as i32)) as usize] } * if (((fTemp106 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec36[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp108: F32 = fTemp105 + fTemp107;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp108, self.fRec38[1] + 1.0) };
			let mut iTemp109: i32 = ((self.fRec38[0] < fTemp105) as i32);
			let mut fTemp110: F32 = (self.fRec38[0] - fTemp105) / fTemp107;
			let mut iTemp111: i32 = ((self.fRec38[0] < fTemp104) as i32);
			let mut fTemp112: F32 = (self.fRec38[0] - fTemp104) / fTemp101;
			let mut fTemp113: F32 = self.fRec38[0] / fTemp104;
			let mut fTemp114: F32 = if (iTemp109 as i32 != 0) { if (iTemp111 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp102 } else { if (iTemp111 as i32 != 0) { fTemp102 + fTemp103 * if (((self.fRec35[0] > fTemp102) as i32) as i32 != 0) { F32::powf(fTemp113, 0.33333334) } else { fTemp113 } } else { self.fRec35[0] } } } else { if (iTemp109 as i32 != 0) { self.fRec35[0] + fTemp100 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec36[0] } } } else { if (((self.fRec38[0] < fTemp108) as i32) as i32 != 0) { self.fRec36[0] + fTemp106 * if (((self.fRec37[0] > self.fRec36[0]) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec37[0] } };
			let mut iTemp115: i32 = ((fTemp114) as i32);
			let mut fTemp116: F32 = unsafe { ftbl0DSP_SnareSIG0[(iTemp115) as usize] };
			let mut fTemp117: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst12 };
			self.fRec39[0] = fTemp117 - F32::floor(fTemp117);
			self.fRec34[0] = 0.161 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec39[0] + 17.391304 * self.fRec34[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp116 + (fTemp114 - ((iTemp115) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp115, 1)) as usize] } - fTemp116));
			let mut fTemp118: F32 = if (iTemp58 as i32 != 0) { 0.0 } else { self.fRec40[1] + self.fConst14 };
			self.fRec40[0] = fTemp118 - F32::floor(fTemp118);
			let mut fTemp119: F32 = fSlow19 * (0.115 * (fSlow18 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec40[0] + 17.391304 * (self.fRec34[0] + 0.115 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec33[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp98 + (fTemp96 - ((iTemp97) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp97, 1)) as usize] } - fTemp98))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp79 + (fTemp77 - ((iTemp78) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp78, 1)) as usize] } - fTemp79)) + unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_SnareSIG2[(((1024.0 * self.fRec22[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp57 + (fTemp55 - ((iTemp56) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp56, 1)) as usize] } - fTemp57)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp38 + (fTemp36 - ((iTemp37) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp37, 1)) as usize] } - fTemp38)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_SnareSIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22))) - fSlow5 * (self.fRec4[1] + fSlow3 * (self.fRec3[1] + fSlow3 * (self.fRec2[1] + fSlow3 * self.fRec1[1])))) - self.fRec1[1];
			self.fRec1[0] = self.fRec1[1] + fSlow20 * fTemp119;
			let mut fTemp120: F32 = self.fRec1[1] + fSlow3 * fTemp119 - self.fRec2[1];
			self.fRec2[0] = self.fRec2[1] + fSlow20 * fTemp120;
			let mut fTemp121: F32 = self.fRec2[1] + fSlow3 * fTemp120 - self.fRec3[1];
			self.fRec3[0] = self.fRec3[1] + fSlow20 * fTemp121;
			let mut fTemp122: F32 = self.fRec3[1] + fSlow3 * fTemp121 - self.fRec4[1];
			self.fRec4[0] = self.fRec4[1] + fSlow20 * fTemp122;
			self.fRec5[0] = self.fRec4[1] + fSlow3 * fTemp122;
			self.fRec0[0] = self.fConst20 * self.fRec5[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * self.fRec5[0]);
			*output0 = fSlow23 * self.fRec0[0];
			*output1 = fSlow24 * self.fRec0[0];
			*output2 = fSlow25 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec24[1] = self.fRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec1[1] = self.fRec1[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
