// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Tom1 -pn processTom1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Tom1SIG0 {
	iRec1: [i32;2],
}

impl DSP_Tom1SIG0 {
	
	fn get_num_inputsDSP_Tom1SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom1SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Tom1SIG0() -> DSP_Tom1SIG0 { 
	DSP_Tom1SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Tom1SIG1 {
	iRec5: [i32;2],
}

impl DSP_Tom1SIG1 {
	
	fn get_num_inputsDSP_Tom1SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom1SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Tom1SIG1() -> DSP_Tom1SIG1 { 
	DSP_Tom1SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Tom1SIG2 {
	iVec3: [i32;2],
	iRec9: [i32;2],
}

impl DSP_Tom1SIG2 {
	
	fn get_num_inputsDSP_Tom1SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec9[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom1SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec9[0] = (i32::wrapping_add(self.iVec3[1], self.iRec9[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec9[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec9[1] = self.iRec9[0];
		}
	}

}


pub fn newDSP_Tom1SIG2() -> DSP_Tom1SIG2 { 
	DSP_Tom1SIG2 {
		iVec3: [0;2],
		iRec9: [0;2],
	}
}

pub struct DSP_Tom1SIG3 {
	iRec20: [i32;2],
}

impl DSP_Tom1SIG3 {
	
	fn get_num_inputsDSP_Tom1SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG3(&mut self, sample_rate: i32) {
		for l22 in 0..2 {
			self.iRec20[(l22) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom1SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec20[0] = i32::wrapping_add(self.iRec20[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec20[0], -1)) as F32) + -128.0));
			self.iRec20[1] = self.iRec20[0];
		}
	}

}


pub fn newDSP_Tom1SIG3() -> DSP_Tom1SIG3 { 
	DSP_Tom1SIG3 {
		iRec20: [0;2],
	}
}
static mut iDSP_Tom1SIG4Wave0: [i32;100] = [1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,16,16,17,18,18,19,20,21,22,23,24,25,26,27,28,30,31,33,34,36,37,38,39,41,42,44,46,47,49,51,53,54,56,58,60,62,64,66,68,70,72,74,76,79,82,85,88,91,94,98,102,106,110,115,120,125,130,135,141,147,153,159,165,171,178,185,193,202,211,232,243,254,255];

pub struct DSP_Tom1SIG4 {
	iDSP_Tom1SIG4Wave0_idx: i32,
}

impl DSP_Tom1SIG4 {
	
	fn get_num_inputsDSP_Tom1SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Tom1SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Tom1SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Tom1SIG4Wave0[(self.iDSP_Tom1SIG4Wave0_idx) as usize] };
			self.iDSP_Tom1SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom1SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom1SIG4() -> DSP_Tom1SIG4 { 
	DSP_Tom1SIG4 {
		iDSP_Tom1SIG4Wave0_idx: 0,
	}
}
static mut iDSP_Tom1SIG5Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Tom1SIG5 {
	iDSP_Tom1SIG5Wave0_idx: i32,
}

impl DSP_Tom1SIG5 {
	
	fn get_num_inputsDSP_Tom1SIG5(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom1SIG5(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom1SIG5(&mut self, sample_rate: i32) {
		self.iDSP_Tom1SIG5Wave0_idx = 0;
	}
	
	fn fillDSP_Tom1SIG5(&mut self, count: i32, table: &mut[i32]) {
		for i6 in 0..count {
			table[(i6) as usize] = unsafe { iDSP_Tom1SIG5Wave0[(self.iDSP_Tom1SIG5Wave0_idx) as usize] };
			self.iDSP_Tom1SIG5Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom1SIG5Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom1SIG5() -> DSP_Tom1SIG5 { 
	DSP_Tom1SIG5 {
		iDSP_Tom1SIG5Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Tom1SIG0: [F32;16384] = [0.0;16384];
fn DSP_Tom1_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Tom1SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Tom1SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Tom1SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Tom1SIG4: [i32;100] = [0;100];
static mut itbl5DSP_Tom1SIG5: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Tom1 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fRec2: [F32;2],
	fRec4: [F32;2],
	fHslider1: F32,
	fHslider2: F32,
	fRec6: [F32;2],
	fRec7: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fRec13: [F32;2],
	fRec14: [F32;2],
	fRec15: [F32;2],
	fConst5: F32,
	fConst6: F32,
	fRec16: [F32;2],
	fRec17: [F32;2],
	fRec18: [F32;2],
	fConst9: F32,
	fRec19: [F32;2],
	fConst11: F32,
	fRec21: [F32;2],
	fConst13: F32,
	fRec22: [F32;2],
	fRec23: [F32;2],
	fRec24: [F32;2],
	fRec25: [F32;2],
	fRec26: [F32;2],
	fConst14: F32,
	iConst15: i32,
	iRec28: [i32;2],
	iConst16: i32,
	iRec29: [i32;2],
	fConst17: F32,
	fConst18: F32,
	iConst19: i32,
	iRec31: [i32;2],
	fRec30: [F32;2],
	fConst20: F32,
	fRec27: [F32;2],
	fRec33: [F32;2],
	fRec34: [F32;2],
	fRec35: [F32;2],
	fRec36: [F32;2],
	fConst22: F32,
	fRec37: [F32;2],
	fRec32: [F32;2],
	fVec4: [F32;2],
	fConst23: F32,
	fConst24: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_Tom1 {
	type T = F32;
		
	fn new() -> DSP_Tom1 { 
		DSP_Tom1 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fHslider1: 0.0,
			fHslider2: 0.0,
			fRec6: [0.0;2],
			fRec7: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fRec15: [0.0;2],
			fConst5: 0.0,
			fConst6: 0.0,
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fRec18: [0.0;2],
			fConst9: 0.0,
			fRec19: [0.0;2],
			fConst11: 0.0,
			fRec21: [0.0;2],
			fConst13: 0.0,
			fRec22: [0.0;2],
			fRec23: [0.0;2],
			fRec24: [0.0;2],
			fRec25: [0.0;2],
			fRec26: [0.0;2],
			fConst14: 0.0,
			iConst15: 0,
			iRec28: [0;2],
			iConst16: 0,
			iRec29: [0;2],
			fConst17: 0.0,
			fConst18: 0.0,
			iConst19: 0,
			iRec31: [0;2],
			fRec30: [0.0;2],
			fConst20: 0.0,
			fRec27: [0.0;2],
			fRec33: [0.0;2],
			fRec34: [0.0;2],
			fRec35: [0.0;2],
			fRec36: [0.0;2],
			fConst22: 0.0,
			fRec37: [0.0;2],
			fRec32: [0.0;2],
			fVec4: [0.0;2],
			fConst23: 0.0,
			fConst24: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Tom1 -pn processTom1 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Tom1SIG0 = newDSP_Tom1SIG0();
		sig0.instance_initDSP_Tom1SIG0(sample_rate);
		sig0.fillDSP_Tom1SIG0(16384, unsafe { &mut ftbl0DSP_Tom1SIG0 });
		let mut sig1: DSP_Tom1SIG1 = newDSP_Tom1SIG1();
		sig1.instance_initDSP_Tom1SIG1(sample_rate);
		sig1.fillDSP_Tom1SIG1(144, unsafe { &mut ftbl1DSP_Tom1SIG1 });
		let mut sig2: DSP_Tom1SIG2 = newDSP_Tom1SIG2();
		sig2.instance_initDSP_Tom1SIG2(sample_rate);
		sig2.fillDSP_Tom1SIG2(1024, unsafe { &mut ftbl2DSP_Tom1SIG2 });
		let mut sig3: DSP_Tom1SIG3 = newDSP_Tom1SIG3();
		sig3.instance_initDSP_Tom1SIG3(sample_rate);
		sig3.fillDSP_Tom1SIG3(4096, unsafe { &mut ftbl3DSP_Tom1SIG3 });
		let mut sig4: DSP_Tom1SIG4 = newDSP_Tom1SIG4();
		sig4.instance_initDSP_Tom1SIG4(sample_rate);
		sig4.fillDSP_Tom1SIG4(100, unsafe { &mut itbl4DSP_Tom1SIG4 });
		let mut sig5: DSP_Tom1SIG5 = newDSP_Tom1SIG5();
		sig5.instance_initDSP_Tom1SIG5(sample_rate);
		sig5.fillDSP_Tom1SIG5(100, unsafe { &mut itbl5DSP_Tom1SIG5 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 36.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec8[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec15[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec16[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec17[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec18[(l21) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec19[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec21[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec22[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec23[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec24[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec25[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec26[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.iRec28[(l30) as usize] = 0;
		}
		for l31 in 0..2 {
			self.iRec29[(l31) as usize] = 0;
		}
		for l32 in 0..2 {
			self.iRec31[(l32) as usize] = 0;
		}
		for l33 in 0..2 {
			self.fRec30[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec27[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec33[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec34[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec35[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec36[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec37[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec32[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fVec4[(l41) as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec0[(l42) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.fConst5 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst6 = 2.0 * self.fConst5;
		let mut fConst7: F32 = unsafe { ftbl3DSP_Tom1SIG3[2430] };
		let mut fConst8: F32 = 1e+02 / self.fConst0;
		self.fConst9 = fConst8 * (fConst7 + 0.08177344 * (unsafe { ftbl3DSP_Tom1SIG3[2431] } - fConst7));
		let mut fConst10: F32 = unsafe { ftbl3DSP_Tom1SIG3[2111] };
		self.fConst11 = fConst8 * (fConst10 + 0.2636289 * (unsafe { ftbl3DSP_Tom1SIG3[2112] } - fConst10));
		let mut fConst12: F32 = unsafe { ftbl3DSP_Tom1SIG3[2047] };
		self.fConst13 = 1e+01 / self.fConst0 * (fConst12 + 0.5 * (unsafe { ftbl3DSP_Tom1SIG3[2048] } - fConst12));
		self.fConst14 = ((unsafe { itbl4DSP_Tom1SIG4[81] }) as F32);
		self.iConst15 = unsafe { itbl5DSP_Tom1SIG5[50] };
		self.iConst16 = unsafe { itbl5DSP_Tom1SIG5[10] };
		self.fConst17 = 0.64285713 * self.fConst0;
		self.fConst18 = ((unsafe { itbl4DSP_Tom1SIG4[50] }) as F32);
		self.iConst19 = unsafe { itbl5DSP_Tom1SIG5[0] };
		self.fConst20 = 4.4e+02 / self.fConst0;
		let mut fConst21: F32 = unsafe { ftbl3DSP_Tom1SIG3[2257] };
		self.fConst22 = fConst8 * (fConst21 + 0.9199754 * (unsafe { ftbl3DSP_Tom1SIG3[2258] } - fConst21));
		self.fConst23 = 1.0 / (fConst1 * fConst3);
		self.fConst24 = 0.0 - self.fConst23;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Tom1::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "8", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(4), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(6), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			5 => Some(self.fHslider0),
			6 => Some(self.fHslider1),
			3 => Some(self.fHslider2),
			2 => Some(self.fHslider3),
			1 => Some(self.fHslider4),
			4 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			5 => { self.fHslider0 = value }
			6 => { self.fHslider1 = value }
			3 => { self.fHslider2 = value }
			2 => { self.fHslider3 = value }
			1 => { self.fHslider4 = value }
			4 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.42857143 * (0.33333334 * (fSlow2 + 4.7) + 1.0);
		let mut fSlow4: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.07070707 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow2 + -99.3)))) + 87.0)));
		let mut fSlow5: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow4) * (fSlow4 + 28.0);
		let mut fSlow6: F32 = fSlow5 + 4064.0;
		let mut fSlow7: F32 = fSlow5 + 2848.0;
		let mut fSlow8: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.5050505 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -46.3))) + 76.0)));
		let mut fSlow9: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow8) * (fSlow8 + 28.0);
		let mut fSlow10: F32 = fSlow9 + 4064.0;
		let mut fSlow11: F32 = fSlow9 + 3392.0;
		let mut fSlow12: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow13: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow12, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow14: i32 = ((fSlow13) as i32);
		let mut fSlow15: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iSlow14) as usize] };
		let mut fSlow16: F32 = fSlow15 + (fSlow13 - ((iSlow14) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iSlow14, 1)) as usize] } - fSlow15);
		let mut fSlow17: F32 = self.fConst20 * fSlow12;
		let mut fSlow18: F32 = 0.01 * self.fHslider3;
		let mut fSlow19: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.5));
		let mut fSlow20: F32 = fSlow19 * F32::min(1.0, 1.0 - fSlow18);
		let mut fSlow21: F32 = fSlow19 * F32::min(1.0, fSlow18 + 1.0);
		let mut fSlow22: F32 = 0.01 * self.fHslider5 * fSlow19;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3968.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 60.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 45.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec8[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec8[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec8[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec8[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec8[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec8[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec2[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp16) as i32) as i32 != 0) { self.fRec4[0] + fTemp14 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec7[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp23) as usize] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec11[1] };
			let mut fTemp25: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 72.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec13[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp28: F32 = self.fRec10[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			let mut fTemp32: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp32) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 39.5) as i32)) as usize] } * if (((fTemp32 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp34: F32 = fTemp31 + fTemp33;
			self.fRec14[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec14[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec14[0] < fTemp31) as i32);
			let mut fTemp36: F32 = (self.fRec14[0] - fTemp31) / fTemp33;
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp30) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp30) / fTemp26;
			let mut fTemp39: F32 = self.fRec14[0] / fTemp30;
			let mut fTemp40: F32 = if (iTemp35 as i32 != 0) { if (iTemp37 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp37 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec10[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec10[0] } } } else { if (iTemp35 as i32 != 0) { self.fRec10[0] + fTemp25 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp34) as i32) as i32 != 0) { self.fRec11[0] + fTemp32 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec13[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp41) as usize] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec15[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp44: F32 = self.fRec15[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp45, self.fRec16[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec16[0] < fTemp45) as i32);
			let mut fTemp47: F32 = self.fRec16[0] / fTemp45;
			let mut fTemp48: F32 = if (((self.fRec16[0] < (self.fConst5 + fTemp45)) as i32) as i32 != 0) { if (iTemp46 as i32 != 0) { if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp46 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec15[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp47, 0.33333334) } else { fTemp47 } } else { self.fRec15[0] } } } else { self.fRec15[0] } } else { self.fRec15[0] };
			let mut iTemp49: i32 = ((fTemp48) as i32);
			let mut fTemp50: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp49) as usize] };
			let mut fTemp51: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { 32.0 * F32::min(1.0, 0.05 * fTemp51) * (fTemp51 + 28.0) + 4064.0 } else { self.fRec17[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp29 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp54) as i32);
			let mut fTemp56: F32 = self.fRec18[0] / fTemp54;
			let mut fTemp57: F32 = if (((self.fRec18[0] < (self.fConst5 + fTemp54)) as i32) as i32 != 0) { if (iTemp55 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp55 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { self.fRec17[0] };
			let mut iTemp58: i32 = ((fTemp57) as i32);
			let mut fTemp59: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp58) as usize] };
			let mut iTemp60: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp61: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec19[1] + self.fConst9 };
			self.fRec19[0] = fTemp61 - F32::floor(fTemp61);
			let mut fTemp62: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst11 };
			self.fRec21[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst13 };
			self.fRec22[0] = fTemp63 - F32::floor(fTemp63);
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec23[1] };
			self.fRec24[0] = if (iTemp3 as i32 != 0) { fSlow11 } else { self.fRec24[1] };
			let mut fTemp64: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp65: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp64) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 71.5) as i32)) as usize] } * if (((fTemp64 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec25[1] };
			let mut fTemp66: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp67: F32 = self.fRec23[0] - fTemp66;
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (fTemp29 * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp66)) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = fTemp68 + fTemp65;
			let mut fTemp70: F32 = self.fRec25[0] - self.fRec24[0];
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 8.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec24[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp69 + fTemp71;
			self.fRec26[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp72, self.fRec26[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec26[0] < fTemp69) as i32);
			let mut fTemp74: F32 = (self.fRec26[0] - fTemp69) / fTemp71;
			let mut iTemp75: i32 = ((self.fRec26[0] < fTemp68) as i32);
			let mut fTemp76: F32 = (self.fRec26[0] - fTemp68) / fTemp65;
			let mut fTemp77: F32 = self.fRec26[0] / fTemp68;
			let mut fTemp78: F32 = if (iTemp73 as i32 != 0) { if (iTemp75 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp66 } else { if (iTemp75 as i32 != 0) { fTemp66 + fTemp67 * if (((self.fRec23[0] > fTemp66) as i32) as i32 != 0) { F32::powf(fTemp77, 0.33333334) } else { fTemp77 } } else { self.fRec23[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec23[0] + fTemp64 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec24[0] } } } else { if (((self.fRec26[0] < fTemp72) as i32) as i32 != 0) { self.fRec24[0] + fTemp70 * if (((self.fRec25[0] > self.fRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { self.fRec25[0] } };
			let mut iTemp79: i32 = ((fTemp78) as i32);
			let mut fTemp80: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp79) as usize] };
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst15 } else { self.iRec28[1] };
			self.iRec29[0] = if (iTemp3 as i32 != 0) { self.iConst16 } else { self.iRec29[1] };
			let mut iTemp81: i32 = i32::wrapping_sub(self.iRec29[0], self.iRec28[0]);
			let mut fTemp82: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp81)) as F32) / self.fConst14));
			self.iRec31[0] = if (iTemp3 as i32 != 0) { self.iConst19 } else { self.iRec31[1] };
			let mut iTemp83: i32 = i32::wrapping_sub(self.iRec31[0], self.iRec29[0]);
			let mut fTemp84: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp83)) as F32) / self.fConst18));
			let mut fTemp85: F32 = fTemp82 + fTemp84 + 1.0;
			self.fRec30[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp85, self.fRec30[1] + 1.0) };
			let mut iTemp86: i32 = ((self.fRec30[0] < (fTemp82 + 1.0)) as i32);
			let mut fTemp87: F32 = (self.fRec30[0] + (-1.0 - fTemp82)) / fTemp84;
			let mut fTemp88: F32 = ((self.iRec29[0]) as F32);
			let mut fTemp89: F32 = (self.fRec30[0] + -1.0) / fTemp82;
			let mut fTemp90: F32 = ((self.iRec28[0]) as F32);
			let mut fTemp91: F32 = 15.996094 * (0.4 * if (iTemp86 as i32 != 0) { if (((self.fRec30[0] < 1.0) as i32) as i32 != 0) { fTemp90 } else { if (iTemp86 as i32 != 0) { fTemp90 + ((iTemp81) as F32) * if (((self.iRec29[0] > self.iRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp89, 0.33333334) } else { fTemp89 } } else { fTemp88 } } } else { if (((self.fRec30[0] < fTemp85) as i32) as i32 != 0) { fTemp88 + ((iTemp83) as F32) * if (((self.iRec31[0] > self.iRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp87, 0.33333334) } else { fTemp87 } } else { ((self.iRec31[0]) as F32) } } + 128.0);
			let mut iTemp92: i32 = ((fTemp91) as i32);
			let mut fTemp93: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iTemp92) as usize] };
			let mut fTemp94: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow17 * fSlow16 * (fTemp93 + (fTemp91 - ((iTemp92) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iTemp92, 1)) as usize] } - fTemp93)) };
			self.fRec27[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp96: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp95) * (fTemp95 + 28.0);
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4064.0 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4e+03 } else { self.fRec34[1] };
			let mut fTemp97: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp98: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp97) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] } * if (((fTemp97 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp96 } else { self.fRec35[1] };
			let mut fTemp99: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp100: F32 = self.fRec33[0] - fTemp99;
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (fTemp29 * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp99)) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = fTemp101 + fTemp98;
			let mut fTemp103: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp102 + fTemp104;
			self.fRec36[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp105, self.fRec36[1] + 1.0) };
			let mut iTemp106: i32 = ((self.fRec36[0] < fTemp102) as i32);
			let mut fTemp107: F32 = (self.fRec36[0] - fTemp102) / fTemp104;
			let mut iTemp108: i32 = ((self.fRec36[0] < fTemp101) as i32);
			let mut fTemp109: F32 = (self.fRec36[0] - fTemp101) / fTemp98;
			let mut fTemp110: F32 = self.fRec36[0] / fTemp101;
			let mut fTemp111: F32 = if (iTemp106 as i32 != 0) { if (iTemp108 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp99 } else { if (iTemp108 as i32 != 0) { fTemp99 + fTemp100 * if (((self.fRec33[0] > fTemp99) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec33[0] } } } else { if (iTemp106 as i32 != 0) { self.fRec33[0] + fTemp97 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp105) as i32) as i32 != 0) { self.fRec34[0] + fTemp103 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp107, 0.33333334) } else { fTemp107 } } else { self.fRec35[0] } };
			let mut iTemp112: i32 = ((fTemp111) as i32);
			let mut fTemp113: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp112) as usize] };
			let mut fTemp114: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst22 };
			self.fRec37[0] = fTemp114 - F32::floor(fTemp114);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec37[0] + 6.9565215 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp113 + (fTemp111 - ((iTemp112) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp112, 1)) as usize] } - fTemp113));
			let mut fTemp115: F32 = unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * (self.fRec32[0] + 0.115 * (unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp80 + (fTemp78 - ((iTemp79) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp79, 1)) as usize] } - fTemp80)) + unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec22[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec21[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp59 + (fTemp57 - ((iTemp58) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp58, 1)) as usize] } - fTemp59)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp50 + (fTemp48 - ((iTemp49) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp49, 1)) as usize] } - fTemp50)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24));
			self.fVec4[0] = fTemp115;
			self.fRec0[0] = 0.115 * (self.fConst23 * fTemp115 + self.fConst24 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow20 * self.fRec0[0];
			*output1 = fSlow21 * self.fRec0[0];
			*output2 = fSlow22 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.iRec29[1] = self.iRec29[0];
			self.iRec31[1] = self.iRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Tom1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Tom1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.42857143 * (0.33333334 * (fSlow2 + 4.7) + 1.0);
		let mut fSlow4: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.07070707 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow2 + -99.3)))) + 87.0)));
		let mut fSlow5: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow4) * (fSlow4 + 28.0);
		let mut fSlow6: F32 = fSlow5 + 4064.0;
		let mut fSlow7: F32 = fSlow5 + 2848.0;
		let mut fSlow8: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.5050505 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -46.3))) + 76.0)));
		let mut fSlow9: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow8) * (fSlow8 + 28.0);
		let mut fSlow10: F32 = fSlow9 + 4064.0;
		let mut fSlow11: F32 = fSlow9 + 3392.0;
		let mut fSlow12: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow13: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow12, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow14: i32 = ((fSlow13) as i32);
		let mut fSlow15: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iSlow14) as usize] };
		let mut fSlow16: F32 = fSlow15 + (fSlow13 - ((iSlow14) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iSlow14, 1)) as usize] } - fSlow15);
		let mut fSlow17: F32 = self.fConst20 * fSlow12;
		let mut fSlow18: F32 = 0.01 * self.fHslider3;
		let mut fSlow19: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.5));
		let mut fSlow20: F32 = fSlow19 * F32::min(1.0, 1.0 - fSlow18);
		let mut fSlow21: F32 = fSlow19 * F32::min(1.0, fSlow18 + 1.0);
		let mut fSlow22: F32 = 0.01 * self.fHslider5 * fSlow19;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3968.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 60.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 45.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec8[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec8[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec8[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec8[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec8[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec8[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec2[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp16) as i32) as i32 != 0) { self.fRec4[0] + fTemp14 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec7[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp23) as usize] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec11[1] };
			let mut fTemp25: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 72.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec13[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp28: F32 = self.fRec10[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			let mut fTemp32: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp32) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 39.5) as i32)) as usize] } * if (((fTemp32 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp34: F32 = fTemp31 + fTemp33;
			self.fRec14[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec14[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec14[0] < fTemp31) as i32);
			let mut fTemp36: F32 = (self.fRec14[0] - fTemp31) / fTemp33;
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp30) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp30) / fTemp26;
			let mut fTemp39: F32 = self.fRec14[0] / fTemp30;
			let mut fTemp40: F32 = if (iTemp35 as i32 != 0) { if (iTemp37 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp37 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec10[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec10[0] } } } else { if (iTemp35 as i32 != 0) { self.fRec10[0] + fTemp25 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp34) as i32) as i32 != 0) { self.fRec11[0] + fTemp32 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec13[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp41) as usize] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec15[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp44: F32 = self.fRec15[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp45, self.fRec16[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec16[0] < fTemp45) as i32);
			let mut fTemp47: F32 = self.fRec16[0] / fTemp45;
			let mut fTemp48: F32 = if (((self.fRec16[0] < (self.fConst5 + fTemp45)) as i32) as i32 != 0) { if (iTemp46 as i32 != 0) { if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp46 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec15[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp47, 0.33333334) } else { fTemp47 } } else { self.fRec15[0] } } } else { self.fRec15[0] } } else { self.fRec15[0] };
			let mut iTemp49: i32 = ((fTemp48) as i32);
			let mut fTemp50: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp49) as usize] };
			let mut fTemp51: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { 32.0 * F32::min(1.0, 0.05 * fTemp51) * (fTemp51 + 28.0) + 4064.0 } else { self.fRec17[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp29 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp54) as i32);
			let mut fTemp56: F32 = self.fRec18[0] / fTemp54;
			let mut fTemp57: F32 = if (((self.fRec18[0] < (self.fConst5 + fTemp54)) as i32) as i32 != 0) { if (iTemp55 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp55 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { self.fRec17[0] };
			let mut iTemp58: i32 = ((fTemp57) as i32);
			let mut fTemp59: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp58) as usize] };
			let mut iTemp60: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp61: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec19[1] + self.fConst9 };
			self.fRec19[0] = fTemp61 - F32::floor(fTemp61);
			let mut fTemp62: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst11 };
			self.fRec21[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst13 };
			self.fRec22[0] = fTemp63 - F32::floor(fTemp63);
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec23[1] };
			self.fRec24[0] = if (iTemp3 as i32 != 0) { fSlow11 } else { self.fRec24[1] };
			let mut fTemp64: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp65: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp64) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 71.5) as i32)) as usize] } * if (((fTemp64 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec25[1] };
			let mut fTemp66: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp67: F32 = self.fRec23[0] - fTemp66;
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (fTemp29 * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp66)) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = fTemp68 + fTemp65;
			let mut fTemp70: F32 = self.fRec25[0] - self.fRec24[0];
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 8.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec24[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp69 + fTemp71;
			self.fRec26[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp72, self.fRec26[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec26[0] < fTemp69) as i32);
			let mut fTemp74: F32 = (self.fRec26[0] - fTemp69) / fTemp71;
			let mut iTemp75: i32 = ((self.fRec26[0] < fTemp68) as i32);
			let mut fTemp76: F32 = (self.fRec26[0] - fTemp68) / fTemp65;
			let mut fTemp77: F32 = self.fRec26[0] / fTemp68;
			let mut fTemp78: F32 = if (iTemp73 as i32 != 0) { if (iTemp75 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp66 } else { if (iTemp75 as i32 != 0) { fTemp66 + fTemp67 * if (((self.fRec23[0] > fTemp66) as i32) as i32 != 0) { F32::powf(fTemp77, 0.33333334) } else { fTemp77 } } else { self.fRec23[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec23[0] + fTemp64 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec24[0] } } } else { if (((self.fRec26[0] < fTemp72) as i32) as i32 != 0) { self.fRec24[0] + fTemp70 * if (((self.fRec25[0] > self.fRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { self.fRec25[0] } };
			let mut iTemp79: i32 = ((fTemp78) as i32);
			let mut fTemp80: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp79) as usize] };
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst15 } else { self.iRec28[1] };
			self.iRec29[0] = if (iTemp3 as i32 != 0) { self.iConst16 } else { self.iRec29[1] };
			let mut iTemp81: i32 = i32::wrapping_sub(self.iRec29[0], self.iRec28[0]);
			let mut fTemp82: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp81)) as F32) / self.fConst14));
			self.iRec31[0] = if (iTemp3 as i32 != 0) { self.iConst19 } else { self.iRec31[1] };
			let mut iTemp83: i32 = i32::wrapping_sub(self.iRec31[0], self.iRec29[0]);
			let mut fTemp84: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp83)) as F32) / self.fConst18));
			let mut fTemp85: F32 = fTemp82 + fTemp84 + 1.0;
			self.fRec30[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp85, self.fRec30[1] + 1.0) };
			let mut iTemp86: i32 = ((self.fRec30[0] < (fTemp82 + 1.0)) as i32);
			let mut fTemp87: F32 = (self.fRec30[0] + (-1.0 - fTemp82)) / fTemp84;
			let mut fTemp88: F32 = ((self.iRec29[0]) as F32);
			let mut fTemp89: F32 = (self.fRec30[0] + -1.0) / fTemp82;
			let mut fTemp90: F32 = ((self.iRec28[0]) as F32);
			let mut fTemp91: F32 = 15.996094 * (0.4 * if (iTemp86 as i32 != 0) { if (((self.fRec30[0] < 1.0) as i32) as i32 != 0) { fTemp90 } else { if (iTemp86 as i32 != 0) { fTemp90 + ((iTemp81) as F32) * if (((self.iRec29[0] > self.iRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp89, 0.33333334) } else { fTemp89 } } else { fTemp88 } } } else { if (((self.fRec30[0] < fTemp85) as i32) as i32 != 0) { fTemp88 + ((iTemp83) as F32) * if (((self.iRec31[0] > self.iRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp87, 0.33333334) } else { fTemp87 } } else { ((self.iRec31[0]) as F32) } } + 128.0);
			let mut iTemp92: i32 = ((fTemp91) as i32);
			let mut fTemp93: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iTemp92) as usize] };
			let mut fTemp94: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow17 * fSlow16 * (fTemp93 + (fTemp91 - ((iTemp92) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iTemp92, 1)) as usize] } - fTemp93)) };
			self.fRec27[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp96: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp95) * (fTemp95 + 28.0);
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4064.0 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4e+03 } else { self.fRec34[1] };
			let mut fTemp97: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp98: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp97) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] } * if (((fTemp97 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp96 } else { self.fRec35[1] };
			let mut fTemp99: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp100: F32 = self.fRec33[0] - fTemp99;
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (fTemp29 * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp99)) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = fTemp101 + fTemp98;
			let mut fTemp103: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp102 + fTemp104;
			self.fRec36[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp105, self.fRec36[1] + 1.0) };
			let mut iTemp106: i32 = ((self.fRec36[0] < fTemp102) as i32);
			let mut fTemp107: F32 = (self.fRec36[0] - fTemp102) / fTemp104;
			let mut iTemp108: i32 = ((self.fRec36[0] < fTemp101) as i32);
			let mut fTemp109: F32 = (self.fRec36[0] - fTemp101) / fTemp98;
			let mut fTemp110: F32 = self.fRec36[0] / fTemp101;
			let mut fTemp111: F32 = if (iTemp106 as i32 != 0) { if (iTemp108 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp99 } else { if (iTemp108 as i32 != 0) { fTemp99 + fTemp100 * if (((self.fRec33[0] > fTemp99) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec33[0] } } } else { if (iTemp106 as i32 != 0) { self.fRec33[0] + fTemp97 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp105) as i32) as i32 != 0) { self.fRec34[0] + fTemp103 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp107, 0.33333334) } else { fTemp107 } } else { self.fRec35[0] } };
			let mut iTemp112: i32 = ((fTemp111) as i32);
			let mut fTemp113: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp112) as usize] };
			let mut fTemp114: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst22 };
			self.fRec37[0] = fTemp114 - F32::floor(fTemp114);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec37[0] + 6.9565215 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp113 + (fTemp111 - ((iTemp112) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp112, 1)) as usize] } - fTemp113));
			let mut fTemp115: F32 = unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * (self.fRec32[0] + 0.115 * (unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp80 + (fTemp78 - ((iTemp79) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp79, 1)) as usize] } - fTemp80)) + unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec22[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec21[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp59 + (fTemp57 - ((iTemp58) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp58, 1)) as usize] } - fTemp59)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp50 + (fTemp48 - ((iTemp49) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp49, 1)) as usize] } - fTemp50)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24));
			self.fVec4[0] = fTemp115;
			self.fRec0[0] = 0.115 * (self.fConst23 * fTemp115 + self.fConst24 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow20 * self.fRec0[0];
			*output1 = fSlow21 * self.fRec0[0];
			*output2 = fSlow22 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.iRec29[1] = self.iRec29[0];
			self.iRec31[1] = self.iRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Tom1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.42857143 * (0.33333334 * (fSlow2 + 4.7) + 1.0);
		let mut fSlow4: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.07070707 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow2 + -99.3)))) + 87.0)));
		let mut fSlow5: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow4) * (fSlow4 + 28.0);
		let mut fSlow6: F32 = fSlow5 + 4064.0;
		let mut fSlow7: F32 = fSlow5 + 2848.0;
		let mut fSlow8: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.5050505 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -46.3))) + 76.0)));
		let mut fSlow9: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow8) * (fSlow8 + 28.0);
		let mut fSlow10: F32 = fSlow9 + 4064.0;
		let mut fSlow11: F32 = fSlow9 + 3392.0;
		let mut fSlow12: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow13: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow12, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow14: i32 = ((fSlow13) as i32);
		let mut fSlow15: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iSlow14) as usize] };
		let mut fSlow16: F32 = fSlow15 + (fSlow13 - ((iSlow14) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iSlow14, 1)) as usize] } - fSlow15);
		let mut fSlow17: F32 = self.fConst20 * fSlow12;
		let mut fSlow18: F32 = 0.01 * self.fHslider3;
		let mut fSlow19: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.5));
		let mut fSlow20: F32 = fSlow19 * F32::min(1.0, 1.0 - fSlow18);
		let mut fSlow21: F32 = fSlow19 * F32::min(1.0, fSlow18 + 1.0);
		let mut fSlow22: F32 = 0.01 * self.fHslider5 * fSlow19;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3968.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 60.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 45.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec8[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec8[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec8[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec8[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec8[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec8[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec2[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp16) as i32) as i32 != 0) { self.fRec4[0] + fTemp14 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec7[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp23) as usize] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec11[1] };
			let mut fTemp25: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 72.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec13[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp28: F32 = self.fRec10[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			let mut fTemp32: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp32) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 39.5) as i32)) as usize] } * if (((fTemp32 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp34: F32 = fTemp31 + fTemp33;
			self.fRec14[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec14[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec14[0] < fTemp31) as i32);
			let mut fTemp36: F32 = (self.fRec14[0] - fTemp31) / fTemp33;
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp30) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp30) / fTemp26;
			let mut fTemp39: F32 = self.fRec14[0] / fTemp30;
			let mut fTemp40: F32 = if (iTemp35 as i32 != 0) { if (iTemp37 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp37 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec10[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec10[0] } } } else { if (iTemp35 as i32 != 0) { self.fRec10[0] + fTemp25 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp34) as i32) as i32 != 0) { self.fRec11[0] + fTemp32 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec13[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp41) as usize] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec15[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp44: F32 = self.fRec15[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp45, self.fRec16[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec16[0] < fTemp45) as i32);
			let mut fTemp47: F32 = self.fRec16[0] / fTemp45;
			let mut fTemp48: F32 = if (((self.fRec16[0] < (self.fConst5 + fTemp45)) as i32) as i32 != 0) { if (iTemp46 as i32 != 0) { if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp46 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec15[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp47, 0.33333334) } else { fTemp47 } } else { self.fRec15[0] } } } else { self.fRec15[0] } } else { self.fRec15[0] };
			let mut iTemp49: i32 = ((fTemp48) as i32);
			let mut fTemp50: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp49) as usize] };
			let mut fTemp51: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { 32.0 * F32::min(1.0, 0.05 * fTemp51) * (fTemp51 + 28.0) + 4064.0 } else { self.fRec17[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp29 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp54) as i32);
			let mut fTemp56: F32 = self.fRec18[0] / fTemp54;
			let mut fTemp57: F32 = if (((self.fRec18[0] < (self.fConst5 + fTemp54)) as i32) as i32 != 0) { if (iTemp55 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp55 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { self.fRec17[0] };
			let mut iTemp58: i32 = ((fTemp57) as i32);
			let mut fTemp59: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp58) as usize] };
			let mut iTemp60: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp61: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec19[1] + self.fConst9 };
			self.fRec19[0] = fTemp61 - F32::floor(fTemp61);
			let mut fTemp62: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst11 };
			self.fRec21[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst13 };
			self.fRec22[0] = fTemp63 - F32::floor(fTemp63);
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec23[1] };
			self.fRec24[0] = if (iTemp3 as i32 != 0) { fSlow11 } else { self.fRec24[1] };
			let mut fTemp64: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp65: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp64) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 71.5) as i32)) as usize] } * if (((fTemp64 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec25[1] };
			let mut fTemp66: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp67: F32 = self.fRec23[0] - fTemp66;
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (fTemp29 * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp66)) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = fTemp68 + fTemp65;
			let mut fTemp70: F32 = self.fRec25[0] - self.fRec24[0];
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 8.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec24[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp69 + fTemp71;
			self.fRec26[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp72, self.fRec26[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec26[0] < fTemp69) as i32);
			let mut fTemp74: F32 = (self.fRec26[0] - fTemp69) / fTemp71;
			let mut iTemp75: i32 = ((self.fRec26[0] < fTemp68) as i32);
			let mut fTemp76: F32 = (self.fRec26[0] - fTemp68) / fTemp65;
			let mut fTemp77: F32 = self.fRec26[0] / fTemp68;
			let mut fTemp78: F32 = if (iTemp73 as i32 != 0) { if (iTemp75 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp66 } else { if (iTemp75 as i32 != 0) { fTemp66 + fTemp67 * if (((self.fRec23[0] > fTemp66) as i32) as i32 != 0) { F32::powf(fTemp77, 0.33333334) } else { fTemp77 } } else { self.fRec23[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec23[0] + fTemp64 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec24[0] } } } else { if (((self.fRec26[0] < fTemp72) as i32) as i32 != 0) { self.fRec24[0] + fTemp70 * if (((self.fRec25[0] > self.fRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { self.fRec25[0] } };
			let mut iTemp79: i32 = ((fTemp78) as i32);
			let mut fTemp80: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp79) as usize] };
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst15 } else { self.iRec28[1] };
			self.iRec29[0] = if (iTemp3 as i32 != 0) { self.iConst16 } else { self.iRec29[1] };
			let mut iTemp81: i32 = i32::wrapping_sub(self.iRec29[0], self.iRec28[0]);
			let mut fTemp82: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp81)) as F32) / self.fConst14));
			self.iRec31[0] = if (iTemp3 as i32 != 0) { self.iConst19 } else { self.iRec31[1] };
			let mut iTemp83: i32 = i32::wrapping_sub(self.iRec31[0], self.iRec29[0]);
			let mut fTemp84: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp83)) as F32) / self.fConst18));
			let mut fTemp85: F32 = fTemp82 + fTemp84 + 1.0;
			self.fRec30[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp85, self.fRec30[1] + 1.0) };
			let mut iTemp86: i32 = ((self.fRec30[0] < (fTemp82 + 1.0)) as i32);
			let mut fTemp87: F32 = (self.fRec30[0] + (-1.0 - fTemp82)) / fTemp84;
			let mut fTemp88: F32 = ((self.iRec29[0]) as F32);
			let mut fTemp89: F32 = (self.fRec30[0] + -1.0) / fTemp82;
			let mut fTemp90: F32 = ((self.iRec28[0]) as F32);
			let mut fTemp91: F32 = 15.996094 * (0.4 * if (iTemp86 as i32 != 0) { if (((self.fRec30[0] < 1.0) as i32) as i32 != 0) { fTemp90 } else { if (iTemp86 as i32 != 0) { fTemp90 + ((iTemp81) as F32) * if (((self.iRec29[0] > self.iRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp89, 0.33333334) } else { fTemp89 } } else { fTemp88 } } } else { if (((self.fRec30[0] < fTemp85) as i32) as i32 != 0) { fTemp88 + ((iTemp83) as F32) * if (((self.iRec31[0] > self.iRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp87, 0.33333334) } else { fTemp87 } } else { ((self.iRec31[0]) as F32) } } + 128.0);
			let mut iTemp92: i32 = ((fTemp91) as i32);
			let mut fTemp93: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iTemp92) as usize] };
			let mut fTemp94: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow17 * fSlow16 * (fTemp93 + (fTemp91 - ((iTemp92) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iTemp92, 1)) as usize] } - fTemp93)) };
			self.fRec27[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp96: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp95) * (fTemp95 + 28.0);
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4064.0 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4e+03 } else { self.fRec34[1] };
			let mut fTemp97: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp98: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp97) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] } * if (((fTemp97 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp96 } else { self.fRec35[1] };
			let mut fTemp99: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp100: F32 = self.fRec33[0] - fTemp99;
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (fTemp29 * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp99)) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = fTemp101 + fTemp98;
			let mut fTemp103: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp102 + fTemp104;
			self.fRec36[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp105, self.fRec36[1] + 1.0) };
			let mut iTemp106: i32 = ((self.fRec36[0] < fTemp102) as i32);
			let mut fTemp107: F32 = (self.fRec36[0] - fTemp102) / fTemp104;
			let mut iTemp108: i32 = ((self.fRec36[0] < fTemp101) as i32);
			let mut fTemp109: F32 = (self.fRec36[0] - fTemp101) / fTemp98;
			let mut fTemp110: F32 = self.fRec36[0] / fTemp101;
			let mut fTemp111: F32 = if (iTemp106 as i32 != 0) { if (iTemp108 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp99 } else { if (iTemp108 as i32 != 0) { fTemp99 + fTemp100 * if (((self.fRec33[0] > fTemp99) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec33[0] } } } else { if (iTemp106 as i32 != 0) { self.fRec33[0] + fTemp97 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp105) as i32) as i32 != 0) { self.fRec34[0] + fTemp103 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp107, 0.33333334) } else { fTemp107 } } else { self.fRec35[0] } };
			let mut iTemp112: i32 = ((fTemp111) as i32);
			let mut fTemp113: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp112) as usize] };
			let mut fTemp114: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst22 };
			self.fRec37[0] = fTemp114 - F32::floor(fTemp114);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec37[0] + 6.9565215 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp113 + (fTemp111 - ((iTemp112) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp112, 1)) as usize] } - fTemp113));
			let mut fTemp115: F32 = unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * (self.fRec32[0] + 0.115 * (unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp80 + (fTemp78 - ((iTemp79) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp79, 1)) as usize] } - fTemp80)) + unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec22[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec21[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp59 + (fTemp57 - ((iTemp58) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp58, 1)) as usize] } - fTemp59)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp50 + (fTemp48 - ((iTemp49) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp49, 1)) as usize] } - fTemp50)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24));
			self.fVec4[0] = fTemp115;
			self.fRec0[0] = 0.115 * (self.fConst23 * fTemp115 + self.fConst24 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow20 * self.fRec0[0];
			*output1 = fSlow21 * self.fRec0[0];
			*output2 = fSlow22 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.iRec29[1] = self.iRec29[0];
			self.iRec31[1] = self.iRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Tom1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.42857143 * (0.33333334 * (fSlow2 + 4.7) + 1.0);
		let mut fSlow4: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.07070707 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow2 + -99.3)))) + 87.0)));
		let mut fSlow5: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow4) * (fSlow4 + 28.0);
		let mut fSlow6: F32 = fSlow5 + 4064.0;
		let mut fSlow7: F32 = fSlow5 + 2848.0;
		let mut fSlow8: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.5050505 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -46.3))) + 76.0)));
		let mut fSlow9: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow8) * (fSlow8 + 28.0);
		let mut fSlow10: F32 = fSlow9 + 4064.0;
		let mut fSlow11: F32 = fSlow9 + 3392.0;
		let mut fSlow12: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow13: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow12, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow14: i32 = ((fSlow13) as i32);
		let mut fSlow15: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iSlow14) as usize] };
		let mut fSlow16: F32 = fSlow15 + (fSlow13 - ((iSlow14) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iSlow14, 1)) as usize] } - fSlow15);
		let mut fSlow17: F32 = self.fConst20 * fSlow12;
		let mut fSlow18: F32 = 0.01 * self.fHslider3;
		let mut fSlow19: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.5));
		let mut fSlow20: F32 = fSlow19 * F32::min(1.0, 1.0 - fSlow18);
		let mut fSlow21: F32 = fSlow19 * F32::min(1.0, fSlow18 + 1.0);
		let mut fSlow22: F32 = 0.01 * self.fHslider5 * fSlow19;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3968.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 60.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 45.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec8[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec8[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec8[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec8[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec8[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec8[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec2[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp16) as i32) as i32 != 0) { self.fRec4[0] + fTemp14 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec7[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp23) as usize] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec11[1] };
			let mut fTemp25: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 72.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec13[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp28: F32 = self.fRec10[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			let mut fTemp32: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp32) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 39.5) as i32)) as usize] } * if (((fTemp32 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp34: F32 = fTemp31 + fTemp33;
			self.fRec14[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec14[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec14[0] < fTemp31) as i32);
			let mut fTemp36: F32 = (self.fRec14[0] - fTemp31) / fTemp33;
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp30) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp30) / fTemp26;
			let mut fTemp39: F32 = self.fRec14[0] / fTemp30;
			let mut fTemp40: F32 = if (iTemp35 as i32 != 0) { if (iTemp37 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp37 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec10[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec10[0] } } } else { if (iTemp35 as i32 != 0) { self.fRec10[0] + fTemp25 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp34) as i32) as i32 != 0) { self.fRec11[0] + fTemp32 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec13[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp41) as usize] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec15[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp44: F32 = self.fRec15[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp45, self.fRec16[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec16[0] < fTemp45) as i32);
			let mut fTemp47: F32 = self.fRec16[0] / fTemp45;
			let mut fTemp48: F32 = if (((self.fRec16[0] < (self.fConst5 + fTemp45)) as i32) as i32 != 0) { if (iTemp46 as i32 != 0) { if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp46 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec15[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp47, 0.33333334) } else { fTemp47 } } else { self.fRec15[0] } } } else { self.fRec15[0] } } else { self.fRec15[0] };
			let mut iTemp49: i32 = ((fTemp48) as i32);
			let mut fTemp50: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp49) as usize] };
			let mut fTemp51: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { 32.0 * F32::min(1.0, 0.05 * fTemp51) * (fTemp51 + 28.0) + 4064.0 } else { self.fRec17[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp29 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp54) as i32);
			let mut fTemp56: F32 = self.fRec18[0] / fTemp54;
			let mut fTemp57: F32 = if (((self.fRec18[0] < (self.fConst5 + fTemp54)) as i32) as i32 != 0) { if (iTemp55 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp55 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { self.fRec17[0] };
			let mut iTemp58: i32 = ((fTemp57) as i32);
			let mut fTemp59: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp58) as usize] };
			let mut iTemp60: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp61: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec19[1] + self.fConst9 };
			self.fRec19[0] = fTemp61 - F32::floor(fTemp61);
			let mut fTemp62: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst11 };
			self.fRec21[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst13 };
			self.fRec22[0] = fTemp63 - F32::floor(fTemp63);
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec23[1] };
			self.fRec24[0] = if (iTemp3 as i32 != 0) { fSlow11 } else { self.fRec24[1] };
			let mut fTemp64: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp65: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp64) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 71.5) as i32)) as usize] } * if (((fTemp64 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec25[1] };
			let mut fTemp66: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp67: F32 = self.fRec23[0] - fTemp66;
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (fTemp29 * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp66)) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = fTemp68 + fTemp65;
			let mut fTemp70: F32 = self.fRec25[0] - self.fRec24[0];
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 8.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec24[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp69 + fTemp71;
			self.fRec26[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp72, self.fRec26[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec26[0] < fTemp69) as i32);
			let mut fTemp74: F32 = (self.fRec26[0] - fTemp69) / fTemp71;
			let mut iTemp75: i32 = ((self.fRec26[0] < fTemp68) as i32);
			let mut fTemp76: F32 = (self.fRec26[0] - fTemp68) / fTemp65;
			let mut fTemp77: F32 = self.fRec26[0] / fTemp68;
			let mut fTemp78: F32 = if (iTemp73 as i32 != 0) { if (iTemp75 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp66 } else { if (iTemp75 as i32 != 0) { fTemp66 + fTemp67 * if (((self.fRec23[0] > fTemp66) as i32) as i32 != 0) { F32::powf(fTemp77, 0.33333334) } else { fTemp77 } } else { self.fRec23[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec23[0] + fTemp64 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec24[0] } } } else { if (((self.fRec26[0] < fTemp72) as i32) as i32 != 0) { self.fRec24[0] + fTemp70 * if (((self.fRec25[0] > self.fRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { self.fRec25[0] } };
			let mut iTemp79: i32 = ((fTemp78) as i32);
			let mut fTemp80: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp79) as usize] };
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst15 } else { self.iRec28[1] };
			self.iRec29[0] = if (iTemp3 as i32 != 0) { self.iConst16 } else { self.iRec29[1] };
			let mut iTemp81: i32 = i32::wrapping_sub(self.iRec29[0], self.iRec28[0]);
			let mut fTemp82: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp81)) as F32) / self.fConst14));
			self.iRec31[0] = if (iTemp3 as i32 != 0) { self.iConst19 } else { self.iRec31[1] };
			let mut iTemp83: i32 = i32::wrapping_sub(self.iRec31[0], self.iRec29[0]);
			let mut fTemp84: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp83)) as F32) / self.fConst18));
			let mut fTemp85: F32 = fTemp82 + fTemp84 + 1.0;
			self.fRec30[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp85, self.fRec30[1] + 1.0) };
			let mut iTemp86: i32 = ((self.fRec30[0] < (fTemp82 + 1.0)) as i32);
			let mut fTemp87: F32 = (self.fRec30[0] + (-1.0 - fTemp82)) / fTemp84;
			let mut fTemp88: F32 = ((self.iRec29[0]) as F32);
			let mut fTemp89: F32 = (self.fRec30[0] + -1.0) / fTemp82;
			let mut fTemp90: F32 = ((self.iRec28[0]) as F32);
			let mut fTemp91: F32 = 15.996094 * (0.4 * if (iTemp86 as i32 != 0) { if (((self.fRec30[0] < 1.0) as i32) as i32 != 0) { fTemp90 } else { if (iTemp86 as i32 != 0) { fTemp90 + ((iTemp81) as F32) * if (((self.iRec29[0] > self.iRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp89, 0.33333334) } else { fTemp89 } } else { fTemp88 } } } else { if (((self.fRec30[0] < fTemp85) as i32) as i32 != 0) { fTemp88 + ((iTemp83) as F32) * if (((self.iRec31[0] > self.iRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp87, 0.33333334) } else { fTemp87 } } else { ((self.iRec31[0]) as F32) } } + 128.0);
			let mut iTemp92: i32 = ((fTemp91) as i32);
			let mut fTemp93: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iTemp92) as usize] };
			let mut fTemp94: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow17 * fSlow16 * (fTemp93 + (fTemp91 - ((iTemp92) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iTemp92, 1)) as usize] } - fTemp93)) };
			self.fRec27[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp96: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp95) * (fTemp95 + 28.0);
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4064.0 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4e+03 } else { self.fRec34[1] };
			let mut fTemp97: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp98: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp97) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] } * if (((fTemp97 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp96 } else { self.fRec35[1] };
			let mut fTemp99: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp100: F32 = self.fRec33[0] - fTemp99;
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (fTemp29 * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp99)) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = fTemp101 + fTemp98;
			let mut fTemp103: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp102 + fTemp104;
			self.fRec36[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp105, self.fRec36[1] + 1.0) };
			let mut iTemp106: i32 = ((self.fRec36[0] < fTemp102) as i32);
			let mut fTemp107: F32 = (self.fRec36[0] - fTemp102) / fTemp104;
			let mut iTemp108: i32 = ((self.fRec36[0] < fTemp101) as i32);
			let mut fTemp109: F32 = (self.fRec36[0] - fTemp101) / fTemp98;
			let mut fTemp110: F32 = self.fRec36[0] / fTemp101;
			let mut fTemp111: F32 = if (iTemp106 as i32 != 0) { if (iTemp108 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp99 } else { if (iTemp108 as i32 != 0) { fTemp99 + fTemp100 * if (((self.fRec33[0] > fTemp99) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec33[0] } } } else { if (iTemp106 as i32 != 0) { self.fRec33[0] + fTemp97 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp105) as i32) as i32 != 0) { self.fRec34[0] + fTemp103 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp107, 0.33333334) } else { fTemp107 } } else { self.fRec35[0] } };
			let mut iTemp112: i32 = ((fTemp111) as i32);
			let mut fTemp113: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp112) as usize] };
			let mut fTemp114: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst22 };
			self.fRec37[0] = fTemp114 - F32::floor(fTemp114);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec37[0] + 6.9565215 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp113 + (fTemp111 - ((iTemp112) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp112, 1)) as usize] } - fTemp113));
			let mut fTemp115: F32 = unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * (self.fRec32[0] + 0.115 * (unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp80 + (fTemp78 - ((iTemp79) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp79, 1)) as usize] } - fTemp80)) + unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec22[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec21[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp59 + (fTemp57 - ((iTemp58) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp58, 1)) as usize] } - fTemp59)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp50 + (fTemp48 - ((iTemp49) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp49, 1)) as usize] } - fTemp50)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24));
			self.fVec4[0] = fTemp115;
			self.fRec0[0] = 0.115 * (self.fConst23 * fTemp115 + self.fConst24 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow20 * self.fRec0[0];
			*output1 = fSlow21 * self.fRec0[0];
			*output2 = fSlow22 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.iRec29[1] = self.iRec29[0];
			self.iRec31[1] = self.iRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom1 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Tom1 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom1 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.42857143 * (0.33333334 * (fSlow2 + 4.7) + 1.0);
		let mut fSlow4: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.07070707 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow2 + -99.3)))) + 87.0)));
		let mut fSlow5: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow4) * (fSlow4 + 28.0);
		let mut fSlow6: F32 = fSlow5 + 4064.0;
		let mut fSlow7: F32 = fSlow5 + 2848.0;
		let mut fSlow8: F32 = F32::max(0.0, F32::min(127.0, F32::min(99.0, 0.5050505 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow2 + -46.3))) + 76.0)));
		let mut fSlow9: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow8) * (fSlow8 + 28.0);
		let mut fSlow10: F32 = fSlow9 + 4064.0;
		let mut fSlow11: F32 = fSlow9 + 3392.0;
		let mut fSlow12: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow13: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow12, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow14: i32 = ((fSlow13) as i32);
		let mut fSlow15: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iSlow14) as usize] };
		let mut fSlow16: F32 = fSlow15 + (fSlow13 - ((iSlow14) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iSlow14, 1)) as usize] } - fSlow15);
		let mut fSlow17: F32 = self.fConst20 * fSlow12;
		let mut fSlow18: F32 = 0.01 * self.fHslider3;
		let mut fSlow19: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 3.5));
		let mut fSlow20: F32 = fSlow19 * F32::min(1.0, 1.0 - fSlow18);
		let mut fSlow21: F32 = fSlow19 * F32::min(1.0, fSlow18 + 1.0);
		let mut fSlow22: F32 = 0.01 * self.fHslider5 * fSlow19;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom1_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3968.0 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow3 } else { self.fRec6[1] };
			let mut fTemp8: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 60.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp9: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp10: F32 = self.fRec2[0] - fTemp9;
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp10) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 99.5) as i32)) as usize] } * if (((fTemp10 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp9)) + 2.0) } else { 0.96 }))));
			let mut fTemp12: F32 = fTemp11 + fTemp8;
			let mut iTemp13: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp14: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp15: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp14) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec6[0] + 45.5) as i32)) as usize] } * if (((fTemp14 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp16: F32 = fTemp12 + fTemp15;
			self.fRec8[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp16, self.fRec8[1] + 1.0) };
			let mut iTemp17: i32 = ((self.fRec8[0] < fTemp12) as i32);
			let mut fTemp18: F32 = (self.fRec8[0] - fTemp12) / fTemp15;
			let mut iTemp19: i32 = ((self.fRec8[0] < fTemp11) as i32);
			let mut fTemp20: F32 = (self.fRec8[0] - fTemp11) / fTemp8;
			let mut fTemp21: F32 = self.fRec8[0] / fTemp11;
			let mut fTemp22: F32 = if (iTemp17 as i32 != 0) { if (iTemp19 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp9 } else { if (iTemp19 as i32 != 0) { fTemp9 + fTemp10 * if (((self.fRec2[0] > fTemp9) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec2[0] } } } else { if (iTemp17 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp20, 0.33333334) } else { fTemp20 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp16) as i32) as i32 != 0) { self.fRec4[0] + fTemp14 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec7[0] } };
			let mut iTemp23: i32 = ((fTemp22) as i32);
			let mut fTemp24: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp23) as usize] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec11[1] };
			let mut fTemp25: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 72.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec13[1] };
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp28: F32 = self.fRec10[0] - fTemp27;
			let mut fTemp29: F32 = unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp30: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp29 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp31: F32 = fTemp30 + fTemp26;
			let mut fTemp32: F32 = self.fRec13[0] - self.fRec11[0];
			let mut fTemp33: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp32) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 39.5) as i32)) as usize] } * if (((fTemp32 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec11[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp34: F32 = fTemp31 + fTemp33;
			self.fRec14[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp34, self.fRec14[1] + 1.0) };
			let mut iTemp35: i32 = ((self.fRec14[0] < fTemp31) as i32);
			let mut fTemp36: F32 = (self.fRec14[0] - fTemp31) / fTemp33;
			let mut iTemp37: i32 = ((self.fRec14[0] < fTemp30) as i32);
			let mut fTemp38: F32 = (self.fRec14[0] - fTemp30) / fTemp26;
			let mut fTemp39: F32 = self.fRec14[0] / fTemp30;
			let mut fTemp40: F32 = if (iTemp35 as i32 != 0) { if (iTemp37 as i32 != 0) { if (((self.fRec14[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp37 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec10[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec10[0] } } } else { if (iTemp35 as i32 != 0) { self.fRec10[0] + fTemp25 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp38, 0.33333334) } else { fTemp38 } } else { self.fRec11[0] } } } else { if (((self.fRec14[0] < fTemp34) as i32) as i32 != 0) { self.fRec11[0] + fTemp32 * if (((self.fRec13[0] > self.fRec11[0]) as i32) as i32 != 0) { F32::powf(fTemp36, 0.33333334) } else { fTemp36 } } else { self.fRec13[0] } };
			let mut iTemp41: i32 = ((fTemp40) as i32);
			let mut fTemp42: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp41) as usize] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { 8128.0 } else { self.fRec15[1] };
			let mut fTemp43: F32 = F32::max(5076.0, self.fRec15[0]);
			let mut fTemp44: F32 = self.fRec15[0] - fTemp43;
			let mut fTemp45: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp44) / (fTemp29 * if (((fTemp44 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp43)) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp45, self.fRec16[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec16[0] < fTemp45) as i32);
			let mut fTemp47: F32 = self.fRec16[0] / fTemp45;
			let mut fTemp48: F32 = if (((self.fRec16[0] < (self.fConst5 + fTemp45)) as i32) as i32 != 0) { if (iTemp46 as i32 != 0) { if (((self.fRec16[0] < 0.0) as i32) as i32 != 0) { fTemp43 } else { if (iTemp46 as i32 != 0) { fTemp43 + fTemp44 * if (((self.fRec15[0] > fTemp43) as i32) as i32 != 0) { F32::powf(fTemp47, 0.33333334) } else { fTemp47 } } else { self.fRec15[0] } } } else { self.fRec15[0] } } else { self.fRec15[0] };
			let mut iTemp49: i32 = ((fTemp48) as i32);
			let mut fTemp50: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp49) as usize] };
			let mut fTemp51: F32 = F32::max(0.0, F32::min(127.0, 0.42857143 * fTemp4 + 99.0));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { 32.0 * F32::min(1.0, 0.05 * fTemp51) * (fTemp51 + 28.0) + 4064.0 } else { self.fRec17[1] };
			let mut fTemp52: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp53: F32 = self.fRec17[0] - fTemp52;
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (fTemp29 * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp52)) + 2.0) } else { 0.96 }))));
			self.fRec18[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(self.fConst6 + fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp54) as i32);
			let mut fTemp56: F32 = self.fRec18[0] / fTemp54;
			let mut fTemp57: F32 = if (((self.fRec18[0] < (self.fConst5 + fTemp54)) as i32) as i32 != 0) { if (iTemp55 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp52 } else { if (iTemp55 as i32 != 0) { fTemp52 + fTemp53 * if (((self.fRec17[0] > fTemp52) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } } } else { self.fRec17[0] } } else { self.fRec17[0] };
			let mut iTemp58: i32 = ((fTemp57) as i32);
			let mut fTemp59: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp58) as usize] };
			let mut iTemp60: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp61: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec19[1] + self.fConst9 };
			self.fRec19[0] = fTemp61 - F32::floor(fTemp61);
			let mut fTemp62: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec21[1] + self.fConst11 };
			self.fRec21[0] = fTemp62 - F32::floor(fTemp62);
			let mut fTemp63: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec22[1] + self.fConst13 };
			self.fRec22[0] = fTemp63 - F32::floor(fTemp63);
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec23[1] };
			self.fRec24[0] = if (iTemp3 as i32 != 0) { fSlow11 } else { self.fRec24[1] };
			let mut fTemp64: F32 = self.fRec24[0] - self.fRec23[0];
			let mut fTemp65: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp64) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 71.5) as i32)) as usize] } * if (((fTemp64 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec23[0])) + 2.0) } else { 0.96 }))));
			self.fRec25[0] = if (iTemp3 as i32 != 0) { fSlow9 } else { self.fRec25[1] };
			let mut fTemp66: F32 = F32::max(5076.0, self.fRec25[0]);
			let mut fTemp67: F32 = self.fRec23[0] - fTemp66;
			let mut fTemp68: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp67) / (fTemp29 * if (((fTemp67 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp66)) + 2.0) } else { 0.96 }))));
			let mut fTemp69: F32 = fTemp68 + fTemp65;
			let mut fTemp70: F32 = self.fRec25[0] - self.fRec24[0];
			let mut fTemp71: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp70) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 8.5) as i32)) as usize] } * if (((fTemp70 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec24[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp72: F32 = fTemp69 + fTemp71;
			self.fRec26[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp72, self.fRec26[1] + 1.0) };
			let mut iTemp73: i32 = ((self.fRec26[0] < fTemp69) as i32);
			let mut fTemp74: F32 = (self.fRec26[0] - fTemp69) / fTemp71;
			let mut iTemp75: i32 = ((self.fRec26[0] < fTemp68) as i32);
			let mut fTemp76: F32 = (self.fRec26[0] - fTemp68) / fTemp65;
			let mut fTemp77: F32 = self.fRec26[0] / fTemp68;
			let mut fTemp78: F32 = if (iTemp73 as i32 != 0) { if (iTemp75 as i32 != 0) { if (((self.fRec26[0] < 0.0) as i32) as i32 != 0) { fTemp66 } else { if (iTemp75 as i32 != 0) { fTemp66 + fTemp67 * if (((self.fRec23[0] > fTemp66) as i32) as i32 != 0) { F32::powf(fTemp77, 0.33333334) } else { fTemp77 } } else { self.fRec23[0] } } } else { if (iTemp73 as i32 != 0) { self.fRec23[0] + fTemp64 * if (((self.fRec24[0] > self.fRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp76, 0.33333334) } else { fTemp76 } } else { self.fRec24[0] } } } else { if (((self.fRec26[0] < fTemp72) as i32) as i32 != 0) { self.fRec24[0] + fTemp70 * if (((self.fRec25[0] > self.fRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { self.fRec25[0] } };
			let mut iTemp79: i32 = ((fTemp78) as i32);
			let mut fTemp80: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp79) as usize] };
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst15 } else { self.iRec28[1] };
			self.iRec29[0] = if (iTemp3 as i32 != 0) { self.iConst16 } else { self.iRec29[1] };
			let mut iTemp81: i32 = i32::wrapping_sub(self.iRec29[0], self.iRec28[0]);
			let mut fTemp82: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp81)) as F32) / self.fConst14));
			self.iRec31[0] = if (iTemp3 as i32 != 0) { self.iConst19 } else { self.iRec31[1] };
			let mut iTemp83: i32 = i32::wrapping_sub(self.iRec31[0], self.iRec29[0]);
			let mut fTemp84: F32 = F32::max(1.0, self.fConst17 * (((i32::abs(iTemp83)) as F32) / self.fConst18));
			let mut fTemp85: F32 = fTemp82 + fTemp84 + 1.0;
			self.fRec30[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp85, self.fRec30[1] + 1.0) };
			let mut iTemp86: i32 = ((self.fRec30[0] < (fTemp82 + 1.0)) as i32);
			let mut fTemp87: F32 = (self.fRec30[0] + (-1.0 - fTemp82)) / fTemp84;
			let mut fTemp88: F32 = ((self.iRec29[0]) as F32);
			let mut fTemp89: F32 = (self.fRec30[0] + -1.0) / fTemp82;
			let mut fTemp90: F32 = ((self.iRec28[0]) as F32);
			let mut fTemp91: F32 = 15.996094 * (0.4 * if (iTemp86 as i32 != 0) { if (((self.fRec30[0] < 1.0) as i32) as i32 != 0) { fTemp90 } else { if (iTemp86 as i32 != 0) { fTemp90 + ((iTemp81) as F32) * if (((self.iRec29[0] > self.iRec28[0]) as i32) as i32 != 0) { F32::powf(fTemp89, 0.33333334) } else { fTemp89 } } else { fTemp88 } } } else { if (((self.fRec30[0] < fTemp85) as i32) as i32 != 0) { fTemp88 + ((iTemp83) as F32) * if (((self.iRec31[0] > self.iRec29[0]) as i32) as i32 != 0) { F32::powf(fTemp87, 0.33333334) } else { fTemp87 } } else { ((self.iRec31[0]) as F32) } } + 128.0);
			let mut iTemp92: i32 = ((fTemp91) as i32);
			let mut fTemp93: F32 = unsafe { ftbl3DSP_Tom1SIG3[(iTemp92) as usize] };
			let mut fTemp94: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow17 * fSlow16 * (fTemp93 + (fTemp91 - ((iTemp92) as F32)) * (unsafe { ftbl3DSP_Tom1SIG3[(i32::wrapping_add(iTemp92, 1)) as usize] } - fTemp93)) };
			self.fRec27[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = F32::max(0.0, F32::min(127.0, 0.71428573 * fTemp4 + 99.0));
			let mut fTemp96: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp95) * (fTemp95 + 28.0);
			self.fRec33[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4064.0 } else { self.fRec33[1] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp96 + 4e+03 } else { self.fRec34[1] };
			let mut fTemp97: F32 = self.fRec34[0] - self.fRec33[0];
			let mut fTemp98: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp97) / (unsafe { ftbl1DSP_Tom1SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] } * if (((fTemp97 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec33[0])) + 2.0) } else { 0.96 }))));
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp96 } else { self.fRec35[1] };
			let mut fTemp99: F32 = F32::max(5076.0, self.fRec35[0]);
			let mut fTemp100: F32 = self.fRec33[0] - fTemp99;
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (fTemp29 * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp99)) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = fTemp101 + fTemp98;
			let mut fTemp103: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp104: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp103) / (fTemp29 * if (((fTemp103 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp105: F32 = fTemp102 + fTemp104;
			self.fRec36[0] = if (iTemp13 as i32 != 0) { 0.0 } else { F32::min(fTemp105, self.fRec36[1] + 1.0) };
			let mut iTemp106: i32 = ((self.fRec36[0] < fTemp102) as i32);
			let mut fTemp107: F32 = (self.fRec36[0] - fTemp102) / fTemp104;
			let mut iTemp108: i32 = ((self.fRec36[0] < fTemp101) as i32);
			let mut fTemp109: F32 = (self.fRec36[0] - fTemp101) / fTemp98;
			let mut fTemp110: F32 = self.fRec36[0] / fTemp101;
			let mut fTemp111: F32 = if (iTemp106 as i32 != 0) { if (iTemp108 as i32 != 0) { if (((self.fRec36[0] < 0.0) as i32) as i32 != 0) { fTemp99 } else { if (iTemp108 as i32 != 0) { fTemp99 + fTemp100 * if (((self.fRec33[0] > fTemp99) as i32) as i32 != 0) { F32::powf(fTemp110, 0.33333334) } else { fTemp110 } } else { self.fRec33[0] } } } else { if (iTemp106 as i32 != 0) { self.fRec33[0] + fTemp97 * if (((self.fRec34[0] > self.fRec33[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec34[0] } } } else { if (((self.fRec36[0] < fTemp105) as i32) as i32 != 0) { self.fRec34[0] + fTemp103 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp107, 0.33333334) } else { fTemp107 } } else { self.fRec35[0] } };
			let mut iTemp112: i32 = ((fTemp111) as i32);
			let mut fTemp113: F32 = unsafe { ftbl0DSP_Tom1SIG0[(iTemp112) as usize] };
			let mut fTemp114: F32 = if (iTemp60 as i32 != 0) { 0.0 } else { self.fRec37[1] + self.fConst22 };
			self.fRec37[0] = fTemp114 - F32::floor(fTemp114);
			self.fRec32[0] = 0.115 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec37[0] + 6.9565215 * self.fRec32[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp113 + (fTemp111 - ((iTemp112) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp112, 1)) as usize] } - fTemp113));
			let mut fTemp115: F32 = unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * (self.fRec32[0] + 0.115 * (unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec27[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp80 + (fTemp78 - ((iTemp79) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp79, 1)) as usize] } - fTemp80)) + unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec22[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * (self.fRec21[0] + 2.0 * unsafe { ftbl2DSP_Tom1SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp59 + (fTemp57 - ((iTemp58) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp58, 1)) as usize] } - fTemp59)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp50 + (fTemp48 - ((iTemp49) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp49, 1)) as usize] } - fTemp50)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp42 + (fTemp40 - ((iTemp41) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp41, 1)) as usize] } - fTemp42)))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp24 + (fTemp22 - ((iTemp23) as F32)) * (unsafe { ftbl0DSP_Tom1SIG0[(i32::wrapping_add(iTemp23, 1)) as usize] } - fTemp24));
			self.fVec4[0] = fTemp115;
			self.fRec0[0] = 0.115 * (self.fConst23 * fTemp115 + self.fConst24 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow20 * self.fRec0[0];
			*output1 = fSlow21 * self.fRec0[0];
			*output2 = fSlow22 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.iRec29[1] = self.iRec29[0];
			self.iRec31[1] = self.iRec31[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec32[1] = self.fRec32[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
