// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Tom2 -pn processTom2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Tom2SIG0 {
	iRec1: [i32;2],
}

impl DSP_Tom2SIG0 {
	
	fn get_num_inputsDSP_Tom2SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom2SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Tom2SIG0() -> DSP_Tom2SIG0 { 
	DSP_Tom2SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Tom2SIG1 {
	iRec5: [i32;2],
}

impl DSP_Tom2SIG1 {
	
	fn get_num_inputsDSP_Tom2SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom2SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Tom2SIG1() -> DSP_Tom2SIG1 { 
	DSP_Tom2SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Tom2SIG2 {
	iVec3: [i32;2],
	iRec8: [i32;2],
}

impl DSP_Tom2SIG2 {
	
	fn get_num_inputsDSP_Tom2SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG2(&mut self, sample_rate: i32) {
		for l10 in 0..2 {
			self.iVec3[(l10) as usize] = 0;
		}
		for l11 in 0..2 {
			self.iRec8[(l11) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom2SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec8[0] = (i32::wrapping_add(self.iVec3[1], self.iRec8[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec8[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec8[1] = self.iRec8[0];
		}
	}

}


pub fn newDSP_Tom2SIG2() -> DSP_Tom2SIG2 { 
	DSP_Tom2SIG2 {
		iVec3: [0;2],
		iRec8: [0;2],
	}
}

pub struct DSP_Tom2SIG3 {
	iRec21: [i32;2],
}

impl DSP_Tom2SIG3 {
	
	fn get_num_inputsDSP_Tom2SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG3(&mut self, sample_rate: i32) {
		for l22 in 0..2 {
			self.iRec21[(l22) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom2SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec21[0] = i32::wrapping_add(self.iRec21[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec21[0], -1)) as F32) + -128.0));
			self.iRec21[1] = self.iRec21[0];
		}
	}

}


pub fn newDSP_Tom2SIG3() -> DSP_Tom2SIG3 { 
	DSP_Tom2SIG3 {
		iRec21: [0;2],
	}
}
static mut iDSP_Tom2SIG4Wave0: [i32;100] = [1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,16,16,17,18,18,19,20,21,22,23,24,25,26,27,28,30,31,33,34,36,37,38,39,41,42,44,46,47,49,51,53,54,56,58,60,62,64,66,68,70,72,74,76,79,82,85,88,91,94,98,102,106,110,115,120,125,130,135,141,147,153,159,165,171,178,185,193,202,211,232,243,254,255];

pub struct DSP_Tom2SIG4 {
	iDSP_Tom2SIG4Wave0_idx: i32,
}

impl DSP_Tom2SIG4 {
	
	fn get_num_inputsDSP_Tom2SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Tom2SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Tom2SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Tom2SIG4Wave0[(self.iDSP_Tom2SIG4Wave0_idx) as usize] };
			self.iDSP_Tom2SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom2SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom2SIG4() -> DSP_Tom2SIG4 { 
	DSP_Tom2SIG4 {
		iDSP_Tom2SIG4Wave0_idx: 0,
	}
}
static mut iDSP_Tom2SIG5Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Tom2SIG5 {
	iDSP_Tom2SIG5Wave0_idx: i32,
}

impl DSP_Tom2SIG5 {
	
	fn get_num_inputsDSP_Tom2SIG5(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom2SIG5(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom2SIG5(&mut self, sample_rate: i32) {
		self.iDSP_Tom2SIG5Wave0_idx = 0;
	}
	
	fn fillDSP_Tom2SIG5(&mut self, count: i32, table: &mut[i32]) {
		for i6 in 0..count {
			table[(i6) as usize] = unsafe { iDSP_Tom2SIG5Wave0[(self.iDSP_Tom2SIG5Wave0_idx) as usize] };
			self.iDSP_Tom2SIG5Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom2SIG5Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom2SIG5() -> DSP_Tom2SIG5 { 
	DSP_Tom2SIG5 {
		iDSP_Tom2SIG5Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Tom2SIG0: [F32;16384] = [0.0;16384];
fn DSP_Tom2_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Tom2SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Tom2SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Tom2SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Tom2SIG4: [i32;100] = [0;100];
static mut itbl5DSP_Tom2SIG5: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Tom2 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fHslider1: F32,
	fHslider2: F32,
	fRec2: [F32;2],
	fRec4: [F32;2],
	fRec6: [F32;2],
	fConst5: F32,
	fRec7: [F32;2],
	fRec9: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fRec13: [F32;2],
	fRec14: [F32;2],
	fRec15: [F32;2],
	fRec17: [F32;2],
	fRec18: [F32;2],
	fRec19: [F32;2],
	fConst6: F32,
	iConst7: i32,
	iRec22: [i32;2],
	iConst8: i32,
	iRec23: [i32;2],
	fConst9: F32,
	fConst10: F32,
	iConst11: i32,
	iRec24: [i32;2],
	fConst12: F32,
	iConst13: i32,
	iRec26: [i32;2],
	fRec25: [F32;2],
	fConst14: F32,
	fRec20: [F32;2],
	fRec16: [F32;2],
	fConst15: F32,
	fRec27: [F32;2],
	fConst16: F32,
	fRec28: [F32;2],
	fConst17: F32,
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fRec32: [F32;2],
	fRec33: [F32;2],
	fRec34: [F32;2],
	fRec35: [F32;2],
	fRec36: [F32;2],
	fRec37: [F32;2],
	fRec38: [F32;2],
	fConst18: F32,
	fRec39: [F32;2],
	fConst19: F32,
	fRec40: [F32;2],
	fVec4: [F32;2],
	fConst20: F32,
	fConst21: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_Tom2 {
	type T = F32;
		
	fn new() -> DSP_Tom2 { 
		DSP_Tom2 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fHslider1: 0.0,
			fHslider2: 0.0,
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fRec6: [0.0;2],
			fConst5: 0.0,
			fRec7: [0.0;2],
			fRec9: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fRec15: [0.0;2],
			fRec17: [0.0;2],
			fRec18: [0.0;2],
			fRec19: [0.0;2],
			fConst6: 0.0,
			iConst7: 0,
			iRec22: [0;2],
			iConst8: 0,
			iRec23: [0;2],
			fConst9: 0.0,
			fConst10: 0.0,
			iConst11: 0,
			iRec24: [0;2],
			fConst12: 0.0,
			iConst13: 0,
			iRec26: [0;2],
			fRec25: [0.0;2],
			fConst14: 0.0,
			fRec20: [0.0;2],
			fRec16: [0.0;2],
			fConst15: 0.0,
			fRec27: [0.0;2],
			fConst16: 0.0,
			fRec28: [0.0;2],
			fConst17: 0.0,
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fRec32: [0.0;2],
			fRec33: [0.0;2],
			fRec34: [0.0;2],
			fRec35: [0.0;2],
			fRec36: [0.0;2],
			fRec37: [0.0;2],
			fRec38: [0.0;2],
			fConst18: 0.0,
			fRec39: [0.0;2],
			fConst19: 0.0,
			fRec40: [0.0;2],
			fVec4: [0.0;2],
			fConst20: 0.0,
			fConst21: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Tom2 -pn processTom2 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Tom2SIG0 = newDSP_Tom2SIG0();
		sig0.instance_initDSP_Tom2SIG0(sample_rate);
		sig0.fillDSP_Tom2SIG0(16384, unsafe { &mut ftbl0DSP_Tom2SIG0 });
		let mut sig1: DSP_Tom2SIG1 = newDSP_Tom2SIG1();
		sig1.instance_initDSP_Tom2SIG1(sample_rate);
		sig1.fillDSP_Tom2SIG1(144, unsafe { &mut ftbl1DSP_Tom2SIG1 });
		let mut sig2: DSP_Tom2SIG2 = newDSP_Tom2SIG2();
		sig2.instance_initDSP_Tom2SIG2(sample_rate);
		sig2.fillDSP_Tom2SIG2(1024, unsafe { &mut ftbl2DSP_Tom2SIG2 });
		let mut sig3: DSP_Tom2SIG3 = newDSP_Tom2SIG3();
		sig3.instance_initDSP_Tom2SIG3(sample_rate);
		sig3.fillDSP_Tom2SIG3(4096, unsafe { &mut ftbl3DSP_Tom2SIG3 });
		let mut sig4: DSP_Tom2SIG4 = newDSP_Tom2SIG4();
		sig4.instance_initDSP_Tom2SIG4(sample_rate);
		sig4.fillDSP_Tom2SIG4(100, unsafe { &mut itbl4DSP_Tom2SIG4 });
		let mut sig5: DSP_Tom2SIG5 = newDSP_Tom2SIG5();
		sig5.instance_initDSP_Tom2SIG5(sample_rate);
		sig5.fillDSP_Tom2SIG5(100, unsafe { &mut itbl5DSP_Tom2SIG5 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 36.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l2 in 0..2 {
			self.fVec1[(l2) as usize] = 0.0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l12 in 0..2 {
			self.fRec9[(l12) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec15[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec17[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec18[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec19[(l21) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.iRec22[(l23) as usize] = 0;
		}
		for l24 in 0..2 {
			self.iRec23[(l24) as usize] = 0;
		}
		for l25 in 0..2 {
			self.iRec24[(l25) as usize] = 0;
		}
		for l26 in 0..2 {
			self.iRec26[(l26) as usize] = 0;
		}
		for l27 in 0..2 {
			self.fRec25[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec20[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec16[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec27[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec28[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec29[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec30[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec31[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec32[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec33[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec34[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec35[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec36[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec37[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec38[(l41) as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec39[(l42) as usize] = 0.0;
		}
		for l43 in 0..2 {
			self.fRec40[(l43) as usize] = 0.0;
		}
		for l44 in 0..2 {
			self.fVec4[(l44) as usize] = 0.0;
		}
		for l45 in 0..2 {
			self.fRec0[(l45) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.fConst5 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst6 = ((unsafe { itbl4DSP_Tom2SIG4[98] }) as F32);
		self.iConst7 = unsafe { itbl5DSP_Tom2SIG5[52] };
		self.iConst8 = unsafe { itbl5DSP_Tom2SIG5[50] };
		self.fConst9 = 0.64285713 * self.fConst0;
		self.fConst10 = ((unsafe { itbl4DSP_Tom2SIG4[54] }) as F32);
		self.iConst11 = unsafe { itbl5DSP_Tom2SIG5[51] };
		self.fConst12 = ((unsafe { itbl4DSP_Tom2SIG4[7] }) as F32);
		self.iConst13 = unsafe { itbl5DSP_Tom2SIG5[53] };
		self.fConst14 = 765.6 / self.fConst0;
		self.fConst15 = 299.2 / self.fConst0;
		self.fConst16 = 598.4 / self.fConst0;
		self.fConst17 = 4.4e+02 / self.fConst0;
		self.fConst18 = 686.4 / self.fConst0;
		self.fConst19 = 457.6 / self.fConst0;
		self.fConst20 = 1.0 / (fConst1 * fConst3);
		self.fConst21 = 0.0 - self.fConst20;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Tom2::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "8", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(4), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(6), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			5 => Some(self.fHslider0),
			6 => Some(self.fHslider1),
			3 => Some(self.fHslider2),
			2 => Some(self.fHslider3),
			1 => Some(self.fHslider4),
			4 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			5 => { self.fHslider0 = value }
			6 => { self.fHslider1 = value }
			3 => { self.fHslider2 = value }
			2 => { self.fHslider3 = value }
			1 => { self.fHslider4 = value }
			4 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = fSlow2 + -57.3;
		let mut fSlow4: F32 = 0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow3));
		let mut fSlow5: F32 = F32::min(99.0, 0.64646465 * fSlow4 + 99.0);
		let mut fSlow6: F32 = 0.33333334 * (fSlow2 + -1.3) + 1.0;
		let mut fSlow7: F32 = 0.71428573 * fSlow6;
		let mut fSlow8: F32 = F32::min(99.0, 0.64646465 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow2 + -45.3))) + 77.0);
		let mut fSlow9: F32 = F32::min(99.0, 1.1919192 * F32::max(0.0, F32::abs(-1.0 * fSlow3)) + 0.6969697 * fSlow4 + 99.0);
		let mut fSlow10: F32 = 0.14285715 * fSlow6;
		let mut fSlow11: F32 = F32::max(0.0, F32::min(127.0, fSlow9));
		let mut fSlow12: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow11) * (fSlow11 + 28.0);
		let mut fSlow13: F32 = fSlow12 + 4064.0;
		let mut fSlow14: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -70.3));
		let mut fSlow15: F32 = 1.0 - 0.008333334 * (17.31234 * F32::log(fSlow14, std::f32::consts::E) + 48.0);
		let mut fSlow16: F32 = 15.996094 * (0.1 * fSlow15 + 128.0);
		let mut iSlow17: i32 = ((fSlow16) as i32);
		let mut fSlow18: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow17) as usize] };
		let mut fSlow19: F32 = fSlow18 + (fSlow16 - ((iSlow17) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow17, 1)) as usize] } - fSlow18);
		let mut fSlow20: F32 = self.fConst14 * fSlow14;
		let mut fSlow21: F32 = 15.996094 * (0.042857144 * fSlow15 + 128.0);
		let mut iSlow22: i32 = ((fSlow21) as i32);
		let mut fSlow23: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow22) as usize] };
		let mut fSlow24: F32 = fSlow23 + (fSlow21 - ((iSlow22) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow22, 1)) as usize] } - fSlow23);
		let mut fSlow25: F32 = self.fConst15 * fSlow14;
		let mut fSlow26: F32 = 15.996094 * (0.057142857 * fSlow15 + 128.0);
		let mut iSlow27: i32 = ((fSlow26) as i32);
		let mut fSlow28: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow27) as usize] };
		let mut fSlow29: F32 = fSlow28 + (fSlow26 - ((iSlow27) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow27, 1)) as usize] } - fSlow28);
		let mut fSlow30: F32 = self.fConst16 * fSlow14;
		let mut fSlow31: F32 = self.fConst17 * fSlow14;
		let mut fSlow32: F32 = 0.42857143 * fSlow6;
		let mut fSlow33: F32 = self.fConst18 * fSlow14;
		let mut fSlow34: F32 = self.fConst19 * fSlow14;
		let mut fSlow35: F32 = 0.01 * self.fHslider3;
		let mut fSlow36: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow37: F32 = fSlow36 * F32::min(1.0, 1.0 - fSlow35);
		let mut fSlow38: F32 = fSlow36 * F32::min(1.0, fSlow35 + 1.0);
		let mut fSlow39: F32 = 0.01 * self.fHslider5 * fSlow36;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = 0.71428573 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec4[1] };
			let mut fTemp8: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 38.5) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 98.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp14, self.fRec7[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec7[0] - fTemp13) / fTemp9;
			let mut fTemp19: F32 = self.fRec7[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp17 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec2[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec2[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec2[0] + fTemp8 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, fSlow8 + fTemp5));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec10[1] };
			let mut fTemp25: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 26.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp28: F32 = self.fRec9[0] - fTemp27;
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp30: F32 = fTemp29 + fTemp26;
			self.fRec11[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp30, self.fRec11[1] + 1.0) };
			let mut iTemp31: i32 = ((self.fRec11[0] < fTemp30) as i32);
			let mut iTemp32: i32 = ((self.fRec11[0] < fTemp29) as i32);
			let mut fTemp33: F32 = (self.fRec11[0] - fTemp29) / fTemp26;
			let mut fTemp34: F32 = self.fRec11[0] / fTemp29;
			let mut fTemp35: F32 = if (iTemp31 as i32 != 0) { if (iTemp32 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp32 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec9[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec9[0] } } } else { if (iTemp31 as i32 != 0) { self.fRec9[0] + fTemp25 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp33, 0.33333334) } else { fTemp33 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp36: i32 = ((fTemp35) as i32);
			let mut fTemp37: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp36) as usize] };
			let mut fTemp38: F32 = F32::max(0.0, F32::min(127.0, fSlow9 + fTemp5));
			let mut fTemp39: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp38) * (fTemp38 + 28.0);
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp39 + 4064.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp39 } else { self.fRec13[1] };
			let mut fTemp40: F32 = self.fRec13[0] - self.fRec12[0];
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec14[1] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp40) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 79.5) as i32)) as usize] } * if (((fTemp40 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp43: F32 = self.fRec12[0] - fTemp42;
			let mut fTemp44: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp43) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 95.5) as i32)) as usize] } * if (((fTemp43 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp42)) + 2.0) } else { 0.96 }))));
			let mut fTemp45: F32 = fTemp44 + fTemp41;
			self.fRec15[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp45, self.fRec15[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec15[0] < fTemp45) as i32);
			let mut iTemp47: i32 = ((self.fRec15[0] < fTemp44) as i32);
			let mut fTemp48: F32 = (self.fRec15[0] - fTemp44) / fTemp41;
			let mut fTemp49: F32 = self.fRec15[0] / fTemp44;
			let mut fTemp50: F32 = if (iTemp46 as i32 != 0) { if (iTemp47 as i32 != 0) { if (((self.fRec15[0] < 0.0) as i32) as i32 != 0) { fTemp42 } else { if (iTemp47 as i32 != 0) { fTemp42 + fTemp43 * if (((self.fRec12[0] > fTemp42) as i32) as i32 != 0) { F32::powf(fTemp49, 0.33333334) } else { fTemp49 } } else { self.fRec12[0] } } } else { if (iTemp46 as i32 != 0) { self.fRec12[0] + fTemp40 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp48, 0.33333334) } else { fTemp48 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp51: i32 = ((fTemp50) as i32);
			let mut fTemp52: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp51) as usize] };
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow13 } else { self.fRec17[1] };
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec18[1] };
			let mut fTemp53: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 78.5) as i32)) as usize] } * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp56: F32 = self.fRec17[0] - fTemp55;
			let mut fTemp57: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp56) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp56 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp55)) + 2.0) } else { 0.96 }))));
			let mut fTemp58: F32 = fTemp57 + fTemp54;
			let mut fTemp59: F32 = self.fRec17[0] - self.fRec18[0];
			let mut fTemp60: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp59) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp59 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp61: F32 = fTemp58 + fTemp60;
			self.fRec19[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec19[1] + 1.0) };
			let mut iTemp62: i32 = ((self.fRec19[0] < fTemp58) as i32);
			let mut fTemp63: F32 = (self.fRec19[0] - fTemp58) / fTemp60;
			let mut iTemp64: i32 = ((self.fRec19[0] < fTemp57) as i32);
			let mut fTemp65: F32 = (self.fRec19[0] - fTemp57) / fTemp54;
			let mut fTemp66: F32 = self.fRec19[0] / fTemp57;
			let mut fTemp67: F32 = if (iTemp62 as i32 != 0) { if (iTemp64 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp55 } else { if (iTemp64 as i32 != 0) { fTemp55 + fTemp56 * if (((self.fRec17[0] > fTemp55) as i32) as i32 != 0) { F32::powf(fTemp66, 0.33333334) } else { fTemp66 } } else { self.fRec17[0] } } } else { if (iTemp62 as i32 != 0) { self.fRec17[0] + fTemp53 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec18[0] } } } else { if (((self.fRec19[0] < fTemp61) as i32) as i32 != 0) { self.fRec18[0] + fTemp59 * if (((self.fRec17[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec17[0] } };
			let mut iTemp68: i32 = ((fTemp67) as i32);
			let mut fTemp69: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp68) as usize] };
			let mut iTemp70: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec22[1] };
			self.iRec23[0] = if (iTemp3 as i32 != 0) { self.iConst8 } else { self.iRec23[1] };
			let mut iTemp71: i32 = i32::wrapping_sub(self.iRec23[0], self.iRec22[0]);
			let mut fTemp72: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp71)) as F32) / self.fConst6));
			self.iRec24[0] = if (iTemp3 as i32 != 0) { self.iConst11 } else { self.iRec24[1] };
			let mut iTemp73: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec24[0]);
			let mut fTemp74: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp73)) as F32) / self.fConst10));
			let mut fTemp75: F32 = fTemp74 + fTemp72;
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec26[1] };
			let mut iTemp76: i32 = i32::wrapping_sub(self.iRec26[0], self.iRec23[0]);
			let mut fTemp77: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp76)) as F32) / self.fConst12));
			let mut fTemp78: F32 = fTemp75 + fTemp77;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp78, self.fRec25[1] + 1.0) };
			let mut iTemp79: i32 = ((self.fRec25[0] < fTemp75) as i32);
			let mut fTemp80: F32 = (self.fRec25[0] - fTemp75) / fTemp77;
			let mut fTemp81: F32 = ((self.iRec23[0]) as F32);
			let mut iTemp82: i32 = ((self.fRec25[0] < fTemp74) as i32);
			let mut fTemp83: F32 = (self.fRec25[0] - fTemp74) / fTemp72;
			let mut fTemp84: F32 = ((self.iRec22[0]) as F32);
			let mut fTemp85: F32 = self.fRec25[0] / fTemp74;
			let mut fTemp86: F32 = ((self.iRec24[0]) as F32);
			let mut fTemp87: F32 = 15.996094 * (0.4 * if (iTemp79 as i32 != 0) { if (iTemp82 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp86 } else { if (iTemp82 as i32 != 0) { fTemp86 + ((iTemp73) as F32) * if (((self.iRec22[0] > self.iRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { fTemp84 } } } else { if (iTemp79 as i32 != 0) { fTemp84 + ((iTemp71) as F32) * if (((self.iRec23[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { fTemp81 } } } else { if (((self.fRec25[0] < fTemp78) as i32) as i32 != 0) { fTemp81 + ((iTemp76) as F32) * if (((self.iRec26[0] > self.iRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { ((self.iRec26[0]) as F32) } } + 128.0);
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iTemp88) as usize] };
			let mut fTemp90: F32 = fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89);
			let mut fTemp91: F32 = fSlow19 * fTemp90;
			let mut fTemp92: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec20[1] + fSlow20 * fTemp91 };
			self.fRec20[0] = fTemp92 - F32::floor(fTemp92);
			self.fRec16[0] = 0.115 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec20[0] + 20.869566 * self.fRec16[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp69 + (fTemp67 - ((iTemp68) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp68, 1)) as usize] } - fTemp69));
			let mut fTemp93: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow25 * fTemp90 * fSlow24 };
			self.fRec27[0] = fTemp93 - F32::floor(fTemp93);
			let mut fTemp94: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec28[1] + fSlow30 * fTemp90 * fSlow29 };
			self.fRec28[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec29[1] + fSlow31 * fTemp91 };
			self.fRec29[0] = fTemp95 - F32::floor(fTemp95);
			let mut fTemp96: F32 = 0.5714286 * fTemp4;
			let mut fTemp97: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 99.0));
			let mut fTemp98: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp97) * (fTemp97 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp98 + 4064.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp98 + 2368.0 } else { self.fRec31[1] };
			let mut fTemp99: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp100: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp99) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 37.5) as i32)) as usize] } * if (((fTemp99 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp98 } else { self.fRec32[1] };
			let mut fTemp101: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp102: F32 = self.fRec30[0] - fTemp101;
			let mut fTemp103: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp102) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 94.5) as i32)) as usize] } * if (((fTemp102 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp101)) + 2.0) } else { 0.96 }))));
			let mut fTemp104: F32 = fTemp103 + fTemp100;
			let mut fTemp105: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp106: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp105) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 57.5) as i32)) as usize] } * if (((fTemp105 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp107: F32 = fTemp104 + fTemp106;
			self.fRec33[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp107, self.fRec33[1] + 1.0) };
			let mut iTemp108: i32 = ((self.fRec33[0] < fTemp104) as i32);
			let mut fTemp109: F32 = (self.fRec33[0] - fTemp104) / fTemp106;
			let mut iTemp110: i32 = ((self.fRec33[0] < fTemp103) as i32);
			let mut fTemp111: F32 = (self.fRec33[0] - fTemp103) / fTemp100;
			let mut fTemp112: F32 = self.fRec33[0] / fTemp103;
			let mut fTemp113: F32 = if (iTemp108 as i32 != 0) { if (iTemp110 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp101 } else { if (iTemp110 as i32 != 0) { fTemp101 + fTemp102 * if (((self.fRec30[0] > fTemp101) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec30[0] } } } else { if (iTemp108 as i32 != 0) { self.fRec30[0] + fTemp99 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp111, 0.33333334) } else { fTemp111 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp107) as i32) as i32 != 0) { self.fRec31[0] + fTemp105 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec32[0] } };
			let mut iTemp114: i32 = ((fTemp113) as i32);
			let mut fTemp115: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp114) as usize] };
			let mut fTemp116: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 69.0));
			let mut fTemp117: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp116) * (fTemp116 + 28.0);
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp117 + 2464.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp117 + 4064.0 } else { self.fRec35[1] };
			let mut fTemp118: F32 = self.fRec35[0] - self.fRec34[0];
			self.fRec36[0] = if (iTemp3 as i32 != 0) { fSlow32 } else { self.fRec36[1] };
			let mut fTemp119: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp118) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 97.5) as i32)) as usize] } * if (((fTemp118 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { fTemp117 } else { self.fRec37[1] };
			let mut fTemp120: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp121: F32 = self.fRec34[0] - fTemp120;
			let mut fTemp122: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp121) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 63.5) as i32)) as usize] } * if (((fTemp121 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp120)) + 2.0) } else { 0.96 }))));
			let mut fTemp123: F32 = fTemp122 + fTemp119;
			let mut fTemp124: F32 = self.fRec37[0] - self.fRec35[0];
			let mut fTemp125: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp124) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 54.5) as i32)) as usize] } * if (((fTemp124 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp126: F32 = fTemp123 + fTemp125;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp126, self.fRec38[1] + 1.0) };
			let mut iTemp127: i32 = ((self.fRec38[0] < fTemp123) as i32);
			let mut fTemp128: F32 = (self.fRec38[0] - fTemp123) / fTemp125;
			let mut iTemp129: i32 = ((self.fRec38[0] < fTemp122) as i32);
			let mut fTemp130: F32 = (self.fRec38[0] - fTemp122) / fTemp119;
			let mut fTemp131: F32 = self.fRec38[0] / fTemp122;
			let mut fTemp132: F32 = if (iTemp127 as i32 != 0) { if (iTemp129 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp120 } else { if (iTemp129 as i32 != 0) { fTemp120 + fTemp121 * if (((self.fRec34[0] > fTemp120) as i32) as i32 != 0) { F32::powf(fTemp131, 0.33333334) } else { fTemp131 } } else { self.fRec34[0] } } } else { if (iTemp127 as i32 != 0) { self.fRec34[0] + fTemp118 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp130, 0.33333334) } else { fTemp130 } } else { self.fRec35[0] } } } else { if (((self.fRec38[0] < fTemp126) as i32) as i32 != 0) { self.fRec35[0] + fTemp124 * if (((self.fRec37[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp128, 0.33333334) } else { fTemp128 } } else { self.fRec37[0] } };
			let mut iTemp133: i32 = ((fTemp132) as i32);
			let mut fTemp134: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp133) as usize] };
			let mut fTemp135: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec39[1] + fSlow33 * fTemp91 };
			self.fRec39[0] = fTemp135 - F32::floor(fTemp135);
			let mut fTemp136: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow34 * fTemp91 };
			self.fRec40[0] = fTemp136 - F32::floor(fTemp136);
			let mut fTemp137: F32 = unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * self.fRec39[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp134 + (fTemp132 - ((iTemp133) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp133, 1)) as usize] } - fTemp134)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp115 + (fTemp113 - ((iTemp114) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp114, 1)) as usize] } - fTemp115)) + unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec29[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec28[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * self.fRec16[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp52 + (fTemp50 - ((iTemp51) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp51, 1)) as usize] } - fTemp52)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp37 + (fTemp35 - ((iTemp36) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp36, 1)) as usize] } - fTemp37)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22));
			self.fVec4[0] = fTemp137;
			self.fRec0[0] = 0.115 * (self.fConst20 * fTemp137 + self.fConst21 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow37 * self.fRec0[0];
			*output1 = fSlow38 * self.fRec0[0];
			*output2 = fSlow39 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.iRec22[1] = self.iRec22[0];
			self.iRec23[1] = self.iRec23[0];
			self.iRec24[1] = self.iRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Tom2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Tom2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = fSlow2 + -57.3;
		let mut fSlow4: F32 = 0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow3));
		let mut fSlow5: F32 = F32::min(99.0, 0.64646465 * fSlow4 + 99.0);
		let mut fSlow6: F32 = 0.33333334 * (fSlow2 + -1.3) + 1.0;
		let mut fSlow7: F32 = 0.71428573 * fSlow6;
		let mut fSlow8: F32 = F32::min(99.0, 0.64646465 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow2 + -45.3))) + 77.0);
		let mut fSlow9: F32 = F32::min(99.0, 1.1919192 * F32::max(0.0, F32::abs(-1.0 * fSlow3)) + 0.6969697 * fSlow4 + 99.0);
		let mut fSlow10: F32 = 0.14285715 * fSlow6;
		let mut fSlow11: F32 = F32::max(0.0, F32::min(127.0, fSlow9));
		let mut fSlow12: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow11) * (fSlow11 + 28.0);
		let mut fSlow13: F32 = fSlow12 + 4064.0;
		let mut fSlow14: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -70.3));
		let mut fSlow15: F32 = 1.0 - 0.008333334 * (17.31234 * F32::log(fSlow14, std::f32::consts::E) + 48.0);
		let mut fSlow16: F32 = 15.996094 * (0.1 * fSlow15 + 128.0);
		let mut iSlow17: i32 = ((fSlow16) as i32);
		let mut fSlow18: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow17) as usize] };
		let mut fSlow19: F32 = fSlow18 + (fSlow16 - ((iSlow17) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow17, 1)) as usize] } - fSlow18);
		let mut fSlow20: F32 = self.fConst14 * fSlow14;
		let mut fSlow21: F32 = 15.996094 * (0.042857144 * fSlow15 + 128.0);
		let mut iSlow22: i32 = ((fSlow21) as i32);
		let mut fSlow23: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow22) as usize] };
		let mut fSlow24: F32 = fSlow23 + (fSlow21 - ((iSlow22) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow22, 1)) as usize] } - fSlow23);
		let mut fSlow25: F32 = self.fConst15 * fSlow14;
		let mut fSlow26: F32 = 15.996094 * (0.057142857 * fSlow15 + 128.0);
		let mut iSlow27: i32 = ((fSlow26) as i32);
		let mut fSlow28: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow27) as usize] };
		let mut fSlow29: F32 = fSlow28 + (fSlow26 - ((iSlow27) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow27, 1)) as usize] } - fSlow28);
		let mut fSlow30: F32 = self.fConst16 * fSlow14;
		let mut fSlow31: F32 = self.fConst17 * fSlow14;
		let mut fSlow32: F32 = 0.42857143 * fSlow6;
		let mut fSlow33: F32 = self.fConst18 * fSlow14;
		let mut fSlow34: F32 = self.fConst19 * fSlow14;
		let mut fSlow35: F32 = 0.01 * self.fHslider3;
		let mut fSlow36: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow37: F32 = fSlow36 * F32::min(1.0, 1.0 - fSlow35);
		let mut fSlow38: F32 = fSlow36 * F32::min(1.0, fSlow35 + 1.0);
		let mut fSlow39: F32 = 0.01 * self.fHslider5 * fSlow36;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = 0.71428573 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec4[1] };
			let mut fTemp8: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 38.5) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 98.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp14, self.fRec7[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec7[0] - fTemp13) / fTemp9;
			let mut fTemp19: F32 = self.fRec7[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp17 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec2[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec2[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec2[0] + fTemp8 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, fSlow8 + fTemp5));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec10[1] };
			let mut fTemp25: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 26.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp28: F32 = self.fRec9[0] - fTemp27;
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp30: F32 = fTemp29 + fTemp26;
			self.fRec11[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp30, self.fRec11[1] + 1.0) };
			let mut iTemp31: i32 = ((self.fRec11[0] < fTemp30) as i32);
			let mut iTemp32: i32 = ((self.fRec11[0] < fTemp29) as i32);
			let mut fTemp33: F32 = (self.fRec11[0] - fTemp29) / fTemp26;
			let mut fTemp34: F32 = self.fRec11[0] / fTemp29;
			let mut fTemp35: F32 = if (iTemp31 as i32 != 0) { if (iTemp32 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp32 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec9[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec9[0] } } } else { if (iTemp31 as i32 != 0) { self.fRec9[0] + fTemp25 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp33, 0.33333334) } else { fTemp33 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp36: i32 = ((fTemp35) as i32);
			let mut fTemp37: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp36) as usize] };
			let mut fTemp38: F32 = F32::max(0.0, F32::min(127.0, fSlow9 + fTemp5));
			let mut fTemp39: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp38) * (fTemp38 + 28.0);
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp39 + 4064.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp39 } else { self.fRec13[1] };
			let mut fTemp40: F32 = self.fRec13[0] - self.fRec12[0];
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec14[1] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp40) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 79.5) as i32)) as usize] } * if (((fTemp40 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp43: F32 = self.fRec12[0] - fTemp42;
			let mut fTemp44: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp43) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 95.5) as i32)) as usize] } * if (((fTemp43 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp42)) + 2.0) } else { 0.96 }))));
			let mut fTemp45: F32 = fTemp44 + fTemp41;
			self.fRec15[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp45, self.fRec15[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec15[0] < fTemp45) as i32);
			let mut iTemp47: i32 = ((self.fRec15[0] < fTemp44) as i32);
			let mut fTemp48: F32 = (self.fRec15[0] - fTemp44) / fTemp41;
			let mut fTemp49: F32 = self.fRec15[0] / fTemp44;
			let mut fTemp50: F32 = if (iTemp46 as i32 != 0) { if (iTemp47 as i32 != 0) { if (((self.fRec15[0] < 0.0) as i32) as i32 != 0) { fTemp42 } else { if (iTemp47 as i32 != 0) { fTemp42 + fTemp43 * if (((self.fRec12[0] > fTemp42) as i32) as i32 != 0) { F32::powf(fTemp49, 0.33333334) } else { fTemp49 } } else { self.fRec12[0] } } } else { if (iTemp46 as i32 != 0) { self.fRec12[0] + fTemp40 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp48, 0.33333334) } else { fTemp48 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp51: i32 = ((fTemp50) as i32);
			let mut fTemp52: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp51) as usize] };
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow13 } else { self.fRec17[1] };
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec18[1] };
			let mut fTemp53: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 78.5) as i32)) as usize] } * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp56: F32 = self.fRec17[0] - fTemp55;
			let mut fTemp57: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp56) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp56 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp55)) + 2.0) } else { 0.96 }))));
			let mut fTemp58: F32 = fTemp57 + fTemp54;
			let mut fTemp59: F32 = self.fRec17[0] - self.fRec18[0];
			let mut fTemp60: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp59) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp59 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp61: F32 = fTemp58 + fTemp60;
			self.fRec19[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec19[1] + 1.0) };
			let mut iTemp62: i32 = ((self.fRec19[0] < fTemp58) as i32);
			let mut fTemp63: F32 = (self.fRec19[0] - fTemp58) / fTemp60;
			let mut iTemp64: i32 = ((self.fRec19[0] < fTemp57) as i32);
			let mut fTemp65: F32 = (self.fRec19[0] - fTemp57) / fTemp54;
			let mut fTemp66: F32 = self.fRec19[0] / fTemp57;
			let mut fTemp67: F32 = if (iTemp62 as i32 != 0) { if (iTemp64 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp55 } else { if (iTemp64 as i32 != 0) { fTemp55 + fTemp56 * if (((self.fRec17[0] > fTemp55) as i32) as i32 != 0) { F32::powf(fTemp66, 0.33333334) } else { fTemp66 } } else { self.fRec17[0] } } } else { if (iTemp62 as i32 != 0) { self.fRec17[0] + fTemp53 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec18[0] } } } else { if (((self.fRec19[0] < fTemp61) as i32) as i32 != 0) { self.fRec18[0] + fTemp59 * if (((self.fRec17[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec17[0] } };
			let mut iTemp68: i32 = ((fTemp67) as i32);
			let mut fTemp69: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp68) as usize] };
			let mut iTemp70: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec22[1] };
			self.iRec23[0] = if (iTemp3 as i32 != 0) { self.iConst8 } else { self.iRec23[1] };
			let mut iTemp71: i32 = i32::wrapping_sub(self.iRec23[0], self.iRec22[0]);
			let mut fTemp72: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp71)) as F32) / self.fConst6));
			self.iRec24[0] = if (iTemp3 as i32 != 0) { self.iConst11 } else { self.iRec24[1] };
			let mut iTemp73: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec24[0]);
			let mut fTemp74: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp73)) as F32) / self.fConst10));
			let mut fTemp75: F32 = fTemp74 + fTemp72;
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec26[1] };
			let mut iTemp76: i32 = i32::wrapping_sub(self.iRec26[0], self.iRec23[0]);
			let mut fTemp77: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp76)) as F32) / self.fConst12));
			let mut fTemp78: F32 = fTemp75 + fTemp77;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp78, self.fRec25[1] + 1.0) };
			let mut iTemp79: i32 = ((self.fRec25[0] < fTemp75) as i32);
			let mut fTemp80: F32 = (self.fRec25[0] - fTemp75) / fTemp77;
			let mut fTemp81: F32 = ((self.iRec23[0]) as F32);
			let mut iTemp82: i32 = ((self.fRec25[0] < fTemp74) as i32);
			let mut fTemp83: F32 = (self.fRec25[0] - fTemp74) / fTemp72;
			let mut fTemp84: F32 = ((self.iRec22[0]) as F32);
			let mut fTemp85: F32 = self.fRec25[0] / fTemp74;
			let mut fTemp86: F32 = ((self.iRec24[0]) as F32);
			let mut fTemp87: F32 = 15.996094 * (0.4 * if (iTemp79 as i32 != 0) { if (iTemp82 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp86 } else { if (iTemp82 as i32 != 0) { fTemp86 + ((iTemp73) as F32) * if (((self.iRec22[0] > self.iRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { fTemp84 } } } else { if (iTemp79 as i32 != 0) { fTemp84 + ((iTemp71) as F32) * if (((self.iRec23[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { fTemp81 } } } else { if (((self.fRec25[0] < fTemp78) as i32) as i32 != 0) { fTemp81 + ((iTemp76) as F32) * if (((self.iRec26[0] > self.iRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { ((self.iRec26[0]) as F32) } } + 128.0);
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iTemp88) as usize] };
			let mut fTemp90: F32 = fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89);
			let mut fTemp91: F32 = fSlow19 * fTemp90;
			let mut fTemp92: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec20[1] + fSlow20 * fTemp91 };
			self.fRec20[0] = fTemp92 - F32::floor(fTemp92);
			self.fRec16[0] = 0.115 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec20[0] + 20.869566 * self.fRec16[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp69 + (fTemp67 - ((iTemp68) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp68, 1)) as usize] } - fTemp69));
			let mut fTemp93: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow25 * fTemp90 * fSlow24 };
			self.fRec27[0] = fTemp93 - F32::floor(fTemp93);
			let mut fTemp94: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec28[1] + fSlow30 * fTemp90 * fSlow29 };
			self.fRec28[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec29[1] + fSlow31 * fTemp91 };
			self.fRec29[0] = fTemp95 - F32::floor(fTemp95);
			let mut fTemp96: F32 = 0.5714286 * fTemp4;
			let mut fTemp97: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 99.0));
			let mut fTemp98: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp97) * (fTemp97 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp98 + 4064.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp98 + 2368.0 } else { self.fRec31[1] };
			let mut fTemp99: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp100: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp99) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 37.5) as i32)) as usize] } * if (((fTemp99 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp98 } else { self.fRec32[1] };
			let mut fTemp101: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp102: F32 = self.fRec30[0] - fTemp101;
			let mut fTemp103: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp102) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 94.5) as i32)) as usize] } * if (((fTemp102 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp101)) + 2.0) } else { 0.96 }))));
			let mut fTemp104: F32 = fTemp103 + fTemp100;
			let mut fTemp105: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp106: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp105) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 57.5) as i32)) as usize] } * if (((fTemp105 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp107: F32 = fTemp104 + fTemp106;
			self.fRec33[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp107, self.fRec33[1] + 1.0) };
			let mut iTemp108: i32 = ((self.fRec33[0] < fTemp104) as i32);
			let mut fTemp109: F32 = (self.fRec33[0] - fTemp104) / fTemp106;
			let mut iTemp110: i32 = ((self.fRec33[0] < fTemp103) as i32);
			let mut fTemp111: F32 = (self.fRec33[0] - fTemp103) / fTemp100;
			let mut fTemp112: F32 = self.fRec33[0] / fTemp103;
			let mut fTemp113: F32 = if (iTemp108 as i32 != 0) { if (iTemp110 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp101 } else { if (iTemp110 as i32 != 0) { fTemp101 + fTemp102 * if (((self.fRec30[0] > fTemp101) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec30[0] } } } else { if (iTemp108 as i32 != 0) { self.fRec30[0] + fTemp99 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp111, 0.33333334) } else { fTemp111 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp107) as i32) as i32 != 0) { self.fRec31[0] + fTemp105 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec32[0] } };
			let mut iTemp114: i32 = ((fTemp113) as i32);
			let mut fTemp115: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp114) as usize] };
			let mut fTemp116: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 69.0));
			let mut fTemp117: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp116) * (fTemp116 + 28.0);
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp117 + 2464.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp117 + 4064.0 } else { self.fRec35[1] };
			let mut fTemp118: F32 = self.fRec35[0] - self.fRec34[0];
			self.fRec36[0] = if (iTemp3 as i32 != 0) { fSlow32 } else { self.fRec36[1] };
			let mut fTemp119: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp118) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 97.5) as i32)) as usize] } * if (((fTemp118 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { fTemp117 } else { self.fRec37[1] };
			let mut fTemp120: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp121: F32 = self.fRec34[0] - fTemp120;
			let mut fTemp122: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp121) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 63.5) as i32)) as usize] } * if (((fTemp121 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp120)) + 2.0) } else { 0.96 }))));
			let mut fTemp123: F32 = fTemp122 + fTemp119;
			let mut fTemp124: F32 = self.fRec37[0] - self.fRec35[0];
			let mut fTemp125: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp124) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 54.5) as i32)) as usize] } * if (((fTemp124 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp126: F32 = fTemp123 + fTemp125;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp126, self.fRec38[1] + 1.0) };
			let mut iTemp127: i32 = ((self.fRec38[0] < fTemp123) as i32);
			let mut fTemp128: F32 = (self.fRec38[0] - fTemp123) / fTemp125;
			let mut iTemp129: i32 = ((self.fRec38[0] < fTemp122) as i32);
			let mut fTemp130: F32 = (self.fRec38[0] - fTemp122) / fTemp119;
			let mut fTemp131: F32 = self.fRec38[0] / fTemp122;
			let mut fTemp132: F32 = if (iTemp127 as i32 != 0) { if (iTemp129 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp120 } else { if (iTemp129 as i32 != 0) { fTemp120 + fTemp121 * if (((self.fRec34[0] > fTemp120) as i32) as i32 != 0) { F32::powf(fTemp131, 0.33333334) } else { fTemp131 } } else { self.fRec34[0] } } } else { if (iTemp127 as i32 != 0) { self.fRec34[0] + fTemp118 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp130, 0.33333334) } else { fTemp130 } } else { self.fRec35[0] } } } else { if (((self.fRec38[0] < fTemp126) as i32) as i32 != 0) { self.fRec35[0] + fTemp124 * if (((self.fRec37[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp128, 0.33333334) } else { fTemp128 } } else { self.fRec37[0] } };
			let mut iTemp133: i32 = ((fTemp132) as i32);
			let mut fTemp134: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp133) as usize] };
			let mut fTemp135: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec39[1] + fSlow33 * fTemp91 };
			self.fRec39[0] = fTemp135 - F32::floor(fTemp135);
			let mut fTemp136: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow34 * fTemp91 };
			self.fRec40[0] = fTemp136 - F32::floor(fTemp136);
			let mut fTemp137: F32 = unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * self.fRec39[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp134 + (fTemp132 - ((iTemp133) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp133, 1)) as usize] } - fTemp134)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp115 + (fTemp113 - ((iTemp114) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp114, 1)) as usize] } - fTemp115)) + unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec29[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec28[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * self.fRec16[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp52 + (fTemp50 - ((iTemp51) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp51, 1)) as usize] } - fTemp52)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp37 + (fTemp35 - ((iTemp36) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp36, 1)) as usize] } - fTemp37)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22));
			self.fVec4[0] = fTemp137;
			self.fRec0[0] = 0.115 * (self.fConst20 * fTemp137 + self.fConst21 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow37 * self.fRec0[0];
			*output1 = fSlow38 * self.fRec0[0];
			*output2 = fSlow39 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.iRec22[1] = self.iRec22[0];
			self.iRec23[1] = self.iRec23[0];
			self.iRec24[1] = self.iRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Tom2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = fSlow2 + -57.3;
		let mut fSlow4: F32 = 0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow3));
		let mut fSlow5: F32 = F32::min(99.0, 0.64646465 * fSlow4 + 99.0);
		let mut fSlow6: F32 = 0.33333334 * (fSlow2 + -1.3) + 1.0;
		let mut fSlow7: F32 = 0.71428573 * fSlow6;
		let mut fSlow8: F32 = F32::min(99.0, 0.64646465 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow2 + -45.3))) + 77.0);
		let mut fSlow9: F32 = F32::min(99.0, 1.1919192 * F32::max(0.0, F32::abs(-1.0 * fSlow3)) + 0.6969697 * fSlow4 + 99.0);
		let mut fSlow10: F32 = 0.14285715 * fSlow6;
		let mut fSlow11: F32 = F32::max(0.0, F32::min(127.0, fSlow9));
		let mut fSlow12: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow11) * (fSlow11 + 28.0);
		let mut fSlow13: F32 = fSlow12 + 4064.0;
		let mut fSlow14: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -70.3));
		let mut fSlow15: F32 = 1.0 - 0.008333334 * (17.31234 * F32::log(fSlow14, std::f32::consts::E) + 48.0);
		let mut fSlow16: F32 = 15.996094 * (0.1 * fSlow15 + 128.0);
		let mut iSlow17: i32 = ((fSlow16) as i32);
		let mut fSlow18: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow17) as usize] };
		let mut fSlow19: F32 = fSlow18 + (fSlow16 - ((iSlow17) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow17, 1)) as usize] } - fSlow18);
		let mut fSlow20: F32 = self.fConst14 * fSlow14;
		let mut fSlow21: F32 = 15.996094 * (0.042857144 * fSlow15 + 128.0);
		let mut iSlow22: i32 = ((fSlow21) as i32);
		let mut fSlow23: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow22) as usize] };
		let mut fSlow24: F32 = fSlow23 + (fSlow21 - ((iSlow22) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow22, 1)) as usize] } - fSlow23);
		let mut fSlow25: F32 = self.fConst15 * fSlow14;
		let mut fSlow26: F32 = 15.996094 * (0.057142857 * fSlow15 + 128.0);
		let mut iSlow27: i32 = ((fSlow26) as i32);
		let mut fSlow28: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow27) as usize] };
		let mut fSlow29: F32 = fSlow28 + (fSlow26 - ((iSlow27) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow27, 1)) as usize] } - fSlow28);
		let mut fSlow30: F32 = self.fConst16 * fSlow14;
		let mut fSlow31: F32 = self.fConst17 * fSlow14;
		let mut fSlow32: F32 = 0.42857143 * fSlow6;
		let mut fSlow33: F32 = self.fConst18 * fSlow14;
		let mut fSlow34: F32 = self.fConst19 * fSlow14;
		let mut fSlow35: F32 = 0.01 * self.fHslider3;
		let mut fSlow36: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow37: F32 = fSlow36 * F32::min(1.0, 1.0 - fSlow35);
		let mut fSlow38: F32 = fSlow36 * F32::min(1.0, fSlow35 + 1.0);
		let mut fSlow39: F32 = 0.01 * self.fHslider5 * fSlow36;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = 0.71428573 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec4[1] };
			let mut fTemp8: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 38.5) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 98.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp14, self.fRec7[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec7[0] - fTemp13) / fTemp9;
			let mut fTemp19: F32 = self.fRec7[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp17 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec2[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec2[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec2[0] + fTemp8 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, fSlow8 + fTemp5));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec10[1] };
			let mut fTemp25: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 26.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp28: F32 = self.fRec9[0] - fTemp27;
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp30: F32 = fTemp29 + fTemp26;
			self.fRec11[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp30, self.fRec11[1] + 1.0) };
			let mut iTemp31: i32 = ((self.fRec11[0] < fTemp30) as i32);
			let mut iTemp32: i32 = ((self.fRec11[0] < fTemp29) as i32);
			let mut fTemp33: F32 = (self.fRec11[0] - fTemp29) / fTemp26;
			let mut fTemp34: F32 = self.fRec11[0] / fTemp29;
			let mut fTemp35: F32 = if (iTemp31 as i32 != 0) { if (iTemp32 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp32 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec9[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec9[0] } } } else { if (iTemp31 as i32 != 0) { self.fRec9[0] + fTemp25 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp33, 0.33333334) } else { fTemp33 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp36: i32 = ((fTemp35) as i32);
			let mut fTemp37: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp36) as usize] };
			let mut fTemp38: F32 = F32::max(0.0, F32::min(127.0, fSlow9 + fTemp5));
			let mut fTemp39: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp38) * (fTemp38 + 28.0);
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp39 + 4064.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp39 } else { self.fRec13[1] };
			let mut fTemp40: F32 = self.fRec13[0] - self.fRec12[0];
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec14[1] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp40) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 79.5) as i32)) as usize] } * if (((fTemp40 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp43: F32 = self.fRec12[0] - fTemp42;
			let mut fTemp44: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp43) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 95.5) as i32)) as usize] } * if (((fTemp43 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp42)) + 2.0) } else { 0.96 }))));
			let mut fTemp45: F32 = fTemp44 + fTemp41;
			self.fRec15[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp45, self.fRec15[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec15[0] < fTemp45) as i32);
			let mut iTemp47: i32 = ((self.fRec15[0] < fTemp44) as i32);
			let mut fTemp48: F32 = (self.fRec15[0] - fTemp44) / fTemp41;
			let mut fTemp49: F32 = self.fRec15[0] / fTemp44;
			let mut fTemp50: F32 = if (iTemp46 as i32 != 0) { if (iTemp47 as i32 != 0) { if (((self.fRec15[0] < 0.0) as i32) as i32 != 0) { fTemp42 } else { if (iTemp47 as i32 != 0) { fTemp42 + fTemp43 * if (((self.fRec12[0] > fTemp42) as i32) as i32 != 0) { F32::powf(fTemp49, 0.33333334) } else { fTemp49 } } else { self.fRec12[0] } } } else { if (iTemp46 as i32 != 0) { self.fRec12[0] + fTemp40 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp48, 0.33333334) } else { fTemp48 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp51: i32 = ((fTemp50) as i32);
			let mut fTemp52: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp51) as usize] };
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow13 } else { self.fRec17[1] };
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec18[1] };
			let mut fTemp53: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 78.5) as i32)) as usize] } * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp56: F32 = self.fRec17[0] - fTemp55;
			let mut fTemp57: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp56) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp56 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp55)) + 2.0) } else { 0.96 }))));
			let mut fTemp58: F32 = fTemp57 + fTemp54;
			let mut fTemp59: F32 = self.fRec17[0] - self.fRec18[0];
			let mut fTemp60: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp59) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp59 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp61: F32 = fTemp58 + fTemp60;
			self.fRec19[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec19[1] + 1.0) };
			let mut iTemp62: i32 = ((self.fRec19[0] < fTemp58) as i32);
			let mut fTemp63: F32 = (self.fRec19[0] - fTemp58) / fTemp60;
			let mut iTemp64: i32 = ((self.fRec19[0] < fTemp57) as i32);
			let mut fTemp65: F32 = (self.fRec19[0] - fTemp57) / fTemp54;
			let mut fTemp66: F32 = self.fRec19[0] / fTemp57;
			let mut fTemp67: F32 = if (iTemp62 as i32 != 0) { if (iTemp64 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp55 } else { if (iTemp64 as i32 != 0) { fTemp55 + fTemp56 * if (((self.fRec17[0] > fTemp55) as i32) as i32 != 0) { F32::powf(fTemp66, 0.33333334) } else { fTemp66 } } else { self.fRec17[0] } } } else { if (iTemp62 as i32 != 0) { self.fRec17[0] + fTemp53 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec18[0] } } } else { if (((self.fRec19[0] < fTemp61) as i32) as i32 != 0) { self.fRec18[0] + fTemp59 * if (((self.fRec17[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec17[0] } };
			let mut iTemp68: i32 = ((fTemp67) as i32);
			let mut fTemp69: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp68) as usize] };
			let mut iTemp70: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec22[1] };
			self.iRec23[0] = if (iTemp3 as i32 != 0) { self.iConst8 } else { self.iRec23[1] };
			let mut iTemp71: i32 = i32::wrapping_sub(self.iRec23[0], self.iRec22[0]);
			let mut fTemp72: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp71)) as F32) / self.fConst6));
			self.iRec24[0] = if (iTemp3 as i32 != 0) { self.iConst11 } else { self.iRec24[1] };
			let mut iTemp73: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec24[0]);
			let mut fTemp74: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp73)) as F32) / self.fConst10));
			let mut fTemp75: F32 = fTemp74 + fTemp72;
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec26[1] };
			let mut iTemp76: i32 = i32::wrapping_sub(self.iRec26[0], self.iRec23[0]);
			let mut fTemp77: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp76)) as F32) / self.fConst12));
			let mut fTemp78: F32 = fTemp75 + fTemp77;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp78, self.fRec25[1] + 1.0) };
			let mut iTemp79: i32 = ((self.fRec25[0] < fTemp75) as i32);
			let mut fTemp80: F32 = (self.fRec25[0] - fTemp75) / fTemp77;
			let mut fTemp81: F32 = ((self.iRec23[0]) as F32);
			let mut iTemp82: i32 = ((self.fRec25[0] < fTemp74) as i32);
			let mut fTemp83: F32 = (self.fRec25[0] - fTemp74) / fTemp72;
			let mut fTemp84: F32 = ((self.iRec22[0]) as F32);
			let mut fTemp85: F32 = self.fRec25[0] / fTemp74;
			let mut fTemp86: F32 = ((self.iRec24[0]) as F32);
			let mut fTemp87: F32 = 15.996094 * (0.4 * if (iTemp79 as i32 != 0) { if (iTemp82 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp86 } else { if (iTemp82 as i32 != 0) { fTemp86 + ((iTemp73) as F32) * if (((self.iRec22[0] > self.iRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { fTemp84 } } } else { if (iTemp79 as i32 != 0) { fTemp84 + ((iTemp71) as F32) * if (((self.iRec23[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { fTemp81 } } } else { if (((self.fRec25[0] < fTemp78) as i32) as i32 != 0) { fTemp81 + ((iTemp76) as F32) * if (((self.iRec26[0] > self.iRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { ((self.iRec26[0]) as F32) } } + 128.0);
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iTemp88) as usize] };
			let mut fTemp90: F32 = fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89);
			let mut fTemp91: F32 = fSlow19 * fTemp90;
			let mut fTemp92: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec20[1] + fSlow20 * fTemp91 };
			self.fRec20[0] = fTemp92 - F32::floor(fTemp92);
			self.fRec16[0] = 0.115 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec20[0] + 20.869566 * self.fRec16[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp69 + (fTemp67 - ((iTemp68) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp68, 1)) as usize] } - fTemp69));
			let mut fTemp93: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow25 * fTemp90 * fSlow24 };
			self.fRec27[0] = fTemp93 - F32::floor(fTemp93);
			let mut fTemp94: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec28[1] + fSlow30 * fTemp90 * fSlow29 };
			self.fRec28[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec29[1] + fSlow31 * fTemp91 };
			self.fRec29[0] = fTemp95 - F32::floor(fTemp95);
			let mut fTemp96: F32 = 0.5714286 * fTemp4;
			let mut fTemp97: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 99.0));
			let mut fTemp98: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp97) * (fTemp97 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp98 + 4064.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp98 + 2368.0 } else { self.fRec31[1] };
			let mut fTemp99: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp100: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp99) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 37.5) as i32)) as usize] } * if (((fTemp99 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp98 } else { self.fRec32[1] };
			let mut fTemp101: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp102: F32 = self.fRec30[0] - fTemp101;
			let mut fTemp103: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp102) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 94.5) as i32)) as usize] } * if (((fTemp102 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp101)) + 2.0) } else { 0.96 }))));
			let mut fTemp104: F32 = fTemp103 + fTemp100;
			let mut fTemp105: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp106: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp105) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 57.5) as i32)) as usize] } * if (((fTemp105 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp107: F32 = fTemp104 + fTemp106;
			self.fRec33[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp107, self.fRec33[1] + 1.0) };
			let mut iTemp108: i32 = ((self.fRec33[0] < fTemp104) as i32);
			let mut fTemp109: F32 = (self.fRec33[0] - fTemp104) / fTemp106;
			let mut iTemp110: i32 = ((self.fRec33[0] < fTemp103) as i32);
			let mut fTemp111: F32 = (self.fRec33[0] - fTemp103) / fTemp100;
			let mut fTemp112: F32 = self.fRec33[0] / fTemp103;
			let mut fTemp113: F32 = if (iTemp108 as i32 != 0) { if (iTemp110 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp101 } else { if (iTemp110 as i32 != 0) { fTemp101 + fTemp102 * if (((self.fRec30[0] > fTemp101) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec30[0] } } } else { if (iTemp108 as i32 != 0) { self.fRec30[0] + fTemp99 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp111, 0.33333334) } else { fTemp111 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp107) as i32) as i32 != 0) { self.fRec31[0] + fTemp105 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec32[0] } };
			let mut iTemp114: i32 = ((fTemp113) as i32);
			let mut fTemp115: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp114) as usize] };
			let mut fTemp116: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 69.0));
			let mut fTemp117: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp116) * (fTemp116 + 28.0);
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp117 + 2464.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp117 + 4064.0 } else { self.fRec35[1] };
			let mut fTemp118: F32 = self.fRec35[0] - self.fRec34[0];
			self.fRec36[0] = if (iTemp3 as i32 != 0) { fSlow32 } else { self.fRec36[1] };
			let mut fTemp119: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp118) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 97.5) as i32)) as usize] } * if (((fTemp118 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { fTemp117 } else { self.fRec37[1] };
			let mut fTemp120: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp121: F32 = self.fRec34[0] - fTemp120;
			let mut fTemp122: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp121) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 63.5) as i32)) as usize] } * if (((fTemp121 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp120)) + 2.0) } else { 0.96 }))));
			let mut fTemp123: F32 = fTemp122 + fTemp119;
			let mut fTemp124: F32 = self.fRec37[0] - self.fRec35[0];
			let mut fTemp125: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp124) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 54.5) as i32)) as usize] } * if (((fTemp124 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp126: F32 = fTemp123 + fTemp125;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp126, self.fRec38[1] + 1.0) };
			let mut iTemp127: i32 = ((self.fRec38[0] < fTemp123) as i32);
			let mut fTemp128: F32 = (self.fRec38[0] - fTemp123) / fTemp125;
			let mut iTemp129: i32 = ((self.fRec38[0] < fTemp122) as i32);
			let mut fTemp130: F32 = (self.fRec38[0] - fTemp122) / fTemp119;
			let mut fTemp131: F32 = self.fRec38[0] / fTemp122;
			let mut fTemp132: F32 = if (iTemp127 as i32 != 0) { if (iTemp129 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp120 } else { if (iTemp129 as i32 != 0) { fTemp120 + fTemp121 * if (((self.fRec34[0] > fTemp120) as i32) as i32 != 0) { F32::powf(fTemp131, 0.33333334) } else { fTemp131 } } else { self.fRec34[0] } } } else { if (iTemp127 as i32 != 0) { self.fRec34[0] + fTemp118 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp130, 0.33333334) } else { fTemp130 } } else { self.fRec35[0] } } } else { if (((self.fRec38[0] < fTemp126) as i32) as i32 != 0) { self.fRec35[0] + fTemp124 * if (((self.fRec37[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp128, 0.33333334) } else { fTemp128 } } else { self.fRec37[0] } };
			let mut iTemp133: i32 = ((fTemp132) as i32);
			let mut fTemp134: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp133) as usize] };
			let mut fTemp135: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec39[1] + fSlow33 * fTemp91 };
			self.fRec39[0] = fTemp135 - F32::floor(fTemp135);
			let mut fTemp136: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow34 * fTemp91 };
			self.fRec40[0] = fTemp136 - F32::floor(fTemp136);
			let mut fTemp137: F32 = unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * self.fRec39[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp134 + (fTemp132 - ((iTemp133) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp133, 1)) as usize] } - fTemp134)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp115 + (fTemp113 - ((iTemp114) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp114, 1)) as usize] } - fTemp115)) + unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec29[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec28[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * self.fRec16[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp52 + (fTemp50 - ((iTemp51) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp51, 1)) as usize] } - fTemp52)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp37 + (fTemp35 - ((iTemp36) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp36, 1)) as usize] } - fTemp37)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22));
			self.fVec4[0] = fTemp137;
			self.fRec0[0] = 0.115 * (self.fConst20 * fTemp137 + self.fConst21 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow37 * self.fRec0[0];
			*output1 = fSlow38 * self.fRec0[0];
			*output2 = fSlow39 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.iRec22[1] = self.iRec22[0];
			self.iRec23[1] = self.iRec23[0];
			self.iRec24[1] = self.iRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Tom2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = fSlow2 + -57.3;
		let mut fSlow4: F32 = 0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow3));
		let mut fSlow5: F32 = F32::min(99.0, 0.64646465 * fSlow4 + 99.0);
		let mut fSlow6: F32 = 0.33333334 * (fSlow2 + -1.3) + 1.0;
		let mut fSlow7: F32 = 0.71428573 * fSlow6;
		let mut fSlow8: F32 = F32::min(99.0, 0.64646465 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow2 + -45.3))) + 77.0);
		let mut fSlow9: F32 = F32::min(99.0, 1.1919192 * F32::max(0.0, F32::abs(-1.0 * fSlow3)) + 0.6969697 * fSlow4 + 99.0);
		let mut fSlow10: F32 = 0.14285715 * fSlow6;
		let mut fSlow11: F32 = F32::max(0.0, F32::min(127.0, fSlow9));
		let mut fSlow12: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow11) * (fSlow11 + 28.0);
		let mut fSlow13: F32 = fSlow12 + 4064.0;
		let mut fSlow14: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -70.3));
		let mut fSlow15: F32 = 1.0 - 0.008333334 * (17.31234 * F32::log(fSlow14, std::f32::consts::E) + 48.0);
		let mut fSlow16: F32 = 15.996094 * (0.1 * fSlow15 + 128.0);
		let mut iSlow17: i32 = ((fSlow16) as i32);
		let mut fSlow18: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow17) as usize] };
		let mut fSlow19: F32 = fSlow18 + (fSlow16 - ((iSlow17) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow17, 1)) as usize] } - fSlow18);
		let mut fSlow20: F32 = self.fConst14 * fSlow14;
		let mut fSlow21: F32 = 15.996094 * (0.042857144 * fSlow15 + 128.0);
		let mut iSlow22: i32 = ((fSlow21) as i32);
		let mut fSlow23: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow22) as usize] };
		let mut fSlow24: F32 = fSlow23 + (fSlow21 - ((iSlow22) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow22, 1)) as usize] } - fSlow23);
		let mut fSlow25: F32 = self.fConst15 * fSlow14;
		let mut fSlow26: F32 = 15.996094 * (0.057142857 * fSlow15 + 128.0);
		let mut iSlow27: i32 = ((fSlow26) as i32);
		let mut fSlow28: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow27) as usize] };
		let mut fSlow29: F32 = fSlow28 + (fSlow26 - ((iSlow27) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow27, 1)) as usize] } - fSlow28);
		let mut fSlow30: F32 = self.fConst16 * fSlow14;
		let mut fSlow31: F32 = self.fConst17 * fSlow14;
		let mut fSlow32: F32 = 0.42857143 * fSlow6;
		let mut fSlow33: F32 = self.fConst18 * fSlow14;
		let mut fSlow34: F32 = self.fConst19 * fSlow14;
		let mut fSlow35: F32 = 0.01 * self.fHslider3;
		let mut fSlow36: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow37: F32 = fSlow36 * F32::min(1.0, 1.0 - fSlow35);
		let mut fSlow38: F32 = fSlow36 * F32::min(1.0, fSlow35 + 1.0);
		let mut fSlow39: F32 = 0.01 * self.fHslider5 * fSlow36;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = 0.71428573 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec4[1] };
			let mut fTemp8: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 38.5) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 98.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp14, self.fRec7[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec7[0] - fTemp13) / fTemp9;
			let mut fTemp19: F32 = self.fRec7[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp17 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec2[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec2[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec2[0] + fTemp8 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, fSlow8 + fTemp5));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec10[1] };
			let mut fTemp25: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 26.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp28: F32 = self.fRec9[0] - fTemp27;
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp30: F32 = fTemp29 + fTemp26;
			self.fRec11[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp30, self.fRec11[1] + 1.0) };
			let mut iTemp31: i32 = ((self.fRec11[0] < fTemp30) as i32);
			let mut iTemp32: i32 = ((self.fRec11[0] < fTemp29) as i32);
			let mut fTemp33: F32 = (self.fRec11[0] - fTemp29) / fTemp26;
			let mut fTemp34: F32 = self.fRec11[0] / fTemp29;
			let mut fTemp35: F32 = if (iTemp31 as i32 != 0) { if (iTemp32 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp32 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec9[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec9[0] } } } else { if (iTemp31 as i32 != 0) { self.fRec9[0] + fTemp25 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp33, 0.33333334) } else { fTemp33 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp36: i32 = ((fTemp35) as i32);
			let mut fTemp37: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp36) as usize] };
			let mut fTemp38: F32 = F32::max(0.0, F32::min(127.0, fSlow9 + fTemp5));
			let mut fTemp39: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp38) * (fTemp38 + 28.0);
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp39 + 4064.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp39 } else { self.fRec13[1] };
			let mut fTemp40: F32 = self.fRec13[0] - self.fRec12[0];
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec14[1] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp40) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 79.5) as i32)) as usize] } * if (((fTemp40 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp43: F32 = self.fRec12[0] - fTemp42;
			let mut fTemp44: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp43) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 95.5) as i32)) as usize] } * if (((fTemp43 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp42)) + 2.0) } else { 0.96 }))));
			let mut fTemp45: F32 = fTemp44 + fTemp41;
			self.fRec15[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp45, self.fRec15[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec15[0] < fTemp45) as i32);
			let mut iTemp47: i32 = ((self.fRec15[0] < fTemp44) as i32);
			let mut fTemp48: F32 = (self.fRec15[0] - fTemp44) / fTemp41;
			let mut fTemp49: F32 = self.fRec15[0] / fTemp44;
			let mut fTemp50: F32 = if (iTemp46 as i32 != 0) { if (iTemp47 as i32 != 0) { if (((self.fRec15[0] < 0.0) as i32) as i32 != 0) { fTemp42 } else { if (iTemp47 as i32 != 0) { fTemp42 + fTemp43 * if (((self.fRec12[0] > fTemp42) as i32) as i32 != 0) { F32::powf(fTemp49, 0.33333334) } else { fTemp49 } } else { self.fRec12[0] } } } else { if (iTemp46 as i32 != 0) { self.fRec12[0] + fTemp40 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp48, 0.33333334) } else { fTemp48 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp51: i32 = ((fTemp50) as i32);
			let mut fTemp52: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp51) as usize] };
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow13 } else { self.fRec17[1] };
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec18[1] };
			let mut fTemp53: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 78.5) as i32)) as usize] } * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp56: F32 = self.fRec17[0] - fTemp55;
			let mut fTemp57: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp56) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp56 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp55)) + 2.0) } else { 0.96 }))));
			let mut fTemp58: F32 = fTemp57 + fTemp54;
			let mut fTemp59: F32 = self.fRec17[0] - self.fRec18[0];
			let mut fTemp60: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp59) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp59 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp61: F32 = fTemp58 + fTemp60;
			self.fRec19[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec19[1] + 1.0) };
			let mut iTemp62: i32 = ((self.fRec19[0] < fTemp58) as i32);
			let mut fTemp63: F32 = (self.fRec19[0] - fTemp58) / fTemp60;
			let mut iTemp64: i32 = ((self.fRec19[0] < fTemp57) as i32);
			let mut fTemp65: F32 = (self.fRec19[0] - fTemp57) / fTemp54;
			let mut fTemp66: F32 = self.fRec19[0] / fTemp57;
			let mut fTemp67: F32 = if (iTemp62 as i32 != 0) { if (iTemp64 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp55 } else { if (iTemp64 as i32 != 0) { fTemp55 + fTemp56 * if (((self.fRec17[0] > fTemp55) as i32) as i32 != 0) { F32::powf(fTemp66, 0.33333334) } else { fTemp66 } } else { self.fRec17[0] } } } else { if (iTemp62 as i32 != 0) { self.fRec17[0] + fTemp53 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec18[0] } } } else { if (((self.fRec19[0] < fTemp61) as i32) as i32 != 0) { self.fRec18[0] + fTemp59 * if (((self.fRec17[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec17[0] } };
			let mut iTemp68: i32 = ((fTemp67) as i32);
			let mut fTemp69: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp68) as usize] };
			let mut iTemp70: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec22[1] };
			self.iRec23[0] = if (iTemp3 as i32 != 0) { self.iConst8 } else { self.iRec23[1] };
			let mut iTemp71: i32 = i32::wrapping_sub(self.iRec23[0], self.iRec22[0]);
			let mut fTemp72: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp71)) as F32) / self.fConst6));
			self.iRec24[0] = if (iTemp3 as i32 != 0) { self.iConst11 } else { self.iRec24[1] };
			let mut iTemp73: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec24[0]);
			let mut fTemp74: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp73)) as F32) / self.fConst10));
			let mut fTemp75: F32 = fTemp74 + fTemp72;
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec26[1] };
			let mut iTemp76: i32 = i32::wrapping_sub(self.iRec26[0], self.iRec23[0]);
			let mut fTemp77: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp76)) as F32) / self.fConst12));
			let mut fTemp78: F32 = fTemp75 + fTemp77;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp78, self.fRec25[1] + 1.0) };
			let mut iTemp79: i32 = ((self.fRec25[0] < fTemp75) as i32);
			let mut fTemp80: F32 = (self.fRec25[0] - fTemp75) / fTemp77;
			let mut fTemp81: F32 = ((self.iRec23[0]) as F32);
			let mut iTemp82: i32 = ((self.fRec25[0] < fTemp74) as i32);
			let mut fTemp83: F32 = (self.fRec25[0] - fTemp74) / fTemp72;
			let mut fTemp84: F32 = ((self.iRec22[0]) as F32);
			let mut fTemp85: F32 = self.fRec25[0] / fTemp74;
			let mut fTemp86: F32 = ((self.iRec24[0]) as F32);
			let mut fTemp87: F32 = 15.996094 * (0.4 * if (iTemp79 as i32 != 0) { if (iTemp82 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp86 } else { if (iTemp82 as i32 != 0) { fTemp86 + ((iTemp73) as F32) * if (((self.iRec22[0] > self.iRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { fTemp84 } } } else { if (iTemp79 as i32 != 0) { fTemp84 + ((iTemp71) as F32) * if (((self.iRec23[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { fTemp81 } } } else { if (((self.fRec25[0] < fTemp78) as i32) as i32 != 0) { fTemp81 + ((iTemp76) as F32) * if (((self.iRec26[0] > self.iRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { ((self.iRec26[0]) as F32) } } + 128.0);
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iTemp88) as usize] };
			let mut fTemp90: F32 = fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89);
			let mut fTemp91: F32 = fSlow19 * fTemp90;
			let mut fTemp92: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec20[1] + fSlow20 * fTemp91 };
			self.fRec20[0] = fTemp92 - F32::floor(fTemp92);
			self.fRec16[0] = 0.115 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec20[0] + 20.869566 * self.fRec16[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp69 + (fTemp67 - ((iTemp68) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp68, 1)) as usize] } - fTemp69));
			let mut fTemp93: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow25 * fTemp90 * fSlow24 };
			self.fRec27[0] = fTemp93 - F32::floor(fTemp93);
			let mut fTemp94: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec28[1] + fSlow30 * fTemp90 * fSlow29 };
			self.fRec28[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec29[1] + fSlow31 * fTemp91 };
			self.fRec29[0] = fTemp95 - F32::floor(fTemp95);
			let mut fTemp96: F32 = 0.5714286 * fTemp4;
			let mut fTemp97: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 99.0));
			let mut fTemp98: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp97) * (fTemp97 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp98 + 4064.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp98 + 2368.0 } else { self.fRec31[1] };
			let mut fTemp99: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp100: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp99) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 37.5) as i32)) as usize] } * if (((fTemp99 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp98 } else { self.fRec32[1] };
			let mut fTemp101: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp102: F32 = self.fRec30[0] - fTemp101;
			let mut fTemp103: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp102) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 94.5) as i32)) as usize] } * if (((fTemp102 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp101)) + 2.0) } else { 0.96 }))));
			let mut fTemp104: F32 = fTemp103 + fTemp100;
			let mut fTemp105: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp106: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp105) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 57.5) as i32)) as usize] } * if (((fTemp105 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp107: F32 = fTemp104 + fTemp106;
			self.fRec33[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp107, self.fRec33[1] + 1.0) };
			let mut iTemp108: i32 = ((self.fRec33[0] < fTemp104) as i32);
			let mut fTemp109: F32 = (self.fRec33[0] - fTemp104) / fTemp106;
			let mut iTemp110: i32 = ((self.fRec33[0] < fTemp103) as i32);
			let mut fTemp111: F32 = (self.fRec33[0] - fTemp103) / fTemp100;
			let mut fTemp112: F32 = self.fRec33[0] / fTemp103;
			let mut fTemp113: F32 = if (iTemp108 as i32 != 0) { if (iTemp110 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp101 } else { if (iTemp110 as i32 != 0) { fTemp101 + fTemp102 * if (((self.fRec30[0] > fTemp101) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec30[0] } } } else { if (iTemp108 as i32 != 0) { self.fRec30[0] + fTemp99 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp111, 0.33333334) } else { fTemp111 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp107) as i32) as i32 != 0) { self.fRec31[0] + fTemp105 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec32[0] } };
			let mut iTemp114: i32 = ((fTemp113) as i32);
			let mut fTemp115: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp114) as usize] };
			let mut fTemp116: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 69.0));
			let mut fTemp117: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp116) * (fTemp116 + 28.0);
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp117 + 2464.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp117 + 4064.0 } else { self.fRec35[1] };
			let mut fTemp118: F32 = self.fRec35[0] - self.fRec34[0];
			self.fRec36[0] = if (iTemp3 as i32 != 0) { fSlow32 } else { self.fRec36[1] };
			let mut fTemp119: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp118) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 97.5) as i32)) as usize] } * if (((fTemp118 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { fTemp117 } else { self.fRec37[1] };
			let mut fTemp120: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp121: F32 = self.fRec34[0] - fTemp120;
			let mut fTemp122: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp121) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 63.5) as i32)) as usize] } * if (((fTemp121 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp120)) + 2.0) } else { 0.96 }))));
			let mut fTemp123: F32 = fTemp122 + fTemp119;
			let mut fTemp124: F32 = self.fRec37[0] - self.fRec35[0];
			let mut fTemp125: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp124) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 54.5) as i32)) as usize] } * if (((fTemp124 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp126: F32 = fTemp123 + fTemp125;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp126, self.fRec38[1] + 1.0) };
			let mut iTemp127: i32 = ((self.fRec38[0] < fTemp123) as i32);
			let mut fTemp128: F32 = (self.fRec38[0] - fTemp123) / fTemp125;
			let mut iTemp129: i32 = ((self.fRec38[0] < fTemp122) as i32);
			let mut fTemp130: F32 = (self.fRec38[0] - fTemp122) / fTemp119;
			let mut fTemp131: F32 = self.fRec38[0] / fTemp122;
			let mut fTemp132: F32 = if (iTemp127 as i32 != 0) { if (iTemp129 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp120 } else { if (iTemp129 as i32 != 0) { fTemp120 + fTemp121 * if (((self.fRec34[0] > fTemp120) as i32) as i32 != 0) { F32::powf(fTemp131, 0.33333334) } else { fTemp131 } } else { self.fRec34[0] } } } else { if (iTemp127 as i32 != 0) { self.fRec34[0] + fTemp118 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp130, 0.33333334) } else { fTemp130 } } else { self.fRec35[0] } } } else { if (((self.fRec38[0] < fTemp126) as i32) as i32 != 0) { self.fRec35[0] + fTemp124 * if (((self.fRec37[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp128, 0.33333334) } else { fTemp128 } } else { self.fRec37[0] } };
			let mut iTemp133: i32 = ((fTemp132) as i32);
			let mut fTemp134: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp133) as usize] };
			let mut fTemp135: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec39[1] + fSlow33 * fTemp91 };
			self.fRec39[0] = fTemp135 - F32::floor(fTemp135);
			let mut fTemp136: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow34 * fTemp91 };
			self.fRec40[0] = fTemp136 - F32::floor(fTemp136);
			let mut fTemp137: F32 = unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * self.fRec39[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp134 + (fTemp132 - ((iTemp133) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp133, 1)) as usize] } - fTemp134)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp115 + (fTemp113 - ((iTemp114) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp114, 1)) as usize] } - fTemp115)) + unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec29[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec28[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * self.fRec16[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp52 + (fTemp50 - ((iTemp51) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp51, 1)) as usize] } - fTemp52)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp37 + (fTemp35 - ((iTemp36) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp36, 1)) as usize] } - fTemp37)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22));
			self.fVec4[0] = fTemp137;
			self.fRec0[0] = 0.115 * (self.fConst20 * fTemp137 + self.fConst21 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow37 * self.fRec0[0];
			*output1 = fSlow38 * self.fRec0[0];
			*output2 = fSlow39 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.iRec22[1] = self.iRec22[0];
			self.iRec23[1] = self.iRec23[0];
			self.iRec24[1] = self.iRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom2 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Tom2 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom2 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = fSlow2 + -57.3;
		let mut fSlow4: F32 = 0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow3));
		let mut fSlow5: F32 = F32::min(99.0, 0.64646465 * fSlow4 + 99.0);
		let mut fSlow6: F32 = 0.33333334 * (fSlow2 + -1.3) + 1.0;
		let mut fSlow7: F32 = 0.71428573 * fSlow6;
		let mut fSlow8: F32 = F32::min(99.0, 0.64646465 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow2 + -45.3))) + 77.0);
		let mut fSlow9: F32 = F32::min(99.0, 1.1919192 * F32::max(0.0, F32::abs(-1.0 * fSlow3)) + 0.6969697 * fSlow4 + 99.0);
		let mut fSlow10: F32 = 0.14285715 * fSlow6;
		let mut fSlow11: F32 = F32::max(0.0, F32::min(127.0, fSlow9));
		let mut fSlow12: F32 = 32.0 * F32::min(1.0, 0.05 * fSlow11) * (fSlow11 + 28.0);
		let mut fSlow13: F32 = fSlow12 + 4064.0;
		let mut fSlow14: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -70.3));
		let mut fSlow15: F32 = 1.0 - 0.008333334 * (17.31234 * F32::log(fSlow14, std::f32::consts::E) + 48.0);
		let mut fSlow16: F32 = 15.996094 * (0.1 * fSlow15 + 128.0);
		let mut iSlow17: i32 = ((fSlow16) as i32);
		let mut fSlow18: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow17) as usize] };
		let mut fSlow19: F32 = fSlow18 + (fSlow16 - ((iSlow17) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow17, 1)) as usize] } - fSlow18);
		let mut fSlow20: F32 = self.fConst14 * fSlow14;
		let mut fSlow21: F32 = 15.996094 * (0.042857144 * fSlow15 + 128.0);
		let mut iSlow22: i32 = ((fSlow21) as i32);
		let mut fSlow23: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow22) as usize] };
		let mut fSlow24: F32 = fSlow23 + (fSlow21 - ((iSlow22) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow22, 1)) as usize] } - fSlow23);
		let mut fSlow25: F32 = self.fConst15 * fSlow14;
		let mut fSlow26: F32 = 15.996094 * (0.057142857 * fSlow15 + 128.0);
		let mut iSlow27: i32 = ((fSlow26) as i32);
		let mut fSlow28: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iSlow27) as usize] };
		let mut fSlow29: F32 = fSlow28 + (fSlow26 - ((iSlow27) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iSlow27, 1)) as usize] } - fSlow28);
		let mut fSlow30: F32 = self.fConst16 * fSlow14;
		let mut fSlow31: F32 = self.fConst17 * fSlow14;
		let mut fSlow32: F32 = 0.42857143 * fSlow6;
		let mut fSlow33: F32 = self.fConst18 * fSlow14;
		let mut fSlow34: F32 = self.fConst19 * fSlow14;
		let mut fSlow35: F32 = 0.01 * self.fHslider3;
		let mut fSlow36: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4));
		let mut fSlow37: F32 = fSlow36 * F32::min(1.0, 1.0 - fSlow35);
		let mut fSlow38: F32 = fSlow36 * F32::min(1.0, fSlow35 + 1.0);
		let mut fSlow39: F32 = 0.01 * self.fHslider5 * fSlow36;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom2_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = 0.71428573 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec4[1] };
			let mut fTemp8: F32 = self.fRec4[0] - self.fRec2[0];
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow7 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp8) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 38.5) as i32)) as usize] } * if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec4[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 98.5) as i32)) as usize] };
			let mut fTemp13: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp11) / (fTemp12 * if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 }))));
			let mut fTemp14: F32 = fTemp13 + fTemp9;
			let mut iTemp15: i32 = ((iTemp2 > 0) as i32);
			self.fRec7[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp14, self.fRec7[1] + 1.0) };
			let mut iTemp16: i32 = ((self.fRec7[0] < fTemp14) as i32);
			let mut iTemp17: i32 = ((self.fRec7[0] < fTemp13) as i32);
			let mut fTemp18: F32 = (self.fRec7[0] - fTemp13) / fTemp9;
			let mut fTemp19: F32 = self.fRec7[0] / fTemp13;
			let mut fTemp20: F32 = if (iTemp16 as i32 != 0) { if (iTemp17 as i32 != 0) { if (((self.fRec7[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp17 as i32 != 0) { fTemp10 + fTemp11 * if (((self.fRec2[0] > fTemp10) as i32) as i32 != 0) { F32::powf(fTemp19, 0.33333334) } else { fTemp19 } } else { self.fRec2[0] } } } else { if (iTemp16 as i32 != 0) { self.fRec2[0] + fTemp8 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp18, 0.33333334) } else { fTemp18 } } else { self.fRec4[0] } } } else { self.fRec4[0] };
			let mut iTemp21: i32 = ((fTemp20) as i32);
			let mut fTemp22: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp21) as usize] };
			let mut fTemp23: F32 = F32::max(0.0, F32::min(127.0, fSlow8 + fTemp5));
			let mut fTemp24: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp23) * (fTemp23 + 28.0);
			self.fRec9[0] = if (iTemp3 as i32 != 0) { fTemp24 + 4064.0 } else { self.fRec9[1] };
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp24 } else { self.fRec10[1] };
			let mut fTemp25: F32 = self.fRec10[0] - self.fRec9[0];
			let mut fTemp26: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp25) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 26.5) as i32)) as usize] } * if (((fTemp25 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec9[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp27: F32 = F32::max(5076.0, self.fRec10[0]);
			let mut fTemp28: F32 = self.fRec9[0] - fTemp27;
			let mut fTemp29: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp28) / (fTemp12 * if (((fTemp28 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp27)) + 2.0) } else { 0.96 }))));
			let mut fTemp30: F32 = fTemp29 + fTemp26;
			self.fRec11[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp30, self.fRec11[1] + 1.0) };
			let mut iTemp31: i32 = ((self.fRec11[0] < fTemp30) as i32);
			let mut iTemp32: i32 = ((self.fRec11[0] < fTemp29) as i32);
			let mut fTemp33: F32 = (self.fRec11[0] - fTemp29) / fTemp26;
			let mut fTemp34: F32 = self.fRec11[0] / fTemp29;
			let mut fTemp35: F32 = if (iTemp31 as i32 != 0) { if (iTemp32 as i32 != 0) { if (((self.fRec11[0] < 0.0) as i32) as i32 != 0) { fTemp27 } else { if (iTemp32 as i32 != 0) { fTemp27 + fTemp28 * if (((self.fRec9[0] > fTemp27) as i32) as i32 != 0) { F32::powf(fTemp34, 0.33333334) } else { fTemp34 } } else { self.fRec9[0] } } } else { if (iTemp31 as i32 != 0) { self.fRec9[0] + fTemp25 * if (((self.fRec10[0] > self.fRec9[0]) as i32) as i32 != 0) { F32::powf(fTemp33, 0.33333334) } else { fTemp33 } } else { self.fRec10[0] } } } else { self.fRec10[0] };
			let mut iTemp36: i32 = ((fTemp35) as i32);
			let mut fTemp37: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp36) as usize] };
			let mut fTemp38: F32 = F32::max(0.0, F32::min(127.0, fSlow9 + fTemp5));
			let mut fTemp39: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp38) * (fTemp38 + 28.0);
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fTemp39 + 4064.0 } else { self.fRec12[1] };
			self.fRec13[0] = if (iTemp3 as i32 != 0) { fTemp39 } else { self.fRec13[1] };
			let mut fTemp40: F32 = self.fRec13[0] - self.fRec12[0];
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fSlow10 } else { self.fRec14[1] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp40) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 79.5) as i32)) as usize] } * if (((fTemp40 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec12[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = F32::max(5076.0, self.fRec13[0]);
			let mut fTemp43: F32 = self.fRec12[0] - fTemp42;
			let mut fTemp44: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp43) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec14[0] + 95.5) as i32)) as usize] } * if (((fTemp43 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp42)) + 2.0) } else { 0.96 }))));
			let mut fTemp45: F32 = fTemp44 + fTemp41;
			self.fRec15[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp45, self.fRec15[1] + 1.0) };
			let mut iTemp46: i32 = ((self.fRec15[0] < fTemp45) as i32);
			let mut iTemp47: i32 = ((self.fRec15[0] < fTemp44) as i32);
			let mut fTemp48: F32 = (self.fRec15[0] - fTemp44) / fTemp41;
			let mut fTemp49: F32 = self.fRec15[0] / fTemp44;
			let mut fTemp50: F32 = if (iTemp46 as i32 != 0) { if (iTemp47 as i32 != 0) { if (((self.fRec15[0] < 0.0) as i32) as i32 != 0) { fTemp42 } else { if (iTemp47 as i32 != 0) { fTemp42 + fTemp43 * if (((self.fRec12[0] > fTemp42) as i32) as i32 != 0) { F32::powf(fTemp49, 0.33333334) } else { fTemp49 } } else { self.fRec12[0] } } } else { if (iTemp46 as i32 != 0) { self.fRec12[0] + fTemp40 * if (((self.fRec13[0] > self.fRec12[0]) as i32) as i32 != 0) { F32::powf(fTemp48, 0.33333334) } else { fTemp48 } } else { self.fRec13[0] } } } else { self.fRec13[0] };
			let mut iTemp51: i32 = ((fTemp50) as i32);
			let mut fTemp52: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp51) as usize] };
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fSlow13 } else { self.fRec17[1] };
			self.fRec18[0] = if (iTemp3 as i32 != 0) { fSlow12 } else { self.fRec18[1] };
			let mut fTemp53: F32 = self.fRec18[0] - self.fRec17[0];
			let mut fTemp54: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp53) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 78.5) as i32)) as usize] } * if (((fTemp53 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec17[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp55: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp56: F32 = self.fRec17[0] - fTemp55;
			let mut fTemp57: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp56) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 95.5) as i32)) as usize] } * if (((fTemp56 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp55)) + 2.0) } else { 0.96 }))));
			let mut fTemp58: F32 = fTemp57 + fTemp54;
			let mut fTemp59: F32 = self.fRec17[0] - self.fRec18[0];
			let mut fTemp60: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp59) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 69.5) as i32)) as usize] } * if (((fTemp59 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec18[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp61: F32 = fTemp58 + fTemp60;
			self.fRec19[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp61, self.fRec19[1] + 1.0) };
			let mut iTemp62: i32 = ((self.fRec19[0] < fTemp58) as i32);
			let mut fTemp63: F32 = (self.fRec19[0] - fTemp58) / fTemp60;
			let mut iTemp64: i32 = ((self.fRec19[0] < fTemp57) as i32);
			let mut fTemp65: F32 = (self.fRec19[0] - fTemp57) / fTemp54;
			let mut fTemp66: F32 = self.fRec19[0] / fTemp57;
			let mut fTemp67: F32 = if (iTemp62 as i32 != 0) { if (iTemp64 as i32 != 0) { if (((self.fRec19[0] < 0.0) as i32) as i32 != 0) { fTemp55 } else { if (iTemp64 as i32 != 0) { fTemp55 + fTemp56 * if (((self.fRec17[0] > fTemp55) as i32) as i32 != 0) { F32::powf(fTemp66, 0.33333334) } else { fTemp66 } } else { self.fRec17[0] } } } else { if (iTemp62 as i32 != 0) { self.fRec17[0] + fTemp53 * if (((self.fRec18[0] > self.fRec17[0]) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec18[0] } } } else { if (((self.fRec19[0] < fTemp61) as i32) as i32 != 0) { self.fRec18[0] + fTemp59 * if (((self.fRec17[0] > self.fRec18[0]) as i32) as i32 != 0) { F32::powf(fTemp63, 0.33333334) } else { fTemp63 } } else { self.fRec17[0] } };
			let mut iTemp68: i32 = ((fTemp67) as i32);
			let mut fTemp69: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp68) as usize] };
			let mut iTemp70: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst7 } else { self.iRec22[1] };
			self.iRec23[0] = if (iTemp3 as i32 != 0) { self.iConst8 } else { self.iRec23[1] };
			let mut iTemp71: i32 = i32::wrapping_sub(self.iRec23[0], self.iRec22[0]);
			let mut fTemp72: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp71)) as F32) / self.fConst6));
			self.iRec24[0] = if (iTemp3 as i32 != 0) { self.iConst11 } else { self.iRec24[1] };
			let mut iTemp73: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec24[0]);
			let mut fTemp74: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp73)) as F32) / self.fConst10));
			let mut fTemp75: F32 = fTemp74 + fTemp72;
			self.iRec26[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec26[1] };
			let mut iTemp76: i32 = i32::wrapping_sub(self.iRec26[0], self.iRec23[0]);
			let mut fTemp77: F32 = F32::max(1.0, self.fConst9 * (((i32::abs(iTemp76)) as F32) / self.fConst12));
			let mut fTemp78: F32 = fTemp75 + fTemp77;
			self.fRec25[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp78, self.fRec25[1] + 1.0) };
			let mut iTemp79: i32 = ((self.fRec25[0] < fTemp75) as i32);
			let mut fTemp80: F32 = (self.fRec25[0] - fTemp75) / fTemp77;
			let mut fTemp81: F32 = ((self.iRec23[0]) as F32);
			let mut iTemp82: i32 = ((self.fRec25[0] < fTemp74) as i32);
			let mut fTemp83: F32 = (self.fRec25[0] - fTemp74) / fTemp72;
			let mut fTemp84: F32 = ((self.iRec22[0]) as F32);
			let mut fTemp85: F32 = self.fRec25[0] / fTemp74;
			let mut fTemp86: F32 = ((self.iRec24[0]) as F32);
			let mut fTemp87: F32 = 15.996094 * (0.4 * if (iTemp79 as i32 != 0) { if (iTemp82 as i32 != 0) { if (((self.fRec25[0] < 0.0) as i32) as i32 != 0) { fTemp86 } else { if (iTemp82 as i32 != 0) { fTemp86 + ((iTemp73) as F32) * if (((self.iRec22[0] > self.iRec24[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { fTemp84 } } } else { if (iTemp79 as i32 != 0) { fTemp84 + ((iTemp71) as F32) * if (((self.iRec23[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { fTemp81 } } } else { if (((self.fRec25[0] < fTemp78) as i32) as i32 != 0) { fTemp81 + ((iTemp76) as F32) * if (((self.iRec26[0] > self.iRec23[0]) as i32) as i32 != 0) { F32::powf(fTemp80, 0.33333334) } else { fTemp80 } } else { ((self.iRec26[0]) as F32) } } + 128.0);
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl3DSP_Tom2SIG3[(iTemp88) as usize] };
			let mut fTemp90: F32 = fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl3DSP_Tom2SIG3[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89);
			let mut fTemp91: F32 = fSlow19 * fTemp90;
			let mut fTemp92: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec20[1] + fSlow20 * fTemp91 };
			self.fRec20[0] = fTemp92 - F32::floor(fTemp92);
			self.fRec16[0] = 0.115 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec20[0] + 20.869566 * self.fRec16[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp69 + (fTemp67 - ((iTemp68) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp68, 1)) as usize] } - fTemp69));
			let mut fTemp93: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow25 * fTemp90 * fSlow24 };
			self.fRec27[0] = fTemp93 - F32::floor(fTemp93);
			let mut fTemp94: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec28[1] + fSlow30 * fTemp90 * fSlow29 };
			self.fRec28[0] = fTemp94 - F32::floor(fTemp94);
			let mut fTemp95: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec29[1] + fSlow31 * fTemp91 };
			self.fRec29[0] = fTemp95 - F32::floor(fTemp95);
			let mut fTemp96: F32 = 0.5714286 * fTemp4;
			let mut fTemp97: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 99.0));
			let mut fTemp98: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp97) * (fTemp97 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp98 + 4064.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp98 + 2368.0 } else { self.fRec31[1] };
			let mut fTemp99: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp100: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp99) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 37.5) as i32)) as usize] } * if (((fTemp99 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp98 } else { self.fRec32[1] };
			let mut fTemp101: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp102: F32 = self.fRec30[0] - fTemp101;
			let mut fTemp103: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp102) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 94.5) as i32)) as usize] } * if (((fTemp102 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp101)) + 2.0) } else { 0.96 }))));
			let mut fTemp104: F32 = fTemp103 + fTemp100;
			let mut fTemp105: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp106: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp105) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec6[0] + 57.5) as i32)) as usize] } * if (((fTemp105 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp107: F32 = fTemp104 + fTemp106;
			self.fRec33[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp107, self.fRec33[1] + 1.0) };
			let mut iTemp108: i32 = ((self.fRec33[0] < fTemp104) as i32);
			let mut fTemp109: F32 = (self.fRec33[0] - fTemp104) / fTemp106;
			let mut iTemp110: i32 = ((self.fRec33[0] < fTemp103) as i32);
			let mut fTemp111: F32 = (self.fRec33[0] - fTemp103) / fTemp100;
			let mut fTemp112: F32 = self.fRec33[0] / fTemp103;
			let mut fTemp113: F32 = if (iTemp108 as i32 != 0) { if (iTemp110 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp101 } else { if (iTemp110 as i32 != 0) { fTemp101 + fTemp102 * if (((self.fRec30[0] > fTemp101) as i32) as i32 != 0) { F32::powf(fTemp112, 0.33333334) } else { fTemp112 } } else { self.fRec30[0] } } } else { if (iTemp108 as i32 != 0) { self.fRec30[0] + fTemp99 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp111, 0.33333334) } else { fTemp111 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp107) as i32) as i32 != 0) { self.fRec31[0] + fTemp105 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp109, 0.33333334) } else { fTemp109 } } else { self.fRec32[0] } };
			let mut iTemp114: i32 = ((fTemp113) as i32);
			let mut fTemp115: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp114) as usize] };
			let mut fTemp116: F32 = F32::max(0.0, F32::min(127.0, fTemp96 + 69.0));
			let mut fTemp117: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp116) * (fTemp116 + 28.0);
			self.fRec34[0] = if (iTemp3 as i32 != 0) { fTemp117 + 2464.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { fTemp117 + 4064.0 } else { self.fRec35[1] };
			let mut fTemp118: F32 = self.fRec35[0] - self.fRec34[0];
			self.fRec36[0] = if (iTemp3 as i32 != 0) { fSlow32 } else { self.fRec36[1] };
			let mut fTemp119: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp118) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 97.5) as i32)) as usize] } * if (((fTemp118 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec37[0] = if (iTemp3 as i32 != 0) { fTemp117 } else { self.fRec37[1] };
			let mut fTemp120: F32 = F32::max(5076.0, self.fRec37[0]);
			let mut fTemp121: F32 = self.fRec34[0] - fTemp120;
			let mut fTemp122: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp121) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 63.5) as i32)) as usize] } * if (((fTemp121 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp120)) + 2.0) } else { 0.96 }))));
			let mut fTemp123: F32 = fTemp122 + fTemp119;
			let mut fTemp124: F32 = self.fRec37[0] - self.fRec35[0];
			let mut fTemp125: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp124) / (unsafe { ftbl1DSP_Tom2SIG1[(((self.fRec36[0] + 54.5) as i32)) as usize] } * if (((fTemp124 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp126: F32 = fTemp123 + fTemp125;
			self.fRec38[0] = if (iTemp15 as i32 != 0) { 0.0 } else { F32::min(fTemp126, self.fRec38[1] + 1.0) };
			let mut iTemp127: i32 = ((self.fRec38[0] < fTemp123) as i32);
			let mut fTemp128: F32 = (self.fRec38[0] - fTemp123) / fTemp125;
			let mut iTemp129: i32 = ((self.fRec38[0] < fTemp122) as i32);
			let mut fTemp130: F32 = (self.fRec38[0] - fTemp122) / fTemp119;
			let mut fTemp131: F32 = self.fRec38[0] / fTemp122;
			let mut fTemp132: F32 = if (iTemp127 as i32 != 0) { if (iTemp129 as i32 != 0) { if (((self.fRec38[0] < 0.0) as i32) as i32 != 0) { fTemp120 } else { if (iTemp129 as i32 != 0) { fTemp120 + fTemp121 * if (((self.fRec34[0] > fTemp120) as i32) as i32 != 0) { F32::powf(fTemp131, 0.33333334) } else { fTemp131 } } else { self.fRec34[0] } } } else { if (iTemp127 as i32 != 0) { self.fRec34[0] + fTemp118 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp130, 0.33333334) } else { fTemp130 } } else { self.fRec35[0] } } } else { if (((self.fRec38[0] < fTemp126) as i32) as i32 != 0) { self.fRec35[0] + fTemp124 * if (((self.fRec37[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp128, 0.33333334) } else { fTemp128 } } else { self.fRec37[0] } };
			let mut iTemp133: i32 = ((fTemp132) as i32);
			let mut fTemp134: F32 = unsafe { ftbl0DSP_Tom2SIG0[(iTemp133) as usize] };
			let mut fTemp135: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec39[1] + fSlow33 * fTemp91 };
			self.fRec39[0] = fTemp135 - F32::floor(fTemp135);
			let mut fTemp136: F32 = if (iTemp70 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow34 * fTemp91 };
			self.fRec40[0] = fTemp136 - F32::floor(fTemp136);
			let mut fTemp137: F32 = unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * self.fRec39[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp134 + (fTemp132 - ((iTemp133) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp133, 1)) as usize] } - fTemp134)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp115 + (fTemp113 - ((iTemp114) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp114, 1)) as usize] } - fTemp115)) + unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec29[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec28[0] + 2.0 * unsafe { ftbl2DSP_Tom2SIG2[(((1024.0 * (self.fRec27[0] + 17.391304 * self.fRec16[0] + 1e+01)) as i32) % 1024) as usize] } * (fTemp52 + (fTemp50 - ((iTemp51) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp51, 1)) as usize] } - fTemp52)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp37 + (fTemp35 - ((iTemp36) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp36, 1)) as usize] } - fTemp37)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp22 + (fTemp20 - ((iTemp21) as F32)) * (unsafe { ftbl0DSP_Tom2SIG0[(i32::wrapping_add(iTemp21, 1)) as usize] } - fTemp22));
			self.fVec4[0] = fTemp137;
			self.fRec0[0] = 0.115 * (self.fConst20 * fTemp137 + self.fConst21 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow37 * self.fRec0[0];
			*output1 = fSlow38 * self.fRec0[0];
			*output2 = fSlow39 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec9[1] = self.fRec9[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec19[1] = self.fRec19[0];
			self.iRec22[1] = self.iRec22[0];
			self.iRec23[1] = self.iRec23[0];
			self.iRec24[1] = self.iRec24[0];
			self.iRec26[1] = self.iRec26[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
