// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Tom3 -pn processTom3 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Tom3SIG0 {
	iRec1: [i32;2],
}

impl DSP_Tom3SIG0 {
	
	fn get_num_inputsDSP_Tom3SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG0(&mut self, sample_rate: i32) {
		for l0 in 0..2 {
			self.iRec1[(l0) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom3SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Tom3SIG0() -> DSP_Tom3SIG0 { 
	DSP_Tom3SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Tom3SIG1 {
	iRec5: [i32;2],
}

impl DSP_Tom3SIG1 {
	
	fn get_num_inputsDSP_Tom3SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG1(&mut self, sample_rate: i32) {
		for l7 in 0..2 {
			self.iRec5[(l7) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom3SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec5[0] = i32::wrapping_add(self.iRec5[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec5[0], -1)) as F32));
			self.iRec5[1] = self.iRec5[0];
		}
	}

}


pub fn newDSP_Tom3SIG1() -> DSP_Tom3SIG1 { 
	DSP_Tom3SIG1 {
		iRec5: [0;2],
	}
}

pub struct DSP_Tom3SIG2 {
	iVec3: [i32;2],
	iRec9: [i32;2],
}

impl DSP_Tom3SIG2 {
	
	fn get_num_inputsDSP_Tom3SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec9[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom3SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec9[0] = (i32::wrapping_add(self.iVec3[1], self.iRec9[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec9[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec9[1] = self.iRec9[0];
		}
	}

}


pub fn newDSP_Tom3SIG2() -> DSP_Tom3SIG2 { 
	DSP_Tom3SIG2 {
		iVec3: [0;2],
		iRec9: [0;2],
	}
}

pub struct DSP_Tom3SIG3 {
	iRec20: [i32;2],
}

impl DSP_Tom3SIG3 {
	
	fn get_num_inputsDSP_Tom3SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG3(&mut self, sample_rate: i32) {
		for l22 in 0..2 {
			self.iRec20[(l22) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom3SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec20[0] = i32::wrapping_add(self.iRec20[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec20[0], -1)) as F32) + -128.0));
			self.iRec20[1] = self.iRec20[0];
		}
	}

}


pub fn newDSP_Tom3SIG3() -> DSP_Tom3SIG3 { 
	DSP_Tom3SIG3 {
		iRec20: [0;2],
	}
}
static mut iDSP_Tom3SIG4Wave0: [i32;100] = [1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,16,16,17,18,18,19,20,21,22,23,24,25,26,27,28,30,31,33,34,36,37,38,39,41,42,44,46,47,49,51,53,54,56,58,60,62,64,66,68,70,72,74,76,79,82,85,88,91,94,98,102,106,110,115,120,125,130,135,141,147,153,159,165,171,178,185,193,202,211,232,243,254,255];

pub struct DSP_Tom3SIG4 {
	iDSP_Tom3SIG4Wave0_idx: i32,
}

impl DSP_Tom3SIG4 {
	
	fn get_num_inputsDSP_Tom3SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Tom3SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Tom3SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Tom3SIG4Wave0[(self.iDSP_Tom3SIG4Wave0_idx) as usize] };
			self.iDSP_Tom3SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom3SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom3SIG4() -> DSP_Tom3SIG4 { 
	DSP_Tom3SIG4 {
		iDSP_Tom3SIG4Wave0_idx: 0,
	}
}
static mut iDSP_Tom3SIG5Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Tom3SIG5 {
	iDSP_Tom3SIG5Wave0_idx: i32,
}

impl DSP_Tom3SIG5 {
	
	fn get_num_inputsDSP_Tom3SIG5(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom3SIG5(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom3SIG5(&mut self, sample_rate: i32) {
		self.iDSP_Tom3SIG5Wave0_idx = 0;
	}
	
	fn fillDSP_Tom3SIG5(&mut self, count: i32, table: &mut[i32]) {
		for i6 in 0..count {
			table[(i6) as usize] = unsafe { iDSP_Tom3SIG5Wave0[(self.iDSP_Tom3SIG5Wave0_idx) as usize] };
			self.iDSP_Tom3SIG5Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom3SIG5Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom3SIG5() -> DSP_Tom3SIG5 { 
	DSP_Tom3SIG5 {
		iDSP_Tom3SIG5Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Tom3SIG0: [F32;16384] = [0.0;16384];
fn DSP_Tom3_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl1DSP_Tom3SIG1: [F32;144] = [0.0;144];
static mut ftbl2DSP_Tom3SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Tom3SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Tom3SIG4: [i32;100] = [0;100];
static mut itbl5DSP_Tom3SIG5: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Tom3 {
	fEntry0: F32,
	fVec0: [F32;2],
	iVec1: [i32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fRec3: [F32;2],
	fRec2: [F32;2],
	fRec4: [F32;2],
	fHslider1: F32,
	fHslider2: F32,
	fRec6: [F32;2],
	fSampleRate: i32,
	fConst0: F32,
	fRec7: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fConst1: F32,
	fRec13: [F32;2],
	fRec14: [F32;2],
	fRec15: [F32;2],
	fRec16: [F32;2],
	fRec17: [F32;2],
	fRec18: [F32;2],
	fConst2: F32,
	iConst3: i32,
	iRec21: [i32;2],
	iConst4: i32,
	iRec22: [i32;2],
	fConst5: F32,
	fConst6: F32,
	fRec23: [F32;2],
	fConst7: F32,
	fRec19: [F32;2],
	fConst9: F32,
	fRec24: [F32;2],
	fConst10: F32,
	fRec25: [F32;2],
	fRec27: [F32;2],
	fRec28: [F32;2],
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fRec32: [F32;2],
	fRec33: [F32;2],
	fRec34: [F32;2],
	fRec35: [F32;2],
	fRec36: [F32;2],
	fRec37: [F32;2],
	fConst11: F32,
	fRec38: [F32;2],
	fConst13: F32,
	fRec39: [F32;2],
	fConst14: F32,
	fRec40: [F32;2],
	fRec26: [F32;2],
	fVec4: [F32;2],
	fConst16: F32,
	fConst17: F32,
	fConst19: F32,
	fConst20: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_Tom3 {
	type T = F32;
		
	fn new() -> DSP_Tom3 { 
		DSP_Tom3 {
			fEntry0: 0.0,
			fVec0: [0.0;2],
			iVec1: [0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fRec3: [0.0;2],
			fRec2: [0.0;2],
			fRec4: [0.0;2],
			fHslider1: 0.0,
			fHslider2: 0.0,
			fRec6: [0.0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fRec7: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fConst1: 0.0,
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fRec15: [0.0;2],
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fRec18: [0.0;2],
			fConst2: 0.0,
			iConst3: 0,
			iRec21: [0;2],
			iConst4: 0,
			iRec22: [0;2],
			fConst5: 0.0,
			fConst6: 0.0,
			fRec23: [0.0;2],
			fConst7: 0.0,
			fRec19: [0.0;2],
			fConst9: 0.0,
			fRec24: [0.0;2],
			fConst10: 0.0,
			fRec25: [0.0;2],
			fRec27: [0.0;2],
			fRec28: [0.0;2],
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fRec32: [0.0;2],
			fRec33: [0.0;2],
			fRec34: [0.0;2],
			fRec35: [0.0;2],
			fRec36: [0.0;2],
			fRec37: [0.0;2],
			fConst11: 0.0,
			fRec38: [0.0;2],
			fConst13: 0.0,
			fRec39: [0.0;2],
			fConst14: 0.0,
			fRec40: [0.0;2],
			fRec26: [0.0;2],
			fVec4: [0.0;2],
			fConst16: 0.0,
			fConst17: 0.0,
			fConst19: 0.0,
			fConst20: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Tom3 -pn processTom3 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Tom3SIG0 = newDSP_Tom3SIG0();
		sig0.instance_initDSP_Tom3SIG0(sample_rate);
		sig0.fillDSP_Tom3SIG0(16384, unsafe { &mut ftbl0DSP_Tom3SIG0 });
		let mut sig1: DSP_Tom3SIG1 = newDSP_Tom3SIG1();
		sig1.instance_initDSP_Tom3SIG1(sample_rate);
		sig1.fillDSP_Tom3SIG1(144, unsafe { &mut ftbl1DSP_Tom3SIG1 });
		let mut sig2: DSP_Tom3SIG2 = newDSP_Tom3SIG2();
		sig2.instance_initDSP_Tom3SIG2(sample_rate);
		sig2.fillDSP_Tom3SIG2(1024, unsafe { &mut ftbl2DSP_Tom3SIG2 });
		let mut sig3: DSP_Tom3SIG3 = newDSP_Tom3SIG3();
		sig3.instance_initDSP_Tom3SIG3(sample_rate);
		sig3.fillDSP_Tom3SIG3(4096, unsafe { &mut ftbl3DSP_Tom3SIG3 });
		let mut sig4: DSP_Tom3SIG4 = newDSP_Tom3SIG4();
		sig4.instance_initDSP_Tom3SIG4(sample_rate);
		sig4.fillDSP_Tom3SIG4(100, unsafe { &mut itbl4DSP_Tom3SIG4 });
		let mut sig5: DSP_Tom3SIG5 = newDSP_Tom3SIG5();
		sig5.instance_initDSP_Tom3SIG5(sample_rate);
		sig5.fillDSP_Tom3SIG5(100, unsafe { &mut itbl5DSP_Tom3SIG5 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 0.0;
		self.fHslider1 = 36.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l1 in 0..2 {
			self.fVec0[(l1) as usize] = 0.0;
		}
		for l2 in 0..2 {
			self.iVec1[(l2) as usize] = 0;
		}
		for l3 in 0..2 {
			self.iVec2[(l3) as usize] = 0;
		}
		for l4 in 0..2 {
			self.fRec3[(l4) as usize] = 0.0;
		}
		for l5 in 0..2 {
			self.fRec2[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec4[(l6) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec8[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec15[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec16[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec17[(l20) as usize] = 0.0;
		}
		for l21 in 0..2 {
			self.fRec18[(l21) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.iRec21[(l23) as usize] = 0;
		}
		for l24 in 0..2 {
			self.iRec22[(l24) as usize] = 0;
		}
		for l25 in 0..2 {
			self.fRec23[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec19[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec24[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec25[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec27[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.fRec28[(l30) as usize] = 0.0;
		}
		for l31 in 0..2 {
			self.fRec29[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec30[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec31[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec32[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec33[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec34[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec35[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec36[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fRec37[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec38[(l40) as usize] = 0.0;
		}
		for l41 in 0..2 {
			self.fRec39[(l41) as usize] = 0.0;
		}
		for l42 in 0..2 {
			self.fRec40[(l42) as usize] = 0.0;
		}
		for l43 in 0..2 {
			self.fRec26[(l43) as usize] = 0.0;
		}
		for l44 in 0..2 {
			self.fVec4[(l44) as usize] = 0.0;
		}
		for l45 in 0..2 {
			self.fRec0[(l45) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		self.fConst1 = F32::max(1.0, 0.001 * self.fConst0);
		self.fConst2 = ((unsafe { itbl4DSP_Tom3SIG4[29] }) as F32);
		self.iConst3 = unsafe { itbl5DSP_Tom3SIG5[52] };
		self.iConst4 = unsafe { itbl5DSP_Tom3SIG5[50] };
		self.fConst5 = 0.64285713 * self.fConst0;
		self.fConst6 = ((unsafe { itbl4DSP_Tom3SIG4[75] }) as F32);
		self.fConst7 = 814.0 / self.fConst0;
		let mut fConst8: F32 = unsafe { ftbl3DSP_Tom3SIG3[2315] };
		self.fConst9 = 1.0 / self.fConst0 * (fConst8 + 0.3072414 * (unsafe { ftbl3DSP_Tom3SIG3[2316] } - fConst8));
		self.fConst10 = 332.2 / self.fConst0;
		self.fConst11 = 385.0 / self.fConst0;
		let mut fConst12: F32 = unsafe { ftbl3DSP_Tom3SIG3[2474] };
		self.fConst13 = 1e+02 / self.fConst0 * (fConst12 + 0.71631366 * (unsafe { ftbl3DSP_Tom3SIG3[2475] } - fConst12));
		self.fConst14 = 734.8 / self.fConst0;
		let mut fConst15: F32 = F32::tan(62.831852 / self.fConst0);
		self.fConst16 = 1.0 / fConst15;
		self.fConst17 = 1.0 - self.fConst16;
		let mut fConst18: F32 = self.fConst16 + 1.0;
		self.fConst19 = 1.0 / fConst18;
		self.fConst20 = 0.0 - 1.0 / (fConst15 * fConst18);
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Tom3::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "8", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(4), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(6), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			5 => Some(self.fHslider0),
			6 => Some(self.fHslider1),
			3 => Some(self.fHslider2),
			2 => Some(self.fHslider3),
			1 => Some(self.fHslider4),
			4 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			5 => { self.fHslider0 = value }
			6 => { self.fHslider1 = value }
			3 => { self.fHslider2 = value }
			2 => { self.fHslider3 = value }
			1 => { self.fHslider4 = value }
			4 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * (fSlow2 + 4.7) + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.71428573 * fSlow3;
		let mut fSlow6: F32 = 0.14285715 * fSlow3;
		let mut fSlow7: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow8: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow7, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow9: i32 = ((fSlow8) as i32);
		let mut fSlow10: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iSlow9) as usize] };
		let mut fSlow11: F32 = fSlow10 + (fSlow8 - ((iSlow9) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iSlow9, 1)) as usize] } - fSlow10);
		let mut fSlow12: F32 = self.fConst7 * fSlow7;
		let mut fSlow13: F32 = self.fConst10 * fSlow7;
		let mut fSlow14: F32 = 0.42857143 * fSlow3;
		let mut fSlow15: F32 = self.fConst11 * fSlow7;
		let mut fSlow16: F32 = self.fConst14 * fSlow7;
		let mut fSlow17: F32 = 0.01 * self.fHslider3;
		let mut fSlow18: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 1.5));
		let mut fSlow19: F32 = fSlow18 * F32::min(1.0, 1.0 - fSlow17);
		let mut fSlow20: F32 = fSlow18 * F32::min(1.0, fSlow17 + 1.0);
		let mut fSlow21: F32 = 0.01 * self.fHslider5 * fSlow18;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec0[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom3_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 1.92e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			let mut fTemp8: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0);
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 49.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 };
			let mut fTemp13: F32 = F32::abs(fTemp11);
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 84.5) as i32)) as usize] } * fTemp12))));
			let mut fTemp15: F32 = fTemp14 + fTemp9;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp18: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp17) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 77.5) as i32)) as usize] } * if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp19: F32 = fTemp15 + fTemp18;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp19, self.fRec8[1] + 1.0) };
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp15) / fTemp18;
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut fTemp23: F32 = (self.fRec8[0] - fTemp14) / fTemp9;
			let mut iTemp24: i32 = ((self.fRec2[0] > fTemp10) as i32);
			let mut fTemp25: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp26: F32 = if (iTemp20 as i32 != 0) { if (iTemp22 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp22 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp25, 0.33333334) } else { fTemp25 } } else { self.fRec2[0] } } } else { if (iTemp20 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp19) as i32) as i32 != 0) { self.fRec4[0] + fTemp17 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } };
			let mut iTemp27: i32 = ((fTemp26) as i32);
			let mut fTemp28: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp27) as usize] };
			let mut fTemp29: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 89.0));
			let mut fTemp30: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp29) * (fTemp29 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp30 + 4064.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp30 } else { self.fRec11[1] };
			let mut fTemp31: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 49.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp34: F32 = self.fRec10[0] - fTemp33;
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 82.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp33)) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp35 + fTemp32;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp36, self.fRec13[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec13[0] < fTemp36) as i32);
			let mut iTemp38: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp39: F32 = (self.fRec13[0] - fTemp35) / fTemp32;
			let mut fTemp40: F32 = self.fRec13[0] / fTemp35;
			let mut fTemp41: F32 = if (iTemp37 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp33 } else { if (iTemp38 as i32 != 0) { fTemp33 + fTemp34 * if (((self.fRec10[0] > fTemp33) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp31 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 71.0));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4e+03 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3456.0 } else { self.fRec15[1] };
			let mut fTemp46: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec16[1] };
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 85.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec17[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp49: F32 = self.fRec14[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 76.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec17[0] - self.fRec15[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 39.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec18[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec18[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec18[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec18[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec18[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec14[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec14[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec14[0] + fTemp46 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec15[0] } } } else { if (((self.fRec18[0] < fTemp54) as i32) as i32 != 0) { self.fRec15[0] + fTemp52 * if (((self.fRec17[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			self.iRec21[0] = if (iTemp3 as i32 != 0) { self.iConst3 } else { self.iRec21[1] };
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst4 } else { self.iRec22[1] };
			let mut iTemp64: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec21[0]);
			let mut fTemp65: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp64)) as F32) / self.fConst2));
			let mut iTemp66: i32 = i32::wrapping_sub(self.iRec21[0], self.iRec22[0]);
			let mut fTemp67: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp66)) as F32) / self.fConst6));
			let mut fTemp68: F32 = fTemp67 + fTemp65;
			self.fRec23[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp68 + 1.0, self.fRec23[1] + 1.0) };
			let mut iTemp69: i32 = ((self.fRec23[0] < fTemp68) as i32);
			let mut fTemp70: F32 = ((self.iRec22[0]) as F32);
			let mut iTemp71: i32 = ((self.fRec23[0] < fTemp67) as i32);
			let mut fTemp72: F32 = (self.fRec23[0] - fTemp67) / fTemp65;
			let mut fTemp73: F32 = ((self.iRec21[0]) as F32);
			let mut fTemp74: F32 = self.fRec23[0] / fTemp67;
			let mut fTemp75: F32 = 15.996094 * (0.4 * if (iTemp69 as i32 != 0) { if (iTemp71 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp71 as i32 != 0) { fTemp70 + ((iTemp66) as F32) * if (((self.iRec21[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { fTemp73 } } } else { if (iTemp69 as i32 != 0) { fTemp73 + ((iTemp64) as F32) * if (((self.iRec22[0] > self.iRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp72, 0.33333334) } else { fTemp72 } } else { fTemp70 } } } else { fTemp70 } + 128.0);
			let mut iTemp76: i32 = ((fTemp75) as i32);
			let mut fTemp77: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iTemp76) as usize] };
			let mut fTemp78: F32 = fSlow11 * (fTemp77 + (fTemp75 - ((iTemp76) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iTemp76, 1)) as usize] } - fTemp77));
			let mut fTemp79: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec19[1] + fSlow12 * fTemp78 };
			self.fRec19[0] = fTemp79 - F32::floor(fTemp79);
			let mut fTemp80: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst9 };
			self.fRec24[0] = fTemp80 - F32::floor(fTemp80);
			let mut fTemp81: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow13 * fTemp78 };
			self.fRec25[0] = fTemp81 - F32::floor(fTemp81);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec27[1] };
			let mut fTemp82: F32 = self.fRec27[0] - self.fRec2[0];
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow14 } else { self.fRec28[1] };
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 71.5) as i32)) as usize] } * if (((fTemp82 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (fTemp12 * unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 94.5) as i32)) as usize] }))));
			let mut fTemp85: F32 = fTemp84 + fTemp83;
			let mut fTemp86: F32 = self.fRec7[0] - self.fRec27[0];
			let mut fTemp87: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp86) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 50.5) as i32)) as usize] } * if (((fTemp86 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp88: F32 = fTemp85 + fTemp87;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp88, self.fRec29[1] + 1.0) };
			let mut iTemp89: i32 = ((self.fRec29[0] < fTemp85) as i32);
			let mut fTemp90: F32 = (self.fRec29[0] - fTemp85) / fTemp87;
			let mut iTemp91: i32 = ((self.fRec29[0] < fTemp84) as i32);
			let mut fTemp92: F32 = (self.fRec29[0] - fTemp84) / fTemp83;
			let mut fTemp93: F32 = self.fRec29[0] / fTemp84;
			let mut fTemp94: F32 = if (iTemp89 as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp91 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp93, 0.33333334) } else { fTemp93 } } else { self.fRec2[0] } } } else { if (iTemp89 as i32 != 0) { self.fRec2[0] + fTemp82 * if (((self.fRec27[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec27[0] } } } else { if (((self.fRec29[0] < fTemp88) as i32) as i32 != 0) { self.fRec27[0] + fTemp86 * if (((self.fRec7[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec7[0] } };
			let mut iTemp95: i32 = ((fTemp94) as i32);
			let mut fTemp96: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp95) as usize] };
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 3296.0 } else { self.fRec30[1] };
			let mut fTemp97: F32 = F32::max(5076.0, self.fRec30[0]);
			self.fRec31[0] = if (iTemp3 as i32 != 0) { 7.36e+03 } else { self.fRec31[1] };
			let mut fTemp98: F32 = self.fRec31[0] - fTemp97;
			self.fRec32[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec32[1] };
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp98) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 83.5) as i32)) as usize] } * if (((fTemp98 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp97)) + 2.0) } else { 0.96 }))));
			let mut fTemp100: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 71.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = self.fConst1 + fTemp99 + fTemp101;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp102, self.fRec33[1] + 1.0) };
			let mut fTemp103: F32 = (self.fRec33[0] - fTemp99 - self.fConst1) / fTemp101;
			let mut iTemp104: i32 = ((self.fRec33[0] < fTemp99) as i32);
			let mut fTemp105: F32 = self.fRec33[0] / fTemp99;
			let mut fTemp106: F32 = if (((self.fRec33[0] < (self.fConst1 + fTemp99)) as i32) as i32 != 0) { if (iTemp104 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp97 } else { if (iTemp104 as i32 != 0) { fTemp97 + fTemp98 * if (((self.fRec31[0] > fTemp97) as i32) as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec31[0] } } } else { self.fRec31[0] } } else { if (((self.fRec33[0] < fTemp102) as i32) as i32 != 0) { self.fRec31[0] + fTemp100 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp103, 0.33333334) } else { fTemp103 } } else { self.fRec30[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp107) as usize] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { 8096.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 7584.0 } else { self.fRec35[1] };
			let mut fTemp109: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp110: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp109) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 85.5) as i32)) as usize] } * if (((fTemp109 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 4032.0 } else { self.fRec36[1] };
			let mut fTemp111: F32 = F32::max(5076.0, self.fRec36[0]);
			let mut fTemp112: F32 = self.fRec34[0] - fTemp111;
			let mut fTemp113: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp112) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 89.5) as i32)) as usize] } * if (((fTemp112 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp111)) + 2.0) } else { 0.96 }))));
			let mut fTemp114: F32 = fTemp113 + fTemp110;
			let mut fTemp115: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp116: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp115) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 81.5) as i32)) as usize] } * if (((fTemp115 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp117: F32 = fTemp114 + fTemp116;
			self.fRec37[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp117, self.fRec37[1] + 1.0) };
			let mut iTemp118: i32 = ((self.fRec37[0] < fTemp114) as i32);
			let mut fTemp119: F32 = (self.fRec37[0] - fTemp114) / fTemp116;
			let mut iTemp120: i32 = ((self.fRec37[0] < fTemp113) as i32);
			let mut fTemp121: F32 = (self.fRec37[0] - fTemp113) / fTemp110;
			let mut fTemp122: F32 = self.fRec37[0] / fTemp113;
			let mut fTemp123: F32 = if (iTemp118 as i32 != 0) { if (iTemp120 as i32 != 0) { if (((self.fRec37[0] < 0.0) as i32) as i32 != 0) { fTemp111 } else { if (iTemp120 as i32 != 0) { fTemp111 + fTemp112 * if (((self.fRec34[0] > fTemp111) as i32) as i32 != 0) { F32::powf(fTemp122, 0.33333334) } else { fTemp122 } } else { self.fRec34[0] } } } else { if (iTemp118 as i32 != 0) { self.fRec34[0] + fTemp109 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec35[0] } } } else { if (((self.fRec37[0] < fTemp117) as i32) as i32 != 0) { self.fRec35[0] + fTemp115 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp119, 0.33333334) } else { fTemp119 } } else { self.fRec36[0] } };
			let mut iTemp124: i32 = ((fTemp123) as i32);
			let mut fTemp125: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp124) as usize] };
			let mut fTemp126: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec38[1] + fSlow15 * fTemp78 };
			self.fRec38[0] = fTemp126 - F32::floor(fTemp126);
			let mut fTemp127: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst13 };
			self.fRec39[0] = fTemp127 - F32::floor(fTemp127);
			let mut fTemp128: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow16 * fTemp78 };
			self.fRec40[0] = fTemp128 - F32::floor(fTemp128);
			self.fRec26[0] = 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec39[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec38[0] + 24.347826 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp125 + (fTemp123 - ((iTemp124) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp124, 1)) as usize] } - fTemp125)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp96 + (fTemp94 - ((iTemp95) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp95, 1)) as usize] } - fTemp96));
			let mut fTemp129: F32 = self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp28 + (fTemp26 - ((iTemp27) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp27, 1)) as usize] } - fTemp28));
			self.fVec4[0] = fTemp129;
			self.fRec0[0] = self.fConst20 * self.fVec4[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * fTemp129);
			*output0 = fSlow19 * self.fRec0[0];
			*output1 = fSlow20 * self.fRec0[0];
			*output2 = fSlow21 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.iRec21[1] = self.iRec21[0];
			self.iRec22[1] = self.iRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec26[1] = self.fRec26[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Tom3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Tom3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * (fSlow2 + 4.7) + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.71428573 * fSlow3;
		let mut fSlow6: F32 = 0.14285715 * fSlow3;
		let mut fSlow7: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow8: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow7, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow9: i32 = ((fSlow8) as i32);
		let mut fSlow10: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iSlow9) as usize] };
		let mut fSlow11: F32 = fSlow10 + (fSlow8 - ((iSlow9) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iSlow9, 1)) as usize] } - fSlow10);
		let mut fSlow12: F32 = self.fConst7 * fSlow7;
		let mut fSlow13: F32 = self.fConst10 * fSlow7;
		let mut fSlow14: F32 = 0.42857143 * fSlow3;
		let mut fSlow15: F32 = self.fConst11 * fSlow7;
		let mut fSlow16: F32 = self.fConst14 * fSlow7;
		let mut fSlow17: F32 = 0.01 * self.fHslider3;
		let mut fSlow18: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 1.5));
		let mut fSlow19: F32 = fSlow18 * F32::min(1.0, 1.0 - fSlow17);
		let mut fSlow20: F32 = fSlow18 * F32::min(1.0, fSlow17 + 1.0);
		let mut fSlow21: F32 = 0.01 * self.fHslider5 * fSlow18;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec0[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom3_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 1.92e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			let mut fTemp8: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0);
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 49.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 };
			let mut fTemp13: F32 = F32::abs(fTemp11);
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 84.5) as i32)) as usize] } * fTemp12))));
			let mut fTemp15: F32 = fTemp14 + fTemp9;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp18: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp17) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 77.5) as i32)) as usize] } * if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp19: F32 = fTemp15 + fTemp18;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp19, self.fRec8[1] + 1.0) };
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp15) / fTemp18;
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut fTemp23: F32 = (self.fRec8[0] - fTemp14) / fTemp9;
			let mut iTemp24: i32 = ((self.fRec2[0] > fTemp10) as i32);
			let mut fTemp25: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp26: F32 = if (iTemp20 as i32 != 0) { if (iTemp22 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp22 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp25, 0.33333334) } else { fTemp25 } } else { self.fRec2[0] } } } else { if (iTemp20 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp19) as i32) as i32 != 0) { self.fRec4[0] + fTemp17 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } };
			let mut iTemp27: i32 = ((fTemp26) as i32);
			let mut fTemp28: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp27) as usize] };
			let mut fTemp29: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 89.0));
			let mut fTemp30: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp29) * (fTemp29 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp30 + 4064.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp30 } else { self.fRec11[1] };
			let mut fTemp31: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 49.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp34: F32 = self.fRec10[0] - fTemp33;
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 82.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp33)) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp35 + fTemp32;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp36, self.fRec13[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec13[0] < fTemp36) as i32);
			let mut iTemp38: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp39: F32 = (self.fRec13[0] - fTemp35) / fTemp32;
			let mut fTemp40: F32 = self.fRec13[0] / fTemp35;
			let mut fTemp41: F32 = if (iTemp37 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp33 } else { if (iTemp38 as i32 != 0) { fTemp33 + fTemp34 * if (((self.fRec10[0] > fTemp33) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp31 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 71.0));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4e+03 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3456.0 } else { self.fRec15[1] };
			let mut fTemp46: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec16[1] };
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 85.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec17[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp49: F32 = self.fRec14[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 76.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec17[0] - self.fRec15[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 39.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec18[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec18[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec18[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec18[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec18[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec14[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec14[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec14[0] + fTemp46 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec15[0] } } } else { if (((self.fRec18[0] < fTemp54) as i32) as i32 != 0) { self.fRec15[0] + fTemp52 * if (((self.fRec17[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			self.iRec21[0] = if (iTemp3 as i32 != 0) { self.iConst3 } else { self.iRec21[1] };
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst4 } else { self.iRec22[1] };
			let mut iTemp64: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec21[0]);
			let mut fTemp65: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp64)) as F32) / self.fConst2));
			let mut iTemp66: i32 = i32::wrapping_sub(self.iRec21[0], self.iRec22[0]);
			let mut fTemp67: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp66)) as F32) / self.fConst6));
			let mut fTemp68: F32 = fTemp67 + fTemp65;
			self.fRec23[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp68 + 1.0, self.fRec23[1] + 1.0) };
			let mut iTemp69: i32 = ((self.fRec23[0] < fTemp68) as i32);
			let mut fTemp70: F32 = ((self.iRec22[0]) as F32);
			let mut iTemp71: i32 = ((self.fRec23[0] < fTemp67) as i32);
			let mut fTemp72: F32 = (self.fRec23[0] - fTemp67) / fTemp65;
			let mut fTemp73: F32 = ((self.iRec21[0]) as F32);
			let mut fTemp74: F32 = self.fRec23[0] / fTemp67;
			let mut fTemp75: F32 = 15.996094 * (0.4 * if (iTemp69 as i32 != 0) { if (iTemp71 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp71 as i32 != 0) { fTemp70 + ((iTemp66) as F32) * if (((self.iRec21[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { fTemp73 } } } else { if (iTemp69 as i32 != 0) { fTemp73 + ((iTemp64) as F32) * if (((self.iRec22[0] > self.iRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp72, 0.33333334) } else { fTemp72 } } else { fTemp70 } } } else { fTemp70 } + 128.0);
			let mut iTemp76: i32 = ((fTemp75) as i32);
			let mut fTemp77: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iTemp76) as usize] };
			let mut fTemp78: F32 = fSlow11 * (fTemp77 + (fTemp75 - ((iTemp76) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iTemp76, 1)) as usize] } - fTemp77));
			let mut fTemp79: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec19[1] + fSlow12 * fTemp78 };
			self.fRec19[0] = fTemp79 - F32::floor(fTemp79);
			let mut fTemp80: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst9 };
			self.fRec24[0] = fTemp80 - F32::floor(fTemp80);
			let mut fTemp81: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow13 * fTemp78 };
			self.fRec25[0] = fTemp81 - F32::floor(fTemp81);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec27[1] };
			let mut fTemp82: F32 = self.fRec27[0] - self.fRec2[0];
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow14 } else { self.fRec28[1] };
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 71.5) as i32)) as usize] } * if (((fTemp82 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (fTemp12 * unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 94.5) as i32)) as usize] }))));
			let mut fTemp85: F32 = fTemp84 + fTemp83;
			let mut fTemp86: F32 = self.fRec7[0] - self.fRec27[0];
			let mut fTemp87: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp86) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 50.5) as i32)) as usize] } * if (((fTemp86 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp88: F32 = fTemp85 + fTemp87;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp88, self.fRec29[1] + 1.0) };
			let mut iTemp89: i32 = ((self.fRec29[0] < fTemp85) as i32);
			let mut fTemp90: F32 = (self.fRec29[0] - fTemp85) / fTemp87;
			let mut iTemp91: i32 = ((self.fRec29[0] < fTemp84) as i32);
			let mut fTemp92: F32 = (self.fRec29[0] - fTemp84) / fTemp83;
			let mut fTemp93: F32 = self.fRec29[0] / fTemp84;
			let mut fTemp94: F32 = if (iTemp89 as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp91 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp93, 0.33333334) } else { fTemp93 } } else { self.fRec2[0] } } } else { if (iTemp89 as i32 != 0) { self.fRec2[0] + fTemp82 * if (((self.fRec27[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec27[0] } } } else { if (((self.fRec29[0] < fTemp88) as i32) as i32 != 0) { self.fRec27[0] + fTemp86 * if (((self.fRec7[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec7[0] } };
			let mut iTemp95: i32 = ((fTemp94) as i32);
			let mut fTemp96: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp95) as usize] };
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 3296.0 } else { self.fRec30[1] };
			let mut fTemp97: F32 = F32::max(5076.0, self.fRec30[0]);
			self.fRec31[0] = if (iTemp3 as i32 != 0) { 7.36e+03 } else { self.fRec31[1] };
			let mut fTemp98: F32 = self.fRec31[0] - fTemp97;
			self.fRec32[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec32[1] };
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp98) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 83.5) as i32)) as usize] } * if (((fTemp98 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp97)) + 2.0) } else { 0.96 }))));
			let mut fTemp100: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 71.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = self.fConst1 + fTemp99 + fTemp101;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp102, self.fRec33[1] + 1.0) };
			let mut fTemp103: F32 = (self.fRec33[0] - fTemp99 - self.fConst1) / fTemp101;
			let mut iTemp104: i32 = ((self.fRec33[0] < fTemp99) as i32);
			let mut fTemp105: F32 = self.fRec33[0] / fTemp99;
			let mut fTemp106: F32 = if (((self.fRec33[0] < (self.fConst1 + fTemp99)) as i32) as i32 != 0) { if (iTemp104 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp97 } else { if (iTemp104 as i32 != 0) { fTemp97 + fTemp98 * if (((self.fRec31[0] > fTemp97) as i32) as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec31[0] } } } else { self.fRec31[0] } } else { if (((self.fRec33[0] < fTemp102) as i32) as i32 != 0) { self.fRec31[0] + fTemp100 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp103, 0.33333334) } else { fTemp103 } } else { self.fRec30[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp107) as usize] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { 8096.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 7584.0 } else { self.fRec35[1] };
			let mut fTemp109: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp110: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp109) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 85.5) as i32)) as usize] } * if (((fTemp109 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 4032.0 } else { self.fRec36[1] };
			let mut fTemp111: F32 = F32::max(5076.0, self.fRec36[0]);
			let mut fTemp112: F32 = self.fRec34[0] - fTemp111;
			let mut fTemp113: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp112) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 89.5) as i32)) as usize] } * if (((fTemp112 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp111)) + 2.0) } else { 0.96 }))));
			let mut fTemp114: F32 = fTemp113 + fTemp110;
			let mut fTemp115: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp116: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp115) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 81.5) as i32)) as usize] } * if (((fTemp115 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp117: F32 = fTemp114 + fTemp116;
			self.fRec37[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp117, self.fRec37[1] + 1.0) };
			let mut iTemp118: i32 = ((self.fRec37[0] < fTemp114) as i32);
			let mut fTemp119: F32 = (self.fRec37[0] - fTemp114) / fTemp116;
			let mut iTemp120: i32 = ((self.fRec37[0] < fTemp113) as i32);
			let mut fTemp121: F32 = (self.fRec37[0] - fTemp113) / fTemp110;
			let mut fTemp122: F32 = self.fRec37[0] / fTemp113;
			let mut fTemp123: F32 = if (iTemp118 as i32 != 0) { if (iTemp120 as i32 != 0) { if (((self.fRec37[0] < 0.0) as i32) as i32 != 0) { fTemp111 } else { if (iTemp120 as i32 != 0) { fTemp111 + fTemp112 * if (((self.fRec34[0] > fTemp111) as i32) as i32 != 0) { F32::powf(fTemp122, 0.33333334) } else { fTemp122 } } else { self.fRec34[0] } } } else { if (iTemp118 as i32 != 0) { self.fRec34[0] + fTemp109 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec35[0] } } } else { if (((self.fRec37[0] < fTemp117) as i32) as i32 != 0) { self.fRec35[0] + fTemp115 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp119, 0.33333334) } else { fTemp119 } } else { self.fRec36[0] } };
			let mut iTemp124: i32 = ((fTemp123) as i32);
			let mut fTemp125: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp124) as usize] };
			let mut fTemp126: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec38[1] + fSlow15 * fTemp78 };
			self.fRec38[0] = fTemp126 - F32::floor(fTemp126);
			let mut fTemp127: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst13 };
			self.fRec39[0] = fTemp127 - F32::floor(fTemp127);
			let mut fTemp128: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow16 * fTemp78 };
			self.fRec40[0] = fTemp128 - F32::floor(fTemp128);
			self.fRec26[0] = 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec39[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec38[0] + 24.347826 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp125 + (fTemp123 - ((iTemp124) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp124, 1)) as usize] } - fTemp125)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp96 + (fTemp94 - ((iTemp95) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp95, 1)) as usize] } - fTemp96));
			let mut fTemp129: F32 = self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp28 + (fTemp26 - ((iTemp27) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp27, 1)) as usize] } - fTemp28));
			self.fVec4[0] = fTemp129;
			self.fRec0[0] = self.fConst20 * self.fVec4[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * fTemp129);
			*output0 = fSlow19 * self.fRec0[0];
			*output1 = fSlow20 * self.fRec0[0];
			*output2 = fSlow21 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.iRec21[1] = self.iRec21[0];
			self.iRec22[1] = self.iRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec26[1] = self.fRec26[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Tom3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * (fSlow2 + 4.7) + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.71428573 * fSlow3;
		let mut fSlow6: F32 = 0.14285715 * fSlow3;
		let mut fSlow7: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow8: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow7, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow9: i32 = ((fSlow8) as i32);
		let mut fSlow10: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iSlow9) as usize] };
		let mut fSlow11: F32 = fSlow10 + (fSlow8 - ((iSlow9) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iSlow9, 1)) as usize] } - fSlow10);
		let mut fSlow12: F32 = self.fConst7 * fSlow7;
		let mut fSlow13: F32 = self.fConst10 * fSlow7;
		let mut fSlow14: F32 = 0.42857143 * fSlow3;
		let mut fSlow15: F32 = self.fConst11 * fSlow7;
		let mut fSlow16: F32 = self.fConst14 * fSlow7;
		let mut fSlow17: F32 = 0.01 * self.fHslider3;
		let mut fSlow18: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 1.5));
		let mut fSlow19: F32 = fSlow18 * F32::min(1.0, 1.0 - fSlow17);
		let mut fSlow20: F32 = fSlow18 * F32::min(1.0, fSlow17 + 1.0);
		let mut fSlow21: F32 = 0.01 * self.fHslider5 * fSlow18;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec0[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom3_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 1.92e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			let mut fTemp8: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0);
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 49.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 };
			let mut fTemp13: F32 = F32::abs(fTemp11);
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 84.5) as i32)) as usize] } * fTemp12))));
			let mut fTemp15: F32 = fTemp14 + fTemp9;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp18: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp17) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 77.5) as i32)) as usize] } * if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp19: F32 = fTemp15 + fTemp18;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp19, self.fRec8[1] + 1.0) };
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp15) / fTemp18;
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut fTemp23: F32 = (self.fRec8[0] - fTemp14) / fTemp9;
			let mut iTemp24: i32 = ((self.fRec2[0] > fTemp10) as i32);
			let mut fTemp25: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp26: F32 = if (iTemp20 as i32 != 0) { if (iTemp22 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp22 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp25, 0.33333334) } else { fTemp25 } } else { self.fRec2[0] } } } else { if (iTemp20 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp19) as i32) as i32 != 0) { self.fRec4[0] + fTemp17 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } };
			let mut iTemp27: i32 = ((fTemp26) as i32);
			let mut fTemp28: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp27) as usize] };
			let mut fTemp29: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 89.0));
			let mut fTemp30: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp29) * (fTemp29 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp30 + 4064.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp30 } else { self.fRec11[1] };
			let mut fTemp31: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 49.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp34: F32 = self.fRec10[0] - fTemp33;
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 82.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp33)) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp35 + fTemp32;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp36, self.fRec13[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec13[0] < fTemp36) as i32);
			let mut iTemp38: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp39: F32 = (self.fRec13[0] - fTemp35) / fTemp32;
			let mut fTemp40: F32 = self.fRec13[0] / fTemp35;
			let mut fTemp41: F32 = if (iTemp37 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp33 } else { if (iTemp38 as i32 != 0) { fTemp33 + fTemp34 * if (((self.fRec10[0] > fTemp33) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp31 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 71.0));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4e+03 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3456.0 } else { self.fRec15[1] };
			let mut fTemp46: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec16[1] };
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 85.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec17[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp49: F32 = self.fRec14[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 76.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec17[0] - self.fRec15[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 39.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec18[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec18[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec18[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec18[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec18[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec14[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec14[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec14[0] + fTemp46 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec15[0] } } } else { if (((self.fRec18[0] < fTemp54) as i32) as i32 != 0) { self.fRec15[0] + fTemp52 * if (((self.fRec17[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			self.iRec21[0] = if (iTemp3 as i32 != 0) { self.iConst3 } else { self.iRec21[1] };
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst4 } else { self.iRec22[1] };
			let mut iTemp64: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec21[0]);
			let mut fTemp65: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp64)) as F32) / self.fConst2));
			let mut iTemp66: i32 = i32::wrapping_sub(self.iRec21[0], self.iRec22[0]);
			let mut fTemp67: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp66)) as F32) / self.fConst6));
			let mut fTemp68: F32 = fTemp67 + fTemp65;
			self.fRec23[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp68 + 1.0, self.fRec23[1] + 1.0) };
			let mut iTemp69: i32 = ((self.fRec23[0] < fTemp68) as i32);
			let mut fTemp70: F32 = ((self.iRec22[0]) as F32);
			let mut iTemp71: i32 = ((self.fRec23[0] < fTemp67) as i32);
			let mut fTemp72: F32 = (self.fRec23[0] - fTemp67) / fTemp65;
			let mut fTemp73: F32 = ((self.iRec21[0]) as F32);
			let mut fTemp74: F32 = self.fRec23[0] / fTemp67;
			let mut fTemp75: F32 = 15.996094 * (0.4 * if (iTemp69 as i32 != 0) { if (iTemp71 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp71 as i32 != 0) { fTemp70 + ((iTemp66) as F32) * if (((self.iRec21[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { fTemp73 } } } else { if (iTemp69 as i32 != 0) { fTemp73 + ((iTemp64) as F32) * if (((self.iRec22[0] > self.iRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp72, 0.33333334) } else { fTemp72 } } else { fTemp70 } } } else { fTemp70 } + 128.0);
			let mut iTemp76: i32 = ((fTemp75) as i32);
			let mut fTemp77: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iTemp76) as usize] };
			let mut fTemp78: F32 = fSlow11 * (fTemp77 + (fTemp75 - ((iTemp76) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iTemp76, 1)) as usize] } - fTemp77));
			let mut fTemp79: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec19[1] + fSlow12 * fTemp78 };
			self.fRec19[0] = fTemp79 - F32::floor(fTemp79);
			let mut fTemp80: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst9 };
			self.fRec24[0] = fTemp80 - F32::floor(fTemp80);
			let mut fTemp81: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow13 * fTemp78 };
			self.fRec25[0] = fTemp81 - F32::floor(fTemp81);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec27[1] };
			let mut fTemp82: F32 = self.fRec27[0] - self.fRec2[0];
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow14 } else { self.fRec28[1] };
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 71.5) as i32)) as usize] } * if (((fTemp82 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (fTemp12 * unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 94.5) as i32)) as usize] }))));
			let mut fTemp85: F32 = fTemp84 + fTemp83;
			let mut fTemp86: F32 = self.fRec7[0] - self.fRec27[0];
			let mut fTemp87: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp86) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 50.5) as i32)) as usize] } * if (((fTemp86 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp88: F32 = fTemp85 + fTemp87;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp88, self.fRec29[1] + 1.0) };
			let mut iTemp89: i32 = ((self.fRec29[0] < fTemp85) as i32);
			let mut fTemp90: F32 = (self.fRec29[0] - fTemp85) / fTemp87;
			let mut iTemp91: i32 = ((self.fRec29[0] < fTemp84) as i32);
			let mut fTemp92: F32 = (self.fRec29[0] - fTemp84) / fTemp83;
			let mut fTemp93: F32 = self.fRec29[0] / fTemp84;
			let mut fTemp94: F32 = if (iTemp89 as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp91 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp93, 0.33333334) } else { fTemp93 } } else { self.fRec2[0] } } } else { if (iTemp89 as i32 != 0) { self.fRec2[0] + fTemp82 * if (((self.fRec27[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec27[0] } } } else { if (((self.fRec29[0] < fTemp88) as i32) as i32 != 0) { self.fRec27[0] + fTemp86 * if (((self.fRec7[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec7[0] } };
			let mut iTemp95: i32 = ((fTemp94) as i32);
			let mut fTemp96: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp95) as usize] };
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 3296.0 } else { self.fRec30[1] };
			let mut fTemp97: F32 = F32::max(5076.0, self.fRec30[0]);
			self.fRec31[0] = if (iTemp3 as i32 != 0) { 7.36e+03 } else { self.fRec31[1] };
			let mut fTemp98: F32 = self.fRec31[0] - fTemp97;
			self.fRec32[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec32[1] };
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp98) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 83.5) as i32)) as usize] } * if (((fTemp98 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp97)) + 2.0) } else { 0.96 }))));
			let mut fTemp100: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 71.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = self.fConst1 + fTemp99 + fTemp101;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp102, self.fRec33[1] + 1.0) };
			let mut fTemp103: F32 = (self.fRec33[0] - fTemp99 - self.fConst1) / fTemp101;
			let mut iTemp104: i32 = ((self.fRec33[0] < fTemp99) as i32);
			let mut fTemp105: F32 = self.fRec33[0] / fTemp99;
			let mut fTemp106: F32 = if (((self.fRec33[0] < (self.fConst1 + fTemp99)) as i32) as i32 != 0) { if (iTemp104 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp97 } else { if (iTemp104 as i32 != 0) { fTemp97 + fTemp98 * if (((self.fRec31[0] > fTemp97) as i32) as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec31[0] } } } else { self.fRec31[0] } } else { if (((self.fRec33[0] < fTemp102) as i32) as i32 != 0) { self.fRec31[0] + fTemp100 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp103, 0.33333334) } else { fTemp103 } } else { self.fRec30[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp107) as usize] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { 8096.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 7584.0 } else { self.fRec35[1] };
			let mut fTemp109: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp110: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp109) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 85.5) as i32)) as usize] } * if (((fTemp109 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 4032.0 } else { self.fRec36[1] };
			let mut fTemp111: F32 = F32::max(5076.0, self.fRec36[0]);
			let mut fTemp112: F32 = self.fRec34[0] - fTemp111;
			let mut fTemp113: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp112) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 89.5) as i32)) as usize] } * if (((fTemp112 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp111)) + 2.0) } else { 0.96 }))));
			let mut fTemp114: F32 = fTemp113 + fTemp110;
			let mut fTemp115: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp116: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp115) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 81.5) as i32)) as usize] } * if (((fTemp115 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp117: F32 = fTemp114 + fTemp116;
			self.fRec37[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp117, self.fRec37[1] + 1.0) };
			let mut iTemp118: i32 = ((self.fRec37[0] < fTemp114) as i32);
			let mut fTemp119: F32 = (self.fRec37[0] - fTemp114) / fTemp116;
			let mut iTemp120: i32 = ((self.fRec37[0] < fTemp113) as i32);
			let mut fTemp121: F32 = (self.fRec37[0] - fTemp113) / fTemp110;
			let mut fTemp122: F32 = self.fRec37[0] / fTemp113;
			let mut fTemp123: F32 = if (iTemp118 as i32 != 0) { if (iTemp120 as i32 != 0) { if (((self.fRec37[0] < 0.0) as i32) as i32 != 0) { fTemp111 } else { if (iTemp120 as i32 != 0) { fTemp111 + fTemp112 * if (((self.fRec34[0] > fTemp111) as i32) as i32 != 0) { F32::powf(fTemp122, 0.33333334) } else { fTemp122 } } else { self.fRec34[0] } } } else { if (iTemp118 as i32 != 0) { self.fRec34[0] + fTemp109 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec35[0] } } } else { if (((self.fRec37[0] < fTemp117) as i32) as i32 != 0) { self.fRec35[0] + fTemp115 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp119, 0.33333334) } else { fTemp119 } } else { self.fRec36[0] } };
			let mut iTemp124: i32 = ((fTemp123) as i32);
			let mut fTemp125: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp124) as usize] };
			let mut fTemp126: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec38[1] + fSlow15 * fTemp78 };
			self.fRec38[0] = fTemp126 - F32::floor(fTemp126);
			let mut fTemp127: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst13 };
			self.fRec39[0] = fTemp127 - F32::floor(fTemp127);
			let mut fTemp128: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow16 * fTemp78 };
			self.fRec40[0] = fTemp128 - F32::floor(fTemp128);
			self.fRec26[0] = 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec39[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec38[0] + 24.347826 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp125 + (fTemp123 - ((iTemp124) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp124, 1)) as usize] } - fTemp125)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp96 + (fTemp94 - ((iTemp95) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp95, 1)) as usize] } - fTemp96));
			let mut fTemp129: F32 = self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp28 + (fTemp26 - ((iTemp27) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp27, 1)) as usize] } - fTemp28));
			self.fVec4[0] = fTemp129;
			self.fRec0[0] = self.fConst20 * self.fVec4[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * fTemp129);
			*output0 = fSlow19 * self.fRec0[0];
			*output1 = fSlow20 * self.fRec0[0];
			*output2 = fSlow21 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.iRec21[1] = self.iRec21[0];
			self.iRec22[1] = self.iRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec26[1] = self.fRec26[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Tom3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * (fSlow2 + 4.7) + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.71428573 * fSlow3;
		let mut fSlow6: F32 = 0.14285715 * fSlow3;
		let mut fSlow7: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow8: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow7, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow9: i32 = ((fSlow8) as i32);
		let mut fSlow10: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iSlow9) as usize] };
		let mut fSlow11: F32 = fSlow10 + (fSlow8 - ((iSlow9) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iSlow9, 1)) as usize] } - fSlow10);
		let mut fSlow12: F32 = self.fConst7 * fSlow7;
		let mut fSlow13: F32 = self.fConst10 * fSlow7;
		let mut fSlow14: F32 = 0.42857143 * fSlow3;
		let mut fSlow15: F32 = self.fConst11 * fSlow7;
		let mut fSlow16: F32 = self.fConst14 * fSlow7;
		let mut fSlow17: F32 = 0.01 * self.fHslider3;
		let mut fSlow18: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 1.5));
		let mut fSlow19: F32 = fSlow18 * F32::min(1.0, 1.0 - fSlow17);
		let mut fSlow20: F32 = fSlow18 * F32::min(1.0, fSlow17 + 1.0);
		let mut fSlow21: F32 = 0.01 * self.fHslider5 * fSlow18;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec0[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom3_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 1.92e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			let mut fTemp8: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0);
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 49.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 };
			let mut fTemp13: F32 = F32::abs(fTemp11);
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 84.5) as i32)) as usize] } * fTemp12))));
			let mut fTemp15: F32 = fTemp14 + fTemp9;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp18: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp17) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 77.5) as i32)) as usize] } * if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp19: F32 = fTemp15 + fTemp18;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp19, self.fRec8[1] + 1.0) };
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp15) / fTemp18;
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut fTemp23: F32 = (self.fRec8[0] - fTemp14) / fTemp9;
			let mut iTemp24: i32 = ((self.fRec2[0] > fTemp10) as i32);
			let mut fTemp25: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp26: F32 = if (iTemp20 as i32 != 0) { if (iTemp22 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp22 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp25, 0.33333334) } else { fTemp25 } } else { self.fRec2[0] } } } else { if (iTemp20 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp19) as i32) as i32 != 0) { self.fRec4[0] + fTemp17 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } };
			let mut iTemp27: i32 = ((fTemp26) as i32);
			let mut fTemp28: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp27) as usize] };
			let mut fTemp29: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 89.0));
			let mut fTemp30: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp29) * (fTemp29 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp30 + 4064.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp30 } else { self.fRec11[1] };
			let mut fTemp31: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 49.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp34: F32 = self.fRec10[0] - fTemp33;
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 82.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp33)) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp35 + fTemp32;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp36, self.fRec13[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec13[0] < fTemp36) as i32);
			let mut iTemp38: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp39: F32 = (self.fRec13[0] - fTemp35) / fTemp32;
			let mut fTemp40: F32 = self.fRec13[0] / fTemp35;
			let mut fTemp41: F32 = if (iTemp37 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp33 } else { if (iTemp38 as i32 != 0) { fTemp33 + fTemp34 * if (((self.fRec10[0] > fTemp33) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp31 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 71.0));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4e+03 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3456.0 } else { self.fRec15[1] };
			let mut fTemp46: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec16[1] };
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 85.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec17[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp49: F32 = self.fRec14[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 76.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec17[0] - self.fRec15[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 39.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec18[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec18[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec18[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec18[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec18[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec14[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec14[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec14[0] + fTemp46 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec15[0] } } } else { if (((self.fRec18[0] < fTemp54) as i32) as i32 != 0) { self.fRec15[0] + fTemp52 * if (((self.fRec17[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			self.iRec21[0] = if (iTemp3 as i32 != 0) { self.iConst3 } else { self.iRec21[1] };
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst4 } else { self.iRec22[1] };
			let mut iTemp64: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec21[0]);
			let mut fTemp65: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp64)) as F32) / self.fConst2));
			let mut iTemp66: i32 = i32::wrapping_sub(self.iRec21[0], self.iRec22[0]);
			let mut fTemp67: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp66)) as F32) / self.fConst6));
			let mut fTemp68: F32 = fTemp67 + fTemp65;
			self.fRec23[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp68 + 1.0, self.fRec23[1] + 1.0) };
			let mut iTemp69: i32 = ((self.fRec23[0] < fTemp68) as i32);
			let mut fTemp70: F32 = ((self.iRec22[0]) as F32);
			let mut iTemp71: i32 = ((self.fRec23[0] < fTemp67) as i32);
			let mut fTemp72: F32 = (self.fRec23[0] - fTemp67) / fTemp65;
			let mut fTemp73: F32 = ((self.iRec21[0]) as F32);
			let mut fTemp74: F32 = self.fRec23[0] / fTemp67;
			let mut fTemp75: F32 = 15.996094 * (0.4 * if (iTemp69 as i32 != 0) { if (iTemp71 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp71 as i32 != 0) { fTemp70 + ((iTemp66) as F32) * if (((self.iRec21[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { fTemp73 } } } else { if (iTemp69 as i32 != 0) { fTemp73 + ((iTemp64) as F32) * if (((self.iRec22[0] > self.iRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp72, 0.33333334) } else { fTemp72 } } else { fTemp70 } } } else { fTemp70 } + 128.0);
			let mut iTemp76: i32 = ((fTemp75) as i32);
			let mut fTemp77: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iTemp76) as usize] };
			let mut fTemp78: F32 = fSlow11 * (fTemp77 + (fTemp75 - ((iTemp76) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iTemp76, 1)) as usize] } - fTemp77));
			let mut fTemp79: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec19[1] + fSlow12 * fTemp78 };
			self.fRec19[0] = fTemp79 - F32::floor(fTemp79);
			let mut fTemp80: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst9 };
			self.fRec24[0] = fTemp80 - F32::floor(fTemp80);
			let mut fTemp81: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow13 * fTemp78 };
			self.fRec25[0] = fTemp81 - F32::floor(fTemp81);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec27[1] };
			let mut fTemp82: F32 = self.fRec27[0] - self.fRec2[0];
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow14 } else { self.fRec28[1] };
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 71.5) as i32)) as usize] } * if (((fTemp82 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (fTemp12 * unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 94.5) as i32)) as usize] }))));
			let mut fTemp85: F32 = fTemp84 + fTemp83;
			let mut fTemp86: F32 = self.fRec7[0] - self.fRec27[0];
			let mut fTemp87: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp86) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 50.5) as i32)) as usize] } * if (((fTemp86 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp88: F32 = fTemp85 + fTemp87;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp88, self.fRec29[1] + 1.0) };
			let mut iTemp89: i32 = ((self.fRec29[0] < fTemp85) as i32);
			let mut fTemp90: F32 = (self.fRec29[0] - fTemp85) / fTemp87;
			let mut iTemp91: i32 = ((self.fRec29[0] < fTemp84) as i32);
			let mut fTemp92: F32 = (self.fRec29[0] - fTemp84) / fTemp83;
			let mut fTemp93: F32 = self.fRec29[0] / fTemp84;
			let mut fTemp94: F32 = if (iTemp89 as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp91 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp93, 0.33333334) } else { fTemp93 } } else { self.fRec2[0] } } } else { if (iTemp89 as i32 != 0) { self.fRec2[0] + fTemp82 * if (((self.fRec27[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec27[0] } } } else { if (((self.fRec29[0] < fTemp88) as i32) as i32 != 0) { self.fRec27[0] + fTemp86 * if (((self.fRec7[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec7[0] } };
			let mut iTemp95: i32 = ((fTemp94) as i32);
			let mut fTemp96: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp95) as usize] };
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 3296.0 } else { self.fRec30[1] };
			let mut fTemp97: F32 = F32::max(5076.0, self.fRec30[0]);
			self.fRec31[0] = if (iTemp3 as i32 != 0) { 7.36e+03 } else { self.fRec31[1] };
			let mut fTemp98: F32 = self.fRec31[0] - fTemp97;
			self.fRec32[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec32[1] };
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp98) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 83.5) as i32)) as usize] } * if (((fTemp98 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp97)) + 2.0) } else { 0.96 }))));
			let mut fTemp100: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 71.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = self.fConst1 + fTemp99 + fTemp101;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp102, self.fRec33[1] + 1.0) };
			let mut fTemp103: F32 = (self.fRec33[0] - fTemp99 - self.fConst1) / fTemp101;
			let mut iTemp104: i32 = ((self.fRec33[0] < fTemp99) as i32);
			let mut fTemp105: F32 = self.fRec33[0] / fTemp99;
			let mut fTemp106: F32 = if (((self.fRec33[0] < (self.fConst1 + fTemp99)) as i32) as i32 != 0) { if (iTemp104 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp97 } else { if (iTemp104 as i32 != 0) { fTemp97 + fTemp98 * if (((self.fRec31[0] > fTemp97) as i32) as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec31[0] } } } else { self.fRec31[0] } } else { if (((self.fRec33[0] < fTemp102) as i32) as i32 != 0) { self.fRec31[0] + fTemp100 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp103, 0.33333334) } else { fTemp103 } } else { self.fRec30[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp107) as usize] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { 8096.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 7584.0 } else { self.fRec35[1] };
			let mut fTemp109: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp110: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp109) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 85.5) as i32)) as usize] } * if (((fTemp109 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 4032.0 } else { self.fRec36[1] };
			let mut fTemp111: F32 = F32::max(5076.0, self.fRec36[0]);
			let mut fTemp112: F32 = self.fRec34[0] - fTemp111;
			let mut fTemp113: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp112) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 89.5) as i32)) as usize] } * if (((fTemp112 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp111)) + 2.0) } else { 0.96 }))));
			let mut fTemp114: F32 = fTemp113 + fTemp110;
			let mut fTemp115: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp116: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp115) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 81.5) as i32)) as usize] } * if (((fTemp115 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp117: F32 = fTemp114 + fTemp116;
			self.fRec37[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp117, self.fRec37[1] + 1.0) };
			let mut iTemp118: i32 = ((self.fRec37[0] < fTemp114) as i32);
			let mut fTemp119: F32 = (self.fRec37[0] - fTemp114) / fTemp116;
			let mut iTemp120: i32 = ((self.fRec37[0] < fTemp113) as i32);
			let mut fTemp121: F32 = (self.fRec37[0] - fTemp113) / fTemp110;
			let mut fTemp122: F32 = self.fRec37[0] / fTemp113;
			let mut fTemp123: F32 = if (iTemp118 as i32 != 0) { if (iTemp120 as i32 != 0) { if (((self.fRec37[0] < 0.0) as i32) as i32 != 0) { fTemp111 } else { if (iTemp120 as i32 != 0) { fTemp111 + fTemp112 * if (((self.fRec34[0] > fTemp111) as i32) as i32 != 0) { F32::powf(fTemp122, 0.33333334) } else { fTemp122 } } else { self.fRec34[0] } } } else { if (iTemp118 as i32 != 0) { self.fRec34[0] + fTemp109 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec35[0] } } } else { if (((self.fRec37[0] < fTemp117) as i32) as i32 != 0) { self.fRec35[0] + fTemp115 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp119, 0.33333334) } else { fTemp119 } } else { self.fRec36[0] } };
			let mut iTemp124: i32 = ((fTemp123) as i32);
			let mut fTemp125: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp124) as usize] };
			let mut fTemp126: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec38[1] + fSlow15 * fTemp78 };
			self.fRec38[0] = fTemp126 - F32::floor(fTemp126);
			let mut fTemp127: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst13 };
			self.fRec39[0] = fTemp127 - F32::floor(fTemp127);
			let mut fTemp128: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow16 * fTemp78 };
			self.fRec40[0] = fTemp128 - F32::floor(fTemp128);
			self.fRec26[0] = 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec39[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec38[0] + 24.347826 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp125 + (fTemp123 - ((iTemp124) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp124, 1)) as usize] } - fTemp125)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp96 + (fTemp94 - ((iTemp95) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp95, 1)) as usize] } - fTemp96));
			let mut fTemp129: F32 = self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp28 + (fTemp26 - ((iTemp27) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp27, 1)) as usize] } - fTemp28));
			self.fVec4[0] = fTemp129;
			self.fRec0[0] = self.fConst20 * self.fVec4[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * fTemp129);
			*output0 = fSlow19 * self.fRec0[0];
			*output1 = fSlow20 * self.fRec0[0];
			*output2 = fSlow21 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.iRec21[1] = self.iRec21[0];
			self.iRec22[1] = self.iRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec26[1] = self.fRec26[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom3 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Tom3 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom3 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider0;
		let mut fSlow2: F32 = self.fHslider2 + self.fHslider1;
		let mut fSlow3: F32 = 0.33333334 * (fSlow2 + 4.7) + 1.0;
		let mut fSlow4: F32 = 0.2857143 * fSlow3;
		let mut fSlow5: F32 = 0.71428573 * fSlow3;
		let mut fSlow6: F32 = 0.14285715 * fSlow3;
		let mut fSlow7: F32 = F32::powf(2.0, 0.083333336 * (fSlow2 + -64.3));
		let mut fSlow8: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow7, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow9: i32 = ((fSlow8) as i32);
		let mut fSlow10: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iSlow9) as usize] };
		let mut fSlow11: F32 = fSlow10 + (fSlow8 - ((iSlow9) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iSlow9, 1)) as usize] } - fSlow10);
		let mut fSlow12: F32 = self.fConst7 * fSlow7;
		let mut fSlow13: F32 = self.fConst10 * fSlow7;
		let mut fSlow14: F32 = 0.42857143 * fSlow3;
		let mut fSlow15: F32 = self.fConst11 * fSlow7;
		let mut fSlow16: F32 = self.fConst14 * fSlow7;
		let mut fSlow17: F32 = 0.01 * self.fHslider3;
		let mut fSlow18: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + 1.5));
		let mut fSlow19: F32 = fSlow18 * F32::min(1.0, 1.0 - fSlow17);
		let mut fSlow20: F32 = fSlow18 * F32::min(1.0, fSlow17 + 1.0);
		let mut fSlow21: F32 = 0.01 * self.fHslider5 * fSlow18;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.fVec0[0] = fSlow0;
			self.iVec1[0] = 1;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec0[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec3[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom3_faustpower2_f(1.0 - F32::max(fSlow1, self.fRec3[0]))) + -99.0;
			let mut fTemp5: F32 = F32::max(0.0, F32::min(127.0, 0.5714286 * fTemp4 + 99.0));
			let mut fTemp6: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp5) * (fTemp5 + 28.0);
			self.fRec2[0] = if (iTemp3 as i32 != 0) { fTemp6 + 4064.0 } else { self.fRec2[1] };
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp6 + 1.92e+03 } else { self.fRec4[1] };
			let mut fTemp7: F32 = self.fRec4[0] - self.fRec2[0];
			let mut fTemp8: F32 = 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec2[0])) + 2.0);
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fSlow4 } else { self.fRec6[1] };
			let mut fTemp9: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp7) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 49.5) as i32)) as usize] } * if (((fTemp7 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp6 } else { self.fRec7[1] };
			let mut fTemp10: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp11: F32 = self.fRec2[0] - fTemp10;
			let mut fTemp12: F32 = if (((fTemp11 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp10)) + 2.0) } else { 0.96 };
			let mut fTemp13: F32 = F32::abs(fTemp11);
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 84.5) as i32)) as usize] } * fTemp12))));
			let mut fTemp15: F32 = fTemp14 + fTemp9;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec4[0];
			let mut fTemp18: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp17) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 77.5) as i32)) as usize] } * if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp19: F32 = fTemp15 + fTemp18;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp19, self.fRec8[1] + 1.0) };
			let mut iTemp20: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut fTemp21: F32 = (self.fRec8[0] - fTemp15) / fTemp18;
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut fTemp23: F32 = (self.fRec8[0] - fTemp14) / fTemp9;
			let mut iTemp24: i32 = ((self.fRec2[0] > fTemp10) as i32);
			let mut fTemp25: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp26: F32 = if (iTemp20 as i32 != 0) { if (iTemp22 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp22 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp25, 0.33333334) } else { fTemp25 } } else { self.fRec2[0] } } } else { if (iTemp20 as i32 != 0) { self.fRec2[0] + fTemp7 * if (((self.fRec4[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp23, 0.33333334) } else { fTemp23 } } else { self.fRec4[0] } } } else { if (((self.fRec8[0] < fTemp19) as i32) as i32 != 0) { self.fRec4[0] + fTemp17 * if (((self.fRec7[0] > self.fRec4[0]) as i32) as i32 != 0) { F32::powf(fTemp21, 0.33333334) } else { fTemp21 } } else { self.fRec7[0] } };
			let mut iTemp27: i32 = ((fTemp26) as i32);
			let mut fTemp28: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp27) as usize] };
			let mut fTemp29: F32 = F32::max(0.0, F32::min(127.0, 0.14285715 * fTemp4 + 89.0));
			let mut fTemp30: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp29) * (fTemp29 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp30 + 4064.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp30 } else { self.fRec11[1] };
			let mut fTemp31: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { fSlow5 } else { self.fRec12[1] };
			let mut fTemp32: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp31) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 49.5) as i32)) as usize] } * if (((fTemp31 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp33: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp34: F32 = self.fRec10[0] - fTemp33;
			let mut fTemp35: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp34) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec12[0] + 82.5) as i32)) as usize] } * if (((fTemp34 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp33)) + 2.0) } else { 0.96 }))));
			let mut fTemp36: F32 = fTemp35 + fTemp32;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst1 + fTemp36, self.fRec13[1] + 1.0) };
			let mut iTemp37: i32 = ((self.fRec13[0] < fTemp36) as i32);
			let mut iTemp38: i32 = ((self.fRec13[0] < fTemp35) as i32);
			let mut fTemp39: F32 = (self.fRec13[0] - fTemp35) / fTemp32;
			let mut fTemp40: F32 = self.fRec13[0] / fTemp35;
			let mut fTemp41: F32 = if (iTemp37 as i32 != 0) { if (iTemp38 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp33 } else { if (iTemp38 as i32 != 0) { fTemp33 + fTemp34 * if (((self.fRec10[0] > fTemp33) as i32) as i32 != 0) { F32::powf(fTemp40, 0.33333334) } else { fTemp40 } } else { self.fRec10[0] } } } else { if (iTemp37 as i32 != 0) { self.fRec10[0] + fTemp31 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp39, 0.33333334) } else { fTemp39 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp42: i32 = ((fTemp41) as i32);
			let mut fTemp43: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp42) as usize] };
			let mut fTemp44: F32 = F32::max(0.0, F32::min(127.0, 0.2857143 * fTemp4 + 71.0));
			let mut fTemp45: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp44) * (fTemp44 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp45 + 4e+03 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp45 + 3456.0 } else { self.fRec15[1] };
			let mut fTemp46: F32 = self.fRec15[0] - self.fRec14[0];
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fSlow6 } else { self.fRec16[1] };
			let mut fTemp47: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp46) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 85.5) as i32)) as usize] } * if (((fTemp46 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec17[0] = if (iTemp3 as i32 != 0) { fTemp45 } else { self.fRec17[1] };
			let mut fTemp48: F32 = F32::max(5076.0, self.fRec17[0]);
			let mut fTemp49: F32 = self.fRec14[0] - fTemp48;
			let mut fTemp50: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp49) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 76.5) as i32)) as usize] } * if (((fTemp49 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp48)) + 2.0) } else { 0.96 }))));
			let mut fTemp51: F32 = fTemp50 + fTemp47;
			let mut fTemp52: F32 = self.fRec17[0] - self.fRec15[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec16[0] + 39.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp54: F32 = fTemp51 + fTemp53;
			self.fRec18[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp54, self.fRec18[1] + 1.0) };
			let mut iTemp55: i32 = ((self.fRec18[0] < fTemp51) as i32);
			let mut fTemp56: F32 = (self.fRec18[0] - fTemp51) / fTemp53;
			let mut iTemp57: i32 = ((self.fRec18[0] < fTemp50) as i32);
			let mut fTemp58: F32 = (self.fRec18[0] - fTemp50) / fTemp47;
			let mut fTemp59: F32 = self.fRec18[0] / fTemp50;
			let mut fTemp60: F32 = if (iTemp55 as i32 != 0) { if (iTemp57 as i32 != 0) { if (((self.fRec18[0] < 0.0) as i32) as i32 != 0) { fTemp48 } else { if (iTemp57 as i32 != 0) { fTemp48 + fTemp49 * if (((self.fRec14[0] > fTemp48) as i32) as i32 != 0) { F32::powf(fTemp59, 0.33333334) } else { fTemp59 } } else { self.fRec14[0] } } } else { if (iTemp55 as i32 != 0) { self.fRec14[0] + fTemp46 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp58, 0.33333334) } else { fTemp58 } } else { self.fRec15[0] } } } else { if (((self.fRec18[0] < fTemp54) as i32) as i32 != 0) { self.fRec15[0] + fTemp52 * if (((self.fRec17[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp56, 0.33333334) } else { fTemp56 } } else { self.fRec17[0] } };
			let mut iTemp61: i32 = ((fTemp60) as i32);
			let mut fTemp62: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp61) as usize] };
			let mut iTemp63: i32 = i32::wrapping_sub(1, self.iVec1[1]);
			self.iRec21[0] = if (iTemp3 as i32 != 0) { self.iConst3 } else { self.iRec21[1] };
			self.iRec22[0] = if (iTemp3 as i32 != 0) { self.iConst4 } else { self.iRec22[1] };
			let mut iTemp64: i32 = i32::wrapping_sub(self.iRec22[0], self.iRec21[0]);
			let mut fTemp65: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp64)) as F32) / self.fConst2));
			let mut iTemp66: i32 = i32::wrapping_sub(self.iRec21[0], self.iRec22[0]);
			let mut fTemp67: F32 = F32::max(1.0, self.fConst5 * (((i32::abs(iTemp66)) as F32) / self.fConst6));
			let mut fTemp68: F32 = fTemp67 + fTemp65;
			self.fRec23[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp68 + 1.0, self.fRec23[1] + 1.0) };
			let mut iTemp69: i32 = ((self.fRec23[0] < fTemp68) as i32);
			let mut fTemp70: F32 = ((self.iRec22[0]) as F32);
			let mut iTemp71: i32 = ((self.fRec23[0] < fTemp67) as i32);
			let mut fTemp72: F32 = (self.fRec23[0] - fTemp67) / fTemp65;
			let mut fTemp73: F32 = ((self.iRec21[0]) as F32);
			let mut fTemp74: F32 = self.fRec23[0] / fTemp67;
			let mut fTemp75: F32 = 15.996094 * (0.4 * if (iTemp69 as i32 != 0) { if (iTemp71 as i32 != 0) { if (((self.fRec23[0] < 0.0) as i32) as i32 != 0) { fTemp70 } else { if (iTemp71 as i32 != 0) { fTemp70 + ((iTemp66) as F32) * if (((self.iRec21[0] > self.iRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp74, 0.33333334) } else { fTemp74 } } else { fTemp73 } } } else { if (iTemp69 as i32 != 0) { fTemp73 + ((iTemp64) as F32) * if (((self.iRec22[0] > self.iRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp72, 0.33333334) } else { fTemp72 } } else { fTemp70 } } } else { fTemp70 } + 128.0);
			let mut iTemp76: i32 = ((fTemp75) as i32);
			let mut fTemp77: F32 = unsafe { ftbl3DSP_Tom3SIG3[(iTemp76) as usize] };
			let mut fTemp78: F32 = fSlow11 * (fTemp77 + (fTemp75 - ((iTemp76) as F32)) * (unsafe { ftbl3DSP_Tom3SIG3[(i32::wrapping_add(iTemp76, 1)) as usize] } - fTemp77));
			let mut fTemp79: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec19[1] + fSlow12 * fTemp78 };
			self.fRec19[0] = fTemp79 - F32::floor(fTemp79);
			let mut fTemp80: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec24[1] + self.fConst9 };
			self.fRec24[0] = fTemp80 - F32::floor(fTemp80);
			let mut fTemp81: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec25[1] + fSlow13 * fTemp78 };
			self.fRec25[0] = fTemp81 - F32::floor(fTemp81);
			self.fRec27[0] = if (iTemp3 as i32 != 0) { fTemp6 + 3776.0 } else { self.fRec27[1] };
			let mut fTemp82: F32 = self.fRec27[0] - self.fRec2[0];
			self.fRec28[0] = if (iTemp3 as i32 != 0) { fSlow14 } else { self.fRec28[1] };
			let mut fTemp83: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp82) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 71.5) as i32)) as usize] } * if (((fTemp82 > 0.0) as i32) as i32 != 0) { fTemp8 } else { 0.96 }))));
			let mut fTemp84: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp13 / (fTemp12 * unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 94.5) as i32)) as usize] }))));
			let mut fTemp85: F32 = fTemp84 + fTemp83;
			let mut fTemp86: F32 = self.fRec7[0] - self.fRec27[0];
			let mut fTemp87: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp86) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec28[0] + 50.5) as i32)) as usize] } * if (((fTemp86 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec27[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp88: F32 = fTemp85 + fTemp87;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp88, self.fRec29[1] + 1.0) };
			let mut iTemp89: i32 = ((self.fRec29[0] < fTemp85) as i32);
			let mut fTemp90: F32 = (self.fRec29[0] - fTemp85) / fTemp87;
			let mut iTemp91: i32 = ((self.fRec29[0] < fTemp84) as i32);
			let mut fTemp92: F32 = (self.fRec29[0] - fTemp84) / fTemp83;
			let mut fTemp93: F32 = self.fRec29[0] / fTemp84;
			let mut fTemp94: F32 = if (iTemp89 as i32 != 0) { if (iTemp91 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp10 } else { if (iTemp91 as i32 != 0) { fTemp10 + fTemp11 * if (iTemp24 as i32 != 0) { F32::powf(fTemp93, 0.33333334) } else { fTemp93 } } else { self.fRec2[0] } } } else { if (iTemp89 as i32 != 0) { self.fRec2[0] + fTemp82 * if (((self.fRec27[0] > self.fRec2[0]) as i32) as i32 != 0) { F32::powf(fTemp92, 0.33333334) } else { fTemp92 } } else { self.fRec27[0] } } } else { if (((self.fRec29[0] < fTemp88) as i32) as i32 != 0) { self.fRec27[0] + fTemp86 * if (((self.fRec7[0] > self.fRec27[0]) as i32) as i32 != 0) { F32::powf(fTemp90, 0.33333334) } else { fTemp90 } } else { self.fRec7[0] } };
			let mut iTemp95: i32 = ((fTemp94) as i32);
			let mut fTemp96: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp95) as usize] };
			self.fRec30[0] = if (iTemp3 as i32 != 0) { 3296.0 } else { self.fRec30[1] };
			let mut fTemp97: F32 = F32::max(5076.0, self.fRec30[0]);
			self.fRec31[0] = if (iTemp3 as i32 != 0) { 7.36e+03 } else { self.fRec31[1] };
			let mut fTemp98: F32 = self.fRec31[0] - fTemp97;
			self.fRec32[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec32[1] };
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp98) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 83.5) as i32)) as usize] } * if (((fTemp98 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp97)) + 2.0) } else { 0.96 }))));
			let mut fTemp100: F32 = self.fRec30[0] - self.fRec31[0];
			let mut fTemp101: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp100) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec32[0] + 71.5) as i32)) as usize] } * if (((fTemp100 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp102: F32 = self.fConst1 + fTemp99 + fTemp101;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp102, self.fRec33[1] + 1.0) };
			let mut fTemp103: F32 = (self.fRec33[0] - fTemp99 - self.fConst1) / fTemp101;
			let mut iTemp104: i32 = ((self.fRec33[0] < fTemp99) as i32);
			let mut fTemp105: F32 = self.fRec33[0] / fTemp99;
			let mut fTemp106: F32 = if (((self.fRec33[0] < (self.fConst1 + fTemp99)) as i32) as i32 != 0) { if (iTemp104 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp97 } else { if (iTemp104 as i32 != 0) { fTemp97 + fTemp98 * if (((self.fRec31[0] > fTemp97) as i32) as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec31[0] } } } else { self.fRec31[0] } } else { if (((self.fRec33[0] < fTemp102) as i32) as i32 != 0) { self.fRec31[0] + fTemp100 * if (((self.fRec30[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp103, 0.33333334) } else { fTemp103 } } else { self.fRec30[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp107) as usize] };
			self.fRec34[0] = if (iTemp3 as i32 != 0) { 8096.0 } else { self.fRec34[1] };
			self.fRec35[0] = if (iTemp3 as i32 != 0) { 7584.0 } else { self.fRec35[1] };
			let mut fTemp109: F32 = self.fRec35[0] - self.fRec34[0];
			let mut fTemp110: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp109) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 85.5) as i32)) as usize] } * if (((fTemp109 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec34[0])) + 2.0) } else { 0.96 }))));
			self.fRec36[0] = if (iTemp3 as i32 != 0) { 4032.0 } else { self.fRec36[1] };
			let mut fTemp111: F32 = F32::max(5076.0, self.fRec36[0]);
			let mut fTemp112: F32 = self.fRec34[0] - fTemp111;
			let mut fTemp113: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp112) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 89.5) as i32)) as usize] } * if (((fTemp112 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp111)) + 2.0) } else { 0.96 }))));
			let mut fTemp114: F32 = fTemp113 + fTemp110;
			let mut fTemp115: F32 = self.fRec36[0] - self.fRec35[0];
			let mut fTemp116: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp115) / (unsafe { ftbl1DSP_Tom3SIG1[(((self.fRec6[0] + 81.5) as i32)) as usize] } * if (((fTemp115 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec35[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp117: F32 = fTemp114 + fTemp116;
			self.fRec37[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp117, self.fRec37[1] + 1.0) };
			let mut iTemp118: i32 = ((self.fRec37[0] < fTemp114) as i32);
			let mut fTemp119: F32 = (self.fRec37[0] - fTemp114) / fTemp116;
			let mut iTemp120: i32 = ((self.fRec37[0] < fTemp113) as i32);
			let mut fTemp121: F32 = (self.fRec37[0] - fTemp113) / fTemp110;
			let mut fTemp122: F32 = self.fRec37[0] / fTemp113;
			let mut fTemp123: F32 = if (iTemp118 as i32 != 0) { if (iTemp120 as i32 != 0) { if (((self.fRec37[0] < 0.0) as i32) as i32 != 0) { fTemp111 } else { if (iTemp120 as i32 != 0) { fTemp111 + fTemp112 * if (((self.fRec34[0] > fTemp111) as i32) as i32 != 0) { F32::powf(fTemp122, 0.33333334) } else { fTemp122 } } else { self.fRec34[0] } } } else { if (iTemp118 as i32 != 0) { self.fRec34[0] + fTemp109 * if (((self.fRec35[0] > self.fRec34[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec35[0] } } } else { if (((self.fRec37[0] < fTemp117) as i32) as i32 != 0) { self.fRec35[0] + fTemp115 * if (((self.fRec36[0] > self.fRec35[0]) as i32) as i32 != 0) { F32::powf(fTemp119, 0.33333334) } else { fTemp119 } } else { self.fRec36[0] } };
			let mut iTemp124: i32 = ((fTemp123) as i32);
			let mut fTemp125: F32 = unsafe { ftbl0DSP_Tom3SIG0[(iTemp124) as usize] };
			let mut fTemp126: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec38[1] + fSlow15 * fTemp78 };
			self.fRec38[0] = fTemp126 - F32::floor(fTemp126);
			let mut fTemp127: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec39[1] + self.fConst13 };
			self.fRec39[0] = fTemp127 - F32::floor(fTemp127);
			let mut fTemp128: F32 = if (iTemp63 as i32 != 0) { 0.0 } else { self.fRec40[1] + fSlow16 * fTemp78 };
			self.fRec40[0] = fTemp128 - F32::floor(fTemp128);
			self.fRec26[0] = 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec40[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec39[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec38[0] + 24.347826 * self.fRec26[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp125 + (fTemp123 - ((iTemp124) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp124, 1)) as usize] } - fTemp125)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp96 + (fTemp94 - ((iTemp95) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp95, 1)) as usize] } - fTemp96));
			let mut fTemp129: F32 = self.fRec26[0] + 0.115 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec25[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * (self.fRec24[0] + 2.0 * unsafe { ftbl2DSP_Tom3SIG2[(((1024.0 * self.fRec19[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp62 + (fTemp60 - ((iTemp61) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp61, 1)) as usize] } - fTemp62)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp43 + (fTemp41 - ((iTemp42) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp42, 1)) as usize] } - fTemp43)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp28 + (fTemp26 - ((iTemp27) as F32)) * (unsafe { ftbl0DSP_Tom3SIG0[(i32::wrapping_add(iTemp27, 1)) as usize] } - fTemp28));
			self.fVec4[0] = fTemp129;
			self.fRec0[0] = self.fConst20 * self.fVec4[1] - self.fConst19 * (self.fConst17 * self.fRec0[1] - self.fConst16 * fTemp129);
			*output0 = fSlow19 * self.fRec0[0];
			*output1 = fSlow20 * self.fRec0[0];
			*output2 = fSlow21 * self.fRec0[0];
			self.fVec0[1] = self.fVec0[0];
			self.iVec1[1] = self.iVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec2[1] = self.fRec2[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.iRec21[1] = self.iRec21[0];
			self.iRec22[1] = self.iRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec19[1] = self.fRec19[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec28[1] = self.fRec28[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fRec36[1] = self.fRec36[0];
			self.fRec37[1] = self.fRec37[0];
			self.fRec38[1] = self.fRec38[0];
			self.fRec39[1] = self.fRec39[0];
			self.fRec40[1] = self.fRec40[0];
			self.fRec26[1] = self.fRec26[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
