// Optimized
/* ------------------------------------------------------------
name: "main"
Code generated with Faust 2.60.3 (https://faust.grame.fr)
Compilation options: -a arch.rs -lang rust -ct 0 -cn DSP_Tom4 -pn processTom4 -dtl 65536 -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2022 Punk Labs LLC

    This section is part of OneTrick

    OneTrick is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

use faust_types::*;




pub struct DSP_Tom4SIG0 {
	iRec1: [i32;2],
}

impl DSP_Tom4SIG0 {
	
	fn get_num_inputsDSP_Tom4SIG0(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom4SIG0(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom4SIG0(&mut self, sample_rate: i32) {
		for l1 in 0..2 {
			self.iRec1[(l1) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom4SIG0(&mut self, count: i32, table: &mut[F32]) {
		for i1 in 0..count {
			self.iRec1[0] = i32::wrapping_add(self.iRec1[1], 1);
			let mut fTemp0: F32 = ((i32::wrapping_add(self.iRec1[0], -1)) as F32);
			table[(i1) as usize] = F32::max(0.0, F32::min(2.0, F32::powf(1e+01, 0.05 * (0.0 - 0.0235 * (8096.0 - fTemp0))))) * (((((7.2e+03 - fTemp0) < 3824.0) as i32)) as F32);
			self.iRec1[1] = self.iRec1[0];
		}
	}

}


pub fn newDSP_Tom4SIG0() -> DSP_Tom4SIG0 { 
	DSP_Tom4SIG0 {
		iRec1: [0;2],
	}
}

pub struct DSP_Tom4SIG1 {
	iRec2: [i32;2],
}

impl DSP_Tom4SIG1 {
	
	fn get_num_inputsDSP_Tom4SIG1(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom4SIG1(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom4SIG1(&mut self, sample_rate: i32) {
		for l2 in 0..2 {
			self.iRec2[(l2) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom4SIG1(&mut self, count: i32, table: &mut[F32]) {
		for i2 in 0..count {
			self.iRec2[0] = i32::wrapping_add(self.iRec2[1], 1);
			table[(i2) as usize] = 0.2819 * F32::powf(2.0, 0.16 * ((i32::wrapping_add(self.iRec2[0], -1)) as F32));
			self.iRec2[1] = self.iRec2[0];
		}
	}

}


pub fn newDSP_Tom4SIG1() -> DSP_Tom4SIG1 { 
	DSP_Tom4SIG1 {
		iRec2: [0;2],
	}
}

pub struct DSP_Tom4SIG2 {
	iVec3: [i32;2],
	iRec9: [i32;2],
}

impl DSP_Tom4SIG2 {
	
	fn get_num_inputsDSP_Tom4SIG2(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom4SIG2(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom4SIG2(&mut self, sample_rate: i32) {
		for l11 in 0..2 {
			self.iVec3[(l11) as usize] = 0;
		}
		for l12 in 0..2 {
			self.iRec9[(l12) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom4SIG2(&mut self, count: i32, table: &mut[F32]) {
		for i3 in 0..count {
			self.iVec3[0] = 1;
			self.iRec9[0] = (i32::wrapping_add(self.iVec3[1], self.iRec9[1])) % 1024;
			table[(i3) as usize] = F32::sin(0.0061359233 * ((self.iRec9[0]) as F32));
			self.iVec3[1] = self.iVec3[0];
			self.iRec9[1] = self.iRec9[0];
		}
	}

}


pub fn newDSP_Tom4SIG2() -> DSP_Tom4SIG2 { 
	DSP_Tom4SIG2 {
		iVec3: [0;2],
		iRec9: [0;2],
	}
}

pub struct DSP_Tom4SIG3 {
	iRec19: [i32;2],
}

impl DSP_Tom4SIG3 {
	
	fn get_num_inputsDSP_Tom4SIG3(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom4SIG3(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom4SIG3(&mut self, sample_rate: i32) {
		for l21 in 0..2 {
			self.iRec19[(l21) as usize] = 0;
		}
	}
	
	fn fillDSP_Tom4SIG3(&mut self, count: i32, table: &mut[F32]) {
		for i4 in 0..count {
			self.iRec19[0] = i32::wrapping_add(self.iRec19[1], 1);
			table[(i4) as usize] = F32::powf(2.0, 0.083333336 * (0.062515266 * ((i32::wrapping_add(self.iRec19[0], -1)) as F32) + -128.0));
			self.iRec19[1] = self.iRec19[0];
		}
	}

}


pub fn newDSP_Tom4SIG3() -> DSP_Tom4SIG3 { 
	DSP_Tom4SIG3 {
		iRec19: [0;2],
	}
}
static mut iDSP_Tom4SIG4Wave0: [i32;100] = [-128,-116,-104,-95,-85,-76,-68,-61,-56,-52,-49,-46,-43,-41,-39,-37,-35,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,38,40,43,46,49,53,58,65,73,82,92,103,115,127];

pub struct DSP_Tom4SIG4 {
	iDSP_Tom4SIG4Wave0_idx: i32,
}

impl DSP_Tom4SIG4 {
	
	fn get_num_inputsDSP_Tom4SIG4(&self) -> i32 {
		return 0;
	}
	fn get_num_outputsDSP_Tom4SIG4(&self) -> i32 {
		return 1;
	}
	
	fn instance_initDSP_Tom4SIG4(&mut self, sample_rate: i32) {
		self.iDSP_Tom4SIG4Wave0_idx = 0;
	}
	
	fn fillDSP_Tom4SIG4(&mut self, count: i32, table: &mut[i32]) {
		for i5 in 0..count {
			table[(i5) as usize] = unsafe { iDSP_Tom4SIG4Wave0[(self.iDSP_Tom4SIG4Wave0_idx) as usize] };
			self.iDSP_Tom4SIG4Wave0_idx = (i32::wrapping_add(1, self.iDSP_Tom4SIG4Wave0_idx)) % 100;
		}
	}

}


pub fn newDSP_Tom4SIG4() -> DSP_Tom4SIG4 { 
	DSP_Tom4SIG4 {
		iDSP_Tom4SIG4Wave0_idx: 0,
	}
}
static mut ftbl0DSP_Tom4SIG0: [F32;16384] = [0.0;16384];
static mut ftbl1DSP_Tom4SIG1: [F32;144] = [0.0;144];
fn DSP_Tom4_faustpower2_f(value: F32) -> F32 {
	return value * value;
}
static mut ftbl2DSP_Tom4SIG2: [F32;1024] = [0.0;1024];
static mut ftbl3DSP_Tom4SIG3: [F32;4096] = [0.0;4096];
static mut itbl4DSP_Tom4SIG4: [i32;100] = [0;100];

#[cfg_attr(feature = "default-boxed", derive(default_boxed::DefaultBoxed))]
#[repr(C)]
pub struct DSP_Tom4 {
	iVec0: [i32;2],
	fSampleRate: i32,
	fConst0: F32,
	fConst4: F32,
	fEntry0: F32,
	fVec1: [F32;2],
	iVec2: [i32;2],
	fHslider0: F32,
	fHslider1: F32,
	fRec3: [F32;2],
	fHslider2: F32,
	fRec5: [F32;2],
	fRec4: [F32;2],
	fRec6: [F32;2],
	fRec7: [F32;2],
	fRec8: [F32;2],
	fRec10: [F32;2],
	fRec11: [F32;2],
	fRec12: [F32;2],
	fConst5: F32,
	fRec13: [F32;2],
	fRec14: [F32;2],
	fRec15: [F32;2],
	fRec16: [F32;2],
	fRec17: [F32;2],
	fConst7: F32,
	fRec18: [F32;2],
	fRec21: [F32;2],
	fRec22: [F32;2],
	fRec23: [F32;2],
	fRec24: [F32;2],
	fConst10: F32,
	fRec25: [F32;2],
	fRec20: [F32;2],
	fConst12: F32,
	fRec26: [F32;2],
	iConst13: i32,
	iRec28: [i32;2],
	fConst14: F32,
	fRec27: [F32;2],
	fRec29: [F32;2],
	fRec30: [F32;2],
	fRec31: [F32;2],
	fRec32: [F32;2],
	fRec33: [F32;2],
	fConst16: F32,
	fRec34: [F32;2],
	fConst17: F32,
	fRec35: [F32;2],
	fVec4: [F32;2],
	fConst18: F32,
	fConst19: F32,
	fRec0: [F32;2],
	fHslider3: F32,
	fHslider4: F32,
	fHslider5: F32,
}

impl FaustDsp for DSP_Tom4 {
	type T = F32;
		
	fn new() -> DSP_Tom4 { 
		DSP_Tom4 {
			iVec0: [0;2],
			fSampleRate: 0,
			fConst0: 0.0,
			fConst4: 0.0,
			fEntry0: 0.0,
			fVec1: [0.0;2],
			iVec2: [0;2],
			fHslider0: 0.0,
			fHslider1: 0.0,
			fRec3: [0.0;2],
			fHslider2: 0.0,
			fRec5: [0.0;2],
			fRec4: [0.0;2],
			fRec6: [0.0;2],
			fRec7: [0.0;2],
			fRec8: [0.0;2],
			fRec10: [0.0;2],
			fRec11: [0.0;2],
			fRec12: [0.0;2],
			fConst5: 0.0,
			fRec13: [0.0;2],
			fRec14: [0.0;2],
			fRec15: [0.0;2],
			fRec16: [0.0;2],
			fRec17: [0.0;2],
			fConst7: 0.0,
			fRec18: [0.0;2],
			fRec21: [0.0;2],
			fRec22: [0.0;2],
			fRec23: [0.0;2],
			fRec24: [0.0;2],
			fConst10: 0.0,
			fRec25: [0.0;2],
			fRec20: [0.0;2],
			fConst12: 0.0,
			fRec26: [0.0;2],
			iConst13: 0,
			iRec28: [0;2],
			fConst14: 0.0,
			fRec27: [0.0;2],
			fRec29: [0.0;2],
			fRec30: [0.0;2],
			fRec31: [0.0;2],
			fRec32: [0.0;2],
			fRec33: [0.0;2],
			fConst16: 0.0,
			fRec34: [0.0;2],
			fConst17: 0.0,
			fRec35: [0.0;2],
			fVec4: [0.0;2],
			fConst18: 0.0,
			fConst19: 0.0,
			fRec0: [0.0;2],
			fHslider3: 0.0,
			fHslider4: 0.0,
			fHslider5: 0.0,
		}
	}
	fn metadata(&self, m: &mut dyn Meta) { 
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/sAndH:author", "Romain Michon");
		m.declare("basics.lib/tabulate:author", "Stephane Letz");
		m.declare("basics.lib/tabulateNd", "Copyright (C) 2023 Bart Brouns <bart@magnetophon.nl>");
		m.declare("basics.lib/version", "1.10.0");
		m.declare("compile_options", "-a arch.rs -lang rust -ct 0 -cn DSP_Tom4 -pn processTom4 -dtl 65536 -es 1 -mcd 16 -single -ftz 0");
		m.declare("filename", "main.dsp");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/tf1:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf1s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf1s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf1s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "1.3.0");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "1.3.0");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.6.0");
		m.declare("name", "main");
		m.declare("oscillators.lib/name", "Faust Oscillator Library");
		m.declare("oscillators.lib/version", "1.4.0");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "1.3.0");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "1.3.0");
	}

	fn get_sample_rate(&self) -> i32 {
		return self.fSampleRate;
	}
	fn get_num_inputs(&self) -> i32 {
		return 0;
	}
	fn get_num_outputs(&self) -> i32 {
		return 3;
	}
	
	fn class_init(sample_rate: i32) {
		let mut sig0: DSP_Tom4SIG0 = newDSP_Tom4SIG0();
		sig0.instance_initDSP_Tom4SIG0(sample_rate);
		sig0.fillDSP_Tom4SIG0(16384, unsafe { &mut ftbl0DSP_Tom4SIG0 });
		let mut sig1: DSP_Tom4SIG1 = newDSP_Tom4SIG1();
		sig1.instance_initDSP_Tom4SIG1(sample_rate);
		sig1.fillDSP_Tom4SIG1(144, unsafe { &mut ftbl1DSP_Tom4SIG1 });
		let mut sig2: DSP_Tom4SIG2 = newDSP_Tom4SIG2();
		sig2.instance_initDSP_Tom4SIG2(sample_rate);
		sig2.fillDSP_Tom4SIG2(1024, unsafe { &mut ftbl2DSP_Tom4SIG2 });
		let mut sig3: DSP_Tom4SIG3 = newDSP_Tom4SIG3();
		sig3.instance_initDSP_Tom4SIG3(sample_rate);
		sig3.fillDSP_Tom4SIG3(4096, unsafe { &mut ftbl3DSP_Tom4SIG3 });
		let mut sig4: DSP_Tom4SIG4 = newDSP_Tom4SIG4();
		sig4.instance_initDSP_Tom4SIG4(sample_rate);
		sig4.fillDSP_Tom4SIG4(100, unsafe { &mut itbl4DSP_Tom4SIG4 });
	}
	fn instance_reset_params(&mut self) {
		self.fEntry0 = 0.0;
		self.fHslider0 = 36.0;
		self.fHslider1 = 0.0;
		self.fHslider2 = 0.0;
		self.fHslider3 = 0.0;
		self.fHslider4 = 0.0;
		self.fHslider5 = 2e+01;
	}
	fn instance_clear(&mut self) {
		for l0 in 0..2 {
			self.iVec0[(l0) as usize] = 0;
		}
		for l3 in 0..2 {
			self.fVec1[(l3) as usize] = 0.0;
		}
		for l4 in 0..2 {
			self.iVec2[(l4) as usize] = 0;
		}
		for l5 in 0..2 {
			self.fRec3[(l5) as usize] = 0.0;
		}
		for l6 in 0..2 {
			self.fRec5[(l6) as usize] = 0.0;
		}
		for l7 in 0..2 {
			self.fRec4[(l7) as usize] = 0.0;
		}
		for l8 in 0..2 {
			self.fRec6[(l8) as usize] = 0.0;
		}
		for l9 in 0..2 {
			self.fRec7[(l9) as usize] = 0.0;
		}
		for l10 in 0..2 {
			self.fRec8[(l10) as usize] = 0.0;
		}
		for l13 in 0..2 {
			self.fRec10[(l13) as usize] = 0.0;
		}
		for l14 in 0..2 {
			self.fRec11[(l14) as usize] = 0.0;
		}
		for l15 in 0..2 {
			self.fRec12[(l15) as usize] = 0.0;
		}
		for l16 in 0..2 {
			self.fRec13[(l16) as usize] = 0.0;
		}
		for l17 in 0..2 {
			self.fRec14[(l17) as usize] = 0.0;
		}
		for l18 in 0..2 {
			self.fRec15[(l18) as usize] = 0.0;
		}
		for l19 in 0..2 {
			self.fRec16[(l19) as usize] = 0.0;
		}
		for l20 in 0..2 {
			self.fRec17[(l20) as usize] = 0.0;
		}
		for l22 in 0..2 {
			self.fRec18[(l22) as usize] = 0.0;
		}
		for l23 in 0..2 {
			self.fRec21[(l23) as usize] = 0.0;
		}
		for l24 in 0..2 {
			self.fRec22[(l24) as usize] = 0.0;
		}
		for l25 in 0..2 {
			self.fRec23[(l25) as usize] = 0.0;
		}
		for l26 in 0..2 {
			self.fRec24[(l26) as usize] = 0.0;
		}
		for l27 in 0..2 {
			self.fRec25[(l27) as usize] = 0.0;
		}
		for l28 in 0..2 {
			self.fRec20[(l28) as usize] = 0.0;
		}
		for l29 in 0..2 {
			self.fRec26[(l29) as usize] = 0.0;
		}
		for l30 in 0..2 {
			self.iRec28[(l30) as usize] = 0;
		}
		for l31 in 0..2 {
			self.fRec27[(l31) as usize] = 0.0;
		}
		for l32 in 0..2 {
			self.fRec29[(l32) as usize] = 0.0;
		}
		for l33 in 0..2 {
			self.fRec30[(l33) as usize] = 0.0;
		}
		for l34 in 0..2 {
			self.fRec31[(l34) as usize] = 0.0;
		}
		for l35 in 0..2 {
			self.fRec32[(l35) as usize] = 0.0;
		}
		for l36 in 0..2 {
			self.fRec33[(l36) as usize] = 0.0;
		}
		for l37 in 0..2 {
			self.fRec34[(l37) as usize] = 0.0;
		}
		for l38 in 0..2 {
			self.fRec35[(l38) as usize] = 0.0;
		}
		for l39 in 0..2 {
			self.fVec4[(l39) as usize] = 0.0;
		}
		for l40 in 0..2 {
			self.fRec0[(l40) as usize] = 0.0;
		}
	}
	fn instance_constants(&mut self, sample_rate: i32) {
		self.fSampleRate = sample_rate;
		self.fConst0 = F32::min(1.92e+05, F32::max(1.0, ((self.fSampleRate) as F32)));
		let mut fConst1: F32 = F32::tan(62.831852 / self.fConst0);
		let mut fConst2: F32 = 1.0 / fConst1;
		let mut fConst3: F32 = fConst2 + 1.0;
		self.fConst4 = (1.0 - fConst2) / fConst3;
		self.fConst5 = F32::max(1.0, 0.001 * self.fConst0);
		let mut fConst6: F32 = unsafe { ftbl3DSP_Tom4SIG3[2168] };
		self.fConst7 = 1e+03 / self.fConst0 * (fConst6 + 0.65089494 * (unsafe { ftbl3DSP_Tom4SIG3[2169] } - fConst6));
		let mut fConst8: F32 = unsafe { ftbl3DSP_Tom4SIG3[2404] };
		let mut fConst9: F32 = 1e+02 / self.fConst0;
		self.fConst10 = fConst9 * (fConst8 + 0.5763219 * (unsafe { ftbl3DSP_Tom4SIG3[2405] } - fConst8));
		let mut fConst11: F32 = unsafe { ftbl3DSP_Tom4SIG3[2449] };
		self.fConst12 = fConst9 * (fConst11 + 0.21086212 * (unsafe { ftbl3DSP_Tom4SIG3[2450] } - fConst11));
		self.iConst13 = unsafe { itbl4DSP_Tom4SIG4[50] };
		self.fConst14 = 268.4 / self.fConst0;
		let mut fConst15: F32 = unsafe { ftbl3DSP_Tom4SIG3[2500] };
		self.fConst16 = fConst9 * (fConst15 + 0.22176524 * (unsafe { ftbl3DSP_Tom4SIG3[2501] } - fConst15));
		self.fConst17 = 2.2e+02 / self.fConst0;
		self.fConst18 = 1.0 / (fConst1 * fConst3);
		self.fConst19 = 0.0 - self.fConst18;
	}
	fn instance_init(&mut self, sample_rate: i32) {
		self.instance_constants(sample_rate);
		self.instance_reset_params();
		self.instance_clear();
	}
	fn init(&mut self, sample_rate: i32) {
		DSP_Tom4::class_init(sample_rate);
		self.instance_init(sample_rate);
	}
	
	fn build_user_interface(&self, ui_interface: &mut dyn UI<Self::T>) {
		Self::build_user_interface_static(ui_interface);
	}
	
	fn build_user_interface_static(ui_interface: &mut dyn UI<Self::T>) {
		ui_interface.open_vertical_box("main");
		ui_interface.add_num_entry("Trigger", ParamIndex(0), 0.0, 0.0, 1.0, 0.01);
		ui_interface.declare(Some(ParamIndex(1)), "1", "");
		ui_interface.declare(Some(ParamIndex(1)), "export", "Gain");
		ui_interface.declare(Some(ParamIndex(1)), "unit", "dB");
		ui_interface.add_horizontal_slider("Voice_Gain", ParamIndex(1), 0.0, -1e+02, 6.0, 0.1);
		ui_interface.declare(Some(ParamIndex(2)), "2", "");
		ui_interface.declare(Some(ParamIndex(2)), "export", "Pan");
		ui_interface.declare(Some(ParamIndex(2)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Pan", ParamIndex(2), 0.0, -1e+02, 1e+02, 0.01);
		ui_interface.declare(Some(ParamIndex(3)), "4", "");
		ui_interface.declare(Some(ParamIndex(3)), "export", "Transpose");
		ui_interface.declare(Some(ParamIndex(3)), "unit", "st");
		ui_interface.add_horizontal_slider("Voice_Transpose", ParamIndex(3), 0.0, -12.0, 12.0, 0.01);
		ui_interface.declare(Some(ParamIndex(4)), "8", "");
		ui_interface.declare(Some(ParamIndex(4)), "export", "Reverb");
		ui_interface.declare(Some(ParamIndex(4)), "unit", "%");
		ui_interface.add_horizontal_slider("Voice_Reverb", ParamIndex(4), 2e+01, 0.0, 1e+02, 0.01);
		ui_interface.add_horizontal_slider("gain", ParamIndex(5), 0.0, 0.0, 1.0, 0.01);
		ui_interface.add_horizontal_slider("key", ParamIndex(6), 36.0, 0.0, 127.0, 1.0);
		ui_interface.close_box();
	}
	
	fn get_param(&self, param: ParamIndex) -> Option<Self::T> {
		match param.0 {
			0 => Some(self.fEntry0),
			6 => Some(self.fHslider0),
			3 => Some(self.fHslider1),
			5 => Some(self.fHslider2),
			2 => Some(self.fHslider3),
			1 => Some(self.fHslider4),
			4 => Some(self.fHslider5),
			_ => None,
		}
	}
	
	fn set_param(&mut self, param: ParamIndex, value: Self::T) {
		match param.0 {
			0 => { self.fEntry0 = value }
			6 => { self.fHslider0 = value }
			3 => { self.fHslider1 = value }
			5 => { self.fHslider2 = value }
			2 => { self.fHslider3 = value }
			1 => { self.fHslider4 = value }
			4 => { self.fHslider5 = value }
			_ => {}
		}
	}
	
	fn compute(&mut self, count: i32, inputs: &[&[Self::T]], outputs: &mut[&mut[Self::T]]) {
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx2") {
            // Use specialized avx2 version and return
            unsafe { self.compute_x86_or_x86_64_using_avx2(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("avx") {
            // Use specialized avx version and return
            unsafe { self.compute_x86_or_x86_64_using_avx(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse4.1") {
            // Use specialized sse4.1 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse4_1(count, inputs, outputs); }
            return;
        }
        #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
        if is_x86_feature_detected!("sse3") {
            // Use specialized sse3 version and return
            unsafe { self.compute_x86_or_x86_64_using_sse3(count, inputs, outputs); }
            return;
        }
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider1 + self.fHslider0;
		let mut fSlow2: F32 = 0.42857143 * (0.33333334 * (fSlow1 + 8.2) + 1.0);
		let mut fSlow3: F32 = self.fHslider2;
		let mut fSlow4: F32 = F32::min(99.0, 0.23232323 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow1 + -61.8))) + 8e+01);
		let mut fSlow5: F32 = F32::min(99.0, 0.34343433 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow1 + -52.8)))) + 85.0);
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow1 + -60.8));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst14 * fSlow6;
		let mut fSlow12: F32 = fSlow1 + -53.8;
		let mut fSlow13: F32 = F32::min(99.0, 0.5252525 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow12))) + 0.53535354 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow12))) + 88.0);
		let mut fSlow14: F32 = self.fConst17 * fSlow6;
		let mut fSlow15: F32 = 0.01 * self.fHslider3;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + -3.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider5 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp3 as i32 != 0) { fSlow2 } else { self.fRec3[1] };
			self.fRec5[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec5[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom4_faustpower2_f(1.0 - F32::max(fSlow3, self.fRec5[0]))) + -99.0;
			let mut fTemp5: F32 = 0.5714286 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec4[1] };
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fTemp7 + 3968.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = self.fRec6[0] - self.fRec4[0];
			let mut fTemp9: F32 = if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 };
			let mut fTemp10: F32 = F32::abs(fTemp8);
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (fTemp9 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 28.5) as i32)) as usize] }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec7[1] };
			let mut fTemp12: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp13: F32 = self.fRec4[0] - fTemp12;
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp13) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 88.5) as i32)) as usize] } * if (((fTemp13 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp12)) + 2.0) } else { 0.96 }))));
			let mut fTemp15: F32 = fTemp14 + fTemp11;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec6[0];
			let mut fTemp18: F32 = if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec6[0])) + 2.0) } else { 0.96 };
			let mut fTemp19: F32 = F32::abs(fTemp17);
			let mut fTemp20: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (fTemp18 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 47.5) as i32)) as usize] }))));
			let mut fTemp21: F32 = fTemp15 + fTemp20;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp21, self.fRec8[1] + 1.0) };
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut iTemp23: i32 = ((self.fRec7[0] > self.fRec6[0]) as i32);
			let mut fTemp24: F32 = (self.fRec8[0] - fTemp15) / fTemp20;
			let mut iTemp25: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut iTemp26: i32 = ((self.fRec6[0] > self.fRec4[0]) as i32);
			let mut fTemp27: F32 = (self.fRec8[0] - fTemp14) / fTemp11;
			let mut iTemp28: i32 = ((self.fRec4[0] > fTemp12) as i32);
			let mut fTemp29: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp30: F32 = if (iTemp22 as i32 != 0) { if (iTemp25 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp25 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp29, 0.33333334) } else { fTemp29 } } else { self.fRec4[0] } } } else { if (iTemp22 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp27, 0.33333334) } else { fTemp27 } } else { self.fRec6[0] } } } else { if (((self.fRec8[0] < fTemp21) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec7[0] } };
			let mut iTemp31: i32 = ((fTemp30) as i32);
			let mut fTemp32: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp31) as usize] };
			let mut fTemp33: F32 = F32::max(0.0, F32::min(127.0, fSlow4 + fTemp5));
			let mut fTemp34: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp33) * (fTemp33 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp34 + 3872.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp34 } else { self.fRec11[1] };
			let mut fTemp35: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp36: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] };
			let mut fTemp37: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (fTemp36 * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp38: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp39: F32 = self.fRec10[0] - fTemp38;
			let mut fTemp40: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp39) / (fTemp40 * if (((fTemp39 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp38)) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = fTemp41 + fTemp37;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp42, self.fRec13[1] + 1.0) };
			let mut iTemp43: i32 = ((self.fRec13[0] < fTemp42) as i32);
			let mut iTemp44: i32 = ((self.fRec13[0] < fTemp41) as i32);
			let mut fTemp45: F32 = (self.fRec13[0] - fTemp41) / fTemp37;
			let mut fTemp46: F32 = self.fRec13[0] / fTemp41;
			let mut fTemp47: F32 = if (iTemp43 as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp38 } else { if (iTemp44 as i32 != 0) { fTemp38 + fTemp39 * if (((self.fRec10[0] > fTemp38) as i32) as i32 != 0) { F32::powf(fTemp46, 0.33333334) } else { fTemp46 } } else { self.fRec10[0] } } } else { if (iTemp43 as i32 != 0) { self.fRec10[0] + fTemp35 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp48: i32 = ((fTemp47) as i32);
			let mut fTemp49: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp48) as usize] };
			let mut fTemp50: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp51: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp50) * (fTemp50 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp51 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp51 + 2688.0 } else { self.fRec15[1] };
			let mut fTemp52: F32 = self.fRec15[0] - self.fRec14[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 75.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp51 } else { self.fRec16[1] };
			let mut fTemp54: F32 = F32::max(5076.0, self.fRec16[0]);
			let mut fTemp55: F32 = self.fRec14[0] - fTemp54;
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (fTemp40 * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp54)) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = fTemp56 + fTemp53;
			let mut fTemp58: F32 = self.fRec16[0] - self.fRec15[0];
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 59.5) as i32)) as usize] } * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp57 + fTemp59;
			self.fRec17[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp60, self.fRec17[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec17[0] < fTemp57) as i32);
			let mut fTemp62: F32 = (self.fRec17[0] - fTemp57) / fTemp59;
			let mut iTemp63: i32 = ((self.fRec17[0] < fTemp56) as i32);
			let mut fTemp64: F32 = (self.fRec17[0] - fTemp56) / fTemp53;
			let mut fTemp65: F32 = self.fRec17[0] / fTemp56;
			let mut fTemp66: F32 = if (iTemp61 as i32 != 0) { if (iTemp63 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp54 } else { if (iTemp63 as i32 != 0) { fTemp54 + fTemp55 * if (((self.fRec14[0] > fTemp54) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec14[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec14[0] + fTemp52 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec15[0] } } } else { if (((self.fRec17[0] < fTemp60) as i32) as i32 != 0) { self.fRec15[0] + fTemp58 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec16[0] } };
			let mut iTemp67: i32 = ((fTemp66) as i32);
			let mut fTemp68: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp67) as usize] };
			let mut iTemp69: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp70: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst7 };
			self.fRec18[0] = fTemp70 - F32::floor(fTemp70);
			let mut fTemp71: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 96.0));
			let mut fTemp72: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp71) * (fTemp71 + 28.0);
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp72 + 4064.0 } else { self.fRec21[1] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp72 + 3136.0 } else { self.fRec22[1] };
			let mut fTemp73: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp74: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp73) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 79.5) as i32)) as usize] } * if (((fTemp73 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp72 } else { self.fRec23[1] };
			let mut fTemp75: F32 = F32::max(5076.0, self.fRec23[0]);
			let mut fTemp76: F32 = self.fRec21[0] - fTemp75;
			let mut fTemp77: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp76) / (fTemp40 * if (((fTemp76 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp75)) + 2.0) } else { 0.96 }))));
			let mut fTemp78: F32 = fTemp77 + fTemp74;
			let mut fTemp79: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp80: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp79) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp79 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp81: F32 = fTemp78 + fTemp80;
			self.fRec24[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp81, self.fRec24[1] + 1.0) };
			let mut iTemp82: i32 = ((self.fRec24[0] < fTemp78) as i32);
			let mut fTemp83: F32 = (self.fRec24[0] - fTemp78) / fTemp80;
			let mut iTemp84: i32 = ((self.fRec24[0] < fTemp77) as i32);
			let mut fTemp85: F32 = (self.fRec24[0] - fTemp77) / fTemp74;
			let mut fTemp86: F32 = self.fRec24[0] / fTemp77;
			let mut fTemp87: F32 = if (iTemp82 as i32 != 0) { if (iTemp84 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp75 } else { if (iTemp84 as i32 != 0) { fTemp75 + fTemp76 * if (((self.fRec21[0] > fTemp75) as i32) as i32 != 0) { F32::powf(fTemp86, 0.33333334) } else { fTemp86 } } else { self.fRec21[0] } } } else { if (iTemp82 as i32 != 0) { self.fRec21[0] + fTemp73 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { self.fRec22[0] } } } else { if (((self.fRec24[0] < fTemp81) as i32) as i32 != 0) { self.fRec22[0] + fTemp79 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { self.fRec23[0] } };
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp88) as usize] };
			let mut fTemp90: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst10 };
			self.fRec25[0] = fTemp90 - F32::floor(fTemp90);
			self.fRec20[0] = 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec25[0] + 13.913043 * self.fRec20[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89));
			let mut fTemp91: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst12 };
			self.fRec26[0] = fTemp91 - F32::floor(fTemp91);
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec28[1] };
			let mut fTemp92: F32 = 15.996094 * (0.4 * ((self.iRec28[0]) as F32) + 128.0);
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iTemp93) as usize] };
			let mut fTemp95: F32 = fSlow10 * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow11 * fTemp95 };
			self.fRec27[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 41.5) as i32)) as usize] } * fTemp9))));
			let mut fTemp98: F32 = fTemp14 + fTemp97;
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 45.5) as i32)) as usize] } * fTemp18))));
			let mut fTemp100: F32 = fTemp98 + fTemp99;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp100, self.fRec29[1] + 1.0) };
			let mut iTemp101: i32 = ((self.fRec29[0] < fTemp98) as i32);
			let mut fTemp102: F32 = (self.fRec29[0] - fTemp98) / fTemp99;
			let mut iTemp103: i32 = ((self.fRec29[0] < fTemp14) as i32);
			let mut fTemp104: F32 = (self.fRec29[0] - fTemp14) / fTemp97;
			let mut fTemp105: F32 = self.fRec29[0] / fTemp14;
			let mut fTemp106: F32 = if (iTemp101 as i32 != 0) { if (iTemp103 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp103 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec4[0] } } } else { if (iTemp101 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp104, 0.33333334) } else { fTemp104 } } else { self.fRec6[0] } } } else { if (((self.fRec29[0] < fTemp100) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp102, 0.33333334) } else { fTemp102 } } else { self.fRec7[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp107) as usize] };
			let mut fTemp109: F32 = F32::max(0.0, F32::min(127.0, fSlow13 + fTemp5));
			let mut fTemp110: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp109) * (fTemp109 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3872.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3232.0 } else { self.fRec31[1] };
			let mut fTemp111: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp112: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp111) / (fTemp36 * if (((fTemp111 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp110 } else { self.fRec32[1] };
			let mut fTemp113: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp114: F32 = self.fRec30[0] - fTemp113;
			let mut fTemp115: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp114) / (fTemp40 * if (((fTemp114 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp113)) + 2.0) } else { 0.96 }))));
			let mut fTemp116: F32 = fTemp115 + fTemp112;
			let mut fTemp117: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp118: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp117) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 54.5) as i32)) as usize] } * if (((fTemp117 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp119: F32 = fTemp116 + fTemp118;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp119, self.fRec33[1] + 1.0) };
			let mut iTemp120: i32 = ((self.fRec33[0] < fTemp116) as i32);
			let mut fTemp121: F32 = (self.fRec33[0] - fTemp116) / fTemp118;
			let mut iTemp122: i32 = ((self.fRec33[0] < fTemp115) as i32);
			let mut fTemp123: F32 = (self.fRec33[0] - fTemp115) / fTemp112;
			let mut fTemp124: F32 = self.fRec33[0] / fTemp115;
			let mut fTemp125: F32 = if (iTemp120 as i32 != 0) { if (iTemp122 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp113 } else { if (iTemp122 as i32 != 0) { fTemp113 + fTemp114 * if (((self.fRec30[0] > fTemp113) as i32) as i32 != 0) { F32::powf(fTemp124, 0.33333334) } else { fTemp124 } } else { self.fRec30[0] } } } else { if (iTemp120 as i32 != 0) { self.fRec30[0] + fTemp111 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp123, 0.33333334) } else { fTemp123 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp119) as i32) as i32 != 0) { self.fRec31[0] + fTemp117 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec32[0] } };
			let mut iTemp126: i32 = ((fTemp125) as i32);
			let mut fTemp127: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp126) as usize] };
			let mut fTemp128: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst16 };
			self.fRec34[0] = fTemp128 - F32::floor(fTemp128);
			let mut fTemp129: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec35[1] + fSlow14 * fTemp95 };
			self.fRec35[0] = fTemp129 - F32::floor(fTemp129);
			let mut fTemp130: F32 = unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec35[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec34[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp127 + (fTemp125 - ((iTemp126) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp126, 1)) as usize] } - fTemp127)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec27[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec26[0] + 17.391304 * (self.fRec20[0] + 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec18[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp68 + (fTemp66 - ((iTemp67) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp67, 1)) as usize] } - fTemp68))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp49 + (fTemp47 - ((iTemp48) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp48, 1)) as usize] } - fTemp49)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp32 + (fTemp30 - ((iTemp31) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp31, 1)) as usize] } - fTemp32));
			self.fVec4[0] = fTemp130;
			self.fRec0[0] = 0.115 * (self.fConst18 * fTemp130 + self.fConst19 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}

}

impl DSP_Tom4 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse3
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse3")]
	unsafe fn compute_x86_or_x86_64_using_sse3(&mut self, count: i32, inputs: &[&[<DSP_Tom4 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom4 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider1 + self.fHslider0;
		let mut fSlow2: F32 = 0.42857143 * (0.33333334 * (fSlow1 + 8.2) + 1.0);
		let mut fSlow3: F32 = self.fHslider2;
		let mut fSlow4: F32 = F32::min(99.0, 0.23232323 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow1 + -61.8))) + 8e+01);
		let mut fSlow5: F32 = F32::min(99.0, 0.34343433 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow1 + -52.8)))) + 85.0);
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow1 + -60.8));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst14 * fSlow6;
		let mut fSlow12: F32 = fSlow1 + -53.8;
		let mut fSlow13: F32 = F32::min(99.0, 0.5252525 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow12))) + 0.53535354 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow12))) + 88.0);
		let mut fSlow14: F32 = self.fConst17 * fSlow6;
		let mut fSlow15: F32 = 0.01 * self.fHslider3;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + -3.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider5 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp3 as i32 != 0) { fSlow2 } else { self.fRec3[1] };
			self.fRec5[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec5[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom4_faustpower2_f(1.0 - F32::max(fSlow3, self.fRec5[0]))) + -99.0;
			let mut fTemp5: F32 = 0.5714286 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec4[1] };
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fTemp7 + 3968.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = self.fRec6[0] - self.fRec4[0];
			let mut fTemp9: F32 = if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 };
			let mut fTemp10: F32 = F32::abs(fTemp8);
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (fTemp9 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 28.5) as i32)) as usize] }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec7[1] };
			let mut fTemp12: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp13: F32 = self.fRec4[0] - fTemp12;
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp13) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 88.5) as i32)) as usize] } * if (((fTemp13 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp12)) + 2.0) } else { 0.96 }))));
			let mut fTemp15: F32 = fTemp14 + fTemp11;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec6[0];
			let mut fTemp18: F32 = if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec6[0])) + 2.0) } else { 0.96 };
			let mut fTemp19: F32 = F32::abs(fTemp17);
			let mut fTemp20: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (fTemp18 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 47.5) as i32)) as usize] }))));
			let mut fTemp21: F32 = fTemp15 + fTemp20;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp21, self.fRec8[1] + 1.0) };
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut iTemp23: i32 = ((self.fRec7[0] > self.fRec6[0]) as i32);
			let mut fTemp24: F32 = (self.fRec8[0] - fTemp15) / fTemp20;
			let mut iTemp25: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut iTemp26: i32 = ((self.fRec6[0] > self.fRec4[0]) as i32);
			let mut fTemp27: F32 = (self.fRec8[0] - fTemp14) / fTemp11;
			let mut iTemp28: i32 = ((self.fRec4[0] > fTemp12) as i32);
			let mut fTemp29: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp30: F32 = if (iTemp22 as i32 != 0) { if (iTemp25 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp25 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp29, 0.33333334) } else { fTemp29 } } else { self.fRec4[0] } } } else { if (iTemp22 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp27, 0.33333334) } else { fTemp27 } } else { self.fRec6[0] } } } else { if (((self.fRec8[0] < fTemp21) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec7[0] } };
			let mut iTemp31: i32 = ((fTemp30) as i32);
			let mut fTemp32: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp31) as usize] };
			let mut fTemp33: F32 = F32::max(0.0, F32::min(127.0, fSlow4 + fTemp5));
			let mut fTemp34: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp33) * (fTemp33 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp34 + 3872.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp34 } else { self.fRec11[1] };
			let mut fTemp35: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp36: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] };
			let mut fTemp37: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (fTemp36 * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp38: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp39: F32 = self.fRec10[0] - fTemp38;
			let mut fTemp40: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp39) / (fTemp40 * if (((fTemp39 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp38)) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = fTemp41 + fTemp37;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp42, self.fRec13[1] + 1.0) };
			let mut iTemp43: i32 = ((self.fRec13[0] < fTemp42) as i32);
			let mut iTemp44: i32 = ((self.fRec13[0] < fTemp41) as i32);
			let mut fTemp45: F32 = (self.fRec13[0] - fTemp41) / fTemp37;
			let mut fTemp46: F32 = self.fRec13[0] / fTemp41;
			let mut fTemp47: F32 = if (iTemp43 as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp38 } else { if (iTemp44 as i32 != 0) { fTemp38 + fTemp39 * if (((self.fRec10[0] > fTemp38) as i32) as i32 != 0) { F32::powf(fTemp46, 0.33333334) } else { fTemp46 } } else { self.fRec10[0] } } } else { if (iTemp43 as i32 != 0) { self.fRec10[0] + fTemp35 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp48: i32 = ((fTemp47) as i32);
			let mut fTemp49: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp48) as usize] };
			let mut fTemp50: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp51: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp50) * (fTemp50 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp51 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp51 + 2688.0 } else { self.fRec15[1] };
			let mut fTemp52: F32 = self.fRec15[0] - self.fRec14[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 75.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp51 } else { self.fRec16[1] };
			let mut fTemp54: F32 = F32::max(5076.0, self.fRec16[0]);
			let mut fTemp55: F32 = self.fRec14[0] - fTemp54;
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (fTemp40 * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp54)) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = fTemp56 + fTemp53;
			let mut fTemp58: F32 = self.fRec16[0] - self.fRec15[0];
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 59.5) as i32)) as usize] } * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp57 + fTemp59;
			self.fRec17[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp60, self.fRec17[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec17[0] < fTemp57) as i32);
			let mut fTemp62: F32 = (self.fRec17[0] - fTemp57) / fTemp59;
			let mut iTemp63: i32 = ((self.fRec17[0] < fTemp56) as i32);
			let mut fTemp64: F32 = (self.fRec17[0] - fTemp56) / fTemp53;
			let mut fTemp65: F32 = self.fRec17[0] / fTemp56;
			let mut fTemp66: F32 = if (iTemp61 as i32 != 0) { if (iTemp63 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp54 } else { if (iTemp63 as i32 != 0) { fTemp54 + fTemp55 * if (((self.fRec14[0] > fTemp54) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec14[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec14[0] + fTemp52 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec15[0] } } } else { if (((self.fRec17[0] < fTemp60) as i32) as i32 != 0) { self.fRec15[0] + fTemp58 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec16[0] } };
			let mut iTemp67: i32 = ((fTemp66) as i32);
			let mut fTemp68: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp67) as usize] };
			let mut iTemp69: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp70: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst7 };
			self.fRec18[0] = fTemp70 - F32::floor(fTemp70);
			let mut fTemp71: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 96.0));
			let mut fTemp72: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp71) * (fTemp71 + 28.0);
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp72 + 4064.0 } else { self.fRec21[1] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp72 + 3136.0 } else { self.fRec22[1] };
			let mut fTemp73: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp74: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp73) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 79.5) as i32)) as usize] } * if (((fTemp73 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp72 } else { self.fRec23[1] };
			let mut fTemp75: F32 = F32::max(5076.0, self.fRec23[0]);
			let mut fTemp76: F32 = self.fRec21[0] - fTemp75;
			let mut fTemp77: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp76) / (fTemp40 * if (((fTemp76 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp75)) + 2.0) } else { 0.96 }))));
			let mut fTemp78: F32 = fTemp77 + fTemp74;
			let mut fTemp79: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp80: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp79) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp79 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp81: F32 = fTemp78 + fTemp80;
			self.fRec24[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp81, self.fRec24[1] + 1.0) };
			let mut iTemp82: i32 = ((self.fRec24[0] < fTemp78) as i32);
			let mut fTemp83: F32 = (self.fRec24[0] - fTemp78) / fTemp80;
			let mut iTemp84: i32 = ((self.fRec24[0] < fTemp77) as i32);
			let mut fTemp85: F32 = (self.fRec24[0] - fTemp77) / fTemp74;
			let mut fTemp86: F32 = self.fRec24[0] / fTemp77;
			let mut fTemp87: F32 = if (iTemp82 as i32 != 0) { if (iTemp84 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp75 } else { if (iTemp84 as i32 != 0) { fTemp75 + fTemp76 * if (((self.fRec21[0] > fTemp75) as i32) as i32 != 0) { F32::powf(fTemp86, 0.33333334) } else { fTemp86 } } else { self.fRec21[0] } } } else { if (iTemp82 as i32 != 0) { self.fRec21[0] + fTemp73 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { self.fRec22[0] } } } else { if (((self.fRec24[0] < fTemp81) as i32) as i32 != 0) { self.fRec22[0] + fTemp79 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { self.fRec23[0] } };
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp88) as usize] };
			let mut fTemp90: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst10 };
			self.fRec25[0] = fTemp90 - F32::floor(fTemp90);
			self.fRec20[0] = 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec25[0] + 13.913043 * self.fRec20[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89));
			let mut fTemp91: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst12 };
			self.fRec26[0] = fTemp91 - F32::floor(fTemp91);
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec28[1] };
			let mut fTemp92: F32 = 15.996094 * (0.4 * ((self.iRec28[0]) as F32) + 128.0);
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iTemp93) as usize] };
			let mut fTemp95: F32 = fSlow10 * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow11 * fTemp95 };
			self.fRec27[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 41.5) as i32)) as usize] } * fTemp9))));
			let mut fTemp98: F32 = fTemp14 + fTemp97;
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 45.5) as i32)) as usize] } * fTemp18))));
			let mut fTemp100: F32 = fTemp98 + fTemp99;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp100, self.fRec29[1] + 1.0) };
			let mut iTemp101: i32 = ((self.fRec29[0] < fTemp98) as i32);
			let mut fTemp102: F32 = (self.fRec29[0] - fTemp98) / fTemp99;
			let mut iTemp103: i32 = ((self.fRec29[0] < fTemp14) as i32);
			let mut fTemp104: F32 = (self.fRec29[0] - fTemp14) / fTemp97;
			let mut fTemp105: F32 = self.fRec29[0] / fTemp14;
			let mut fTemp106: F32 = if (iTemp101 as i32 != 0) { if (iTemp103 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp103 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec4[0] } } } else { if (iTemp101 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp104, 0.33333334) } else { fTemp104 } } else { self.fRec6[0] } } } else { if (((self.fRec29[0] < fTemp100) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp102, 0.33333334) } else { fTemp102 } } else { self.fRec7[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp107) as usize] };
			let mut fTemp109: F32 = F32::max(0.0, F32::min(127.0, fSlow13 + fTemp5));
			let mut fTemp110: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp109) * (fTemp109 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3872.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3232.0 } else { self.fRec31[1] };
			let mut fTemp111: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp112: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp111) / (fTemp36 * if (((fTemp111 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp110 } else { self.fRec32[1] };
			let mut fTemp113: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp114: F32 = self.fRec30[0] - fTemp113;
			let mut fTemp115: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp114) / (fTemp40 * if (((fTemp114 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp113)) + 2.0) } else { 0.96 }))));
			let mut fTemp116: F32 = fTemp115 + fTemp112;
			let mut fTemp117: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp118: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp117) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 54.5) as i32)) as usize] } * if (((fTemp117 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp119: F32 = fTemp116 + fTemp118;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp119, self.fRec33[1] + 1.0) };
			let mut iTemp120: i32 = ((self.fRec33[0] < fTemp116) as i32);
			let mut fTemp121: F32 = (self.fRec33[0] - fTemp116) / fTemp118;
			let mut iTemp122: i32 = ((self.fRec33[0] < fTemp115) as i32);
			let mut fTemp123: F32 = (self.fRec33[0] - fTemp115) / fTemp112;
			let mut fTemp124: F32 = self.fRec33[0] / fTemp115;
			let mut fTemp125: F32 = if (iTemp120 as i32 != 0) { if (iTemp122 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp113 } else { if (iTemp122 as i32 != 0) { fTemp113 + fTemp114 * if (((self.fRec30[0] > fTemp113) as i32) as i32 != 0) { F32::powf(fTemp124, 0.33333334) } else { fTemp124 } } else { self.fRec30[0] } } } else { if (iTemp120 as i32 != 0) { self.fRec30[0] + fTemp111 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp123, 0.33333334) } else { fTemp123 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp119) as i32) as i32 != 0) { self.fRec31[0] + fTemp117 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec32[0] } };
			let mut iTemp126: i32 = ((fTemp125) as i32);
			let mut fTemp127: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp126) as usize] };
			let mut fTemp128: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst16 };
			self.fRec34[0] = fTemp128 - F32::floor(fTemp128);
			let mut fTemp129: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec35[1] + fSlow14 * fTemp95 };
			self.fRec35[0] = fTemp129 - F32::floor(fTemp129);
			let mut fTemp130: F32 = unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec35[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec34[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp127 + (fTemp125 - ((iTemp126) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp126, 1)) as usize] } - fTemp127)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec27[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec26[0] + 17.391304 * (self.fRec20[0] + 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec18[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp68 + (fTemp66 - ((iTemp67) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp67, 1)) as usize] } - fTemp68))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp49 + (fTemp47 - ((iTemp48) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp48, 1)) as usize] } - fTemp49)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp32 + (fTemp30 - ((iTemp31) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp31, 1)) as usize] } - fTemp32));
			self.fVec4[0] = fTemp130;
			self.fRec0[0] = 0.115 * (self.fConst18 * fTemp130 + self.fConst19 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom4 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using sse4.1
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "sse4.1")]
	unsafe fn compute_x86_or_x86_64_using_sse4_1(&mut self, count: i32, inputs: &[&[<DSP_Tom4 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom4 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider1 + self.fHslider0;
		let mut fSlow2: F32 = 0.42857143 * (0.33333334 * (fSlow1 + 8.2) + 1.0);
		let mut fSlow3: F32 = self.fHslider2;
		let mut fSlow4: F32 = F32::min(99.0, 0.23232323 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow1 + -61.8))) + 8e+01);
		let mut fSlow5: F32 = F32::min(99.0, 0.34343433 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow1 + -52.8)))) + 85.0);
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow1 + -60.8));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst14 * fSlow6;
		let mut fSlow12: F32 = fSlow1 + -53.8;
		let mut fSlow13: F32 = F32::min(99.0, 0.5252525 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow12))) + 0.53535354 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow12))) + 88.0);
		let mut fSlow14: F32 = self.fConst17 * fSlow6;
		let mut fSlow15: F32 = 0.01 * self.fHslider3;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + -3.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider5 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp3 as i32 != 0) { fSlow2 } else { self.fRec3[1] };
			self.fRec5[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec5[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom4_faustpower2_f(1.0 - F32::max(fSlow3, self.fRec5[0]))) + -99.0;
			let mut fTemp5: F32 = 0.5714286 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec4[1] };
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fTemp7 + 3968.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = self.fRec6[0] - self.fRec4[0];
			let mut fTemp9: F32 = if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 };
			let mut fTemp10: F32 = F32::abs(fTemp8);
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (fTemp9 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 28.5) as i32)) as usize] }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec7[1] };
			let mut fTemp12: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp13: F32 = self.fRec4[0] - fTemp12;
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp13) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 88.5) as i32)) as usize] } * if (((fTemp13 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp12)) + 2.0) } else { 0.96 }))));
			let mut fTemp15: F32 = fTemp14 + fTemp11;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec6[0];
			let mut fTemp18: F32 = if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec6[0])) + 2.0) } else { 0.96 };
			let mut fTemp19: F32 = F32::abs(fTemp17);
			let mut fTemp20: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (fTemp18 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 47.5) as i32)) as usize] }))));
			let mut fTemp21: F32 = fTemp15 + fTemp20;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp21, self.fRec8[1] + 1.0) };
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut iTemp23: i32 = ((self.fRec7[0] > self.fRec6[0]) as i32);
			let mut fTemp24: F32 = (self.fRec8[0] - fTemp15) / fTemp20;
			let mut iTemp25: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut iTemp26: i32 = ((self.fRec6[0] > self.fRec4[0]) as i32);
			let mut fTemp27: F32 = (self.fRec8[0] - fTemp14) / fTemp11;
			let mut iTemp28: i32 = ((self.fRec4[0] > fTemp12) as i32);
			let mut fTemp29: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp30: F32 = if (iTemp22 as i32 != 0) { if (iTemp25 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp25 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp29, 0.33333334) } else { fTemp29 } } else { self.fRec4[0] } } } else { if (iTemp22 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp27, 0.33333334) } else { fTemp27 } } else { self.fRec6[0] } } } else { if (((self.fRec8[0] < fTemp21) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec7[0] } };
			let mut iTemp31: i32 = ((fTemp30) as i32);
			let mut fTemp32: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp31) as usize] };
			let mut fTemp33: F32 = F32::max(0.0, F32::min(127.0, fSlow4 + fTemp5));
			let mut fTemp34: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp33) * (fTemp33 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp34 + 3872.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp34 } else { self.fRec11[1] };
			let mut fTemp35: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp36: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] };
			let mut fTemp37: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (fTemp36 * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp38: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp39: F32 = self.fRec10[0] - fTemp38;
			let mut fTemp40: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp39) / (fTemp40 * if (((fTemp39 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp38)) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = fTemp41 + fTemp37;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp42, self.fRec13[1] + 1.0) };
			let mut iTemp43: i32 = ((self.fRec13[0] < fTemp42) as i32);
			let mut iTemp44: i32 = ((self.fRec13[0] < fTemp41) as i32);
			let mut fTemp45: F32 = (self.fRec13[0] - fTemp41) / fTemp37;
			let mut fTemp46: F32 = self.fRec13[0] / fTemp41;
			let mut fTemp47: F32 = if (iTemp43 as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp38 } else { if (iTemp44 as i32 != 0) { fTemp38 + fTemp39 * if (((self.fRec10[0] > fTemp38) as i32) as i32 != 0) { F32::powf(fTemp46, 0.33333334) } else { fTemp46 } } else { self.fRec10[0] } } } else { if (iTemp43 as i32 != 0) { self.fRec10[0] + fTemp35 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp48: i32 = ((fTemp47) as i32);
			let mut fTemp49: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp48) as usize] };
			let mut fTemp50: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp51: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp50) * (fTemp50 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp51 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp51 + 2688.0 } else { self.fRec15[1] };
			let mut fTemp52: F32 = self.fRec15[0] - self.fRec14[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 75.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp51 } else { self.fRec16[1] };
			let mut fTemp54: F32 = F32::max(5076.0, self.fRec16[0]);
			let mut fTemp55: F32 = self.fRec14[0] - fTemp54;
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (fTemp40 * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp54)) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = fTemp56 + fTemp53;
			let mut fTemp58: F32 = self.fRec16[0] - self.fRec15[0];
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 59.5) as i32)) as usize] } * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp57 + fTemp59;
			self.fRec17[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp60, self.fRec17[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec17[0] < fTemp57) as i32);
			let mut fTemp62: F32 = (self.fRec17[0] - fTemp57) / fTemp59;
			let mut iTemp63: i32 = ((self.fRec17[0] < fTemp56) as i32);
			let mut fTemp64: F32 = (self.fRec17[0] - fTemp56) / fTemp53;
			let mut fTemp65: F32 = self.fRec17[0] / fTemp56;
			let mut fTemp66: F32 = if (iTemp61 as i32 != 0) { if (iTemp63 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp54 } else { if (iTemp63 as i32 != 0) { fTemp54 + fTemp55 * if (((self.fRec14[0] > fTemp54) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec14[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec14[0] + fTemp52 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec15[0] } } } else { if (((self.fRec17[0] < fTemp60) as i32) as i32 != 0) { self.fRec15[0] + fTemp58 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec16[0] } };
			let mut iTemp67: i32 = ((fTemp66) as i32);
			let mut fTemp68: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp67) as usize] };
			let mut iTemp69: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp70: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst7 };
			self.fRec18[0] = fTemp70 - F32::floor(fTemp70);
			let mut fTemp71: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 96.0));
			let mut fTemp72: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp71) * (fTemp71 + 28.0);
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp72 + 4064.0 } else { self.fRec21[1] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp72 + 3136.0 } else { self.fRec22[1] };
			let mut fTemp73: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp74: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp73) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 79.5) as i32)) as usize] } * if (((fTemp73 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp72 } else { self.fRec23[1] };
			let mut fTemp75: F32 = F32::max(5076.0, self.fRec23[0]);
			let mut fTemp76: F32 = self.fRec21[0] - fTemp75;
			let mut fTemp77: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp76) / (fTemp40 * if (((fTemp76 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp75)) + 2.0) } else { 0.96 }))));
			let mut fTemp78: F32 = fTemp77 + fTemp74;
			let mut fTemp79: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp80: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp79) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp79 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp81: F32 = fTemp78 + fTemp80;
			self.fRec24[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp81, self.fRec24[1] + 1.0) };
			let mut iTemp82: i32 = ((self.fRec24[0] < fTemp78) as i32);
			let mut fTemp83: F32 = (self.fRec24[0] - fTemp78) / fTemp80;
			let mut iTemp84: i32 = ((self.fRec24[0] < fTemp77) as i32);
			let mut fTemp85: F32 = (self.fRec24[0] - fTemp77) / fTemp74;
			let mut fTemp86: F32 = self.fRec24[0] / fTemp77;
			let mut fTemp87: F32 = if (iTemp82 as i32 != 0) { if (iTemp84 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp75 } else { if (iTemp84 as i32 != 0) { fTemp75 + fTemp76 * if (((self.fRec21[0] > fTemp75) as i32) as i32 != 0) { F32::powf(fTemp86, 0.33333334) } else { fTemp86 } } else { self.fRec21[0] } } } else { if (iTemp82 as i32 != 0) { self.fRec21[0] + fTemp73 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { self.fRec22[0] } } } else { if (((self.fRec24[0] < fTemp81) as i32) as i32 != 0) { self.fRec22[0] + fTemp79 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { self.fRec23[0] } };
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp88) as usize] };
			let mut fTemp90: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst10 };
			self.fRec25[0] = fTemp90 - F32::floor(fTemp90);
			self.fRec20[0] = 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec25[0] + 13.913043 * self.fRec20[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89));
			let mut fTemp91: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst12 };
			self.fRec26[0] = fTemp91 - F32::floor(fTemp91);
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec28[1] };
			let mut fTemp92: F32 = 15.996094 * (0.4 * ((self.iRec28[0]) as F32) + 128.0);
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iTemp93) as usize] };
			let mut fTemp95: F32 = fSlow10 * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow11 * fTemp95 };
			self.fRec27[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 41.5) as i32)) as usize] } * fTemp9))));
			let mut fTemp98: F32 = fTemp14 + fTemp97;
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 45.5) as i32)) as usize] } * fTemp18))));
			let mut fTemp100: F32 = fTemp98 + fTemp99;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp100, self.fRec29[1] + 1.0) };
			let mut iTemp101: i32 = ((self.fRec29[0] < fTemp98) as i32);
			let mut fTemp102: F32 = (self.fRec29[0] - fTemp98) / fTemp99;
			let mut iTemp103: i32 = ((self.fRec29[0] < fTemp14) as i32);
			let mut fTemp104: F32 = (self.fRec29[0] - fTemp14) / fTemp97;
			let mut fTemp105: F32 = self.fRec29[0] / fTemp14;
			let mut fTemp106: F32 = if (iTemp101 as i32 != 0) { if (iTemp103 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp103 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec4[0] } } } else { if (iTemp101 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp104, 0.33333334) } else { fTemp104 } } else { self.fRec6[0] } } } else { if (((self.fRec29[0] < fTemp100) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp102, 0.33333334) } else { fTemp102 } } else { self.fRec7[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp107) as usize] };
			let mut fTemp109: F32 = F32::max(0.0, F32::min(127.0, fSlow13 + fTemp5));
			let mut fTemp110: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp109) * (fTemp109 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3872.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3232.0 } else { self.fRec31[1] };
			let mut fTemp111: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp112: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp111) / (fTemp36 * if (((fTemp111 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp110 } else { self.fRec32[1] };
			let mut fTemp113: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp114: F32 = self.fRec30[0] - fTemp113;
			let mut fTemp115: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp114) / (fTemp40 * if (((fTemp114 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp113)) + 2.0) } else { 0.96 }))));
			let mut fTemp116: F32 = fTemp115 + fTemp112;
			let mut fTemp117: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp118: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp117) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 54.5) as i32)) as usize] } * if (((fTemp117 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp119: F32 = fTemp116 + fTemp118;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp119, self.fRec33[1] + 1.0) };
			let mut iTemp120: i32 = ((self.fRec33[0] < fTemp116) as i32);
			let mut fTemp121: F32 = (self.fRec33[0] - fTemp116) / fTemp118;
			let mut iTemp122: i32 = ((self.fRec33[0] < fTemp115) as i32);
			let mut fTemp123: F32 = (self.fRec33[0] - fTemp115) / fTemp112;
			let mut fTemp124: F32 = self.fRec33[0] / fTemp115;
			let mut fTemp125: F32 = if (iTemp120 as i32 != 0) { if (iTemp122 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp113 } else { if (iTemp122 as i32 != 0) { fTemp113 + fTemp114 * if (((self.fRec30[0] > fTemp113) as i32) as i32 != 0) { F32::powf(fTemp124, 0.33333334) } else { fTemp124 } } else { self.fRec30[0] } } } else { if (iTemp120 as i32 != 0) { self.fRec30[0] + fTemp111 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp123, 0.33333334) } else { fTemp123 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp119) as i32) as i32 != 0) { self.fRec31[0] + fTemp117 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec32[0] } };
			let mut iTemp126: i32 = ((fTemp125) as i32);
			let mut fTemp127: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp126) as usize] };
			let mut fTemp128: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst16 };
			self.fRec34[0] = fTemp128 - F32::floor(fTemp128);
			let mut fTemp129: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec35[1] + fSlow14 * fTemp95 };
			self.fRec35[0] = fTemp129 - F32::floor(fTemp129);
			let mut fTemp130: F32 = unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec35[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec34[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp127 + (fTemp125 - ((iTemp126) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp126, 1)) as usize] } - fTemp127)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec27[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec26[0] + 17.391304 * (self.fRec20[0] + 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec18[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp68 + (fTemp66 - ((iTemp67) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp67, 1)) as usize] } - fTemp68))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp49 + (fTemp47 - ((iTemp48) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp48, 1)) as usize] } - fTemp49)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp32 + (fTemp30 - ((iTemp31) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp31, 1)) as usize] } - fTemp32));
			self.fVec4[0] = fTemp130;
			self.fRec0[0] = 0.115 * (self.fConst18 * fTemp130 + self.fConst19 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom4 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx")]
	unsafe fn compute_x86_or_x86_64_using_avx(&mut self, count: i32, inputs: &[&[<DSP_Tom4 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom4 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider1 + self.fHslider0;
		let mut fSlow2: F32 = 0.42857143 * (0.33333334 * (fSlow1 + 8.2) + 1.0);
		let mut fSlow3: F32 = self.fHslider2;
		let mut fSlow4: F32 = F32::min(99.0, 0.23232323 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow1 + -61.8))) + 8e+01);
		let mut fSlow5: F32 = F32::min(99.0, 0.34343433 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow1 + -52.8)))) + 85.0);
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow1 + -60.8));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst14 * fSlow6;
		let mut fSlow12: F32 = fSlow1 + -53.8;
		let mut fSlow13: F32 = F32::min(99.0, 0.5252525 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow12))) + 0.53535354 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow12))) + 88.0);
		let mut fSlow14: F32 = self.fConst17 * fSlow6;
		let mut fSlow15: F32 = 0.01 * self.fHslider3;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + -3.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider5 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp3 as i32 != 0) { fSlow2 } else { self.fRec3[1] };
			self.fRec5[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec5[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom4_faustpower2_f(1.0 - F32::max(fSlow3, self.fRec5[0]))) + -99.0;
			let mut fTemp5: F32 = 0.5714286 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec4[1] };
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fTemp7 + 3968.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = self.fRec6[0] - self.fRec4[0];
			let mut fTemp9: F32 = if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 };
			let mut fTemp10: F32 = F32::abs(fTemp8);
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (fTemp9 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 28.5) as i32)) as usize] }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec7[1] };
			let mut fTemp12: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp13: F32 = self.fRec4[0] - fTemp12;
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp13) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 88.5) as i32)) as usize] } * if (((fTemp13 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp12)) + 2.0) } else { 0.96 }))));
			let mut fTemp15: F32 = fTemp14 + fTemp11;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec6[0];
			let mut fTemp18: F32 = if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec6[0])) + 2.0) } else { 0.96 };
			let mut fTemp19: F32 = F32::abs(fTemp17);
			let mut fTemp20: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (fTemp18 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 47.5) as i32)) as usize] }))));
			let mut fTemp21: F32 = fTemp15 + fTemp20;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp21, self.fRec8[1] + 1.0) };
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut iTemp23: i32 = ((self.fRec7[0] > self.fRec6[0]) as i32);
			let mut fTemp24: F32 = (self.fRec8[0] - fTemp15) / fTemp20;
			let mut iTemp25: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut iTemp26: i32 = ((self.fRec6[0] > self.fRec4[0]) as i32);
			let mut fTemp27: F32 = (self.fRec8[0] - fTemp14) / fTemp11;
			let mut iTemp28: i32 = ((self.fRec4[0] > fTemp12) as i32);
			let mut fTemp29: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp30: F32 = if (iTemp22 as i32 != 0) { if (iTemp25 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp25 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp29, 0.33333334) } else { fTemp29 } } else { self.fRec4[0] } } } else { if (iTemp22 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp27, 0.33333334) } else { fTemp27 } } else { self.fRec6[0] } } } else { if (((self.fRec8[0] < fTemp21) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec7[0] } };
			let mut iTemp31: i32 = ((fTemp30) as i32);
			let mut fTemp32: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp31) as usize] };
			let mut fTemp33: F32 = F32::max(0.0, F32::min(127.0, fSlow4 + fTemp5));
			let mut fTemp34: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp33) * (fTemp33 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp34 + 3872.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp34 } else { self.fRec11[1] };
			let mut fTemp35: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp36: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] };
			let mut fTemp37: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (fTemp36 * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp38: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp39: F32 = self.fRec10[0] - fTemp38;
			let mut fTemp40: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp39) / (fTemp40 * if (((fTemp39 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp38)) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = fTemp41 + fTemp37;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp42, self.fRec13[1] + 1.0) };
			let mut iTemp43: i32 = ((self.fRec13[0] < fTemp42) as i32);
			let mut iTemp44: i32 = ((self.fRec13[0] < fTemp41) as i32);
			let mut fTemp45: F32 = (self.fRec13[0] - fTemp41) / fTemp37;
			let mut fTemp46: F32 = self.fRec13[0] / fTemp41;
			let mut fTemp47: F32 = if (iTemp43 as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp38 } else { if (iTemp44 as i32 != 0) { fTemp38 + fTemp39 * if (((self.fRec10[0] > fTemp38) as i32) as i32 != 0) { F32::powf(fTemp46, 0.33333334) } else { fTemp46 } } else { self.fRec10[0] } } } else { if (iTemp43 as i32 != 0) { self.fRec10[0] + fTemp35 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp48: i32 = ((fTemp47) as i32);
			let mut fTemp49: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp48) as usize] };
			let mut fTemp50: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp51: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp50) * (fTemp50 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp51 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp51 + 2688.0 } else { self.fRec15[1] };
			let mut fTemp52: F32 = self.fRec15[0] - self.fRec14[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 75.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp51 } else { self.fRec16[1] };
			let mut fTemp54: F32 = F32::max(5076.0, self.fRec16[0]);
			let mut fTemp55: F32 = self.fRec14[0] - fTemp54;
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (fTemp40 * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp54)) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = fTemp56 + fTemp53;
			let mut fTemp58: F32 = self.fRec16[0] - self.fRec15[0];
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 59.5) as i32)) as usize] } * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp57 + fTemp59;
			self.fRec17[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp60, self.fRec17[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec17[0] < fTemp57) as i32);
			let mut fTemp62: F32 = (self.fRec17[0] - fTemp57) / fTemp59;
			let mut iTemp63: i32 = ((self.fRec17[0] < fTemp56) as i32);
			let mut fTemp64: F32 = (self.fRec17[0] - fTemp56) / fTemp53;
			let mut fTemp65: F32 = self.fRec17[0] / fTemp56;
			let mut fTemp66: F32 = if (iTemp61 as i32 != 0) { if (iTemp63 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp54 } else { if (iTemp63 as i32 != 0) { fTemp54 + fTemp55 * if (((self.fRec14[0] > fTemp54) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec14[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec14[0] + fTemp52 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec15[0] } } } else { if (((self.fRec17[0] < fTemp60) as i32) as i32 != 0) { self.fRec15[0] + fTemp58 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec16[0] } };
			let mut iTemp67: i32 = ((fTemp66) as i32);
			let mut fTemp68: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp67) as usize] };
			let mut iTemp69: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp70: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst7 };
			self.fRec18[0] = fTemp70 - F32::floor(fTemp70);
			let mut fTemp71: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 96.0));
			let mut fTemp72: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp71) * (fTemp71 + 28.0);
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp72 + 4064.0 } else { self.fRec21[1] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp72 + 3136.0 } else { self.fRec22[1] };
			let mut fTemp73: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp74: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp73) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 79.5) as i32)) as usize] } * if (((fTemp73 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp72 } else { self.fRec23[1] };
			let mut fTemp75: F32 = F32::max(5076.0, self.fRec23[0]);
			let mut fTemp76: F32 = self.fRec21[0] - fTemp75;
			let mut fTemp77: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp76) / (fTemp40 * if (((fTemp76 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp75)) + 2.0) } else { 0.96 }))));
			let mut fTemp78: F32 = fTemp77 + fTemp74;
			let mut fTemp79: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp80: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp79) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp79 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp81: F32 = fTemp78 + fTemp80;
			self.fRec24[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp81, self.fRec24[1] + 1.0) };
			let mut iTemp82: i32 = ((self.fRec24[0] < fTemp78) as i32);
			let mut fTemp83: F32 = (self.fRec24[0] - fTemp78) / fTemp80;
			let mut iTemp84: i32 = ((self.fRec24[0] < fTemp77) as i32);
			let mut fTemp85: F32 = (self.fRec24[0] - fTemp77) / fTemp74;
			let mut fTemp86: F32 = self.fRec24[0] / fTemp77;
			let mut fTemp87: F32 = if (iTemp82 as i32 != 0) { if (iTemp84 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp75 } else { if (iTemp84 as i32 != 0) { fTemp75 + fTemp76 * if (((self.fRec21[0] > fTemp75) as i32) as i32 != 0) { F32::powf(fTemp86, 0.33333334) } else { fTemp86 } } else { self.fRec21[0] } } } else { if (iTemp82 as i32 != 0) { self.fRec21[0] + fTemp73 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { self.fRec22[0] } } } else { if (((self.fRec24[0] < fTemp81) as i32) as i32 != 0) { self.fRec22[0] + fTemp79 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { self.fRec23[0] } };
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp88) as usize] };
			let mut fTemp90: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst10 };
			self.fRec25[0] = fTemp90 - F32::floor(fTemp90);
			self.fRec20[0] = 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec25[0] + 13.913043 * self.fRec20[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89));
			let mut fTemp91: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst12 };
			self.fRec26[0] = fTemp91 - F32::floor(fTemp91);
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec28[1] };
			let mut fTemp92: F32 = 15.996094 * (0.4 * ((self.iRec28[0]) as F32) + 128.0);
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iTemp93) as usize] };
			let mut fTemp95: F32 = fSlow10 * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow11 * fTemp95 };
			self.fRec27[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 41.5) as i32)) as usize] } * fTemp9))));
			let mut fTemp98: F32 = fTemp14 + fTemp97;
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 45.5) as i32)) as usize] } * fTemp18))));
			let mut fTemp100: F32 = fTemp98 + fTemp99;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp100, self.fRec29[1] + 1.0) };
			let mut iTemp101: i32 = ((self.fRec29[0] < fTemp98) as i32);
			let mut fTemp102: F32 = (self.fRec29[0] - fTemp98) / fTemp99;
			let mut iTemp103: i32 = ((self.fRec29[0] < fTemp14) as i32);
			let mut fTemp104: F32 = (self.fRec29[0] - fTemp14) / fTemp97;
			let mut fTemp105: F32 = self.fRec29[0] / fTemp14;
			let mut fTemp106: F32 = if (iTemp101 as i32 != 0) { if (iTemp103 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp103 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec4[0] } } } else { if (iTemp101 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp104, 0.33333334) } else { fTemp104 } } else { self.fRec6[0] } } } else { if (((self.fRec29[0] < fTemp100) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp102, 0.33333334) } else { fTemp102 } } else { self.fRec7[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp107) as usize] };
			let mut fTemp109: F32 = F32::max(0.0, F32::min(127.0, fSlow13 + fTemp5));
			let mut fTemp110: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp109) * (fTemp109 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3872.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3232.0 } else { self.fRec31[1] };
			let mut fTemp111: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp112: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp111) / (fTemp36 * if (((fTemp111 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp110 } else { self.fRec32[1] };
			let mut fTemp113: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp114: F32 = self.fRec30[0] - fTemp113;
			let mut fTemp115: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp114) / (fTemp40 * if (((fTemp114 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp113)) + 2.0) } else { 0.96 }))));
			let mut fTemp116: F32 = fTemp115 + fTemp112;
			let mut fTemp117: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp118: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp117) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 54.5) as i32)) as usize] } * if (((fTemp117 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp119: F32 = fTemp116 + fTemp118;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp119, self.fRec33[1] + 1.0) };
			let mut iTemp120: i32 = ((self.fRec33[0] < fTemp116) as i32);
			let mut fTemp121: F32 = (self.fRec33[0] - fTemp116) / fTemp118;
			let mut iTemp122: i32 = ((self.fRec33[0] < fTemp115) as i32);
			let mut fTemp123: F32 = (self.fRec33[0] - fTemp115) / fTemp112;
			let mut fTemp124: F32 = self.fRec33[0] / fTemp115;
			let mut fTemp125: F32 = if (iTemp120 as i32 != 0) { if (iTemp122 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp113 } else { if (iTemp122 as i32 != 0) { fTemp113 + fTemp114 * if (((self.fRec30[0] > fTemp113) as i32) as i32 != 0) { F32::powf(fTemp124, 0.33333334) } else { fTemp124 } } else { self.fRec30[0] } } } else { if (iTemp120 as i32 != 0) { self.fRec30[0] + fTemp111 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp123, 0.33333334) } else { fTemp123 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp119) as i32) as i32 != 0) { self.fRec31[0] + fTemp117 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec32[0] } };
			let mut iTemp126: i32 = ((fTemp125) as i32);
			let mut fTemp127: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp126) as usize] };
			let mut fTemp128: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst16 };
			self.fRec34[0] = fTemp128 - F32::floor(fTemp128);
			let mut fTemp129: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec35[1] + fSlow14 * fTemp95 };
			self.fRec35[0] = fTemp129 - F32::floor(fTemp129);
			let mut fTemp130: F32 = unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec35[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec34[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp127 + (fTemp125 - ((iTemp126) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp126, 1)) as usize] } - fTemp127)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec27[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec26[0] + 17.391304 * (self.fRec20[0] + 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec18[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp68 + (fTemp66 - ((iTemp67) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp67, 1)) as usize] } - fTemp68))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp49 + (fTemp47 - ((iTemp48) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp48, 1)) as usize] } - fTemp49)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp32 + (fTemp30 - ((iTemp31) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp31, 1)) as usize] } - fTemp32));
			self.fVec4[0] = fTemp130;
			self.fRec0[0] = 0.115 * (self.fConst18 * fTemp130 + self.fConst19 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
impl DSP_Tom4 {
    /*
       This function was copied from above and
       tweaked to enable auto-vectorization using avx2
    */
    #[cfg(any(target_arch = "x86", target_arch = "x86_64"))]
    #[target_feature(enable = "avx2")]
	unsafe fn compute_x86_or_x86_64_using_avx2(&mut self, count: i32, inputs: &[&[<DSP_Tom4 as FaustDsp>::T]], outputs: &mut[&mut[<DSP_Tom4 as FaustDsp>::T]]) {
		let (outputs0, outputs1, outputs2) = if let [outputs0, outputs1, outputs2, ..] = outputs {
			let outputs0 = outputs0[..count as usize].iter_mut();
			let outputs1 = outputs1[..count as usize].iter_mut();
			let outputs2 = outputs2[..count as usize].iter_mut();
			(outputs0, outputs1, outputs2)
		} else {
			panic!("wrong number of outputs");
		};
		let mut fSlow0: F32 = self.fEntry0;
		let mut fSlow1: F32 = self.fHslider1 + self.fHslider0;
		let mut fSlow2: F32 = 0.42857143 * (0.33333334 * (fSlow1 + 8.2) + 1.0);
		let mut fSlow3: F32 = self.fHslider2;
		let mut fSlow4: F32 = F32::min(99.0, 0.23232323 * (0.0 - 2.0 * F32::max(0.0, F32::abs(fSlow1 + -61.8))) + 8e+01);
		let mut fSlow5: F32 = F32::min(99.0, 0.34343433 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * (fSlow1 + -52.8)))) + 85.0);
		let mut fSlow6: F32 = F32::powf(2.0, 0.083333336 * (fSlow1 + -60.8));
		let mut fSlow7: F32 = 15.996094 * (0.1 * (1.0 - 0.008333334 * (17.31234 * F32::log(fSlow6, std::f32::consts::E) + 48.0)) + 128.0);
		let mut iSlow8: i32 = ((fSlow7) as i32);
		let mut fSlow9: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iSlow8) as usize] };
		let mut fSlow10: F32 = fSlow9 + (fSlow7 - ((iSlow8) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iSlow8, 1)) as usize] } - fSlow9);
		let mut fSlow11: F32 = self.fConst14 * fSlow6;
		let mut fSlow12: F32 = fSlow1 + -53.8;
		let mut fSlow13: F32 = F32::min(99.0, 0.5252525 * (0.0 - 2.0 * F32::max(0.0, F32::abs(-1.0 * fSlow12))) + 0.53535354 * (0.0 - 0.666 * F32::max(0.0, F32::abs(fSlow12))) + 88.0);
		let mut fSlow14: F32 = self.fConst17 * fSlow6;
		let mut fSlow15: F32 = 0.01 * self.fHslider3;
		let mut fSlow16: F32 = F32::powf(1e+01, 0.05 * F32::max(-1e+02, self.fHslider4 + -3.0));
		let mut fSlow17: F32 = fSlow16 * F32::min(1.0, 1.0 - fSlow15);
		let mut fSlow18: F32 = fSlow16 * F32::min(1.0, fSlow15 + 1.0);
		let mut fSlow19: F32 = 0.01 * self.fHslider5 * fSlow16;
		let zipped_iterators = outputs0.zip(outputs1).zip(outputs2);
		for ((output0, output1), output2) in zipped_iterators {
			self.iVec0[0] = 1;
			self.fVec1[0] = fSlow0;
			let mut iTemp1: i32 = ((fSlow0 > self.fVec1[1]) as i32);
			self.iVec2[0] = iTemp1;
			let mut iTemp2: i32 = ((iTemp1 > self.iVec2[1]) as i32);
			let mut iTemp3: i32 = i32::wrapping_sub(1, iTemp2);
			self.fRec3[0] = if (iTemp3 as i32 != 0) { fSlow2 } else { self.fRec3[1] };
			self.fRec5[0] = if (iTemp1 as i32 != 0) { fSlow0 } else { self.fRec5[1] };
			let mut fTemp4: F32 = 106.0 * (1.0 - DSP_Tom4_faustpower2_f(1.0 - F32::max(fSlow3, self.fRec5[0]))) + -99.0;
			let mut fTemp5: F32 = 0.5714286 * fTemp4;
			let mut fTemp6: F32 = F32::max(0.0, F32::min(127.0, fTemp5 + 99.0));
			let mut fTemp7: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp6) * (fTemp6 + 28.0);
			self.fRec4[0] = if (iTemp3 as i32 != 0) { fTemp7 + 4064.0 } else { self.fRec4[1] };
			self.fRec6[0] = if (iTemp3 as i32 != 0) { fTemp7 + 3968.0 } else { self.fRec6[1] };
			let mut fTemp8: F32 = self.fRec6[0] - self.fRec4[0];
			let mut fTemp9: F32 = if (((fTemp8 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec4[0])) + 2.0) } else { 0.96 };
			let mut fTemp10: F32 = F32::abs(fTemp8);
			let mut fTemp11: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (fTemp9 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 28.5) as i32)) as usize] }))));
			self.fRec7[0] = if (iTemp3 as i32 != 0) { fTemp7 } else { self.fRec7[1] };
			let mut fTemp12: F32 = F32::max(5076.0, self.fRec7[0]);
			let mut fTemp13: F32 = self.fRec4[0] - fTemp12;
			let mut fTemp14: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp13) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 88.5) as i32)) as usize] } * if (((fTemp13 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp12)) + 2.0) } else { 0.96 }))));
			let mut fTemp15: F32 = fTemp14 + fTemp11;
			let mut iTemp16: i32 = ((iTemp2 > 0) as i32);
			let mut fTemp17: F32 = self.fRec7[0] - self.fRec6[0];
			let mut fTemp18: F32 = if (((fTemp17 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec6[0])) + 2.0) } else { 0.96 };
			let mut fTemp19: F32 = F32::abs(fTemp17);
			let mut fTemp20: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (fTemp18 * unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 47.5) as i32)) as usize] }))));
			let mut fTemp21: F32 = fTemp15 + fTemp20;
			self.fRec8[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp21, self.fRec8[1] + 1.0) };
			let mut iTemp22: i32 = ((self.fRec8[0] < fTemp15) as i32);
			let mut iTemp23: i32 = ((self.fRec7[0] > self.fRec6[0]) as i32);
			let mut fTemp24: F32 = (self.fRec8[0] - fTemp15) / fTemp20;
			let mut iTemp25: i32 = ((self.fRec8[0] < fTemp14) as i32);
			let mut iTemp26: i32 = ((self.fRec6[0] > self.fRec4[0]) as i32);
			let mut fTemp27: F32 = (self.fRec8[0] - fTemp14) / fTemp11;
			let mut iTemp28: i32 = ((self.fRec4[0] > fTemp12) as i32);
			let mut fTemp29: F32 = self.fRec8[0] / fTemp14;
			let mut fTemp30: F32 = if (iTemp22 as i32 != 0) { if (iTemp25 as i32 != 0) { if (((self.fRec8[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp25 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp29, 0.33333334) } else { fTemp29 } } else { self.fRec4[0] } } } else { if (iTemp22 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp27, 0.33333334) } else { fTemp27 } } else { self.fRec6[0] } } } else { if (((self.fRec8[0] < fTemp21) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp24, 0.33333334) } else { fTemp24 } } else { self.fRec7[0] } };
			let mut iTemp31: i32 = ((fTemp30) as i32);
			let mut fTemp32: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp31) as usize] };
			let mut fTemp33: F32 = F32::max(0.0, F32::min(127.0, fSlow4 + fTemp5));
			let mut fTemp34: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp33) * (fTemp33 + 28.0);
			self.fRec10[0] = if (iTemp3 as i32 != 0) { fTemp34 + 3872.0 } else { self.fRec10[1] };
			self.fRec11[0] = if (iTemp3 as i32 != 0) { fTemp34 } else { self.fRec11[1] };
			let mut fTemp35: F32 = self.fRec11[0] - self.fRec10[0];
			self.fRec12[0] = if (iTemp3 as i32 != 0) { 0.0 } else { self.fRec12[1] };
			let mut fTemp36: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 57.5) as i32)) as usize] };
			let mut fTemp37: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp35) / (fTemp36 * if (((fTemp35 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec10[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp38: F32 = F32::max(5076.0, self.fRec11[0]);
			let mut fTemp39: F32 = self.fRec10[0] - fTemp38;
			let mut fTemp40: F32 = unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 99.5) as i32)) as usize] };
			let mut fTemp41: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp39) / (fTemp40 * if (((fTemp39 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp38)) + 2.0) } else { 0.96 }))));
			let mut fTemp42: F32 = fTemp41 + fTemp37;
			self.fRec13[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(self.fConst5 + fTemp42, self.fRec13[1] + 1.0) };
			let mut iTemp43: i32 = ((self.fRec13[0] < fTemp42) as i32);
			let mut iTemp44: i32 = ((self.fRec13[0] < fTemp41) as i32);
			let mut fTemp45: F32 = (self.fRec13[0] - fTemp41) / fTemp37;
			let mut fTemp46: F32 = self.fRec13[0] / fTemp41;
			let mut fTemp47: F32 = if (iTemp43 as i32 != 0) { if (iTemp44 as i32 != 0) { if (((self.fRec13[0] < 0.0) as i32) as i32 != 0) { fTemp38 } else { if (iTemp44 as i32 != 0) { fTemp38 + fTemp39 * if (((self.fRec10[0] > fTemp38) as i32) as i32 != 0) { F32::powf(fTemp46, 0.33333334) } else { fTemp46 } } else { self.fRec10[0] } } } else { if (iTemp43 as i32 != 0) { self.fRec10[0] + fTemp35 * if (((self.fRec11[0] > self.fRec10[0]) as i32) as i32 != 0) { F32::powf(fTemp45, 0.33333334) } else { fTemp45 } } else { self.fRec11[0] } } } else { self.fRec11[0] };
			let mut iTemp48: i32 = ((fTemp47) as i32);
			let mut fTemp49: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp48) as usize] };
			let mut fTemp50: F32 = F32::max(0.0, F32::min(127.0, fSlow5 + fTemp5));
			let mut fTemp51: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp50) * (fTemp50 + 28.0);
			self.fRec14[0] = if (iTemp3 as i32 != 0) { fTemp51 + 4064.0 } else { self.fRec14[1] };
			self.fRec15[0] = if (iTemp3 as i32 != 0) { fTemp51 + 2688.0 } else { self.fRec15[1] };
			let mut fTemp52: F32 = self.fRec15[0] - self.fRec14[0];
			let mut fTemp53: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp52) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 75.5) as i32)) as usize] } * if (((fTemp52 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec14[0])) + 2.0) } else { 0.96 }))));
			self.fRec16[0] = if (iTemp3 as i32 != 0) { fTemp51 } else { self.fRec16[1] };
			let mut fTemp54: F32 = F32::max(5076.0, self.fRec16[0]);
			let mut fTemp55: F32 = self.fRec14[0] - fTemp54;
			let mut fTemp56: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp55) / (fTemp40 * if (((fTemp55 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp54)) + 2.0) } else { 0.96 }))));
			let mut fTemp57: F32 = fTemp56 + fTemp53;
			let mut fTemp58: F32 = self.fRec16[0] - self.fRec15[0];
			let mut fTemp59: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp58) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 59.5) as i32)) as usize] } * if (((fTemp58 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec15[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp60: F32 = fTemp57 + fTemp59;
			self.fRec17[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp60, self.fRec17[1] + 1.0) };
			let mut iTemp61: i32 = ((self.fRec17[0] < fTemp57) as i32);
			let mut fTemp62: F32 = (self.fRec17[0] - fTemp57) / fTemp59;
			let mut iTemp63: i32 = ((self.fRec17[0] < fTemp56) as i32);
			let mut fTemp64: F32 = (self.fRec17[0] - fTemp56) / fTemp53;
			let mut fTemp65: F32 = self.fRec17[0] / fTemp56;
			let mut fTemp66: F32 = if (iTemp61 as i32 != 0) { if (iTemp63 as i32 != 0) { if (((self.fRec17[0] < 0.0) as i32) as i32 != 0) { fTemp54 } else { if (iTemp63 as i32 != 0) { fTemp54 + fTemp55 * if (((self.fRec14[0] > fTemp54) as i32) as i32 != 0) { F32::powf(fTemp65, 0.33333334) } else { fTemp65 } } else { self.fRec14[0] } } } else { if (iTemp61 as i32 != 0) { self.fRec14[0] + fTemp52 * if (((self.fRec15[0] > self.fRec14[0]) as i32) as i32 != 0) { F32::powf(fTemp64, 0.33333334) } else { fTemp64 } } else { self.fRec15[0] } } } else { if (((self.fRec17[0] < fTemp60) as i32) as i32 != 0) { self.fRec15[0] + fTemp58 * if (((self.fRec16[0] > self.fRec15[0]) as i32) as i32 != 0) { F32::powf(fTemp62, 0.33333334) } else { fTemp62 } } else { self.fRec16[0] } };
			let mut iTemp67: i32 = ((fTemp66) as i32);
			let mut fTemp68: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp67) as usize] };
			let mut iTemp69: i32 = i32::wrapping_sub(1, self.iVec0[1]);
			let mut fTemp70: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec18[1] + self.fConst7 };
			self.fRec18[0] = fTemp70 - F32::floor(fTemp70);
			let mut fTemp71: F32 = F32::max(0.0, F32::min(127.0, 0.85714287 * fTemp4 + 96.0));
			let mut fTemp72: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp71) * (fTemp71 + 28.0);
			self.fRec21[0] = if (iTemp3 as i32 != 0) { fTemp72 + 4064.0 } else { self.fRec21[1] };
			self.fRec22[0] = if (iTemp3 as i32 != 0) { fTemp72 + 3136.0 } else { self.fRec22[1] };
			let mut fTemp73: F32 = self.fRec22[0] - self.fRec21[0];
			let mut fTemp74: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp73) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 79.5) as i32)) as usize] } * if (((fTemp73 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec21[0])) + 2.0) } else { 0.96 }))));
			self.fRec23[0] = if (iTemp3 as i32 != 0) { fTemp72 } else { self.fRec23[1] };
			let mut fTemp75: F32 = F32::max(5076.0, self.fRec23[0]);
			let mut fTemp76: F32 = self.fRec21[0] - fTemp75;
			let mut fTemp77: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp76) / (fTemp40 * if (((fTemp76 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp75)) + 2.0) } else { 0.96 }))));
			let mut fTemp78: F32 = fTemp77 + fTemp74;
			let mut fTemp79: F32 = self.fRec23[0] - self.fRec22[0];
			let mut fTemp80: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp79) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 50.5) as i32)) as usize] } * if (((fTemp79 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec22[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp81: F32 = fTemp78 + fTemp80;
			self.fRec24[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp81, self.fRec24[1] + 1.0) };
			let mut iTemp82: i32 = ((self.fRec24[0] < fTemp78) as i32);
			let mut fTemp83: F32 = (self.fRec24[0] - fTemp78) / fTemp80;
			let mut iTemp84: i32 = ((self.fRec24[0] < fTemp77) as i32);
			let mut fTemp85: F32 = (self.fRec24[0] - fTemp77) / fTemp74;
			let mut fTemp86: F32 = self.fRec24[0] / fTemp77;
			let mut fTemp87: F32 = if (iTemp82 as i32 != 0) { if (iTemp84 as i32 != 0) { if (((self.fRec24[0] < 0.0) as i32) as i32 != 0) { fTemp75 } else { if (iTemp84 as i32 != 0) { fTemp75 + fTemp76 * if (((self.fRec21[0] > fTemp75) as i32) as i32 != 0) { F32::powf(fTemp86, 0.33333334) } else { fTemp86 } } else { self.fRec21[0] } } } else { if (iTemp82 as i32 != 0) { self.fRec21[0] + fTemp73 * if (((self.fRec22[0] > self.fRec21[0]) as i32) as i32 != 0) { F32::powf(fTemp85, 0.33333334) } else { fTemp85 } } else { self.fRec22[0] } } } else { if (((self.fRec24[0] < fTemp81) as i32) as i32 != 0) { self.fRec22[0] + fTemp79 * if (((self.fRec23[0] > self.fRec22[0]) as i32) as i32 != 0) { F32::powf(fTemp83, 0.33333334) } else { fTemp83 } } else { self.fRec23[0] } };
			let mut iTemp88: i32 = ((fTemp87) as i32);
			let mut fTemp89: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp88) as usize] };
			let mut fTemp90: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec25[1] + self.fConst10 };
			self.fRec25[0] = fTemp90 - F32::floor(fTemp90);
			self.fRec20[0] = 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec25[0] + 13.913043 * self.fRec20[1] + 1e+01)) as i32) % 1024) as usize] } * (fTemp89 + (fTemp87 - ((iTemp88) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp88, 1)) as usize] } - fTemp89));
			let mut fTemp91: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec26[1] + self.fConst12 };
			self.fRec26[0] = fTemp91 - F32::floor(fTemp91);
			self.iRec28[0] = if (iTemp3 as i32 != 0) { self.iConst13 } else { self.iRec28[1] };
			let mut fTemp92: F32 = 15.996094 * (0.4 * ((self.iRec28[0]) as F32) + 128.0);
			let mut iTemp93: i32 = ((fTemp92) as i32);
			let mut fTemp94: F32 = unsafe { ftbl3DSP_Tom4SIG3[(iTemp93) as usize] };
			let mut fTemp95: F32 = fSlow10 * (fTemp94 + (fTemp92 - ((iTemp93) as F32)) * (unsafe { ftbl3DSP_Tom4SIG3[(i32::wrapping_add(iTemp93, 1)) as usize] } - fTemp94));
			let mut fTemp96: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec27[1] + fSlow11 * fTemp95 };
			self.fRec27[0] = fTemp96 - F32::floor(fTemp96);
			let mut fTemp97: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp10 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 41.5) as i32)) as usize] } * fTemp9))));
			let mut fTemp98: F32 = fTemp14 + fTemp97;
			let mut fTemp99: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (fTemp19 / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec3[0] + 45.5) as i32)) as usize] } * fTemp18))));
			let mut fTemp100: F32 = fTemp98 + fTemp99;
			self.fRec29[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp100, self.fRec29[1] + 1.0) };
			let mut iTemp101: i32 = ((self.fRec29[0] < fTemp98) as i32);
			let mut fTemp102: F32 = (self.fRec29[0] - fTemp98) / fTemp99;
			let mut iTemp103: i32 = ((self.fRec29[0] < fTemp14) as i32);
			let mut fTemp104: F32 = (self.fRec29[0] - fTemp14) / fTemp97;
			let mut fTemp105: F32 = self.fRec29[0] / fTemp14;
			let mut fTemp106: F32 = if (iTemp101 as i32 != 0) { if (iTemp103 as i32 != 0) { if (((self.fRec29[0] < 0.0) as i32) as i32 != 0) { fTemp12 } else { if (iTemp103 as i32 != 0) { fTemp12 + fTemp13 * if (iTemp28 as i32 != 0) { F32::powf(fTemp105, 0.33333334) } else { fTemp105 } } else { self.fRec4[0] } } } else { if (iTemp101 as i32 != 0) { self.fRec4[0] + fTemp8 * if (iTemp26 as i32 != 0) { F32::powf(fTemp104, 0.33333334) } else { fTemp104 } } else { self.fRec6[0] } } } else { if (((self.fRec29[0] < fTemp100) as i32) as i32 != 0) { self.fRec6[0] + fTemp17 * if (iTemp23 as i32 != 0) { F32::powf(fTemp102, 0.33333334) } else { fTemp102 } } else { self.fRec7[0] } };
			let mut iTemp107: i32 = ((fTemp106) as i32);
			let mut fTemp108: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp107) as usize] };
			let mut fTemp109: F32 = F32::max(0.0, F32::min(127.0, fSlow13 + fTemp5));
			let mut fTemp110: F32 = 32.0 * F32::min(1.0, 0.05 * fTemp109) * (fTemp109 + 28.0);
			self.fRec30[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3872.0 } else { self.fRec30[1] };
			self.fRec31[0] = if (iTemp3 as i32 != 0) { fTemp110 + 3232.0 } else { self.fRec31[1] };
			let mut fTemp111: F32 = self.fRec31[0] - self.fRec30[0];
			let mut fTemp112: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp111) / (fTemp36 * if (((fTemp111 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec30[0])) + 2.0) } else { 0.96 }))));
			self.fRec32[0] = if (iTemp3 as i32 != 0) { fTemp110 } else { self.fRec32[1] };
			let mut fTemp113: F32 = F32::max(5076.0, self.fRec32[0]);
			let mut fTemp114: F32 = self.fRec30[0] - fTemp113;
			let mut fTemp115: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp114) / (fTemp40 * if (((fTemp114 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - fTemp113)) + 2.0) } else { 0.96 }))));
			let mut fTemp116: F32 = fTemp115 + fTemp112;
			let mut fTemp117: F32 = self.fRec32[0] - self.fRec31[0];
			let mut fTemp118: F32 = F32::max(1.0, self.fConst0 * F32::max(0.001, 0.0235 * (F32::abs(fTemp117) / (unsafe { ftbl1DSP_Tom4SIG1[(((self.fRec12[0] + 54.5) as i32)) as usize] } * if (((fTemp117 > 0.0) as i32) as i32 != 0) { 0.538 * (F32::max(0.0, 0.00390625 * (7.2e+03 - self.fRec31[0])) + 2.0) } else { 0.96 }))));
			let mut fTemp119: F32 = fTemp116 + fTemp118;
			self.fRec33[0] = if (iTemp16 as i32 != 0) { 0.0 } else { F32::min(fTemp119, self.fRec33[1] + 1.0) };
			let mut iTemp120: i32 = ((self.fRec33[0] < fTemp116) as i32);
			let mut fTemp121: F32 = (self.fRec33[0] - fTemp116) / fTemp118;
			let mut iTemp122: i32 = ((self.fRec33[0] < fTemp115) as i32);
			let mut fTemp123: F32 = (self.fRec33[0] - fTemp115) / fTemp112;
			let mut fTemp124: F32 = self.fRec33[0] / fTemp115;
			let mut fTemp125: F32 = if (iTemp120 as i32 != 0) { if (iTemp122 as i32 != 0) { if (((self.fRec33[0] < 0.0) as i32) as i32 != 0) { fTemp113 } else { if (iTemp122 as i32 != 0) { fTemp113 + fTemp114 * if (((self.fRec30[0] > fTemp113) as i32) as i32 != 0) { F32::powf(fTemp124, 0.33333334) } else { fTemp124 } } else { self.fRec30[0] } } } else { if (iTemp120 as i32 != 0) { self.fRec30[0] + fTemp111 * if (((self.fRec31[0] > self.fRec30[0]) as i32) as i32 != 0) { F32::powf(fTemp123, 0.33333334) } else { fTemp123 } } else { self.fRec31[0] } } } else { if (((self.fRec33[0] < fTemp119) as i32) as i32 != 0) { self.fRec31[0] + fTemp117 * if (((self.fRec32[0] > self.fRec31[0]) as i32) as i32 != 0) { F32::powf(fTemp121, 0.33333334) } else { fTemp121 } } else { self.fRec32[0] } };
			let mut iTemp126: i32 = ((fTemp125) as i32);
			let mut fTemp127: F32 = unsafe { ftbl0DSP_Tom4SIG0[(iTemp126) as usize] };
			let mut fTemp128: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec34[1] + self.fConst16 };
			self.fRec34[0] = fTemp128 - F32::floor(fTemp128);
			let mut fTemp129: F32 = if (iTemp69 as i32 != 0) { 0.0 } else { self.fRec35[1] + fSlow14 * fTemp95 };
			self.fRec35[0] = fTemp129 - F32::floor(fTemp129);
			let mut fTemp130: F32 = unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec35[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec34[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp127 + (fTemp125 - ((iTemp126) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp126, 1)) as usize] } - fTemp127)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp108 + (fTemp106 - ((iTemp107) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp107, 1)) as usize] } - fTemp108)) + unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec27[0] + 2.0 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * (self.fRec26[0] + 17.391304 * (self.fRec20[0] + 0.115 * unsafe { ftbl2DSP_Tom4SIG2[(((1024.0 * self.fRec18[0] + 1.024e+04) as i32) % 1024) as usize] } * (fTemp68 + (fTemp66 - ((iTemp67) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp67, 1)) as usize] } - fTemp68))) + 1e+01)) as i32) % 1024) as usize] } * (fTemp49 + (fTemp47 - ((iTemp48) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp48, 1)) as usize] } - fTemp49)) + 1e+01)) as i32) % 1024) as usize] } * (fTemp32 + (fTemp30 - ((iTemp31) as F32)) * (unsafe { ftbl0DSP_Tom4SIG0[(i32::wrapping_add(iTemp31, 1)) as usize] } - fTemp32));
			self.fVec4[0] = fTemp130;
			self.fRec0[0] = 0.115 * (self.fConst18 * fTemp130 + self.fConst19 * self.fVec4[1]) - self.fConst4 * self.fRec0[1];
			*output0 = fSlow17 * self.fRec0[0];
			*output1 = fSlow18 * self.fRec0[0];
			*output2 = fSlow19 * self.fRec0[0];
			self.iVec0[1] = self.iVec0[0];
			self.fVec1[1] = self.fVec1[0];
			self.iVec2[1] = self.iVec2[0];
			self.fRec3[1] = self.fRec3[0];
			self.fRec5[1] = self.fRec5[0];
			self.fRec4[1] = self.fRec4[0];
			self.fRec6[1] = self.fRec6[0];
			self.fRec7[1] = self.fRec7[0];
			self.fRec8[1] = self.fRec8[0];
			self.fRec10[1] = self.fRec10[0];
			self.fRec11[1] = self.fRec11[0];
			self.fRec12[1] = self.fRec12[0];
			self.fRec13[1] = self.fRec13[0];
			self.fRec14[1] = self.fRec14[0];
			self.fRec15[1] = self.fRec15[0];
			self.fRec16[1] = self.fRec16[0];
			self.fRec17[1] = self.fRec17[0];
			self.fRec18[1] = self.fRec18[0];
			self.fRec21[1] = self.fRec21[0];
			self.fRec22[1] = self.fRec22[0];
			self.fRec23[1] = self.fRec23[0];
			self.fRec24[1] = self.fRec24[0];
			self.fRec25[1] = self.fRec25[0];
			self.fRec20[1] = self.fRec20[0];
			self.fRec26[1] = self.fRec26[0];
			self.iRec28[1] = self.iRec28[0];
			self.fRec27[1] = self.fRec27[0];
			self.fRec29[1] = self.fRec29[0];
			self.fRec30[1] = self.fRec30[0];
			self.fRec31[1] = self.fRec31[0];
			self.fRec32[1] = self.fRec32[0];
			self.fRec33[1] = self.fRec33[0];
			self.fRec34[1] = self.fRec34[0];
			self.fRec35[1] = self.fRec35[0];
			self.fVec4[1] = self.fVec4[0];
			self.fRec0[1] = self.fRec0[0];
		}
	}
}
